<?php

namespace Etrali\GinangBundle\Controller\BackboneLink;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Form\Type\BackboneLink\CustomValidator;
use Etrali\GinangBundle\SendMail;
use Admingenerated\EtraliGinangBundle\BaseBackboneLinkController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    protected function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    }
    
    public function upgradeAction($pk)
    {
        $bbl = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(12);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(3);        
        $bbl->setIdTransactionType($TransType);
        $bbl->setIdTransactionStatus($TransStatus); 
        $bbl->setIdOldBandwidth($bbl->getIdBandwidth()); 
        $bbl->setIdBandwidth(NULL);   
        foreach ($bbl->getIdBackboneLinkExtremitytech() as $extr)
        {
            $extr->setDtOldBbTested($extr->getDtBbTested());
            $extr->setDtBbTested(NULL);
            $em->persist($extr);
        }
        $bbl->setDtInitUpdown(NULL);
        $bbl->setDtRequestedUpdown(NULL);
        $bbl->setDtRealUpdown(NULL);        
        $bbl->setDtScheduledUpdownDelivery(NULL);         
        $bbl->setNbOperation($bbl->getNbOperation()+1);
        $em->persist($bbl);
        $em->flush();
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_BackboneLink_edit" ,array("pk"=>$pk)));
    }
    
     public function terminateAction($pk)
    {
        $bbl = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(18);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(4);        
        $bbl->setIdTransactionType($TransType);
        $bbl->setIdTransactionStatus($TransStatus); 
        $bbl->setNbOperation($bbl->getNbOperation()+1);        
        $em->persist($bbl);
        $em->flush();        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_BackboneLink_edit" ,array("pk"=>$pk)));
    }    
       
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLink $BackboneLink your \Etrali\GinangBundle\Entity\BackboneLink object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLink $BackboneLink)
    {
        $em = $this->getDoctrine()->getManager();         
        if ($BackboneLink->getDtDelivery()!=NULL)
        {
            foreach ($BackboneLink->getIdCostingBackboneLinkLine() as $cost)
            {
                if ($cost->getDtStart()==NULL)
                {
                    $cost->setDtStart($BackboneLink->getDtDelivery());
                    $em->persist($cost);
                }
                if ($cost->getDtStartMrc()==NULL)
                {
                    $cost->setDtStartMrc($BackboneLink->getDtDelivery());                        
                    $em->persist($cost);
                }                                          
            }   
            $em->flush();
        }        
        $chaineret=CustomValidator::isValidForNextStep($BackboneLink,$this->getDoctrine()->getEntityManager(),$this);
        if ($chaineret=="")
        {
            $id_status=$BackboneLink->getIdTransactionStatus()->getIdTransactionStatus()+1;
            
            $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
            $BackboneLink->setIdTransactionStatus($TransStatus);
            $em->persist($BackboneLink);    
            
            $history=new \Etrali\GinangBundle\Entity\BackboneLinkTransactions();
            $history->setIdBackboneLink($BackboneLink);
            $history->setCdBackboneLink($BackboneLink->getCdBackboneLink());
            $history->setIdTransactionStatus($TransStatus);                       
            $history->setIdTransactionType($BackboneLink->getIdTransactionType());                      
            $history->setLbOperation($BackboneLink->getIdTransactionType()." ".$BackboneLink->getNbOperation());
            
            $em->persist($history); 
            
            switch ($id_status)
            {
                case 1:
                    SendMail::send($this,$this->container,"jconan@protego.net",2000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                    
                    break;                
                case 2:
                    SendMail::send($this,$this->container,"jconan@protego.net",2010,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));
                    break;
                case 3:                                     
                    SendMail::send($this,$this->container,"jconan@protego.net",2020,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                    
                    break;
                case 4:
                    SendMail::send($this,$this->container,"jconan@protego.net",2030,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                     
                       
                case 5:                                       
                    SendMail::send($this,$this->container,"jconan@protego.net",2040,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    SendMail::send($this,$this->container,"jconan@protego.net",3000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                      
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $BackboneLink->setIdTransactionStatus($TransStatus);
                    $em->persist($BackboneLink); 
                    
                    $history=new \Etrali\GinangBundle\Entity\BackboneLinkTransactions();
                    $history->setIdBackboneLink($BackboneLink);
                    $history->setCdBackboneLink($BackboneLink->getCdBackboneLink());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($BackboneLink->getIdTransactionType());                      
                    $history->setLbOperation($BackboneLink->getIdTransactionType()." ".$BackboneLink->getNbOperation()); 
                    $em->persist($history);                     
                    break;
                case 6:
                  
                    break;
                case 7:
                    SendMail::send($this,$this->container,"jconan@protego.net",2050,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));     
                    break;
                case 8:
                     SendMail::send($this,$this->container,"jconan@protego.net",2060,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    break;
                case 9:
                     SendMail::send($this,$this->container,"jconan@protego.net",2070,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    break;
                case 10:
                     SendMail::send($this,$this->container,"jconan@protego.net",2080,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                     
                case 11:  
                     $transferExtr=$BackboneLink->getIdTransferExtremity();
                     $transferExtr->setCdBackboneLinkExtremityRef(substr($transferExtr->getCdBackboneLinkExtremityRef(),0,strlen($transferExtr->getCdBackboneLinkExtremityRef())-3));
                     $transferExtr->getIdOldExtremity()->setCdBackboneLinkExtremityRef($transferExtr->getIdOldExtremity()->getCdBackboneLinkExtremityRef()."Old");
                     $transferExtr->getIdOldExtremity()->setBlTransferred(true);
                     $transferExtr->getIdOldExtremity()->getIdBackboneLinkExtremityTech()->setBlTransferred(true);
                     $transferExtr->setDtTransferComplete($transferExtr->getIdBackboneLinkExtremityTech()->getDtBbTested());
                     $transferExtr->getIdOldExtremity()->setDtOldTerminate(clone $transferExtr->getDtTransferComplete()); 
                     $transferExtr->getIdOldExtremity()->getDtOldTerminate()->sub(new \DateInterval('P1D'));
                     $em->persist($transferExtr); 
                     $em->persist($transferExtr->getIdOldExtremity()); 
                     
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $BackboneLink->setIdTransactionStatus($TransStatus);
                    $em->persist($BackboneLink); 

                    $history=new \Etrali\GinangBundle\Entity\BackboneLinkTransactions();
                    $history->setIdBackboneLink($BackboneLink);
                    $history->setCdBackboneLink($BackboneLink->getCdBackboneLink());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($BackboneLink->getIdTransactionType());                      
                    $history->setLbOperation($BackboneLink->getIdTransactionType()." ".$BackboneLink->getNbOperation()); 
                    $em->persist($history); 
                    
                     SendMail::send($this,$this->container,"jconan@protego.net",2090,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                     SendMail::send($this,$this->container,"jconan@protego.net",3000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                                            
                    break; 
                case 12:
               
                    break;
                case 13:                    
                    SendMail::send($this,$this->container,"jconan@protego.net",2100,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    break;
                case 14:
                    SendMail::send($this,$this->container,"jconan@protego.net",2110,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    break;                
                case 15:
                    SendMail::send($this,$this->container,"jconan@protego.net",2120,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    break;
                case 16:
                    SendMail::send($this,$this->container,"jconan@protego.net",2130,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));                        
 
                case 17:    
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $BackboneLink->setIdTransactionStatus($TransStatus);
                    $em->persist($BackboneLink);
                    
                    $history=new \Etrali\GinangBundle\Entity\BackboneLinkTransactions();
                    $history->setIdBackboneLink($BackboneLink);
                    $history->setCdBackboneLink($BackboneLink->getCdBackboneLink());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($BackboneLink->getIdTransactionType());                      
                    $history->setLbOperation($BackboneLink->getIdTransactionType()." ".$BackboneLink->getNbOperation()); 
                    $em->persist($history);                     
                    SendMail::send($this,$this->container,"jconan@protego.net",2140,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));    
                    SendMail::send($this,$this->container,"jconan@protego.net",3000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink()));  
                    $BackboneLink->setDtRealUpdown(new \DateTime());
                    $em->persist($BackboneLink); 
                    break;
                case 18:
                                    
                case 19:
                    SendMail::send($this,$this->container,"jconan@protego.net",2150,array("DATE"=>date("d/m/Y H:i"),"REF"=>$BackboneLink->getCdBackboneLink())); 
                    foreach ($BackboneLink->getIdCostingBackboneLinkLine() as $cost)
                    {
                        $cost->setDtEnd($BackboneLink->getDtRealTerminate());
                        $em->persist($cost);
                    }
                    break;
                case 20:
                    break;                
            }
            
            
            $em->flush();            
        }
        else if ($chaineret!="NA")
            $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );
    }    
}
