<?php

namespace Etrali\GinangBundle\Controller\Branch;

use Admingenerated\EtraliGinangBundle\BaseBranchController\EditController as BaseEditController;
use DateInterval;
use Etrali\GinangBundle\Entity\BillingPeriod;
use Etrali\GinangBundle\Entity\BillingPeriodRef;
use Etrali\GinangBundle\Entity\Branch;
use Symfony\Component\Form\Form;
use Symfony\Component\Validator\Constraints\DateTime;

class EditController extends BaseEditController
{
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Branch $Branch your \Etrali\GinangBundle\Entity\Branch object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Branch $Branch)
    {
        $indFreqArray=array();
        $frequencies=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:BillingFrequency')->findAll();
        foreach ($frequencies as $f)
            $indFreqArray[$f->getIdBillingfrequency()]=$f;
        
        $request = $this->getRequest();
        $cpt=0;
        foreach ($Branch->getIdBillingPeriodRef() as $pref)
        {
            $args=$request->request->get("edit_branch_idBillingPeriodRef_".$cpt);
            $freqs=$args["idBillingFrequency"];
            if ($freqs!=null)
            {
                foreach ($freqs as $freq)
                {
                    $pref->addIdBillingFrequency($indFreqArray[$freq]);
                }
            }
            $cpt++;            
        }
    }   
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param Branch $Branch your \Etrali\GinangBundle\Entity\Branch object
     */
    public function postSave(Form $form, Branch $Branch)
    {                
        
        $em = $this->getDoctrine()->getManager();        

        foreach ($Branch->getIdBillingPeriodRef() as $billPeriodRef)
        {
            if ($billPeriodRef->getIdBillingPeriod()!=null)
            {
               foreach ($billPeriodRef->getIdBillingPeriod() as $billPeriod)
               {
                   $doRemove=true;
                   foreach ($billPeriodRef->getIdBillingFrequency() as $freq)
                   {
                       if ($freq->getIdBillingFrequency()==$billPeriod->getIdBillingfrequency()->getIdBillingFrequency())
                       {
                           $doRemove=false;
                       }
                   }
                   if ($doRemove)
                       $em->remove($billPeriod);
               }
            }
            if ($billPeriodRef->getIdBillingFrequency()!=null)
            {
                foreach ($billPeriodRef->getIdBillingFrequency() as $freq)
                {
                        $found=false;
                        if ($billPeriodRef->getIdBillingPeriod()!=null)
                        {
                            foreach ($billPeriodRef->getIdBillingPeriod() as $billPeriod)
                            {
                                if ($billPeriod->getIdBillingFrequency()->getIdBillingFrequency()==$freq->getIdBillingFrequency())
                                {
                                    $found=true;
                                    break;
                                }
                            }
                        }
                        if (!$found)
                        {
                            $debutInterval=1;
                            $dtPeriodStart=clone $billPeriodRef->getDtBillingStart();
                            $interval=$freq->getInterval();
                            while ($debutInterval<13)
                            {
                                    $dtRefstart=clone $dtPeriodStart;
                                    $dtRefstart->sub(new DateInterval('P'.$interval.'M'));
                                    $dtRefend=clone $dtPeriodStart;
                                    $dtRefend->sub(new DateInterval('P1D'));

                                    $billing=new BillingPeriod();
                                    $billing->setIdBillingPeriodRef($billPeriodRef);
                                    $billing->setIdBillingFrequency($freq);
                                    $billing->setIdBranch($Branch);
                                    $billing->setDtRefStart($dtRefstart);
                                    $billing->setDtRefEnd($dtRefend);
                                    $billing->setDtBillingStart(clone $dtPeriodStart);
                                    $billing->setLbBillingPeriod($billing->getDtBillingStart()->format("Y-m"));                                    

                                    $dtPeriodStart->add(new DateInterval('P'.$interval.'M'));

                                    $dtBillingEnd=clone $dtPeriodStart;
                                    $dtBillingEnd->sub(new DateInterval('P1D'));                    
                                    $billing->setDtBillingEnd($dtBillingEnd);

                                    $em->persist($billing);
                                $debutInterval+=$interval;
                            }
                        }
                }
            }
        }
        
        $em->flush();        
    }

}
