<?php

namespace Etrali\GinangBundle\Controller\Card;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseCardController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getReturnFunction($pk)
    {
        $Card=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($pk);
        if (!$Card->getBlDaughter())
            return $this->render('EtraliGinangBundle:CardModal:index.html.twig', array(
                    "Card" => $Card
                ));      
        else
            return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');
    }    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Card $Cardyour \Etrali\GinangBundle\Entity\Card object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Card $Card)
    {

        if ($Card->getIdCostingCardLine())
        {
            foreach ($Card->getIdCostingCardLine() as $line)
            {
                $line->setIdCard($Card);
            }
        }

    } 
    
    /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Card $Cardyour \Etrali\GinangBundle\Entity\Card object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Card $Card)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $nb=1;        
        $Pere=$Card->getIdEquipment();        
        if ($Pere!=NULL)
        {
            foreach ($Pere->getIdCard() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }
            $em->flush();
            
        }
        $nb=1;        
        $Pere=$Card->getIdSlot();        
        if ($Pere!=NULL)
        {
            foreach ($Pere->getIdCard() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }
            $em->flush();
            
        }       
    }     
    
    public function linkAction(Request $request)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $Card=$em->getRepository('EtraliGinangBundle:Card')->find($request->get("id"));
        $type_pere=$request->get("typepere");
        switch ($type_pere)
        {
            case "ui-gina-comp":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($request->get("idpere"));
                   $Card->setIdComplexModel($Pere);
                break;
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("idpere"));               
                break;
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($request->get("idpere"));
                    $Card->setIdEquipment($Pere);
                break;
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("idpere"));
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($request->get("idpere"));
                   $Card->setIdSlot($Pere);
                break;                
            case "ui-gina-fille":
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($request->get("idpere"));
                   $Card->setIdMotherCard($Pere); 
                   $Card->setBlDaughter($type_pere!="ui-gina-slots");
                break;              
        }
        $em->persist($Card);
        $em->flush();        
        return new Response();
    }


}
