<?php

namespace Etrali\GinangBundle\Controller\Card;

use Admingenerated\EtraliGinangBundle\BaseCardController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        else
            $session->remove('typepere');
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));  
        else
            $session->remove('idpere');
        if ($this->get('request')->query->has('isDaughter'))
            $session->set('isDaughter',$this->get('request')->query->get('isDaughter'));
        else
            $session->remove('isDaughter');
        return parent::indexAction();
    }
    
    public function getReturnFunction($Card)
    {
        return $this->render('EtraliGinangBundle:CardModal:index.html.twig', array(
                    "Card" => $Card
                ));
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Cabinet $Cabinet your \Etrali\GinangBundle\Entity\Cabinet object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Card $Card)
    {
        if ($Card->getIdCostingCardLine())
        {
            foreach ($Card->getIdCostingCardLine() as $line)
            {
                $line->setIdCard($Card);
            }
        }

        $session = $this->getRequest()->getSession(); 
        if ($session->has('isDaughter'))
            $Card->setBlDaughter (true);
        if ($session->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {
                case "ui-gina-comp":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                       $Card->setIdComplexModel($Pere);
                    break;    
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($idpere);
                    $Card->setIdEquipment($Pere);
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($idpere);
                   $Card->setIdSlot($Pere);
                break;  
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($idpere);
                   $Card->setIdMotherCard($Pere); 
                   $Card->setBlDaughter(true);
                break;              
            }
        }        
    }  
    
    /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Card $Cardyour \Etrali\GinangBundle\Entity\Card object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Card $Card)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $nb=1;        
        $Pere=$Card->getIdEquipment();        
        if ($Pere!=NULL)
        {
            foreach ($Pere->getIdCard() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }
            $em->flush();
            
        }
        $nb=1;        
        $Pere=$Card->getIdSlot();        
        if ($Pere!=NULL)
        {
            foreach ($Pere->getIdCard() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }
            $em->flush();
            
        }       
    }     
}
