<?php

namespace Etrali\GinangBundle\Controller\CardInstance;

use Admingenerated\EtraliGinangBundle\BaseCardInstanceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\CardInstance;
use Etrali\GinangBundle\Entity\PortInstance;
use Etrali\GinangBundle\Entity\Ts;
use Exception;
use Symfony\Component\HttpFoundation\Response;


class NewController extends BaseNewController
{
      public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));
        if ($this->get('request')->query->has('return'))
            $session->set('return',$this->get('request')->query->get('return')); 
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));        
        return parent::indexAction();
    }
    
    private function handleTimeslots($em,$port,$cardinst)
    {
                $portinst=new PortInstance();
                $portinst->setCdPortInstance($port->getCdPort());
                $portinst->setLbPortInstance($port->getLbPort());
                $portinst->setCmPortInstance($port->getCmPort()); 
                $portinst->setIdPortType($port->getIdPortType());                
                $portinst->setBlDeactivated(true);
                $portinst->setIdPort($port);
                $portinst->setIdCardInstance($cardinst);
                $portinst->setNbNumber($port->getNbNumber());


                $em->persist($portinst);         
                               
                $TsStatus=$em->getRepository('EtraliGinangBundle:TsStatus')->find(1);                    
                for ($i=0;$i<$port->getNbTimeslots();$i++)
                {
                    $ts=new Ts();
                    $ts->setIdPortInstance($portinst);
                    $ts->setNbTs($i+$port->getIdPortType()->getNbTsStart());
                    $ts->setNbChannel($i+$port->getIdPortType()->getNbChannelStart());
                    $ts->setLbTs($ts->getNbTs());
                    $ts->setIdTsStatus($TsStatus);                        

                    $em->persist($ts);
                }                 
    }    
        
    public function createAction()
    {
        $em=$this->getDoctrine()->getEntityManager()        ;
        $CardInstance = $this->getNewObject();

        $this->preBindRequest($CardInstance);
        $form = $this->createForm($this->getNewType(), $CardInstance);
      
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $CardInstance);
                $session = $this->getRequest()->getSession();  
                $idpere=$session->get('idpere');
                $typepere=$session->get('typepere');                
                if ($typepere=="ui-gina-slots")
                {
                    $Pere=$em->getRepository('EtraliGinangBundle:SlotInstance')->find($idpere);
                    $CardInstance->setIdSlotInstance($Pere);               
                }
                else if ($typepere=="ui-gina-mere")
                {
                    $Pere=$em->getRepository('EtraliGinangBundle:CardInstance')->find($idpere);
                    $CardInstance->setIdMotherCard($Pere);               
                }   
                else if ($typepere=="ui-gina-equi")
                {
                    $Pere=$em->getRepository('EtraliGinangBundle:EquipmentInstance')->find($idpere);
                    $CardInstance->setIdEquipmentInstance($Pere);               
                }                 
                $this->saveObject($CardInstance);
                $this->postSave($form, $CardInstance);

                $entites=array();
                $entites[]=$CardInstance;
                
                if ($session->has("nombre"))
                {
                    for ($i=1;$i<$session->get("nombre");$i++)
                    {
                        $entites[]=clone $CardInstance;
                    }
                }
                
                foreach ($entites as $cardinst)
                {
                    $models=$cardinst->getIdComplexModel()->getIdCard();
                    $cpt=0;
                    foreach ($models as $model)
                    {
                        if ($cpt>0)
                            $cardinst=clone $CardInstance;
                        $cpt++;
                        $cardinst->setIdCard($model);
                        
                        foreach ($model->getIdCostingCardLine() as $costing)
                        {
                            $newcost=clone $costing;
                            $newcost->setIdCard(NULL);
                            $newcost->setIdCardInstance($cardinst);  
                            $em->persist($newcost); 
                        }

                                
                        $em->persist($cardinst);   
                        
                                foreach ($model->getIdPort() as $port)
                                {
                                    $this->handleTimeslots($em, $port,$cardinst);                          
                                }                
                                foreach ($model->getIdDaughterCard() as $dcard)
                                {
                                    $dcardinst=new CardInstance();
                                    $dcardinst->setCdCardInstance($dcard->getCdCard());
                                    $dcardinst->setLbCardInstance($dcard->getLbCard());                                       
                                    $dcardinst->setBlDeactivated(true);
                                    $dcardinst->setIdCard($dcard);
                                    $dcardinst->setIdMotherCard($cardinst);
                                    
                                    foreach ($dcard->getIdCostingCardLine() as $costing)
                                    {
                                        $newcost=clone $costing;
                                        $newcost->setIdCard(NULL);
                                        $newcost->setIdCardInstance($dcardinst); 
                                        $em->persist($newcost); 
                                    }
                                    
                                    $em->persist($dcardinst);   
                                    foreach ($dcard->getIdPort() as $port)
                                    {
                                        $this->handleTimeslots($em, $port,$dcardinst);                                                                       
                                    }                                    
                                }                                    
                    } 
                     
                }
                $em->flush();          
                
                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');

            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $CardInstance);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('EtraliGinangBundle:CardInstanceNew:index.html.twig', $this->getAdditionalRenderParameters($CardInstance) + array(
            "CardInstance" => $CardInstance,
            "form" => $form->createView(),
        ));
    }
}
