<?php

namespace Etrali\GinangBundle\Controller\ComplexModelSelect;

use Admingenerated\EtraliGinangBundle\BaseComplexModelSelectController\ListController as BaseListController;

class ListController extends BaseListController
{   
    
    public function buildQuery()
    {     
        $query=$this->getDoctrine()
                    ->getManager()
                    ->getRepository('Etrali\GinangBundle\Entity\ComplexModel')
                    ->createQueryBuilder('q');

        switch ($this->get('request')->query->get('typepere'))
        {
            case "ui-gina-pop":
                $pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Pop')->find($this->get('request')->query->get('idpere'));
                $query=$query->innerJoin('q.idCabinet','c');
                break;              
            case "ui-gina-comp":
                $pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($this->get('request')->query->get('idpere'));
                if ($pere->getIdCabinet() != NULL && $pere->getIdCabinet()->count()>0)
                    $query=$query->innerJoin('q.idCabinet','c');
                else if (($pere->getIdEquipment() != NULL && $pere->getIdEquipment()->count()>0) || ($pere->getIdPatchPanel() != NULL && $pere->getIdPatchPanel()->count()>0))
                    $query=$query->leftJoin('q.idEquipment','e')->leftJoin('q.idPatchPanel','p')->orWhere('e.idEquipment is not NULL')->orWhere('p.idPatchPanel is not NULL');
                else if (($pere->getIdSlot() != NULL && $pere->getIdSlot()->count()>0) || ($pere->getIdCard() != NULL && $pere->getIdCard()->count()>0 && $pere->getIdCard()->first()->getBlDaughter()))
                    $query=$query->leftJoin('q.idSlot', 's')->leftJoin('q.idCard', 'c')->andWhere('s.idSlot is not NULL')->orWhere('c.idCard is not NULL and c.blDaughter=1');                
                else if ($pere->getIdCard() != NULL && $pere->getIdCard()->count()>0 && !$pere->getIdCard()->first()->getBlDaughter())
                    $query=$query->innerJoin('q.idCard', 'c')->andWhere("c.blDaughter=0");                
                else if ($pere->getIdPort() != NULL && $pere->getIdPort()->count()>0)
                    $query=$query->innerJoin('q.idPort', 'p');                                
                break;                
            case "ui-gina-cab":
                    $query=$query->leftJoin('q.idEquipment', 'e')->leftJoin('q.idPatchPanel', 'p')->orWhere('e.idEquipment is not NULL')->orWhere('p.idPatchPanel is not NULL');
                break;
            case "ui-gina-equi":
                    $query=$query->leftJoin('q.idSlot', 's')->leftJoin('q.idCard', 'c')->orWhere('s.idSlot is not NULL')->orWhere('c.idCard is not NULL and c.blDaughter=1');                
                break;  
            case "ui-gina-patch":
            case "ui-gina-fille" :              
                    $query=$query->innerJoin('q.idPort', 'p');                
                break;
            case "ui-gina-slots" :
                $query=$query->innerJoin('q.idCard', 'c')->andWhere("c.blDaughter=0");  
                break;
            case "ui-gina-mere" :
                $query=$query->innerJoin('q.idCard', 'c')->andWhere("c.blDaughter=1");  
                break;            
        }
        return $query;
    }

}
