<?php

namespace Etrali\GinangBundle\Controller\Equipment;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseEquipmentController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getReturnFunction($pk)
    {
        $Equipment=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($pk);
        return $this->render('EtraliGinangBundle:EquipmentModal:index.html.twig', array(
                    "Equipment" => $Equipment
                ));
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Equipment $Equipment your \Etrali\GinangBundle\Entity\Equipment object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Equipment $Equipment)
    {
        $em = $this->getDoctrine()->getManager();
        $Equipment->postSave($form,$em);
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Equipment $Equipment your \Etrali\GinangBundle\Entity\Equipment object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Equipment $Equipment)
    {

        if ($Equipment->getIdCostingEquipmentLine() )
        {
            foreach ($Equipment->getIdCostingEquipmentLine() as $line)
            {
                $line->setIdEquipment($Equipment);
            }
        }

    }
    
    public function linkAction(Request $request)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $Equipment=$em->getRepository('EtraliGinangBundle:Equipment')->find($request->get("id"));
        $type_pere=$request->get("typepere");
        switch ($type_pere)
        {
            case "ui-gina-comp":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($request->get("idpere"));
                   $Equipment->setIdComplexModel($Pere);
                break;
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("idpere"));
                   $Equipment->setIdCabinet($Pere);                
                break;
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($request->get("idpere"));
                break;
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("idpere"));
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($request->get("idpere"));
                break;                
            case "ui-gina-fille":
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($request->get("idpere"));
                break;              
        }
        $em->persist($Equipment);
        $em->flush();
        return new Response();
    }



}
