<?php

namespace Etrali\GinangBundle\Controller\Equipment;

use Admingenerated\EtraliGinangBundle\BaseEquipmentController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));     
        return parent::indexAction();
    }
    
    public function getReturnFunction($Equipment)
    {
        return $this->render('EtraliGinangBundle:EquipmentModal:index.html.twig', array(
                    "Equipment" => $Equipment
                ));
    }

    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Equipment $Equipment your \Etrali\GinangBundle\Entity\Equipment object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Equipment $Equipment)
    {
        $em = $this->getDoctrine()->getManager();
        $Equipment->postSave($form,$em);
    }  
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Equipment $Equipment your \Etrali\GinangBundle\Entity\Equipment object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Equipment $Equipment)
    {
        if ($Equipment->getIdCostingEquipmentLine() )
        {        
            foreach ($Equipment->getIdCostingEquipmentLine() as $line)
            {
                $line->setIdEquipment($Equipment);
            }
        }
  
        $session = $this->getRequest()->getSession();         
        if ($session->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {
                case "ui-gina-comp":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                       $Equipment->setIdComplexModel($Pere);
                    break;    
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($idpere);
                   $Equipment->setIdCabinet($Pere);                
                break;
            }
        }         
    }    

}
