<?php

namespace Etrali\GinangBundle\Controller\LocalLoop;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Etrali\GinangBundle\Form\Type\LocalLoop\CustomValidator;
use Etrali\GinangBundle\SendMail;
use Admingenerated\EtraliGinangBundle\BaseLocalLoopController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    protected function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
                 
        return $type;
    }
    

    
    
    public function upgradeAction($pk)
    {
        $bbl = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(34);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(7);        
        $bbl->setIdTransactionType($TransType);
        $bbl->setIdTransactionStatus($TransStatus); 
        $bbl->setIdOldBandwidth($bbl->getIdBandwidth());  
        $bbl->setIdBandwidth(NULL); 
        foreach ($bbl->getIdLocalLoopExtremitytech() as $extr)
        {
            $extr->setDtOldLlTested($extr->getDtLlTested());
            $extr->setDtLlTested(NULL);
            $em->persist($extr);
        }        
        $bbl->setDtInitUpdown(NULL);
        $bbl->setDtRequestedUpdown(NULL);
        $bbl->setDtRealUpdown(NULL);        
        $bbl->setDtScheduledUpdownDelivery(NULL);            
        $bbl->setNbOperation($bbl->getNbOperation()+1);        
        $em->persist($bbl);
        $em->flush();
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_LocalLoop_edit" ,array("pk"=>$pk)));
    }
    
     public function terminateAction($pk)
    {
        $bbl = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(40);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(8);        
        $bbl->setIdTransactionType($TransType);
        $bbl->setIdTransactionStatus($TransStatus);
        $bbl->setNbOperation($bbl->getNbOperation()+1);        
        $em->persist($bbl);
        $em->flush();        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_LocalLoop_edit" ,array("pk"=>$pk)));
    }    
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop your \Etrali\GinangBundle\Entity\LocalLoop object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop)
    {
        $em=$this->getDoctrine()->getManager();
       
       /*** test of LL scheduled delivery ***/
        
        $uow = $em->getUnitOfWork();
        $uow->computeChangeSets();
        $changeset = $uow->getEntityChangeSet($LocalLoop);
      
        $hasit=false;
        $newone=false;
        foreach ($changeset as $fieldname=>$change)
        {
            if ($fieldname=="dtScheduledDelivery")
            {
                $hasit=true;
                if ($change[1]!=NULL && $change[0]==NULL)
                {
                    $newone=true;
                }
                break;
            }
        }
        
        $statuses=array(48,59,70,80,90);        
        if ($hasit)
        {
            foreach ($LocalLoop->getIdLocalLoopExtremityTech() as $tech)
            {
                foreach ($tech->getIdServiceExtremityTech() as $extr)
                {
//                if (in_array($extr->getIdService()->getIdTransactionStatus()->getIdTransactionStatus(),$statuses))
//               {
                    if ($newone)
                        SendMail::send($this,$this->container,"jconan@protego.net",6,array("DATE"=>date("d/m/Y H:i"),"REF"=>$extr->getIdService()->getCdService()));
                    else
                        SendMail::send($this,$this->container,"jconan@protego.net",8,array("DATE"=>date("d/m/Y H:i"),"REF"=>$extr->getIdService()->getCdService()));
//                }            
                }
            }
        }
        $treated=array();
        foreach ($LocalLoop->getIdLocalLoopExtremityTech() as $tech)
        {        
            foreach ($tech->getIdServiceExtremityTech() as $extr)
            {
                $service=$extr->getIdService();
                if (in_array($service->getIdTransactionStatus()->getIdTransactionStatus(),$statuses) && !isset($treated[$service->getIdService()]))            
                {
                    $treated[$service->getIdService()]=1;
                    $completed=true;
                    foreach ($service->getIdServiceExtremityTech() as $extrtech)
                    {
                        if ($extrtech->getIdLocalLoop()==NULL || $extrtech->getIdLocalLoop()->getDtScheduledDelivery()==NULL)
                        {
                            $completed=false;
                            break;
                        }
                    }
                    if ($completed)    
                    {
                        SendMail::send($this,$this->container,"jconan@protego.net",5,array("DATE"=>date("d/m/Y H:i"),"REF"=>$service->getCdService()));                      
                        SendMail::send($this,$this->container,"jconan@protego.net",7,array("DATE"=>date("d/m/Y H:i"),"REF"=>$service->getCdService()));
                        $id_status=$service->getIdTransactionStatus()->getIdTransactionStatus()+1;

                        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                        $service->setIdTransactionStatus($TransStatus);
                        $em->persist($service);

                        $history=new \Etrali\GinangBundle\Entity\ServiceTransactions();
                        $history->setIdService($service);
                        $history->setCdService($service->getCdService());
                        $history->setIdTransactionStatus($TransStatus);
                        $history->setIdTransactionType($service->getIdTransactionType());                      
                        $history->setLbOperation($service->getIdTransactionType()." ".$service->getNbOperation());
                        $em->persist($history);    
                        $em->flush();
                    }
                }            
            }        
        }
    } 
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop your \Etrali\GinangBundle\Entity\LocalLoop object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop)
    {
        $em = $this->getDoctrine()->getManager();         
        if ($LocalLoop->getDtDelivery()!=NULL)
        {
            foreach ($LocalLoop->getIdCostingLocalLoopLine() as $cost)
            {
                if ($cost->getDtStart()==NULL)
                {
                    $cost->setDtStart($LocalLoop->getDtDelivery());
                    $em->persist($cost);
                    
                }
                if ($cost->getDtStartMrc()==NULL)
                {
                    $cost->setDtStartMrc($LocalLoop->getDtDelivery());                        
                    $em->persist($cost);
                }                                          
            }       
            $em->flush();
        }
        $chaineret=CustomValidator::isValidForNextStep($LocalLoop,$this->getDoctrine()->getEntityManager(),$this);
        if ($chaineret=="")
        {
            $id_status=$LocalLoop->getIdTransactionStatus()->getIdTransactionStatus()+1;
            
            $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
            $LocalLoop->setIdTransactionStatus($TransStatus);
            $em->persist($LocalLoop);
            
            $history=new \Etrali\GinangBundle\Entity\LocalLoopTransactions();
            $history->setIdLocalLoop($LocalLoop);
            $history->setCdLocalLoop($LocalLoop->getCdLocalLoop());
            $history->setIdTransactionStatus($TransStatus);
            $history->setIdTransactionType($LocalLoop->getIdTransactionType());                      
            $history->setLbOperation($LocalLoop->getIdTransactionType()." ".$LocalLoop->getNbOperation());
            $em->persist($history); 
            
            switch ($id_status)
            {
                case 23:
                    SendMail::send($this,$this->container,"jconan@protego.net",800,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                    
                    break;                
                case 24:
                    SendMail::send($this,$this->container,"jconan@protego.net",810,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));
                    break;
                case 25:                                     
                    SendMail::send($this,$this->container,"jconan@protego.net",820,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                    
                    break;
                case 26:
                    SendMail::send($this,$this->container,"jconan@protego.net",830,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                                            
                case 27: 
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $LocalLoop->setIdTransactionStatus($TransStatus);
                    $em->persist($LocalLoop); 
                    
                    $history=new \Etrali\GinangBundle\Entity\LocalLoopTransactions();
                    $history->setIdLocalLoop($LocalLoop);
                    $history->setCdLocalLoop($LocalLoop->getCdLocalLoop());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($LocalLoop->getIdTransactionType());                      
                    $history->setLbOperation($LocalLoop->getIdTransactionType()." ".$LocalLoop->getNbOperation()); 
                    $em->persist($history);                                         
                    SendMail::send($this,$this->container,"jconan@protego.net",840,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    SendMail::send($this,$this->container,"jconan@protego.net",1000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                      
                    break;
                case 28:                    
                    break;
                case 29:
                    SendMail::send($this,$this->container,"jconan@protego.net",850,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));     
                    break;
                case 30:
                     SendMail::send($this,$this->container,"jconan@protego.net",860,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    break;
                case 31:
                     SendMail::send($this,$this->container,"jconan@protego.net",870,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    break;
                case 32:
                     SendMail::send($this,$this->container,"jconan@protego.net",880,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                     
                case 33: 
                    
                     $transferExtr=$LocalLoop->getIdTransferExtremity();
                     $transferExtr->setCdLocalLoopExtremityRef(substr($transferExtr->getCdLocalLoopExtremityRef(),0,strlen($transferExtr->getCdLocalLoopExtremityRef())-3));
                     $transferExtr->getIdOldExtremity()->setCdLocalLoopExtremityRef($transferExtr->getIdOldExtremity()->getCdLocalLoopExtremityRef()."Old");
                     $transferExtr->getIdOldExtremity()->setBlTransferred(true);
                     $transferExtr->getIdOldExtremity()->getIdLocalLoopExtremityTech()->setBlTransferred(true); 
                     $transferExtr->setDtTransferComplete($transferExtr->getIdLocalLoopExtremityTech()->getDtLlTested());
                     $transferExtr->getIdOldExtremity()->setDtOldTerminate(clone $transferExtr->getDtTransferComplete()); 
                     $transferExtr->getIdOldExtremity()->getDtOldTerminate()->sub(new \DateInterval('P1D'));                     
                     $em->persist($transferExtr); 
                     $em->persist($transferExtr->getIdOldExtremity()); 
                     
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $LocalLoop->setIdTransactionStatus($TransStatus);
                    $em->persist($LocalLoop); 
                    
                    $history=new \Etrali\GinangBundle\Entity\LocalLoopTransactions();
                    $history->setIdLocalLoop($LocalLoop);
                    $history->setCdLocalLoop($LocalLoop->getCdLocalLoop());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($LocalLoop->getIdTransactionType());                      
                    $history->setLbOperation($LocalLoop->getIdTransactionType()." ".$LocalLoop->getNbOperation()); 
                    $em->persist($history);                      
                     SendMail::send($this,$this->container,"jconan@protego.net",890,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                     SendMail::send($this,$this->container,"jconan@protego.net",1000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                                            
                    break;                
                case 35:                    
                    SendMail::send($this,$this->container,"jconan@protego.net",900,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    break;
                case 36:
                    SendMail::send($this,$this->container,"jconan@protego.net",910,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    break;                
                case 37:
                    SendMail::send($this,$this->container,"jconan@protego.net",920,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    break;
                case 38:
                    SendMail::send($this,$this->container,"jconan@protego.net",930,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));                        

                case 39:                                       
                    SendMail::send($this,$this->container,"jconan@protego.net",940,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));    
                    SendMail::send($this,$this->container,"jconan@protego.net",1000,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop()));  
                    $LocalLoop->setDtRealUpdown(new \DateTime());
                    $id_status+=1;
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $LocalLoop->setIdTransactionStatus($TransStatus);
                    $em->persist($LocalLoop); 
                    
                    $history=new \Etrali\GinangBundle\Entity\LocalLoopTransactions();
                    $history->setIdLocalLoop($LocalLoop);
                    $history->setCdLocalLoop($LocalLoop->getCdLocalLoop());
                    $history->setIdTransactionStatus($TransStatus);                       
                    $history->setIdTransactionType($LocalLoop->getIdTransactionType());                      
                    $history->setLbOperation($LocalLoop->getIdTransactionType()." ".$LocalLoop->getNbOperation()); 
                    $em->persist($history);                     

                    break;
                case 41:
                    SendMail::send($this,$this->container,"jconan@protego.net",950,array("DATE"=>date("d/m/Y H:i"),"REF"=>$LocalLoop->getCdLocalLoop())); 
                    foreach ($LocalLoop->getIdCostingLocalLoopLine() as $cost)
                    {
                        $cost->setDtEnd($LocalLoop->getDtRealTerminate());
                        $em->persist($cost);
                    }
                    break;
                case 42:
                    break;                
            }
            $em->flush();            
        }
        else if ($chaineret!="NA")
            $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );
    }  
    
     public function carrierAction($pk)
    {
        $LocalLoop = $this->getObject($pk);

        if ($LocalLoop && $LocalLoop->getIdProviderOfCarrier()!=NULL) 
            return new Response($LocalLoop->getIdProviderOfCarrier()->getIdProvider()."\n".$LocalLoop->getIdProviderOfCarrier());        
        else
            return new Response("");
            
    }
}
