<?php

namespace Etrali\GinangBundle\Controller\LocalLoop;

use Admingenerated\EtraliGinangBundle\BaseLocalLoopController\ListController as BaseListController;
use Etrali\GinangBundle\Entity\LocalLoop;

class ListController extends BaseListController
{
    public function selectWithNetrecova($query)
    {
        if ($this->get('request')->query->get('isSelect')  && $this->get('request')->query->get('motherid'))
        {
            $em=$this->getDoctrine()->getEntityManager();
            $extr=$em->getRepository('EtraliGinangBundle:ServiceExtremity')->find($this->get('request')->query->get('motherid'));
            
            if ($extr->isNetrecovaConnected())
                $query=$query->innerJoin("q.idLocalLoopType","t")->andWhere("t.idLocalLoopType=5");
            else
                $query=$query->innerJoin("q.idLocalLoopType","t")->andWhere("t.idLocalLoopType<>5");
        }
        
        $lls=$q->getQuery()->getResult();
        $inids=array();
        foreach ($lls as $ll)
        {
            if ($ll->getIdServiceExtremityTech()->count()<$ll->getIdCapacity()->getMaxCapacity())
                $inids[]=$ll->getIdLocalLoop();
        }
        if (count($inids)>0)
            return $query->andWhere("q.idLocalLoop in (".implode(",",$inids).")");
        else
            return $query->andWhere("1=2");                
        return $query;
    }
    
    public function getWithNetrecovaAction()
    {
        $this->addToQuery="selectWithNetrecova";
        return $this->indexAction();
    } 
      
    
    public function buildQuery()
    {
        $query=parent::buildQuery();
        
       if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=LocalLoop::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $query=$query->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }
        
        if ($this->get('request')->query->get('isSelect')  && $this->get('request')->query->get('isSelect')==true)
        {            
                  if ($this->get('request')->query->get('groomed')  && $this->get('request')->query->get('groomed')==1 && $this->get('request')->query->get('myid') )
                  {
                      $ll=$this->getDoctrine()->getRepository('EtraliGinangBundle:LocalLoop')->find($this->get('request')->query->get('myid'));
                      $query=$query->innerJoin("q.idLocalLoopType","t")->andWhere('t.idLocalLoopType=2')->innerJoin('q.idLocalLoopExtremity','ex')->innerJoin('ex.idLocalLoopExtremityOwner','ow')->andWhere('ow.idLocalLoopExtremityOwner=2')->innerJoin("ex.idPop","po");                      
                      $chaine="1=2 ";
                      foreach ($ll->getIdLocalLoopExtremity() as $ex)
                      {
                        if ($ex->getIdLocalLoopExtremityOwner()!=NULL && $ex->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner()==2 && $ex->getIdPop()!=NULL && !$ex->getBlOld())
                        {
                            $chaine.="or (po.idPop=".$ex->getIdPop()->getIdPop()." and ex.idAddressPop='".$ex->getIdAddressPop()->getIdAddressPop()."') ";
                        }
                      }
                      $query=$query->andWhere($chaine);

                  }
                  else  if ($this->get('request')->query->get('backup')  && $this->get('request')->query->get('backup')==1 && $this->get('request')->query->get('myid') )
                  {
                      $ll=$this->getDoctrine()->getRepository('EtraliGinangBundle:LocalLoop')->find($this->get('request')->query->get('myid'));
                      $query=$query->innerJoin("q.idLocalLoopType","t")->andWhere('t.idLocalLoopType=3')->innerJoin('q.idLocalLoopExtremity','ex')->innerJoin('ex.idLocalLoopExtremityOwner','ow')->andWhere('ow.idLocalLoopExtremityOwner=1')->innerJoin("ex.idCustomer","cu");                      
                      $chaine="1=2 ";
                      foreach ($ll->getIdLocalLoopExtremity() as $ex)
                      {
                        if ($ex->getIdLocalLoopExtremityOwner()!=NULL && $ex->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner()==1 && $ex->getIdCustomer()!=NULL && !$ex->getBlOld())
                        {
                            $chaine.="or (cu.idCustomer=".$ex->getIdCustomer()->getIdCustomer()." and ex.idDeliveryAddress='".$ex->getIdDeliveryAddress()->getIdAddress()."') ";
                        }
                      }
                      $query=$query->andWhere($chaine);
                  }
        }
        return $query;
        
    }
    
}