<?php

namespace Etrali\GinangBundle\Controller\LocalLoopExtremityTech;

use Admingenerated\EtraliGinangBundle\BaseLocalLoopExtremityTechController\EditController as BaseEditController;
use Etrali\GinangBundle\Entity\LocalLoopExtremityTech;
use Etrali\GinangBundle\Form\Type\Service\CustomValidator;
use Etrali\GinangBundle\SendMail;
use Symfony\Component\Form\Form;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    } 
               

    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param LocalLoopExtremityTech $LocalLoopExtremityTech your \Etrali\GinangBundle\Entity\LocalLoopExtremityTech object
     */
    public function preSave(Form $form, LocalLoopExtremityTech $LocalLoopExtremityTech)
    {
       $em=$this->getDoctrine()->getManager();
     
        if ($LocalLoopExtremityTech->getIdOutConnectionPath())
        {
            foreach ($LocalLoopExtremityTech->getIdOutConnectionPath() as $line)
            {
                $line->setIdLocalLoopExtremityTech($LocalLoopExtremityTech);
            }
        }

      
       /*** test of LL scheduled delivery ***/
       
        $uow = $em->getUnitOfWork();
        $uow->computeChangeSets();
        $changeset = $uow->getEntityChangeSet($LocalLoopExtremityTech);

        $newone=false;
        foreach ($changeset as $fieldname=>$change)
        {
            if ($fieldname=="dtLlTested")
            {
                if ($change[1]!=NULL && $change[0]==NULL)
                {
                    $newone=true;
                } 
                break;
            }
        }

        if ($newone)
        {
                $treated=array();            
                foreach ($LocalLoopExtremityTech->getIdLocalLoop()->getIdServiceExtremityTech() as $extr)
                {
                    SendMail::send($this,$this->container,"jconan@protego.net",9,array("DATE"=>date("d/m/Y H:i"),"REF"=>$extr->getIdService()->getCdService()));           
                    $Service=$extr->getIdService();
                    /******/
                    $id_status=0;
                    $statuses=array(49,50,51,60,61,62,71,72,73,81,82,83,91,92,93);
                    $endstatus=$Service->getIdTransactionStatus()->getIdTransactionStatus();        
                    if (in_array($Service->getIdTransactionStatus()->getIdTransactionStatus(),$statuses))
                    {
                        /* Notice : $endstatus is passed by reference */

                        $chaineret=CustomValidator::isValidBBFrameToFrame($Service,$em,$this,$endstatus);
                        if ($endstatus!="")
                        {                         
                            $id_status=$endstatus;
                            if (strpos($id_status,":")!==FALSE)
                            {
                                $tab=explode(":",$id_status);
                                foreach ($tab as $ids)
                                {
                                   CustomValidator::handlePostSaveService($Service, $this, $ids,$em,$this->container); 
                                }
                            }
                            else
                                CustomValidator::handlePostSaveService($Service, $this, $id_status,$em,$this->container);                               
                            
                            CustomValidator::handlePostSaveService($Service, $this, $id_status,$em,$this->container);                            
                        }
                    }                    
                }
        }
    } 
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param LocalLoopExtremityTech $LocalLoopExtremityTech your \Etrali\GinangBundle\Entity\LocalLoopExtremityTech object
     */
    public function postSave(Form $form, LocalLoopExtremityTech $LocalLoopExtremityTech)
    {            
        $em=$this->getDoctrine()->getManager();        
        if ($LocalLoopExtremityTech->getLbConnectionPath() != NULL && $LocalLoopExtremityTech->getLbConnectionPath()!="")
        {
            if (strpos($LocalLoopExtremityTech->getLbConnectionPath(),"/vlan:")!==FALSE)
            {
                $tab=explode("/",$LocalLoopExtremityTech->getLbConnectionPath());
                $tab2=explode(":",$tab[0]);
                $portid=$tab2[1];
                
                $tab2=explode(":",$tab[1]);
                $vlanref=$tab2[1];
                
                if ($LocalLoopExtremityTech->getIdVlan()->getLbVlan()!=$vlanref)
                {
                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                    $vlan=new Vlan();
                    $vlan->setIdPortInstance($PortInstance);
                    $vlan->setLbVlan($vlanref);
                    $vlan->setIdInLocalLoopExtremityTech($LocalLoopExtremityTech);
                    $em->persist($vlan);
                }                
            }
            else if (strpos($LocalLoopExtremityTech->getLbConnectionPath(),"/timeslot:")!==FALSE)
            {
                $tab=explode("/",$LocalLoopExtremityTech->getLbConnectionPath());
                $tab2=explode(":",$tab[0]);
                $portid=$tab2[1];
                
                $tab2=explode(":",$tab[1]);
                $ts=$tab2[1];
                
                $timeslots=explode(",",$ts);
                
                $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                foreach ($timeslots as $timeslot)
                {
                        $portts=$PortInstance->getTsByNumber($timeslot);                        
                        $portts->setIdInLocalLoopExtremityTech($LocalLoopExtremityTech);
                }
                $em->persist($portts);                                
            }
            else 
            {
                $tab=explode(":",$LocalLoopExtremityTech->getLbConnectionPath());
                $portid=$tab[1];
                
                $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);

                $LocalLoopExtremityTech->setIdPortInstance($PortInstance);
                $em->persist($LocalLoopExtremityTech);
            }            
        }
        foreach ($LocalLoopExtremityTech->getIdOutConnectionPath() as $path)
        {
            if ($path != NULL && $path!="")
            {
                if (strpos($path,"/vlan:")!==FALSE)
                {
                    $tab=explode("/",$path);
                    $tab2=explode(":",$tab[0]);
                    $portid=$tab2[1];

                    $tab2=explode(":",$tab[1]);
                    $vlanref=$tab2[1];

                    if (!$LocalLoopExtremityTech->hasOutVlan($vlanref))
                    {
                        $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                        $vlan=new Vlan();
                        $vlan->setIdPortInstance($PortInstance);
                        $vlan->setLbVlan($vlanref);
                        $vlan->setIdLocalLoopExtremityTech($LocalLoopExtremityTech);
                        $em->persist($vlan);
                    }                
                }
                else if (strpos($path,"/timeslot:")!==FALSE)
                {
                    $tab=explode("/",$path);
                    $tab2=explode(":",$tab[0]);
                    $portid=$tab2[1];

                    $tab2=explode(":",$tab[1]);
                    $ts=$tab2[1];

                    $timeslots=explode(",",$ts);

                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                    foreach ($timeslots as $timeslot)
                    {
                            $portts=$PortInstance->getTsByNumber($timeslot);                        
                            $portts->setIdLocalLoopExtremityTech($LocalLoopExtremityTech);
                    }
                    $em->persist($portts);                                
                }
                else 
                {
                    $tab=explode(":",$path);
                    $portid=$tab[1];

                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);

                    $LocalLoopExtremityTech->setIdOutPortInstance($PortInstance);
                    $em->persist($LocalLoopExtremityTech);
                }            
            }            
        }        
        if ($LocalLoopExtremityTech->getIdLocalLoop()->getIdTransactionType()->getIdTransactionType()==7 && $LocalLoopExtremityTech->getDtLlTested()!=NULL)            
        {
            foreach ($LocalLoopExtremityTech->getIdLocalLoop()->getIdLocalLoopExtremityTech() as $extr)
            {
                if (!$extr->getBlOld() && $extr->getDtLlTested()==NULL)
                {
                    $extr->setDtLlTested($LocalLoopExtremityTech->getDtLlTested());
                    $em->persist($extr);
                }
            }
        }
        $em->flush();        
    }    
}
