<?php

namespace Etrali\GinangBundle\Controller\Pop;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Admingenerated\EtraliGinangBundle\BasePopController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    
    public function getReturnFunction($pk)
    {
        return new RedirectResponse($this->generateUrl("EtraliGinangBundle_admin_etrali_ginang_bundle_Pop_design" ,array("pk"=>$pk)));
    }
    
    public function designAction($pk)
    {
        $Pop = $this->getObject($pk);

        if (!$Pop) {
            throw new NotFoundHttpException("The Etrali\GinangBundle\Entity\Pop with idPop $pk can't be found");
        }        
        
        return $this->render('EtraliGinangBundle:PopDesign:index.html.twig', array(
            "Pop" => $Pop
        ));
    } 
    
    public function admincontactAction($pk)
    {
        $Pop = $this->getObject($pk);

        if ($Pop) {
            $id_contact="";
            $lb_contact="";
            $nb=0;
            foreach ($Pop->getIdContactPop() as $c)
            {
                if ($c->getBlDeactivated() && $c->getIdContactType()->getCdContactType()=="A")
                {
                    $id_contact=$c->getIdContactPop();
                    $lb_contact=$c;                
                    if ($c->getBlDefault())
                    {
                        $nb=1;
                        break;
                    }
                    else
                        $nb++;
                }
            }
            if ($nb>1)
            {
                $id_contact="";
                $lb_contact="";                
            }
            $id_address="";
            $lb_address="";
            $nb=0;
            foreach ($Pop->getIdAddressPop() as $c)
            {
                if ($c->getBlStatus())
                {
                    $id_address=$c->getIdAddressPop();
                    $lb_address=$c;                
                    if ($c->getIdAddressType()!=NULL && $c->getIdAddressType()->getIdAddressType()==2)
                    {
                        $nb=1;
                        break;
                    }
                    else
                        $nb++;
                }
            }
            if ($nb>1)
            {
                $id_address="";
                $lb_address="";                
            }
            
            return new Response($id_contact."\n".$lb_contact."\n".$id_address."\n".$lb_address);
        }        
        else
            return new Response("");
            
    }     
    
  
    
    public function insertAction(Request $request)
    {
        $typepere=$request->get("typepere");
        $idpere=$request->get("idpere");
        $pk=$request->get("pk");        
        $em=$this->getDoctrine()->getEntityManager();
        $ComplexModel=$em->getRepository('EtraliGinangBundle:ComplexModel')->find($pk);        

        if ($typepere=="ui-gina-cab")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Cabinet')->find($idpere);                    
            if ($ComplexModel->getIdEquipment() && $ComplexModel->getIdEquipment()->count()>0)
            {
                $ac = new ArrayCollection();
                foreach ($ComplexModel->getIdEquipment() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCabinet($Pere);                      
                }                
                $Pere->setIdEquipment($ac);                
            }
            if ($ComplexModel->getIdPatchPanel() && $ComplexModel->getIdPatchPanel()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPatchPanel() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCabinet($Pere);  
                }               
                $Pere->setIdPatchPanel($ac);                
            }            
        }
        else if ($typepere=="ui-gina-equi")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Equipment')->find($idpere);        
            if ($ComplexModel->getIdSlot() && $ComplexModel->getIdSlot()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdSlot() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdEquipment($Pere);  
                }               
                $Pere->setIdSlot($ac);                
            }
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdEquipment($Pere);   
                }              
                $Pere->setIdCard($ac);                
            }             
        }
        else if ($typepere=="ui-gina-patch")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:PatchPanel')->find($idpere);             
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdPatchPanel($Pere);                       
                }                
                $Pere->setIdPort($ac);                
            }
        }
        else if ($typepere=="ui-gina-slots")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Slot')->find($idpere);        
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdSlot($Pere);   
                }                
            }             
            $Pere->setIdCard($ac);            
        }
        else if ($typepere=="ui-gina-fille")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Card')->find($idpere);        
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCard($Pere);                       
                }                
                $Pere->setIdPort($ac);                
            }             
        }
        else if ($typepere=="ui-gina-mere")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Card')->find($idpere);        
            if ($ComplexModel->getIdDaughterCard() && $ComplexModel->getIdDaughterCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdDaughterCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdMotherCard($Pere);                    
                }                
                $Pere->setIdDaughterCard($ac);
            }             
        }        
        else 
        {
            $Pere=$em->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere); 
            if ($ComplexModel->getIdEquipment() && $ComplexModel->getIdEquipment()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdEquipment() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdComplexModel($Pere);
                }                  
                $Pere->setIdEquipment($ac);
            }
            if ($ComplexModel->getIdPatchPanel() && $ComplexModel->getIdPatchPanel()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPatchPanel() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);   
                    $cloneElem->setIdComplexModel($Pere);                    
                }               
                $Pere->setIdPatchPanel($ac);                
            }      
            if ($ComplexModel->getIdSlot() && $ComplexModel->getIdSlot()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdSlot() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem); 
                    $cloneElem->setIdComplexModel($Pere);                    
                }               
                $Pere->setIdSlot($ac);                
            }
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);                    
                    $cloneElem->setIdComplexModel($Pere);                    
                }   
                $Pere->setIdCard($ac);                
            }  
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique(); 
                    $ac->add($cloneElem);
                    $cloneElem->setIdComplexModel($Pere);
                }
                $Pere->setIdPort($ac);
            }                
        }
        $em->persist($Pere);
        $em->flush();

        return new Response();
    }         
        
}
