<?php

namespace Etrali\GinangBundle\Controller\Pop;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Admingenerated\EtraliGinangBundle\BasePopController\ListController as BaseListController;
use Etrali\GinangBundle\Entity\Access;
use Symfony\Component\HttpFoundation\Response;

class ListController extends BaseListController
{
    public function exploreAction()
    {
        $form = $this->getFilterForm();
        $query=$this->getDoctrine()
                    ->getManager()
                    ->getRepository('Etrali\GinangBundle\Entity\Access')
                    ->createQueryBuilder('q')
                    ->orderBy("q.cdAccess", "asc");
        
        $query2=$this->getDoctrine()
                    ->getManager()
                    ->getRepository('Etrali\GinangBundle\Entity\Pop')
                    ->createQueryBuilder('q')
                    ->andWhere("q.idAccess is null")
                    ->orderBy("q.cdPop", "asc");        
        
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=Access::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $query=$query->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
                $query2=$query2->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");                
            }
        }

        return $this->render('EtraliGinangBundle:PopExplore:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Access' => $query->getQuery()->getResult() ,           
            'Pops' => $query2->getQuery()->getResult(),
            'form'=>$form->createView(),
            'popid'=>$this->get('request')->query->has('popid')?$this->get('request')->query->get('popid'):null
        ));
    }
    
    public function getConnectionPath($PortInstance)
    {
        if ($PortInstance->getIdCardInstance()!=NULL)
        {
            $mere=$PortInstance->getIdCardInstance();

            if ($mere->getIdMotherCard() != NULL)
            {
                $card=$mere->getIdMotherCard();
                $mere=$card->getIdSlotInstance();
            }
            $equip=$mere->getIdEquipmentInstance();
        }
        else
        {
            $equip=$PortInstance->getIdPatchPanelInstance();
        }
        $cab=$equip->getIdCabinetInstance(); 

        $pop=$cab->getIdPop();

        $tab=array();

        $type=$PortInstance->getIdCardInstance()!=NULL?"ui-gina-fille":"ui-gina-patch";
        $id=$PortInstance->getIdCardInstance()!=NULL?$PortInstance->getIdCardInstance()->getIdCardInstance():$PortInstance->getIdPatchPanelInstance()->getIdPatchPanelInstance();
        $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$id."&type=".$type."'>".$PortInstance->getIdPortInstance()."</a>";
        if ($PortInstance->getIdCardInstance()!=NULL)
        {
            $mere=$PortInstance->getIdCardInstance();
            if ($mere->getIdCard()->getBlCardForRef())
                $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$mere->getIdCardInstance()."&type=ui-gina-fille'>".$mere->getCdCardInstance()."</a>";        
            if ($mere->getIdMotherCard() != NULL)
            {
                $card=$mere->getIdMotherCard();
                if ($card->getIdCard()->getBlCardForRef())                
                    $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$card->getIdCardInstance()."&type=ui-gina-mere'>".$card->getCdCardInstance()."</a>";        
                $mere=$card->getIdSlotInstance();
                if ($mere->getIdSlot()->getBlSlotForRef())
                    $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$mere->getIdSlotInstance()."&type=ui-gina-slot'>".$mere->getCdSlotInstance()."</a>";                        
            }

            $equip=$mere->getIdEquipmentInstance();
            $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$equip->getIdEquipmentInstance()."&type=ui-gina-equi'>".$equip->getCdEquipmentInstance()."</a>";                    
            
        }
        else
        {
            $equip=$PortInstance->getIdPatchPanelInstance();
            if ($equip->getIdPatchPanel()->getBlPanelForRef())
                $tab[]="<a target='_blank'  href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."?openid=".$equip->getIdPatchPanelInstance()."&type=ui-gina-patch'>".$equip->getCdPatchPanelInstance()."</a>"; 
        }
        $cab=$equip->getIdCabinetInstance();                   
        
        $pop=$cab->getIdPop();
        $tab[]="<a target='_blank' href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."'>".$pop->getCdPop()."</a>";                     
        if ($pop->getIdAccess()!=NULL)
        {
            $access=$pop->getIdAccess();
            $tab[]="<a target='_blank' href='".$this->generateUrl('Etrali_GinangBundle_Pop_design',array('pk'=>$pop->getIdPop()))."'>".$access->getCdAccess()."</a>"; 
        }
        
        $tab=array_reverse($tab);
        $chaine=implode(" / ",$tab);
        return $chaine;
    }
    
    public function selectVlanAction()
    {
        if ($this->get('request')->query->has('portid') && $this->get('request')->query->has('vlanref'))
        {
            $em = $this->getDoctrine()->getManager();         
            $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($this->get('request')->query->get('portid'));
            
            $connpath=$this->getConnectionPath($PortInstance); 
            $connpath.=" / VLAN".$this->get('request')->query->get('vlanref');
            $innerconnpath="port:".$PortInstance->getIdPortInstance()."/vlan:".$this->get('request')->query->get('vlanref');              
            
            return new Response("<script>window.parent.closeModal('".$this->get('request')->query->get('winid')."','".$innerconnpath."',\"".$connpath."\");</script>");           
        }
    }
    
    public function selectPortAction()
    {
        if ($this->get('request')->query->has('portid'))
        {
            $em = $this->getDoctrine()->getManager();         
            $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($this->get('request')->query->get('portid'));
            
            $connpath=$this->getConnectionPath($PortInstance);   
            $innerconnpath="port:".$PortInstance->getIdPortInstance();             
            
            return new Response("<script>window.parent.closeModal('".$this->get('request')->query->get('winid')."','".$innerconnpath."',\"".$connpath."\");</script>");           
        }
    }   
    
    public function selectTsAction()
    {
        if ($this->get('request')->query->has('portid'))
        {
            $em = $this->getDoctrine()->getManager();         
            $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($this->get('request')->query->get('portid'));
            
            $connpath=$this->getConnectionPath($PortInstance); 
            $slots=$this->get('request')->request->get('ts');
            $chaine=implode(",",$slots);
            $connpath.=" / ".$chaine; 
            $innerconnpath="port:".$PortInstance->getIdPortInstance()."/timeslot:".$chaine; 
            
            return new Response("<script>window.parent.closeModal('".$this->get('request')->query->get('winid')."','".$innerconnpath."',\"".$connpath."\");</script>");           
        }
    }      
    
    public function portmapAction()
    {     
          
        
        $query=$this->getDoctrine()
                    ->getManager()
                    ->getRepository('Etrali\GinangBundle\Entity\Pop')
                    ->createQueryBuilder('q')
                    ->orderBy("q.cdPop", "asc");         
       $pops=array();
       if ($this->get('request')->query->has('motherentity') && $this->get('request')->query->get('motherentity')!="" && $this->get('request')->query->has('motherid') && $this->get('request')->query->get('motherid')!="")
       {
            $em = $this->getDoctrine()->getManager();         
            $LocalLoop=$em->getRepository('EtraliGinangBundle:LocalLoop')->find($this->get('request')->query->get('motherid'));              
            foreach ($LocalLoop->getIdLocalLoopExtremityTech() as $extr)
            {
                if ($extr->getIdPop()!=NULL)
                    $pops[]=$extr->getIdPop()->getIdPop();
            }
                
       }           
        if (count($pops)>0)
            $query=$query->andWhere("q.idPop in (".implode(",",$pops).")");           
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=Access::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $query=$query->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");                
            }
        }

        return $this->render('EtraliGinangBundle:PopPortmap:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Pops' => $query->getQuery()->getResult(),
            'popid'=>$this->get('request')->query->has('popid')?$this->get('request')->query->get('popid'):null,
            'motherentity'=>$this->get('request')->query->get('motherentity'),
            'isSelect'=>$this->get('request')->query->get('isSelect'),            
            'motherid'=>$this->get('request')->query->has('motherid')?$this->get('request')->query->get('motherid'):null
        ));
    }
    
    public function filtersAction()
    {
        if ($this->get('request')->get('reset')) {
            $this->setFilters(array());

            if ($this->get('request')->get('explorer')) 
                return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Pop_list")."explore");
            else
                return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Pop_list"));
        }

        if ($this->getRequest()->getMethod() == "POST") {
            $form = $this->getFilterForm();
            $form->bind($this->get('request'));

            if ($form->isValid()) {
                $filters = $form->getClientData();
            }
        }

        if ($this->getRequest()->getMethod() == "GET") {
            $filters = $this->getRequest()->query->all();
        }

        if (isset($filters)) {
            $this->setFilters($filters);
        }
        if ($this->get('request')->get('explorer')) 
            return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Pop_list")."explore");
        else
            return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Pop_list"));
    }
    
    public function selectWithDeliveryAndAdmin($query)
    {
        $query=$query->innerJoin("q.idAddressPop","a")->innerJoin("a.idAddressType","at")->andWhere("at.idAddressType=2")->andWhere("a.blStatus=1");
        $query=$query->innerJoin("q.idContactPop","c")->innerJoin("c.idContactType","ct")->andWhere("ct.idContactType=2")->andWhere("c.blDeactivated=1");        
        return $query;
    }
    
    public function getWithAddrAndContactAction()
    {
        $this->addToQuery="selectWithDeliveryAndAdmin";
        return $this->indexAction();
    }    
     
    public function buildQuery()
    {
        $q=parent::buildQuery();
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR" && ($this->getRequest()->get('tag')==NULL || $this->getRequest()->get('tag')!='BackboneLink'))
        {
            $modifiers=Access::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $q=$q->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }
        return $q;
    }
}
