<?php

namespace Etrali\GinangBundle\Controller\Port;

use Admingenerated\EtraliGinangBundle\BasePortController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));    
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));          
        return parent::indexAction();
    }
    
    public function getReturnFunction($Port)
    {
        $session = $this->getRequest()->getSession();        
        return $this->render('EtraliGinangBundle:PortModal:index.html.twig', array(
                    "Ports" => $this->ports
                ));
    }
    /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Port $Port your \Etrali\GinangBundle\Entity\Port object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Port $Port)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $session = $this->getRequest()->getSession(); 
        $nombre=$session->get('nombre');
        $ports=array();
        $ports[]=$Port;

        if ($nombre>1)
        {
            for ($i=1;$i<$nombre;$i++)
            {
                $sl=clone $Port;
                if ($session->has('typepere') && $session->has('idpere'))
                {
                    $type_pere=$session->get('typepere');
                    $idpere=$session->get('idpere');
                    switch ($type_pere)
                    {  
                    case "ui-gina-patch":
                           $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($idpere);
                           $sl->setIdPatchPanel($Pere);                                
                        break;
                    case "ui-gina-fille":            
                           $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($idpere);
                           $sl->setIdCard($Pere);                                
                        break;            
                    }
                }                 
                $em->persist($sl);

                $ports[]=$sl;
            }
            $em->flush();              
        }  

       

        
        $this->ports=$ports;        
        $Card=$Port->getIdCard();        
        $nb=1;
        if ($Card!=NULL)
        {
            foreach ($Card->getIdPort() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }          

        }
        $PatchPanel=$Port->getIdPatchPanel();        
        $nb=1;
        if ($PatchPanel!=NULL)
        {
            foreach ($PatchPanel->getIdPort() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }          
        }   
        $em->flush();        
    }   
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Port $Port your \Etrali\GinangBundle\Entity\Port object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Port $Port)
    {
        $session = $this->getRequest()->getSession();         
        if ($session->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {  
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($idpere);
                   $Port->setIdPatchPanel($Pere);                                
                break;
            case "ui-gina-fille":            
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($idpere);
                   $Port->setIdCard($Pere);                                
                break;            
            }
        }           
    }           
}
