<?php

namespace Etrali\GinangBundle\Controller;

use Etrali\GinangBundle\EtraliGinangBundle;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingPendingServicesType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingLocalLoopOptionsFrenchLLType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingLocalLoopType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingServicesStatusPeriodType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingLocalLoopConnectedServicesType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingAllServicesPerCustomerType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingLocalLoopCostCentralType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingTransferPriceCustomerBillingBranchType;
use Etrali\GinangBundle\Form\Type\Reporting\ReportingLocalLoopToCustomerBillingBranchType;
use Symfony\Component\HttpFoundation\Response;


class ReportingController extends Controller
{   
    const STATUS_SERVICE_IN_SERVICE = 54;
    const STATUS_SERVICE_TERMINATED = 108;   
    const SERVICES_MULTIPOINT_PRODUCT_CARACS = 13; 
    const SERVICES_MULTIPOINT_PRODUCT_CARACS_VALEUR = 1; 
    const TYPE_SHEET_IN_SERVICE = 0;  
    const TYPE_SHEET_TERMINATED = 1;  
    const TYPE_SHEET_TERMINATED_MULTIPOINT = 3; 
    const OWNER_CUSTOMER = 1;
    const OWNER_POP = 2;
    const OWNER_PROVIDER = 3;
    const ADDRESS_TYPE_BILLING = 3;
    const NAME_SHEET_LL_COST_CENTRAL0 = 'Existing_services_or_existing_extremities_in_Multipoint_services';
    const NAME_SHEET_LL_COST_CENTRAL1 = 'New_service_or_New extremities';
    const NAME_SHEET_LL_COST_CENTRAL2 = 'Extremity_transferred';
    const NAME_SHEET_LL_COST_CENTRAL3 = 'Service_up_down_or_Extremity_up_downgrade';
    const NAME_SHEET_LL_COST_CENTRAL4 = 'Extremity_terminated_or_Service_terminated';
       
    private $TotalMTcost = array();
    private $Excel;
    private $nbLLMax = 0;


    /**
     * 
     * @param array $idBranches
     * @return array
     */ 
    public function CustomerAddressServiceMultipoint($idBranches){
        $customers = array();
        
        $query = $this->getDoctrine()
                            ->getManager()
                            ->getRepository('Etrali\GinangBundle\Entity\ServiceExtremity')
                            ->createQueryBuilder('se');
        
        $query = $query->innerJoin("se.idCustomer", "c");
        
        $query = $query->innerJoin("se.idServiceExtremityOwner", "seo");
        $query = $query->andWhere("seo.idLocalLoopExtremityOwner = :ownerCustomer");
        $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);
        
        $query = $query->innerJoin('se.idService', 's');
               
        if(!empty($idBranches)){  
            $query = $query->innerJoin('s.idBranch', 'b');
            $query = $query->andWhere("b.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', $idBranches);
        }
        
        $result = $query->getQuery()->getResult();
        foreach ($result as $serviceExtremity) {
            $service = $serviceExtremity->getIdService();
            if(count($service->getIdServiceExtremity())==2){
                
               $idCustomer = $serviceExtremity->getIdCustomer()->getIdCustomer();
               $idAddress  = $serviceExtremity->getIdDeliveryAddress()->getIdAddress();
               
               if(!isset($customers[$idCustomer])){
                   $customers[$idCustomer] = array( 
                                                    'Address' => array(),
                                                    'label' => "".$serviceExtremity->getIdCustomer()
                                                  );
               }              
               $customers[$idCustomer]['Address'][$idAddress] = "".$serviceExtremity->getIdDeliveryAddress();                                                                     
            }
        } 
        return $customers;
    } 
    
    /**
     * 
     * @param string &$val
     */
    public function ValueGetTheFormArrayAjax(&$val){
        if($val != "null")
            $val = explode(",", $val);
        else 
            $val = null;
    }
      
    /**
     * 
     * @param string $idBranches
     * @return \Symfony\Component\HttpFoundation\Response
     */    
    public function AjaxOfCustomerBranchAction($idBranches){
        $this->ValueGetTheFormArrayAjax($idBranches);                      
        $customers = $this->CustomerAddressServiceMultipoint($idBranches);  
        
        $customersResult = "";        
        foreach ($customers as $key => $value) {
           $customersResult .= $key.','.$value['label'].'!'; 
        } 
        
        if(count($customers))
            return new Response(substr($customersResult,0,strlen($customersResult)-1));
        
        return new Response($customersResult);
    }
    
  
    public function AjaxOfDeliveryAddressCustomerAction($idCustomers, $idBranches){
        $this->ValueGetTheFormArrayAjax($idBranches);
        $this->ValueGetTheFormArrayAjax($idCustomers);            
        $customers = $this->CustomerAddressServiceMultipoint($idBranches);
        
        $AddressResult = ""; 
        foreach ($customers as $key => $value) {
            if(in_array($key , $idCustomers)){
                foreach ($value['Address'] as $keyAddress => $valueAddress) 
                    $AddressResult .= $keyAddress.','.$valueAddress.'!';
                
            }
        } 
        
        if(count($customers))
            return new Response(substr($AddressResult,0,strlen($AddressResult)-1));
        
        return new Response($AddressResult);        
    }
    
    public function reportingTransferPriceCustomerBillingBranchAction(){
        $form = $this->createForm(new ReportingTransferPriceCustomerBillingBranchType, null);
        $request = $this->get('request');

        if ($request->getMethod() == 'POST') {          
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_transfer_price_customer_billing_branch']))
                $post = $_POST['etrali_ginangBundle_reporting_transfer_price_customer_billing_branch'];

            $lists = $this->queryFormTransferPriceCustomerBillingBranch($post); 
            
            $sheetParametre = array(); 
            
            $i = 0;
            foreach ($lists as $key => $value) {
                $parametre = array('list'=>$value, 'title'=>$key, 'numeroSheet' => $i, 'totalSheet' => count($lists));
                $sheetParametre[] = array(
                                         'method_name'=> 'createdSheetTransferPriceCustomerBillingBranch',
                                         'title'=> str_replace('_',' ',substr($key,0,30)),
                                         'list'=> $parametre
                                      );
                $i++;
            }                                                                                         
            return $this->export($post, "Repatriate  Transfer price per Customer Billing Branch", $sheetParametre);                
        } 

        return $this->render('EtraliGinangBundle:Reporting:reportingTransferPriceCustomerBillingBranch.html.twig', array(
          'form' => $form->createView(),
        ));       
        
        
    }
    
    /**
     * 
     * @return type
     */
    public function reportingAllServicesPerCustomerAction(){
        $repositoryCustomer = $this->getDoctrine()
                  ->getManager()
                  ->getRepository('EtraliGinangBundle:Customer');
        $form = $this->createForm(new ReportingAllServicesPerCustomerType, null);
        $request = $this->get('request');
        
        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_all_services_per_customer']))
                $post = $_POST['etrali_ginangBundle_reporting_all_services_per_customer'];
            
            $customers = $this->queryFormAllServicesPerCustomer($post);  
            $sheetParametre = array();
            
            if(count($customers)){
                foreach ($customers as $key => $customer)
                    $sheetParametre[] = array(
                                                'method_name'=>'createdSheetAllServicesPerCustomer',
                                                'title'=> $repositoryCustomer->find($key)->getLbCustomer(),
                                                'list'=> $customer
                                              );
            }else
                $sheetParametre[] = array(
                                            'method_name'=>'createdSheetAllServicesPerCustomer',
                                            'title'=> "No results",
                                            'list'=> array()
                                          );
            
            return $this->export($post, "XLS Export: All services per customer: Data extraction date ".date("d-m-Y"), $sheetParametre);                
        } 
        
        return $this->render('EtraliGinangBundle:Reporting:reportingAllServicesPerCustomer.html.twig', array(
          'form' => $form->createView(),
        ));       
    }
    
    /**
     * 
     * @return type
     */   
    public function reportingLocalLoopCostCentralAction(){
        $form = $this->createForm(new ReportingLocalLoopCostCentralType, null);
        $request = $this->get('request');

        if ($request->getMethod() == 'POST') {          
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_local_loop_cost_central']))
                $post = $_POST['etrali_ginangBundle_reporting_local_loop_cost_central'];

            $serviceExtremitys = $this->queryFormLocalLoopCostCentral($post); 
            
            $sheetParametre = array(); 
            foreach ($serviceExtremitys as $key => $value) {
                $parametre = array('list'=>$value, 'title'=>$key);
                $sheetParametre[] = array(
                                         'method_name'=> 'createdSheetLocalLoopCostCentral',
                                         'title'=> str_replace('_',' ',substr($key,0,30)),
                                         'list'=> $parametre
                                      ); 
            }
            return $this->export($post, "Repatriate Local Loop Cost to Central", $sheetParametre);            
        } 

        return $this->render('EtraliGinangBundle:Reporting:reportingLocalLoopCostCentral.html.twig', array(
          'form' => $form->createView(),
        ));       
    }
    
    /**
     * 
     * @return type
     */   
    public function reportingLocalLoopToCustomerBillingBranchAction(){
        $form = $this->createForm(new ReportingLocalLoopToCustomerBillingBranchType, null);
        $request = $this->get('request');

        if ($request->getMethod() == 'POST') {          
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_local_loop_to_customer_billing_branch']))
                $post = $_POST['etrali_ginangBundle_reporting_local_loop_to_customer_billing_branch'];

            $lists = $this->queryFormLocalLoopToCustomerBillingBranch($post); 
            
            $sheetParametre = array();
            $i = 0;
            foreach ($lists as $key => $value) {
                $parametre = array('list'=>$value, 'title'=>$key, 'numeroSheet' => $i, 'totalSheet' => count($lists));
                $sheetParametre[] = array(
                                         'method_name'=> 'createdSheetLocalLoopToCustomerBillingBranch',
                                         'title'=> substr($key,0,30),
                                         'list'=> $parametre                                        
                                      ); 
                $i++;
            }                                 
            return $this->export($post, "Rebilling of LL to Customer Billing Branch", $sheetParametre);            
        } 

        return $this->render('EtraliGinangBundle:Reporting:reportingLocalLoopToCustomerBillingBranch.html.twig', array(
          'form' => $form->createView(),
        ));       
    }
    
    /**
     * 
     * @return type
     */   
    public function reportingLocalLoopConnectedServicesAction(){
        $form = $this->createForm(new ReportingLocalLoopConnectedServicesType, null);
        $request = $this->get('request');

        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_local_loop_connected_services']))
                $post = $_POST['etrali_ginangBundle_reporting_local_loop_connected_services'];

            $localLoops = $this->queryFormLocalLoopConnectedServices($post); 
            
            $sheetParametre = array();
            
            if(count($localLoops)){
                foreach ($localLoops as $localLoop)
                    $sheetParametre[] = array(
                                                'method_name'=> 'createdSheetLocalLoopConnectedServices',
                                                'title'=> ''.$localLoop->getCdLocalLoop(),
                                                'list'=> $localLoop
                                              );
            }else
                $sheetParametre[] = array(
                                            'method_name'=> 'createdSheetLocalLoopConnectedServices',
                                            'title'=> "No results",
                                            'list'=> array()
                                          );
            
            return $this->export($post, "Local Loop Report with Connected Services: Data extraction date ".date("d-m-Y"), $sheetParametre);                
        } 

        return $this->render('EtraliGinangBundle:Reporting:reportingLocalLoopConnectedServices.html.twig', array(
          'form' => $form->createView(),
        ));       
    }
    
    /**
     * 
     * @return type
     */
    public function reportingLocalLoopAction(){
        $form = $this->createForm(new ReportingLocalLoopType, null);
        $request = $this->get('request');
        
        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_local_loop']))
                $post = $_POST['etrali_ginangBundle_reporting_local_loop'];
            
            $localLoops = $this->queryFormLocalLoop($post);             
            $sheetParametre = array(0 =>array(  'method_name'=>'createdSheetLocalLoop',
                                                'title'=>'Local Loop Report',
                                                'list'=>$localLoops
                                              ));
            return $this->export($post, "XLS Export of Local Loop Report: Data extraction date ".date("d-m-Y"), $sheetParametre);                
        } 
        
        return $this->render('EtraliGinangBundle:Reporting:reportingLocalLoop.html.twig', array(
          'form' => $form->createView(),
        ));       
    }
    
    /**
     * 
     * @return type
     */
    public function reportingPendingServicesAction(){
        
        $form = $this->createForm(new ReportingPendingServicesType, null);
        $request = $this->get('request');
        $post = array();
        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            if(isset($_POST['etrali_ginangBundle_reporting_pending_services']))
                $post = $_POST['etrali_ginangBundle_reporting_pending_services']; 
            
            $services = $this->queryFormPendingServices($post);  
            $sheetParametre = array( 0 =>array( 'method_name'=>'createdSheetPendingServices',
                                                'title'=>'Pending Service',
                                                'list'=>$services
                                               ));
            return $this->export($post, "XLS Export of PEDING SERVICES ".date("d-m-Y"), $sheetParametre); 
            
        } 
        
        return $this->render('EtraliGinangBundle:Reporting:reportingPendingServices.html.twig', array(
          'form' => $form->createView(),
        ));
    }
    
    /**
     * 
     * @return type
     */
    public function reportingLocalLoopOptionsFrenchLLAction(){
        
        $form = $this->createForm(new ReportingLocalLoopOptionsFrenchLLType, null);
        $request = $this->get('request');
        
        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            $post =array();
            if(isset($_POST['etrali_ginangBundle_reporting_local_loop_options_french_ll']))
                $post = $_POST['etrali_ginangBundle_reporting_local_loop_options_french_ll'];
            
            $localLoops = $this->queryFormLocalLoopOptionsFrenchLL($post);             
            $sheetParametre = array(0 =>array(  'method_name'=>'createdSheetLocalLoopOptionsFrenchLL',
                                                'title'=>'LL Report with Options +French',
                                                'list'=>$localLoops
                                              ));
            return $this->export($post, "XLS Export of Local Loop Report with Options and French LL: Data extraction date ".date("d-m-Y"), $sheetParametre);    
            
        } 
        
        return $this->render('EtraliGinangBundle:Reporting:reportingLocalLoopOptionsFrenchLL.html.twig', array(
          'form' => $form->createView(),
        ));
    }
    
    /**
     * 
     * @return type
     */
    public function reportingServicesStatusInServiceAction(){
        
        $form = $this->createForm(new ReportingServicesStatusPeriodType, null);
        $request = $this->get('request');
        
        if ($request->getMethod() == 'POST') {
            //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
            $post = $_POST['etrali_ginangBundle_reporting_services_status_period'];
            $services = $this->queryFormServicesStatus($post, ReportingController::STATUS_SERVICE_IN_SERVICE);            
            $sheetParametre = array(0 =>array(
                                                'method_name'=>'createdSheetServiceInService',
                                                'title'=>'Service',
                                                'list'=>$services
                                             ));
            return $this->export($post, "XLS Export of Services switched into 'In service' status  in a selected period", $sheetParametre);           
        } 
        
        return $this->render('EtraliGinangBundle:Reporting:reportingServicesStatusInService.html.twig', array(
          'form' => $form->createView(),
        ));
    }
    
    /**
     * 
     * @return type
     */
    public function reportingServicesStatusTerminatedAction(){

       $form = $this->createForm(new ReportingServicesStatusPeriodType, null);
       $request = $this->get('request');

       if ($request->getMethod() == 'POST') {
           //$post = $this->get('request')->query->get('etrali_ginangBundle_reporting_services_status_period');
           $post = $_POST['etrali_ginangBundle_reporting_services_status_period'];
           $servicesTerminations = $this->queryFormServicesStatus($post, ReportingController::STATUS_SERVICE_TERMINATED);                   
           $extremityTerminationsMultipoint = $this->queryFormExtremityTerminationsMultipoint($post);  
           
           $sheetParametre = array(
                                    0 => array(  
                                                 'method_name' => 'createdSheetServiceTerminated',
                                                 'title' => 'Service terminations',
                                                 'list' => $servicesTerminations
                                              ),
                                    1 => array(  
                                                 'method_name' => 'createdSheetExtremityTerminatedMultipoint',
                                                 'title' => 'Multip extremity terminations',
                                                 'list' => $extremityTerminationsMultipoint
                                              )
                                   );
           return $this->export($post, "XLS Export of Services switched into terminated status  in a selected period", $sheetParametre);
       } 

       return $this->render('EtraliGinangBundle:Reporting:reportingServicesStatusTerminated.html.twig', array(
         'form' => $form->createView(),
       ));
    }
    
    /**
     * 
     * @return type
     */    
    public function queryFormLocalLoopToCustomerBillingBranch(){      
        $resultServices = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());
        $result = array();
        
        $em = $this->getDoctrine()->getManager();
        
        $servicesAll = $em->getRepository('EtraliGinangBundle:Service')->findAll();
                

        foreach ($servicesAll as $s )            
        {            
            $query = $em->createQueryBuilder();      
            $query = $query->select('ts.idTransactionStatus AS idStatus');
            $query = $query->from('EtraliGinangBundle:ServiceTransactions','st'); 
            $query = $query->innerJoin('st.idTransactionStatus','ts');        
            $query = $query->innerJoin('st.idService','s');                    
            $query = $query->where('ts.idTransactionStatus IN (:statusTermine)');
            $query = $query->setParameter('statusTermine', array(54, 96, 65, 75, 85, 99, 108));
            $query = $query->orderBy('st.dtCreate','desc');
            $query = $query->andwhere('s.idService=:identService');
            $query = $query->setParameter('identService',$s->getIdService());            
            $query = $query->setMaxResults(1);
            
            if( isset($post['billingPeriodMois']) && !empty($post['billingPeriodMois']) && isset($post['billingPeriodAnnee']) && !empty($post['billingPeriodAnnee']) ){ 
                $query = $query->andWhere('st.dtCreate < :dateFin');
                $query = $query->andWhere('st.dtCreate >= :dateBegin');            
                $billingPeriodBegin = "{$post['billingPeriodAnnee']}-{$post['billingPeriodMois']}-01";
                $date = new \DateTime($billingPeriodBegin);
                $date->add(new  \DateInterval('P1M'));
                $billingPeriodFin = $date->format('Y-m-d'); 
                $query = $query->setParameter('dateFin',$billingPeriodFin);
                $query = $query->setParameter('dateBegin',$billingPeriodBegin);
            }
            
            $resultQuery = $query->getQuery()->getResult();
            
            if (count($resultQuery)>0)
            {
                $val=$resultQuery[0];
            
                if( $val['idStatus']== 54 || $val['idStatus']== 96 )
                      $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL1][] = $s;                  
                elseif($val['idStatus']== 65)
                    $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL2][] = $s;  
                    elseif($val['idStatus']== 75 || $val['idStatus']== 85 )
                        $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL3][] = $s;
                        elseif($val['idStatus']== 99 || $val['idStatus']== 108 )
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL4][] = $s;    
                        else              
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL0][] = $s;                    
            }
        }
        
        foreach($resultServices as $category => $services){
            foreach($services as $service){
                foreach($service->getIdServiceExtremity() as $serviceExtremity){ 
                   $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
                   if(isset($post['customerBillingBranch']) && !empty($post['customerBillingBranch'])){                    
                        if($serviceExtremityTech){
                           $localLoop = $serviceExtremityTech->getIdLocalLoop();                  
                           if($localLoop && $localLoop->getIdBranch() && in_array($localLoop->getIdBranch()->getIdBranch(), array_values($post['customerBillingBranch']))){                             
                               if(!isset($result[str_replace(' ','_',$localLoop->getIdBranch())]))
                                   $result[str_replace(' ','_',$localLoop->getIdBranch())] = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());
                               
                               $result[str_replace(' ','_',$localLoop->getIdBranch())][$category][] = $serviceExtremity;
                               
                           }
                        }
                    }
                    else{
                       $localLoop = $serviceExtremityTech->getIdLocalLoop();
                       if($localLoop && $localLoop->getIdBranch()){
                            if(!isset($result[str_replace(' ','_',$localLoop->getIdBranch())]))
                                    $result[str_replace(' ','_',$localLoop->getIdBranch())] = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());

                            $result[str_replace(' ','_',$localLoop->getIdBranch())][$category][] = $serviceExtremity;
                           }
                    }
                }                
            }           
        }
        $this->nbLLMax = count($result); 
        return $result;          
    }
    
    /**
     * 
     * @return type
     */    
    public function queryFormTransferPriceCustomerBillingBranch(){      
        $resultServices = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());
        $result = array();
        
        $em = $this->getDoctrine()->getManager();
        
        $servicesAll = $em->getRepository('EtraliGinangBundle:Service')->findAll();
                

        foreach ($servicesAll as $s )            
        {            
            $query = $em->createQueryBuilder();      
            $query = $query->select('ts.idTransactionStatus AS idStatus');
            $query = $query->from('EtraliGinangBundle:ServiceTransactions','st'); 
            $query = $query->innerJoin('st.idTransactionStatus','ts');        
            $query = $query->innerJoin('st.idService','s');                    
            $query = $query->where('ts.idTransactionStatus IN (:statusTermine)');
            $query = $query->setParameter('statusTermine', array(54, 96, 65, 75, 85, 99, 108));
            $query = $query->orderBy('st.dtCreate','desc');
            $query = $query->andwhere('s.idService=:identService');
            $query = $query->setParameter('identService',$s->getIdService());            
            $query = $query->setMaxResults(1);
            
            if( isset($post['billingPeriodMois']) && !empty($post['billingPeriodMois']) && isset($post['billingPeriodAnnee']) && !empty($post['billingPeriodAnnee']) ){ 
                $query = $query->andWhere('st.dtCreate < :dateFin');
                $query = $query->andWhere('st.dtCreate >= :dateBegin');            
                $billingPeriodBegin = "{$post['billingPeriodAnnee']}-{$post['billingPeriodMois']}-01";
                $date = new \DateTime($billingPeriodBegin);
                $date->add(new  \DateInterval('P1M'));
                $billingPeriodFin = $date->format('Y-m-d'); 
                $query = $query->setParameter('dateFin',$billingPeriodFin);
                $query = $query->setParameter('dateBegin',$billingPeriodBegin);
            }
            
            $resultQuery = $query->getQuery()->getResult();
            
            if (count($resultQuery)>0)
            {
                $val=$resultQuery[0];
            
                if( $val['idStatus']== 54 || $val['idStatus']== 96 )
                      $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL1][] = $s;                  
                elseif($val['idStatus']== 65)
                    $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL2][] = $s;  
                    elseif($val['idStatus']== 75 || $val['idStatus']== 85 )
                        $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL3][] = $s;
                        elseif($val['idStatus']== 99 || $val['idStatus']== 108 )
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL4][] = $s;    
                        else              
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL0][] = $s;                    
            }
        }
        
        foreach($resultServices as $category => $services){
            foreach($services as $service){
                foreach($service->getIdServiceExtremity() as $serviceExtremity){ 
                    $billingServiceActive = $serviceExtremity->getBillingServiceActive();
                    if($billingServiceActive){
                        if(isset($post['customerBillingBranch']) && !empty($post['customerBillingBranch'])){                    
                             if($billingServiceActive){
                                $customer = $billingServiceActive->getIdCustomer();                  
                                if($customer && $customer->getIdBranch() && in_array($customer->getIdBranch()->getIdBranch(), array_values($post['customerBillingBranch']))){                             
                                    if(!isset($result[str_replace(' ','_',$customer->getIdBranch())]))
                                        $result[str_replace(' ','_', $customer->getIdBranch())] = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());

                                    $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['service'] = $service;
                                    $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['customer'][$customer->getIdCustomer] = $customer;
                                    $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['serviceExtremity'][$serviceExtremity->getIdServiceExtremity()] = $serviceExtremity;

                                }
                             }
                         }
                         else{
                            $customer = $billingServiceActive->getIdCustomer();
                            if($customer && $customer->getIdBranch()){
                                 if(!isset($result[str_replace(' ','_',$customer->getIdBranch())]))
                                         $result[str_replace(' ','_',$customer->getIdBranch())] = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());

                                 $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['service'] = $service;
                                 $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['customer'][$customer->getIdCustomer()] = $customer;
                                 $result[str_replace(' ','_', $customer->getIdBranch())][$category][$service->getIdService()]['serviceExtremity'][$serviceExtremity->getIdServiceExtremity()] = $serviceExtremity;
                            }
                         }
                    }                                      
                 }                
            }           
        }
        $this->nbLLMax = count($result); 
        return $result;          
    }
    
    
    /**
     * 
     * @param type $post
     * @return type
     */
    public function queryFormLocalLoopCostCentral($post){
        $resultServices = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());
        $result = array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => array(), ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => array());
        
        $em = $this->getDoctrine()->getManager();
        
        $servicesAll = $em->getRepository('EtraliGinangBundle:Service')->findAll();
                

        foreach ($servicesAll as $s )            
        {            
            $query = $em->createQueryBuilder();      
            $query = $query->select('ts.idTransactionStatus AS idStatus');
            $query = $query->from('EtraliGinangBundle:ServiceTransactions','st'); 
            $query = $query->innerJoin('st.idTransactionStatus','ts');        
            $query = $query->innerJoin('st.idService','s');                    
            $query = $query->where('ts.idTransactionStatus IN (:statusTermine)');
            $query = $query->setParameter('statusTermine', array(54, 96, 65, 75, 85, 99, 108));
            $query = $query->orderBy('st.dtCreate','desc');
            $query = $query->andwhere('s.idService=:identService');
            $query = $query->setParameter('identService',$s->getIdService());            
            $query = $query->setMaxResults(1);
            
            if( isset($post['billingPeriodMois']) && !empty($post['billingPeriodMois']) && isset($post['billingPeriodAnnee']) && !empty($post['billingPeriodAnnee']) ){ 
                $query = $query->andWhere('st.dtCreate < :dateFin');
                $query = $query->andWhere('st.dtCreate >= :dateBegin');            
                $billingPeriodBegin = "{$post['billingPeriodAnnee']}-{$post['billingPeriodMois']}-01";
                $date = new \DateTime($billingPeriodBegin);
                $date->add(new  \DateInterval('P1M'));
                $billingPeriodFin = $date->format('Y-m-d'); 
                $query = $query->setParameter('dateFin',$billingPeriodFin);
                $query = $query->setParameter('dateBegin',$billingPeriodBegin);
            }
            
            $resultQuery = $query->getQuery()->getResult();
            
            if (count($resultQuery)>0)
            {
                $val=$resultQuery[0];
            
                if( $val['idStatus']== 54 || $val['idStatus']== 96 )
                      $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL1][] = $s;                  
                elseif($val['idStatus']== 65)
                    $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL2][] = $s;  
                    elseif($val['idStatus']== 75 || $val['idStatus']== 85 )
                        $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL3][] = $s;
                        elseif($val['idStatus']== 99 || $val['idStatus']== 108 )
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL4][] = $s;    
                        else              
                            $resultServices[ReportingController::NAME_SHEET_LL_COST_CENTRAL0][] = $s;                    
            }
        }
        
        foreach($resultServices as $category => $services){
            foreach($services as $service){
                foreach($service->getIdServiceExtremity() as $serviceExtremity){
                   if(isset($post['llManagingBranch']) && !empty($post['llManagingBranch'])){
                        $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
                        if($serviceExtremityTech){
                           $localLoop = $serviceExtremityTech->getIdLocalLoop();
                           if($localLoop && $localLoop->getIdBranch() && in_array($localLoop->getIdBranch()->getIdBranch(), array_values($post['llManagingBranch'])))
                               $result[$category][] = $serviceExtremity;
                        }
                    }
                    else{
                       $result[$category][] = $serviceExtremity; 
                    }
                }                
            }           
        } 
        
        $this->nbLLMax = 0;        
        foreach ($result as $serviceExtremitys) {
            $nbLL = array();
            foreach($serviceExtremitys as $serviceExtremity){               
                $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
                $localLoop = $serviceExtremityTech->getIdLocalLoop();
                if($localLoop && $localLoop->getIdBranch()){
                    $nbLL[$localLoop->getIdBranch()->getIdBranch()]=1;
                }
                if($this->nbLLMax < count($nbLL))
                    $this->nbLLMax = count($nbLL);
            }            
        } 
        $this->nbLLMax++;
        
        return $result;
    }
    
    /**
     * @param array $post    
     * @return array
     */
    public function queryFormAllServicesPerCustomer($post){ 
        $resultServicesPerCustomer = array();
        $query = $this->getDoctrine()
                            ->getManager()
                            ->getRepository('Etrali\GinangBundle\Entity\ServiceExtremity')
                            ->createQueryBuilder('se');
        
        $query = $query->innerJoin("se.idCustomer", "c");
        $query = $query->innerJoin('se.idService', 's');
        
        $query = $query->innerJoin("se.idServiceExtremityOwner", "seo");
        $query = $query->andWhere("seo.idLocalLoopExtremityOwner = :ownerCustomer");
        $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);      
        
        
        if(isset($post['customerManagedBranch']) && !empty($post['customerManagedBranch'])){ 
            $query = $query->innerJoin('s.idBranch', 'b');
            $query = $query->andWhere("b.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['customerManagedBranch']));
        }
        
        if(isset($post['extremityCustomerName']) && !empty($post['extremityCustomerName'])){                   
            $query = $query->andWhere("c.idCustomer IN(:idCustomers)");
            $query = $query->setParameter('idCustomers', array_values($post['extremityCustomerName']));
        }
        
        if(isset($post['extremityCustomerDeliveryAddress']) && !empty($post['extremityCustomerDeliveryAddress'])){            
            $query = $query->innerJoin("se.idDeliveryAddress", "da");
            $query = $query->andWhere("da.idAddress IN(:idAddresss)");
            $query = $query->setParameter('idAddresss',array_values($post['extremityCustomerDeliveryAddress']));           
        }
        
        if(isset($post['product']) && !empty($post['product'])){ 
            $query = $query->innerJoin('s.idProduct ','prod');                             
            $query = $query->andWhere("prod.idProduct IN(:idProducts)");
            $query = $query->setParameter('idProducts', array_values($post['product']));
        }
        
        if(isset($post['projectCode']) && !empty($post['projectCode'])){  
            $query = $query->innerJoin("se.idProject", "proj");
            $query = $query->andWhere("proj.idProject IN(:idProjects)");
            $query = $query->setParameter('idProjects', array_values($post['projectCode']));
        }

        if(isset($post['serviceStatus']) && !empty($post['serviceStatus'])){  
            $query = $query->innerJoin('s.idTransactionStatus','ts');                             
            $query = $query->andWhere("ts.idTransactionStatus IN(:serviceStatuss)");
            $query = $query->setParameter('serviceStatuss', array_values($post['serviceStatus']));
        }
              
        $result = $query->getQuery()->getResult();
        
        foreach ($result as $serviceExtremity) {
            $service = $serviceExtremity->getIdService();          
            if(count($service->getIdServiceExtremity())==2){ 
                $resultServicesPerCustomer[$serviceExtremity->getIdCustomer()->getIdCustomer()][$serviceExtremity->getIdDeliveryAddress()->getIdAddress()][$serviceExtremity->getIdServiceExtremity()] = $serviceExtremity;       
            }
        } 
        
        return $resultServicesPerCustomer;
    }
       
    /**
     * 
     * @param array $post
     * 
     * @return array
     */
    public function queryFormLocalLoopConnectedServices($post){
        $query = $this->getDoctrine()
                      ->getManager()
                      ->createQueryBuilder(); 
        
        $query = $query->select('ll')
                        ->from('EtraliGinangBundle:LocalLoop','ll','ll.idLocalLoop'); 
               
        if(!empty($post['branch'])){            
            $query = $query->innerJoin('ll.idBranch','b'); 
            $query = $query->andWhere("b.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['branch']));
        }
        
        if(isset($post['carrier']) && !empty($post['carrier'])){
            $query = $query->innerJoin('ll.idProviderOfCarrier','pc');
            $query = $query->leftJoin('pc.idAddressProvider','pcap');
            $query = $query->andWhere("pc.idProvider IN(:carrier)");            
            $query = $query->setParameter('carrier', array_values($post['carrier']));
        }
        
        if(isset($post['bandwidth']) && !empty($post['bandwidth'])){
            $query = $query->innerJoin('ll.idBandwidth','band');
            $query = $query->andWhere("band.idBandwidthAssignee IN(:bandwidth)");            
            $query = $query->setParameter('bandwidth', array_values($post['bandwidth']));
        }
        
        if(isset($post['capacity']) && !empty($post['capacity'])){
            $query = $query->innerJoin('ll.idCapacity','lc');
            $query = $query->andWhere("lc.idCapacity IN(:capacity)");
            $query = $query->setParameter('capacity', array_values($post['capacity']));
        }
        
        if(isset($post['localLoopStatus']) && !empty($post['localLoopStatus'])){
            $query = $query->innerJoin('ll.idTransactionStatus','ts');
            $query = $query->andWhere("ts.idTransactionStatus IN(:localLoopStatus)");
            $query = $query->setParameter('localLoopStatus', array_values($post['localLoopStatus']));
        }
        
        $query = $query->innerJoin('ll.idLocalLoopExtremity','lle');
        $query = $query->innerJoin('lle.idLocalLoopExtremityOwner','lleo');

        
        $query2=clone $query;
        $query3=clone $query;
        
        
        if(isset($post['customer']) && !empty($post['customer'])){
            $query = $query->innerJoin('lle.idCustomer','c');
            $query = $query->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerCustomer) AND (c.idCustomer IN(:customer)) )");            
            $query = $query->setParameter('customer', array_values($post['customer']));
            $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);
            
        }
        
        $result = array_unique($query->getQuery()->getResult());
        
        if(isset($post['provider']) && !empty($post['provider'])){
            $query2 = $query2->innerJoin('lle.idProvider','p');          
            $query2 = $query2->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerProvider) AND (p.idProvider IN(:provider)) )");
            $query2 = $query2->setParameter('provider', array_values($post['provider']));
            $query2 = $query2->setParameter('ownerProvider', ReportingController::OWNER_PROVIDER);
            
            foreach ($query2->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            }
            
        }
        
        if(isset($post['pop']) && !empty($post['pop'])){
            $query3 = $query3->innerJoin('lle.idPop','pp');           
            $query3 = $query3->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerPop) AND (pp.idPop IN(:pop)) )");
            $query3 = $query3->setParameter('pop', array_values($post['pop']));
            $query3 = $query3->setParameter('ownerPop', ReportingController::OWNER_POP);
            
            foreach ($query3->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            } 
        }
              
        return $result;
    }
    
    /**
     * 
     * @param array $post
     * @return array
     */
    public function queryFormExtremityTerminationsMultipoint($post){
        $query = $this->getDoctrine()
                            ->getManager()
                            ->getRepository('Etrali\GinangBundle\Entity\ServiceExtremity')
                            ->createQueryBuilder('se');
        
        $query = $query->innerJoin("se.idService","s");
                
        if(!empty($post['periodStartDate'])){
            $query = $query->andWhere("s.dtDelivery >= :periodStartDate"); 
            $query = $query->setParameter('periodStartDate', $this->dateToMysql($post['periodStartDate']));
        }

        if(!empty($post['periodEndDate'])){
            $query = $query->andWhere("s.dtDelivery <= :periodEndDate");
            $query = $query->setParameter('periodEndDate', $this->dateToMysql($post['periodEndDate']));      
        } 
        
        if(!empty($post['idProduct'])){
            $query = $query->innerJoin('s.idProduct','p');
            $query = $query->andWhere("p.idProduct   IN(:idProduct)");
            $query = $query->setParameter('idProduct', array_values($post['idProduct']));
        }  

        if(!empty($post['idBranch'])){
            $query = $query->innerJoin('s.idBranch','br');
            $query = $query->andWhere("br.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['idBranch']));
        }        
            
        $query = $query->innerJoin("s.idServiceCaracs","sc");
        $query = $query->innerJoin("sc.idProductCaracs","pc");
        $query = $query->andWhere("pc.idProductCaracs = :idProductCaracs");
        $query = $query->andWhere("sc.valeur = :valeur");
        $query = $query->andWhere("se.dtRealTerminate is not null");

        $query = $query->setParameter('idProductCaracs', ReportingController::SERVICES_MULTIPOINT_PRODUCT_CARACS);
        $query = $query->setParameter('valeur', ReportingController::SERVICES_MULTIPOINT_PRODUCT_CARACS_VALEUR);
        

        return $query->getQuery()->getResult();
    }
       
    /**
     * 
     * @param array $post
     * @param int $status
     * @return array
     */
    public function queryFormServicesStatus($post, $status){
        $query = $this->getDoctrine()
                ->getManager()
                ->getRepository('Etrali\GinangBundle\Entity\Service')
                ->createQueryBuilder('s');

        $query = $query->leftJoin('s.idBillingService','bs');
        $query = $query->leftJoin('bs.idBillingServiceLine','bsl');               
        $query = $query->innerJoin('s.idTransactionStatus','ts')->where("ts.idTransactionStatus= :status");
        $query = $query->setParameter('status', $status);
        
        if(!empty($post['periodStartDate'])){
            $query = $query->andWhere("s.dtDelivery >= :periodStartDate"); 
            $query = $query->setParameter('periodStartDate', $this->dateToMysql($post['periodStartDate'])); 
        }

        if(!empty($post['periodEndDate'])){
            $query = $query->andWhere("s.dtDelivery <= :periodEndDate");
            $query = $query->setParameter('periodEndDate', $this->dateToMysql($post['periodEndDate'])); 
        }   
        
        if(!empty($post['idProduct'])){
            $query = $query->innerJoin('s.idProduct','p');
            $query = $query->andWhere("p.idProduct   IN(:idProduct)");
            $query = $query->setParameter('idProduct', array_values($post['idProduct']));
        } 

        if(!empty($post['idBranch'])){
            $query = $query->innerJoin('s.idBranch','br');
            $query = $query->andWhere("br.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['idBranch']));
        }
        
        return $query->getQuery()->getResult();
    }
    
    /**
     * 
     * @param array $post
     * 
     * @return array
     */
    public function queryFormPendingServices($post){
        $query = $this->getDoctrine()
                      ->getManager()
                      ->createQueryBuilder(); 
        
        $query = $query->select('se')
                        ->from('EtraliGinangBundle:ServiceExtremity','se','se.idServiceExtremity'); 
        
        $query = $query->innerJoin('se.idService','s');
        $query = $query->innerJoin('s.idTransactionStatus','ts');
        $query = $query->where("ts.idTransactionStatus <> :statusServiceTerminated");
        $query = $query->setParameter('statusServiceTerminated', ReportingController::STATUS_SERVICE_TERMINATED);
        
        
        if(isset($post['serviceStatus']) && !empty($post['serviceStatus'])){
            $query = $query->andWhere("ts.idTransactionStatus IN(:serviceStatus)");
            $query = $query->setParameter('serviceStatus', array_values($post['serviceStatus']));
        }
        
        if(isset($post['commercialBranch']) && !empty($post['commercialBranch'])){            
            $query = $query->andWhere("s.idBranch IN(:commercialBranch)");
            $query = $query->setParameter('commercialBranch', array_values($post['commercialBranch']));
        }
        
        if(isset($post['billedCustomer']) && !empty($post['billedCustomer'])){
            $query = $query->innerJoin('s.idBillingService','bs');
            $query = $query->innerJoin('bs.idCustomer','bsc');
            $query = $query->andWhere("bsc.idCustomer IN(:billedCustomer)");
            $query = $query->setParameter('billedCustomer', array_values($post['billedCustomer']));
        }
        
        if(isset($post['projectCode']) && !empty($post['projectCode'])){
            $query = $query->innerJoin('se.idProject','pr');
            $query = $query->andWhere('pr.idProject IN(:projectCode)'); 
            $query = $query->andWhere('pr.dtEnd > :curDate');
            $query = $query->setParameter('projectCode', array_values($post['projectCode']));
            $query = $query->setParameter('curDate', date("d/m/Y"));
        }
        
        $query2=clone $query;
        $query3=clone $query;
        
       
        if(isset($post['customer']) && !empty($post['customer'])){
            $query = $query->innerJoin('se.idCustomer','c');
            $query = $query->andWhere("( (se.idServiceExtremityOwner = :ownerCustomer) AND (c.idCustomer IN(:customer)) )");            
            $query = $query->setParameter('customer', array_values($post['customer']));
            $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);            
        
        
            if(isset($post['extremityBranch']) && !empty($post['extremityBranch'])){
                $query = $query->andWhere("c.idBranch IN(:extremityBranch)");           
                $query = $query->setParameter('extremityBranch', array_values($post['extremityBranch']));              
            }                       
        }
        
       $result = array_unique($query->getQuery()->getResult());
       
        if(isset($post['provider']) && !empty($post['provider'])){
            $query2 = $query2->innerJoin('se.idProvider','p');
            $query2 = $query2->andWhere("( (se.idServiceExtremityOwner = :ownerProvider) AND (p.idProvider IN(:provider)) )");            
            $query2 = $query2->setParameter('provider', array_values($post['provider']));
            $query2 = $query2->setParameter('ownerProvider', ReportingController::OWNER_PROVIDER);            
            
            foreach ($query2->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdServiceExtremity()]))
                    $result[$res->getIdServiceExtremity()]=$res;
            } 
        }
        
        if(isset($post['pop']) && !empty($post['pop'])){
            $query3 = $query3->innerJoin('se.idPop','pp');
            $query3 = $query3->andWhere("( (se.idServiceExtremityOwner = :ownerPop) AND (pp.idPop IN(:pop)) )");            
            $query3 = $query3->setParameter('pop', array_values($post['pop']));
            $query3 = $query3->setParameter('ownerPop', ReportingController::OWNER_POP);            


            if(isset($post['extremityBranch']) && !empty($post['extremityBranch'])){
                $query3 = $query3->andWhere("pp.idBranch IN(:extremityBranch)");           
                $query3 = $query3->setParameter('extremityBranch', array_values($post['extremityBranch']));                     
            }
            
            foreach ($query3->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdServiceExtremity()]))
                    $result[$res->getIdServiceExtremity()]=$res;
            } 
        }
        
        return $result;
    }
    
    /**
     * 
     * @param array $post
     * 
     * @return array
     */
    public function queryFormLocalLoopOptionsFrenchLL($post){
        $query = $this->getDoctrine()
                      ->getManager()
                      ->createQueryBuilder(); 
        
        $query = $query->select('ll')
                        ->from('EtraliGinangBundle:LocalLoop','ll','ll.idLocalLoop'); 
        
        $query = $query->leftJoin('ll.idLocalLoopSister','lllls'); 
        
        if(!empty($post['branch'])){            
            $query = $query->innerJoin('ll.idBranch','b'); 
            $query = $query->andWhere("b.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['branch']));
        }
        
        if(isset($post['carrier']) && !empty($post['carrier'])){
            $query = $query->innerJoin('ll.idProviderOfCarrier','pc');
            $query = $query->leftJoin('pc.idAddressProvider','pcap');
            $query = $query->andWhere("pc.idProvider IN(:carrier)");            
            $query = $query->setParameter('carrier', array_values($post['carrier']));
        }
        
        if(isset($post['linkFunction']) && !empty($post['linkFunction'])){
            $query = $query->innerJoin('ll.idLinkFunction','lf');
            $query = $query->andWhere("lf.idLinkFunction IN(:linkFunction)");
            $query = $query->setParameter('linkFunction', array_values($post['linkFunction']));
        }
        
        if(isset($post['localLoopStatus']) && !empty($post['localLoopStatus'])){
            $query = $query->innerJoin('ll.idTransactionStatus','ts');
            $query = $query->andWhere("ts.idTransactionStatus IN(:localLoopStatus)");
            $query = $query->setParameter('localLoopStatus', array_values($post['localLoopStatus']));
        }
        
        $query = $query->innerJoin('ll.idLocalLoopExtremity','lle');
        $query = $query->innerJoin('lle.idLocalLoopExtremityOwner','lleo');

        
        $query2=clone $query;
        $query3=clone $query;
        
        
        if(isset($post['customer']) && !empty($post['customer'])){
            $query = $query->innerJoin('lle.idCustomer','c');
            $query = $query->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerCustomer) AND (c.idCustomer IN(:customer)) )");            
            $query = $query->setParameter('customer', array_values($post['customer']));
            $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);
            
        }
        
        $result = array_unique($query->getQuery()->getResult());
        
        if(isset($post['provider']) && !empty($post['provider'])){
            $query2 = $query2->innerJoin('lle.idProvider','p');          
            $query2 = $query2->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerProvider) AND (p.idProvider IN(:provider)) )");
            $query2 = $query2->setParameter('provider', array_values($post['provider']));
            $query2 = $query2->setParameter('ownerProvider', ReportingController::OWNER_PROVIDER);
            
            foreach ($query2->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            }
            
        }
        
        if(isset($post['pop']) && !empty($post['pop'])){
            $query3 = $query3->innerJoin('lle.idPop','pp');           
            $query3 = $query3->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerPop) AND (pp.idPop IN(:pop)) )");
            $query3 = $query3->setParameter('pop', array_values($post['pop']));
            $query3 = $query3->setParameter('ownerPop', ReportingController::OWNER_POP);
            
            foreach ($query3->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            } 
        }
              
        return $result;
    }
    
    /**
     * 
     * @param array $post
     * 
     * @return array
     */
    public function queryFormLocalLoop($post){
        $query = $this->getDoctrine()
                      ->getManager()
                      ->createQueryBuilder(); 
        
        $query = $query->select('ll')
                        ->from('EtraliGinangBundle:LocalLoop','ll','ll.idLocalLoop'); 
         
        $query = $query->leftJoin('ll.idLocalLoopSister','lllls'); 
        
        if(!empty($post['branch'])){            
            $query = $query->innerJoin('ll.idBranch','b'); 
            $query = $query->andWhere("b.idBranch IN(:idBranchs)");
            $query = $query->setParameter('idBranchs', array_values($post['branch']));
        }
        
        if(isset($post['carrier']) && !empty($post['carrier'])){
            $query = $query->innerJoin('ll.idProviderOfCarrier','pc');
            $query = $query->leftJoin('pc.idAddressProvider','pcap');
            $query = $query->andWhere("pc.idProvider IN(:carrier)");            
            $query = $query->setParameter('carrier', array_values($post['carrier']));
        }
        
        if(isset($post['linkFunction']) && !empty($post['linkFunction'])){
            $query = $query->innerJoin('ll.idLinkFunction','lf');
            $query = $query->andWhere("lf.idLinkFunction IN(:linkFunction)");
            $query = $query->setParameter('linkFunction', array_values($post['linkFunction']));
        }
        
        if(isset($post['localLoopStatus']) && !empty($post['localLoopStatus'])){
            $query = $query->innerJoin('ll.idTransactionStatus','ts');
            $query = $query->andWhere("ts.idTransactionStatus IN(:localLoopStatus)");
            $query = $query->setParameter('localLoopStatus', array_values($post['localLoopStatus']));
        }
        
        $query = $query->innerJoin('ll.idLocalLoopExtremity','lle');
        $query = $query->innerJoin('lle.idLocalLoopExtremityOwner','lleo');

        
        $query2=clone $query;
        $query3=clone $query;
        
        
        if(isset($post['customer']) && !empty($post['customer'])){
            $query = $query->innerJoin('lle.idCustomer','c');
            $query = $query->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerCustomer) AND (c.idCustomer IN(:customer)) )");            
            $query = $query->setParameter('customer', array_values($post['customer']));
            $query = $query->setParameter('ownerCustomer', ReportingController::OWNER_CUSTOMER);
            
        }
        
        $result = array_unique($query->getQuery()->getResult());
        
        if(isset($post['provider']) && !empty($post['provider'])){
            $query2 = $query2->innerJoin('lle.idProvider','p');          
            $query2 = $query2->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerProvider) AND (p.idProvider IN(:provider)) )");
            $query2 = $query2->setParameter('provider', array_values($post['provider']));
            $query2 = $query2->setParameter('ownerProvider', ReportingController::OWNER_PROVIDER);
            
            foreach ($query2->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            }
            
        }
        
        if(isset($post['pop']) && !empty($post['pop'])){
            $query3 = $query3->innerJoin('lle.idPop','pp');           
            $query3 = $query3->andWhere("( (lleo.idLocalLoopExtremityOwner = :ownerPop) AND (pp.idPop IN(:pop)) )");
            $query3 = $query3->setParameter('pop', array_values($post['pop']));
            $query3 = $query3->setParameter('ownerPop', ReportingController::OWNER_POP);
            
            foreach ($query3->getQuery()->getResult() as $res)
            {
                if (!isset($result[$res->getIdLocalLoop()]))
                    $result[$res->getIdLocalLoop()]=$res;
            } 
        }
              
        return $result;
    }

    /**
     * 
     * @param type  $sheet
     * @param array $Services
     * @param array $post
     */    
    public function createdSheetLocalLoopToCustomerBillingBranch(&$sheet, $parametres, $post){
        $column=0;
        $totalLLTechId = 0;
        $totalCarrier = 0;
        $title = "Rebilling of LL to Customer Billing Branch ( ".$parametres['title']." )";
        $list = $parametres['list'];
        $labels = array(
                        "LL Managing branch",
                        "Customer Billing branch",
                        "Billed Customer",
                        "Split Billing",
                        "Extremity Ref",
                        "LL extremity customer",
                        "LL extremity Customer delivery address",
                        "Service Ref",
                        "Product",
                        "Bandwidth",
                        "Carrier",
                        "Local loop Tech ID",
                        "LL cost in EURO",
                        "LL cost in local currency",
                        "Local currency",
                        "Service in Service date",
                        "Service Start Billing Date"                      
                      ); 
                                     
        $filtres = array(   
                            array("valeur"=>isset($post['llManagingBranch'])? $post['llManagingBranch']: null, "entity"=>"Branch", "label"=>"LL Managing branch: "),
                            array("valeur"=>"", "entity"=>null, "label"=> $post['billingPeriodAnnee'] && $post['billingPeriodMois']?"Billing period:{$post['billingPeriodMois']}/{$post['billingPeriodAnnee']}":"Billing period: ALL"), 
                            array("valeur"=>"", "entity"=>null, "label"=>"Date of report retrieval: ".date("d-m-Y")) 
                        );
  
        $row = 7 + $this->nbLLMax ;
        
        if(!$parametres['numeroSheet'])
            $MTcoust = array();
        
        foreach ($list as $categorie => $serviceExtremitys) {
            $column=0;
            $this->getStyleCellule($sheet,$row, $column, true, 15, 'Arial', '046380');
            $sheet->setCellValueByColumnAndRow($column,$row, str_replace('_',' ',$categorie));
            $row++;
            
            $labelsCategorie = $labels;
            switch($categorie){
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                    $labelsCategorie[] = "Transfer completion Date";              
                    break;
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                    $labelsCategorie[] = "Up-Downgrade completion Date";
                    break; 
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                    $labelsCategorie[] = "Service Real Termination Date";
                    $labelsCategorie[] = "Extremity Real Termination Date";
                    $labelsCategorie[] = "End Billing Date";
                    break;
            }
                                                      
            $row = $this->createdEntete($sheet, $labelsCategorie, $title, $filtres, $row);
            
            foreach ($serviceExtremitys as $serviceExtremity){
                $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
                $column=0;

                $service = $serviceExtremity->getIdService();
                $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
                $localLoop = $serviceExtremityTech->getIdLocalLoop();
                $billingService = $serviceExtremity->getBillingServiceActive();

                if($localLoop)           
                    $this->addCellule($sheet, $column, $row, $localLoop->getIdBranch());                                          // LL Managing branch
                else 
                   $column++;  

                if($billingService && $billingService->getIdCustomer()){               
                    $this->addCellule($sheet, $column, $row, $billingService->getIdCustomer()->getIdBranch());                    // Customer Billing branch
                    $this->addCellule($sheet, $column, $row, $billingService->getIdCustomer());                                   // Billed Customer
                }
                else
                   $column+=2;

                if($service->isSplitBilling())
                  $this->addCellule($sheet, $column, $row, "YES");                                                                 // Split Billing 
                else
                  $this->addCellule($sheet, $column, $row, "NO");
             
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getCdServiceExtremity());                              // Extremity Re
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremity());                                       // LL extremity customer
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremityAddress());                                // LL extremity Customer delivery address
                $this->addCellule($sheet, $column, $row, $service->getCdService());                                                // Service Ref
                $this->addCellule($sheet, $column, $row, $service->getIdProduct());                                                // Product
                $this->addCellule($sheet, $column, $row, $service->getIdBandwidth());                                              // Bandwidth

                if($localLoop){
                    $this->addCellule($sheet, $column, $row, $localLoop->getIdProviderOfCarrier());                                // Carrier
                    $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef());                                     // Local loop Tech ID

                    if($localLoop->getCdTechnicalRef())
                        $totalLLTechId++;
                    if($localLoop->getIdProviderOfCarrier())
                        $totalCarrier++;
                }else
                    $column+=2;

                $this->addCellule($sheet, $column, $row, $serviceExtremity->getMtLocalLoopCost());                                  // LL cost in EURO 
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getMtLocalLoopCost());                                  // LL cost in local currency 
                $this->addCellule($sheet, $column, $row, "EURO");                                                                   // Local currency
                $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                                // Service in Service date

                if($billingService)
                    $this->addCellule($sheet, $column, $row, $billingService->getDtStart());                                        // Service Start Billing Date
                else 
                    $column++; 

                switch($categorie){
                    case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                        $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtCompleteTransfer());                       // Transfer completion Date
                        break;
                    case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                        $this->addCellule($sheet, $column, $row, $service->getDtRealUpdown());                                      // Up-Downgrade completion Date
                        break; 
                    case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                        $this->addCellule($sheet, $column, $row, $service->getDtRealTerminate());                                   // Service Real Termination Date
                        $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtRealTerminate());                          // Extremity Real Termination Date

                        if($billingService)
                            $this->addCellule($sheet, $column, $row, $billingService->getDtEnd());                                  // End Billing Date
                        else 
                            $column++; 
                        break;
                }
                
                if($localLoop){
                    if(!isset($this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())]))
                         $this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())]=array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => 0);   

                    $this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())][$categorie] += $serviceExtremity->getMtLocalLoopCost();               
                } 
                
                $row++;                
            } 
            
            $column = 10;
            $this->getStyleCellule($sheet, $row, $column, true, 9);
            $sheet->setCellValueByColumnAndRow($column, $row, "TOTAL: ".$totalCarrier);
            $column++;
            $sheet->setCellValueByColumnAndRow($column, $row, "Sum: ".$totalLLTechId);
            $row += 4;
            $totalCarrier = 0;
            $totalLLTechId = 0;
        }  
        
        $i = 0;       
         if($parametres['numeroSheet'] == ($parametres['totalSheet']-1)){
            while($i<$parametres['totalSheet']){
                $row = 4;
                $sheet_i = $this->Excel->getSheet($i);
                $column = 1;
                $this->getStyleCellule($sheet_i, $row, $column, true, 9);

                $this->addCellule($sheet_i, $column, $row, "LL Managing  Branch");
                $this->addCellule($sheet_i, $column, $row, "Existing");
                $this->addCellule($sheet_i, $column, $row, "New");
                $this->addCellule($sheet_i, $column, $row, "Transfer");
                $this->addCellule($sheet_i, $column, $row, "Up-Down");
                $this->addCellule($sheet_i, $column, $row, "Terminated");
                $this->addCellule($sheet_i, $column, $row, "Total in EUR");
                $row++;

                foreach ($this->TotalMTcost as $nomBranche => $value) {
                    $column = 1;
                    $this->addCellule($sheet_i, $column, $row, str_replace('_',' ', $nomBranche));
                    $totalCategoryMtCos = 0;
                    foreach ($value as $categoryMtCos) {                                      
                        $this->addCellule($sheet_i, $column, $row, $categoryMtCos);
                        $totalCategoryMtCos += $categoryMtCos;
                    }
                    $this->addCellule($sheet_i, $column, $row, $totalCategoryMtCos);                    
                    $row++;               
                }
                $i++;
            }  
        }
             
     }

    /**
     * 
     * @param type  $sheet
     * @param array $Services
     * @param array $post
     */    
    public function createdSheetTransferPriceCustomerBillingBranch(&$sheet, $parametres, $post){
       
        $column=0;
        $nbMaxCustomer = 0;
        $totalTechnicalRoute = 0;
        $totalTransferPrice = 0;
        $title = "Repatriate Transfer price per Customer Billing Branch (".$parametres['title']." )";
        $list = $parametres['list'];
        $labels=array(
                        "Product",
                        "Bandwidth",
                        "Service Ref",
                        "Extremity Ref",
                        "In Service Date", 
                        "Split Billing",
                        "Customer 1", 
                        "City 1",
                        "Customer 2", 
                        "City 2",
                        "Technical route", 
                        "Transfer price in EUR",
                        "Commercial branch"
            ); 
                                       
        $filtres = array(   
                           array("valeur"=>isset($post['llManagingBranch'])? $post['llManagingBranch']: null, "entity"=>"Branch", "label"=>"Billing branch: "),
                           array("valeur"=>"", "entity"=>null, "label"=> $post['billingPeriodAnnee'] && $post['billingPeriodMois']?"Billing period:{$post['billingPeriodMois']}/{$post['billingPeriodAnnee']}":"Billing period: ALL"), 
                           array("valeur"=>"", "entity"=>null, "label"=>"Date of report retrieval: ".date("d-m-Y")) 
                       );
  
        $row = 7 + $this->nbLLMax ;
        
        if(!$parametres['numeroSheet'])
            $MTcoust = array();
        
        foreach ($list as $categorie => $services) {
            $column=0;
            $this->getStyleCellule($sheet,$row, $column, true, 15, 'Arial', '046380');
            $sheet->setCellValueByColumnAndRow($column,$row, str_replace('_',' ',$categorie));
            $row++;
            
            $labelsCategorie = $labels;
            switch($categorie){
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                    $labelsCategorie[] = "Transfer completion Date";              
                    break;
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                    $labelsCategorie[] = "Up-Downgrade completion Date";
                    break; 
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                    $labelsCategorie[] = "Service Real Termination Date";
                    $labelsCategorie[] = "Extremity Real Termination Date";
                    $labelsCategorie[] = "End Billing Date";
                    break;
            }
             

            foreach ($services as $val) {
                $nbCustomers = count($val['customer']);
                if($nbMaxCustomer<$nbCustomers)
                    $nbMaxCustomer = $nbCustomers;               
            }  
            
            $nbMaxCustomer -=2;
            $j = 3;
            while($nbMaxCustomer >0 ){
                $labelsCategorie[] = "Customer ".$j;
                $labelsCategorie[] = "City ".$j;
                $nbMaxCustomer--;
            }
            $row = $this->createdEntete($sheet, $labelsCategorie, $title, $filtres, $row);
            
            foreach ($services as $val){
                    $column=0;
                    $service = $val['service'];
                     
                    $extremityRe = "";
                    $technicalRoute = "";
                    $transferPrice = 0;
                    $transferCompletionDate = "";
                    $extremityRealTerminationDate = "";
                    
                    foreach($val['serviceExtremity'] as $serviceExtremity){
                         $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();                        
                         $extremityRe .=  $serviceExtremity.", ";
                         
                         if($serviceExtremityTech && $serviceExtremityTech->retreiveTechnicalRoute())
                                $technicalRoute .= $serviceExtremityTech->retreiveTechnicalRoute()." ,";
                         
                         if($serviceExtremity->getIdTransferPrice() && $serviceExtremity->getIdTransferPrice()->getMtTransferPrice())
                                $transferPrice += $serviceExtremity->getIdTransferPrice()->getMtTransferPrice();                 
                         
                         if($parametres['title'] == ReportingController::NAME_SHEET_LL_COST_CENTRAL2 && $serviceExtremity->getDtCompleteTransfer())
                                $transferCompletionDate .= $serviceExtremity->getDtCompleteTransfer()." ,";
                         
                         if($parametres['title'] == ReportingController::NAME_SHEET_LL_COST_CENTRAL4 && $serviceExtremity->getDtRealTerminate())
                                $extremityRealTerminationDate .= $serviceExtremity->getDtRealTerminate()." ,";
                                                      
                         if(!isset($this->TotalMTcost[str_replace(' ','_',$parametres['title'])]))
                                $this->TotalMTcost[str_replace(' ','_',$parametres['title'])]=array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => 0);   
                        
                         if($serviceExtremity->getIdTransferPrice())
                                $this->TotalMTcost[str_replace(' ','_',$parametres['title'])][$categorie] += $serviceExtremity->getIdTransferPrice()->getMtTransferPrice();               
                         
                    }
                    
                    $extremityRe = substr($extremityRe,0,strlen($extremityRe)-1);                    
                    $transferCompletionDate = substr($transferCompletionDate,0,strlen($transferCompletionDate)-1);
                    
                    $this->addCellule($sheet, $column, $row, $service->getIdProduct());                                                // Product
                    $this->addCellule($sheet, $column, $row, $service->getIdBandwidth());                                              // Bandwidth
                    $this->addCellule($sheet, $column, $row, $service->getCdService());                                                // Service Ref
                    $this->addCellule($sheet, $column, $row, $extremityRe);                                                            // Extremity Re

                    $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                               // In Service Date 
                    
                    if($service->isSplitBilling())
                        $this->addCellule($sheet, $column, $row, "YES");                                                               // Split Billing 
                    else
                        $this->addCellule($sheet, $column, $row, "NO");
                    
                    $iCustomer = 0;
                    $customers = $val['customer'];
                    foreach ($customers as $customer) {
                       if($iCustomer < 2){
                           $this->addCellule($sheet, $column, $row, $customer);                                                       // Customer 
                           $this->addCellule($sheet, $column, $row, $customer->getAddressDelivery()->getIdCity());                    // City   
                       }
                       $iCustomer++;   
                    }
                    
                    $column = 10;
                    $totalTechnicalRoute += substr_count($technicalRoute, ',');
                    $technicalRoute = substr($technicalRoute,0,strlen($technicalRoute)-1);
                    $this->addCellule($sheet, $column, $row, $technicalRoute);                                                        // Technical route                   
                    $this->addCellule($sheet, $column, $row, $transferPrice);                                                         // Transfer price in EUR 
                    $totalTransferPrice += $transferPrice;
                    

                    $this->addCellule($sheet, $column, $row, $service->getIdBranch());                                                // Commercial branch

                    switch($parametres['title']){
                        case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                            $this->addCellule($sheet, $column, $row, $transferCompletionDate);                                        // Transfer completion Date  
                            break;
                        case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                            $this->addCellule($sheet, $column, $row, $service->getDtRealUpdown());                                    // Up-Downgrade completion Date
                            break; 
                        case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                            $this->addCellule($sheet, $column, $row, $extremityRealTerminationDate);                                  // Extremity Real Termination Date
                    }
                                     
                    $iCustomer = 0; 
                    foreach ($customers as $customer) {
                       if($iCustomer > 1){
                            $this->addCellule($sheet, $column, $row, $customer);                                                      // Customer 
                            $this->addCellule($sheet, $column, $row, $customer->getAddressDelivery()->getIdCity());                   // City   
                       } 
                       $iCustomer++;   
                    }
                    
                    $row++;                
            } 
            
            $column = 10;
            $this->getStyleCellule($sheet, $row, $column, true, 9);
            $sheet->setCellValueByColumnAndRow($column, $row, "TOTAL: ".$totalTechnicalRoute);
            $column++;
            $sheet->setCellValueByColumnAndRow($column, $row, "Sum: ".$totalTransferPrice);
            $row += 4;
            $totalTechnicalRoute = 0;
            $totalTransferPrice = 0;
        }  
        
        $i = 0;       
         if($parametres['numeroSheet'] == ($parametres['totalSheet']-1)){
            while($i<$parametres['totalSheet']){
                $row = 4;
                $sheet_i = $this->Excel->getSheet($i);
                $column = 1;
                $this->getStyleCellule($sheet_i, $row, $column, true, 9);

                $this->addCellule($sheet_i, $column, $row, "LL Managing  Branch");
                $this->addCellule($sheet_i, $column, $row, "Existing");
                $this->addCellule($sheet_i, $column, $row, "New");
                $this->addCellule($sheet_i, $column, $row, "Transfer");
                $this->addCellule($sheet_i, $column, $row, "Up-Down");
                $this->addCellule($sheet_i, $column, $row, "Terminated");
                $this->addCellule($sheet_i, $column, $row, "Total in EUR");
                $row++;

                foreach ($this->TotalMTcost as $nomBranche => $value) {
                    $column = 1;
                    $this->addCellule($sheet_i, $column, $row, str_replace('_',' ', $nomBranche));
                    $totalCategoryMtCos = 0;
                    foreach ($value as $categoryMtCos) {                                      
                        $this->addCellule($sheet_i, $column, $row, $categoryMtCos);
                        $totalCategoryMtCos += $categoryMtCos;
                    }
                    $this->addCellule($sheet_i, $column, $row, $totalCategoryMtCos);                    
                    $row++;               
                }
                $i++;
            }  
        }       
     }
     
    /**
     * 
     * @param type  $sheet
     * @param array $Services
     * @param array $post
     */    
    public function createdSheetLocalLoopCostCentral(&$sheet, $parametres, $post){
        $column=0;
        $totalLLTechId = 0;
        $totalCarrier = 0;
        $title = "Repatriate Local Loop Cost to Central (".str_replace('_',' ',$parametres['title']).")";
        $serviceExtremitys = $parametres['list'];
        $labels=array(
                        "LL Managing branch",
                        "Customer Billing branch",
                        "Billed Customer",
                        "Split Billing",
                        "Extremity Ref",
                        "LL extremity customer",
                        "LL extremity Customer delivery address",
                        "Service Ref",
                        "Product",
                        "Bandwidth",
                        "Carrier",
                        "Local loop Tech ID",
                        "LL cost in EURO",
                        "LL cost in local currency",
                        "Local currency",
                        "Service in Service date",
                        "Service Start Billing Date"                      
                      ); 
        
        switch($parametres['title']){
            case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                $labels[] = "Transfer completion Date";              
                break;
            case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                $labels[] = "Up-Downgrade completion Date";
                break; 
            case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                $labels[] = "Service Real Termination Date";
                $labels[] = "Extremity Real Termination Date";
                $labels[] = "End Billing Date";
                break;
            default:
                $MTcoust = array();
                break; 
         }
                             
        $filtres = array(   
                            array("valeur"=>isset($post['llManagingBranch'])? $post['llManagingBranch']: null, "entity"=>"Branch", "label"=>"LL Managing branch: "),
                            array("valeur"=>"", "entity"=>null, "label"=> $post['billingPeriodAnnee'] && $post['billingPeriodMois']?"Billing period:{$post['billingPeriodMois']}/{$post['billingPeriodAnnee']}":"Billing period: ALL"), 
                            array("valeur"=>"", "entity"=>null, "label"=>"Date of report retrieval: ".date("d-m-Y")) 
                        );
  

        $row = 6 + $this->nbLLMax ;
        $row = $this->createdEntete($sheet, $labels, $title, $filtres, $row);
        
        foreach ($serviceExtremitys as $serviceExtremity){
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            $column=0;
            
            $service = $serviceExtremity->getIdService();
            $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
            $localLoop = $serviceExtremityTech->getIdLocalLoop();
            $billingService = $serviceExtremity->getBillingServiceActive();
            
            if($localLoop)           
                $this->addCellule($sheet, $column, $row, $localLoop->getIdBranch());                                          // LL Managing branch
            else 
               $column++;  
            
            if($billingService && $billingService->getIdCustomer()){               
                $this->addCellule($sheet, $column, $row, $billingService->getIdCustomer()->getIdBranch());                    // Customer Billing branch
                $this->addCellule($sheet, $column, $row, $billingService->getIdCustomer());                                   // Billed Customer
            }
            else
               $column+=2;
            
             if($service->isSplitBilling())
                $this->addCellule($sheet, $column, $row, "YES");                                                              // Split Billing 
             else
                $this->addCellule($sheet, $column, $row, "NO");
                       
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getCdServiceExtremity());                              // Extremity Re
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremity());                                       // LL extremity customer
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremityAddress());                                // LL extremity Customer delivery address
            $this->addCellule($sheet, $column, $row, $service->getCdService());                                                // Service Ref
            $this->addCellule($sheet, $column, $row, $service->getIdProduct());                                                // Product
            $this->addCellule($sheet, $column, $row, $service->getIdBandwidth());                                              // Bandwidth
            
            if($localLoop){
                $this->addCellule($sheet, $column, $row, $localLoop->getIdProviderOfCarrier());                                // Carrier
                $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef());                                     // Local loop Tech ID
                
                if($localLoop->getCdTechnicalRef())
                    $totalLLTechId++;
                if($localLoop->getIdProviderOfCarrier())
                    $totalCarrier++;
            }else
                $column+=2;
            
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getMtLocalLoopCost());                                  // LL cost in EURO 
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getMtLocalLoopCost());                                  // LL cost in local currency 
            $this->addCellule($sheet, $column, $row, "EURO");                                                                   // Local currency
            $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                                // Service in Service date
            
            if($billingService)
                $this->addCellule($sheet, $column, $row, $billingService->getDtStart());                                        // Service Start Billing Date
            else 
                $column++; 
            
            switch($parametres['title']){
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL2:
                    $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtCompleteTransfer());                       // Transfer completion Date
                    break;
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL3:
                    $this->addCellule($sheet, $column, $row, $service->getDtRealUpdown());                                      // Up-Downgrade completion Date
                    break; 
                case ReportingController::NAME_SHEET_LL_COST_CENTRAL4:
                    $this->addCellule($sheet, $column, $row, $service->getDtRealTerminate());                                   // Service Real Termination Date
                    $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtRealTerminate());                          // Extremity Real Termination Date
                    
                    if($billingService)
                        $this->addCellule($sheet, $column, $row, $billingService->getDtEnd());                                  // End Billing Date
                    else 
                        $column++; 
                    break;
            }
            if($localLoop){
                if(!isset($this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())]))
                     $this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())]=array(ReportingController::NAME_SHEET_LL_COST_CENTRAL0 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL1 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL2 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL3 => 0, ReportingController::NAME_SHEET_LL_COST_CENTRAL4 => 0);   
                                       
                $this->TotalMTcost[str_replace(' ','_',$localLoop->getIdBranch())][$parametres['title']] += $serviceExtremity->getMtLocalLoopCost();               
            }               
            $row++;                
        }
        
        $column = 10;
        $this->getStyleCellule($sheet, $row, $column, true, 9);
        $sheet->setCellValueByColumnAndRow($column, $row, "TOTAL: ".$totalCarrier);
        $column++;
        $sheet->setCellValueByColumnAndRow($column, $row, "Sum: ".$totalLLTechId);
        
        $i = 0;       
        if(ReportingController::NAME_SHEET_LL_COST_CENTRAL4 == $parametres['title']){
            while($i<5){
                $row = 4;
                $sheet_i = $this->Excel->getSheet($i);
                $column = 1;
                $this->getStyleCellule($sheet_i, $row, $column, true, 9);

                $this->addCellule($sheet_i, $column, $row, "LL Managing  Branch");
                $this->addCellule($sheet_i, $column, $row, "Existing");
                $this->addCellule($sheet_i, $column, $row, "New");
                $this->addCellule($sheet_i, $column, $row, "Transfer");
                $this->addCellule($sheet_i, $column, $row, "Up-Down");
                $this->addCellule($sheet_i, $column, $row, "Terminated");
                $this->addCellule($sheet_i, $column, $row, "Total in EUR");
                $row++;
                
                foreach ($this->TotalMTcost as $nomBranche => $value) {
                    $column = 1;
                    $this->addCellule($sheet_i, $column, $row, str_replace('_',' ', $nomBranche));
                    $totalCategoryMtCos = 0;
                    foreach ($value as $categoryMtCos) {                                      
                        $this->addCellule($sheet_i, $column, $row, $categoryMtCos);
                        $totalCategoryMtCos += $categoryMtCos;
                    }
                    $this->addCellule($sheet_i, $column, $row, $totalCategoryMtCos);                    
                    $row++;               
                }
                $i++;
            }  
        }
     }
     
    
    /**
     * 
     * @param type $sheet
     * @param array $localLoops
     * @param array $post
     */
    public function createdSheetAllServicesPerCustomer(&$sheet, $customer, $post){
        $column=0;
        $repositoryAddress = $this->getDoctrine()
                  ->getManager()
                  ->getRepository('EtraliGinangBundle:Address');
        $title = "ALL Services per Customer: Data extraction date ".date("d-m-Y");
        $labels=array(
                        "Service Status",
                        "Service Ref",
                        "Product",
                        "Bandwidth",
                        "Project Code",
                        "Connection Path",
                        "Trader",
                        "Far End Customer",
                        "End Delivery Address",
                        "End Connection Path",
                        "Far End Local Loop Ref",
                        "Far End Trader",
                        "In Service Date"
                      ); 
                             
        $filtres = array(   
                            array("valeur"=>isset($post['customerManagedBranch'])? $post['customerManagedBranch']: null,                                    "entity"=>"Branch",             "label"=>"Customer Managed Branch: "),
                            array("valeur"=>isset($post['extremityCustomerName'])? $post['extremityCustomerName']: null,                                    "entity"=>"Customer",           "label"=>"Extremity Customer Name: "),
                            array("valeur"=>isset($post['extremityCustomerDeliveryAddress'])?$post['extremityCustomerDeliveryAddress']: null,               "entity"=>"Address",            "label"=>"Extremity Customer Delivery Address: "),
                            array("valeur"=>isset($post['product'])? $post['product']: null,                                                                "entity"=>"Product",            "label"=>"Product: "),
                            array("valeur"=>isset($post['projectCode'])? $post['projectCode']: null,                                                        "entity"=>"Project",            "label"=>"Project Code: "),
                            array("valeur"=>isset($post['serviceStatus'])? $post['serviceStatus']: null,                                                    "entity"=>"TransactionStatus",  "label"=>"Service Status: ")
                       );
  
        $row = 4;
        $row = $this->createdEntete($sheet, $labels, $title, $filtres, $row, false);
        $row +=3;
        
        foreach($customer as $key => $address){  
            $this->getStyleCellule($sheet,$row, $column, true, 12, 'Arial', 'FFFFFFFF', 'solid', '7FC6BC');
            $sheet->setCellValueByColumnAndRow($column, $row, "Delivery Address: ".$repositoryAddress->find($key));
            $row++;
            $this->createdEnteteTab($sheet, $labels, $row);
                        
            foreach ($address as $serviceExtremity){
                $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
                $column=0;
                $service = $serviceExtremity->getIdService(); 
                $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
                $extremityB = null;
                
                foreach($service->getIdServiceExtremity() as $value){
                      if($value->getIdServiceExtremity() != $serviceExtremity->getIdServiceExtremity())   
                          $extremityB = $value;
                }
                $serviceExtremityTechB = $extremityB->getIdServiceExtremityTech();
                
                $this->addCellule($sheet, $column, $row, $service->getIdTransactionStatus());                                                                                                           // Service Status
                $this->addCellule($sheet, $column, $row, $service->getCdService());                                                                                                                     // Service Ref
                $this->addCellule($sheet, $column, $row, $service->getIdProduct());                                                                                                                     // Product
                $this->addCellule($sheet, $column, $row, $service->getIdBandwidth());                                                                                                                   // Bandwidth
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdProject());                                                                                                            // Project Code
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($serviceExtremityTech->getIdConnectionPath(),$serviceExtremityTech->getIdPortInstance()));       // Connection Path
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getTrader());                                                                                                               // Trader
                $this->addCellule($sheet, $column, $row, $extremityB->getIdCustomer());                                                                                                                 // Far End Customer
                $this->addCellule($sheet, $column, $row, $extremityB->getIdDeliveryAddress());                                                                                                          // End Delivery Address
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($serviceExtremityTechB->getIdConnectionPath(),$serviceExtremityTechB->getIdPortInstance()));     // End Connection Path
                $this->addCellule($sheet, $column, $row, $serviceExtremityTechB->getIdLocalLoop());                                                                                                     // Far End Local Loop Ref
                $this->addCellule($sheet, $column, $row, $extremityB->getTrader());                                                                                                                     // Far End Trader
                $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                                                                                                    // In Service Date

                $row++;                
            } 
            $row += 3;
            $column=0;
        }                 
     }
     
    /**
     * 
     * @param type $sheet
     * @param array $localLoops
     * @param array $post
     */
    public function createdSheetLocalLoopConnectedServices(&$sheet, $localLoop, $post){
        $column=0;
        $services = array();
        $localLoopRef = "";
        
        if($localLoop != null){
            $services = $localLoop->getServices();
            $localLoopRef = "(Ref: ".$localLoop->getCdLocalLoop().") ";
        }
        
        $title = "Local Loop ".$localLoopRef. "Report with Connected Services: Data extraction date ".date("d-m-Y");
        $labels=array(
                        "Nb Connected Services",
                        "Service Ref",
                        "Status du service",
                        "Product",
                        "Bandwidth",
                        "A-End(Customer/POP/Provider)",
                        "A-End Adress",
                        "A-End Status",
                        "B-End(Customer/POP/Provider)",
                        "B-End Adress",
                        "B-End Status"            
                      ); 
                             
        $filtres = array(   
                            array("valeur"=>isset($post['branch'])? $post['branch']: null,                   "entity"=>"Branch",             "label"=>"Branch: "),
                            array("valeur"=>isset($post['carrier'])? $post['carrier']: null,                 "entity"=>"Provider",           "label"=>"Carrier: "),
                            array("valeur"=>isset($post['bandwidth'])?$post['bandwidth']: null,              "entity"=>"BandwidthAssignee",  "label"=>"Bandwidth: "),
                            array("valeur"=>isset($post['capacity'])? $post['capacity']: null,               "entity"=>"Capacity",           "label"=>"Capacity: "),
                            array("valeur"=>isset($post['localLoopStatus'])? $post['localLoopStatus']: null, "entity"=>"TransactionStatus",  "label"=>"Local Loop Status: "),
                            array("valeur"=>isset($post['customer'])? $post['customer']: null,               "entity"=>"Customer",           "label"=>"Extremity customer: "),
                            array("valeur"=>isset($post['provider'])? $post['provider']: null,               "entity"=>"Provider",           "label"=>"Extremity provider: "), 
                            array("valeur"=>isset($post['pop'])? $post['pop']: null,                         "entity"=>"Pop",                "label"=>"Extremity pop: ")
                       );
  
        
        $row = $this->createdEntete($sheet, $labels, $title, $filtres); 
               
        foreach ($services as $service){   
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            
            $this->addCellule($sheet, $column, $row, null);                                        // Nb Connected Services           
            $this->addCellule($sheet, $column, $row, $service->getCdService());                    // Service Ref
            $this->addCellule($sheet, $column, $row, $service->getIdTransactionStatus());          // Status du service
            $this->addCellule($sheet, $column, $row, $service->getIdProduct());                    // Product
            $this->addCellule($sheet, $column, $row, $service->getIdBandwidth());                  // Bandwidth            
            
            $i = 0;
            foreach ($service->getIdServiceExtremity() as $serviceExtremity) {
                if($i<2){
                    
                    $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremity());   // A-End or B-End(Customer/POP/Provider)
                    
                    $extremityAdress = $serviceExtremity->getIdDeliveryAddress();

                    if($extremityAdress && $extremityAdress->getBlStatus())
                        $this->addCellule($sheet, $column, $row, $extremityAdress);                // Extremity A or B Address
                    else
                        $column++;
                                   
                    $this->addCellule($sheet, $column, $row, $serviceExtremity->getStatus());      // A-End or B-End Status  
                }
                $i++;
            }
                       
            $row++;
            $column=0;
        }  
           
        $this->getStyleCellule($sheet, $row, $column, true, 9);       
        $this->addCellule($sheet, $column, $row, "Total: ".count($services));      
     }
     
    /**
     * 
     * @param type &$sheet
     * @param array $services
     * @param array $post
     */
    public function createdSheetPendingServices(&$sheet, $servicesExtremitys, $post){
        $column=0; 
        $title = "PENDING SERVICES ".date("d-m-Y");
        $labels=array(
                        "Service Status",
                        "Service reference",
                        "Commercial branch",
                        "Extremity Ref",
                        "Extremity Branch",
                        "Extremity Customer",
                        "Product name",
                        "Product type",
                        "Requested Delivery Date",
                        "Extremity Requested Delivery Date",
                        "LL Ref",
                        "LL Tech Id",
                        "LL Tested Date",
                        "LL Scheduled Delivery Date",
                        "Backbone Programmed Date",
                        "PIPE ID",
                        "End to End Tested Date", 
                        "In Service Date", 
                        "Real Termination Date", 
                        "Requested Termination Date",      
                        "Initiated Termination Date",
                        "Technical route", 
                        "Sequential Service number",
                        "Project Code", 
                        "Simplified Connection Path"
                      ); 
                             
        $filtres = array(   
                            array("valeur"=>isset($post['commercialBranch'])? $post['commercialBranch']: null,          "entity"=>"Branch",             "label"=>"Commercial branch: "),
                            array("valeur"=>isset($post['extremityBranch'])? $post['extremityBranch']: null,            "entity"=>"Branch",             "label"=>"Extremity branch: "),
                            array("valeur"=>isset($post['customer'])?$post['customer']: null,                           "entity"=>"Customer",           "label"=>"Extremity customer: "),
                            array("valeur"=>isset($post['provider'])? $post['provider']: null,                          "entity"=>"Provider",           "label"=>"Extremity provider: "),
                            array("valeur"=>isset($post['pop'])? $post['pop']: null,                                    "entity"=>"Pop",                "label"=>"Extremity pop: "),
                            array("valeur"=>isset($post['billedCustomer'])? $post['billedCustomer']: null,              "entity"=>"Customer",           "label"=>"Billed customer: "),
                            array("valeur"=>isset($post['projectCode'])? $post['projectCode']: null,                    "entity"=>"Project",            "label"=>"Project Code: "), 
                            array("valeur"=>isset($post['serviceStatus'])? $post['serviceStatus']: null,                "entity"=>"TransactionStatus",  "label"=>"Service Status: ")
                       );
  
        
        $row = $this->createdEntete($sheet, $labels, $title, $filtres);
                            
        foreach ($servicesExtremitys as $serviceExtremity){
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            
            $service = $serviceExtremity->getIdService();
            $serviceExtremityTech = $serviceExtremity->getIdServiceExtremityTech();
            
            $this->addCellule($sheet, $column, $row, $service->getIdTransactionStatus());                               // Service Status
            $this->addCellule($sheet, $column, $row, $service->getCdService());                                         // Service reference 
            $this->addCellule($sheet, $column, $row, $service->getIdBranch());                                          // Commercial branch 
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getCdServiceExtremity());                       // Extremity Ref 
            
            if($serviceExtremity->getExtremity())
                $this->addCellule($sheet, $column, $row, $serviceExtremity->getExtremity()->getIdBranch());             // Extremity Branch  
            else
                $column++; 
            
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdCustomer());                               // Extremity Customer 
            $this->addCellule($sheet, $column, $row, $service->getIdProduct());                                         // Product name
            $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getIdProductType()->getLbProductType()); // Product type 
            $this->addCellule($sheet, $column, $row, $service->getDtDeliveryRequested());                               // Requested Delivery Date 
            
            $localLoop = $serviceExtremityTech->getIdLocalLoop();
            if($localLoop){
                $this->addCellule($sheet, $column, $row, $localLoop->getCdLocalLoop());                                 // LL Ref
                $this->addCellule($sheet, $column, $row, $localLoop->getDtDeliveryRequested());                         // Extremity Requested Delivery Date 
                
                $localLoopExtremityTechs = $localLoop->getIdLocalLoopExtremityTech();
                $localLoopExtremityTech = null;
                if($localLoopExtremityTechs){
                    foreach($localLoopExtremityTechs as $value){
                        switch($value->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner()){
                            case ReportingController::OWNER_CUSTOMER :
                                if($serviceExtremity->getIdDeliveryAddress() && $serviceExtremity->getIdDeliveryAddress()->getIdAddress() == $value->getIdLocalLoopExtremity()->getIdDeliveryAddress()->getIdAddress())
                                    $localLoopExtremityTech = $value; 
                                break;
                            case ReportingController::OWNER_POP :
                                if($serviceExtremity->getIdAddressPop() &&  $serviceExtremity->getIdAddressPop()->getIdAddressPop() == $value->getIdLocalLoopExtremity()->getIdAddressPop()->getIdAddressPop())
                                    $localLoopExtremityTech = $value; 
                                break;
                            case ReportingController::OWNER_PROVIDER :  
                                if($serviceExtremity->getIdAddressProvider() && $serviceExtremity->getIdAddressProvider()->getIdAddressProvider() == $value->getIdLocalLoopExtremity()->getIdAddressProvider()->getIdAddressProvider())
                                    $localLoopExtremityTech = $value; 
                                break;
                        }                                                    
                    }
                    if(!empty($localLoopExtremityTech)){
                        $this->addCellule($sheet, $column, $row, $localLoopExtremityTech);                               // LL Tech Id 
                        $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtOldLlTested());           // LL Tested Date  
                    } else
                        $column+=2;
                }
                else
                    $column+=2;

                $this->addCellule($sheet, $column, $row, $localLoop->getDtScheduledDelivery());                          // LL Scheduled Delivery Date 
            }
            else
                $column += 5;
            
            if($serviceExtremityTech){
                $this->addCellule($sheet, $column, $row, $serviceExtremityTech->getDtBackboneProgram());                 // Backbone Programmed Date 
                $this->addCellule($sheet, $column, $row, $serviceExtremityTech->getCdPipeId());                          // PIPE ID             
                $this->addCellule($sheet, $column, $row, $serviceExtremityTech->getDtEndToEnd());                        // End to End Tested Date 
            }else
                $column += 3;
            
            $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                         // In Service Date 
            $this->addCellule($sheet, $column, $row, $service->getDtRealTerminate());                                    // Real Termination Date 
            $this->addCellule($sheet, $column, $row, $service->getDtRequestTerminate());                                 // Requested Termination Date       
            $this->addCellule($sheet, $column, $row, $service->getDtInitTerminate());                                    // Initiated Termination Date 
            $this->addCellule($sheet, $column, $row, $serviceExtremityTech->retreiveTechnicalRoute());                   // Technical route
            $this->addCellule($sheet, $column, $row, $service->getIdService());                                          // Sequential Service number            
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdProject());                                 // Project Code 
            
            if($serviceExtremityTech)
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($serviceExtremityTech->getIdConnectionPath(),$serviceExtremityTech->getIdPortInstance()));   // Simplified Connection Path 
            
            $row++;
            $column=0;
        } 
        
        
     }
     
    /**
     * 
     * @param type $sheet
     * @param array $localLoops
     * @param array $post
     */
    public function createdSheetLocalLoopOptionsFrenchLL(&$sheet, $localLoops, $post){
        $MrcEuroTotal = 0;
        $NrcEuroTotal = 0;
        $column=0; 
        $title = "Local Loop Report with Options and French LL: Data extraction date ".date("d-m-Y");
        $labels=array(
                        "Nb Local loop",
                        "Branch",
                        "Owner",
                        "Carrier",
                        "Carrier Address",
                        "Link function",
                        "LL usage",
                        "Redundant LL Ref",
                        "Capacitiy Code",
                        "LL Status",
                        "Local loop Ref",
                        "Administrative ref",
                        "Technical ref",
                        "Technical ref2",
                        "Number of connected services",
                        "Bandwidth",
                        "New bandwidth",
                        "LL Order Date",
                        "LL Requested Delivery Date",
                        "LL Scheduled Delivery Date",
                        "Real Delivery Date",
                        "LL Tested Date",
                        "New LL Tested Date",
                        "Requested termination Date",
                        "Real termination Date",
                        "LL Start Billing Date",
                        "LL End Billing Date",
                        "Currency",
                        "MRC",
                        "MRC Details",
                        "MRC EUR",
                        "NRC",
                        "NRC details",
                        "NRC in EUR",
                        "Notice Period",
                        "Billing frequency",
                        "Extremity A customer",
                        "Extremity A Address",
                        "A-End Incoming connection path",
                        "A-End Outgoing connection path",
                        "Extremity B Customer",
                        "Extremity B Address",
                        "B-End Incoming connection path",
                        "B-End Outpoing connection path",
                        "Parent Local Loop",
                        "French Local Loop",
                        "LL Extremity",      
                        "SIRET",
                        "Compte LS",
                        "Situation",
                        "Envoi PTT",
                        "Ordre Racc",
                        "Date fin technique",
                        "Constitution 1",
                        "Constitution Réception",
                        "Date envoi constitution",
                        "Equipement",
                        "Carte nature",
                        "Nombre IT",
                        "Raccordement",
                        "Pénétration",
                        "N° Chrono",
                        "LL Extremity",        
                        "SIRET",
                        "Compte LS",
                        "Situation",
                        "Envoi PTT",
                        "Ordre Racc",
                        "Date fin technique",
                        "Constitution 1",
                        "Constitution Réception",
                        "Date envoi constitution",
                        "Equipement",
                        "Carte nature",
                        "Nombre IT",
                        "Raccordement",
                        "Pénétration",
                        "N° Chrono",
                        "Option type",
                        "Option code",
                        "Option description",
                        "Quantity",
                        "Active(Yes/No)",
                        "Option Creation Date",
                        "Option Update",
                        "Currency",
                        "MRC Start Date",
                        "MRC End Date",
                        "MRC",
                        "MRC Details",
                        "MRC EUR",
                        "NRC",
                        "NRC details",
                        "NRC in EUR"
                      ); 
                             
        $filtres = array(   
                            array("valeur"=>isset($post['branch'])? $post['branch']: null,                            "entity"=>"Branch",                        "label"=>"Branch: "),
                            array("valeur"=>isset($post['carrier'])? $post['carrier']: null,                         "entity"=>"Provider",                      "label"=>"Carrier: "),
                            array("valeur"=>isset($post['linkFunction'])? $post['linkFunction']: null,                "entity"=>"LinkFunction",                  "label"=>"Link function: "),
                            array("valeur"=>isset($post['localLoopStatus'])? $post['localLoopStatus']: null,          "entity"=>"TransactionStatus",             "label"=>"Local Loop Status: "),
                            array("valeur"=>isset($post['customer'])? $post['customer']: null,                        "entity"=>"Customer",                      "label"=>"Extremity customer: "),
                            array("valeur"=>isset($post['provider'])? $post['provider']: null,                        "entity"=>"Provider",                      "label"=>"Extremity provider: "),
                            array("valeur"=>isset($post['pop'])? $post['pop']: null,                                  "entity"=>"Pop",                           "label"=>"Extremity pop: ")

                       );
  
        
        $row = $this->createdEntete($sheet, $labels, $title, $filtres);        
           
        foreach ($localLoops as $localLoop){ 
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            
            $this->addCellule($sheet, $column, $row, null);                                                                                    // Nb Local loop
            $this->addCellule($sheet, $column, $row, $localLoop->getIdBranch()->getLbBranch());                                                // Branch
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopOwner());                                                       // Owner
            $this->addCellule($sheet, $column, $row, $localLoop->getIdProviderOfCarrier());                                                    // Carrier  
            
            $AddressProviders = $localLoop->getIdProviderOfCarrier()->getIdAddressProvider();
            $Addres = null;
            if($AddressProviders){
                foreach($AddressProviders as $value){
                    if($value->getBlStatus() && $value->getIdAddressType()->getIdAddressType()==ReportingController::ADDRESS_TYPE_BILLING)
                        $Addres = $value;
                }
                $this->addCellule($sheet, $column, $row, $Addres);                                                                            // Carrier Address  
            }else
                $column++;
 
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLinkFunction());                                                        // Link function
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopType());                                                       // LL usage
            
            if($localLoop->getIdLocalLoopSister())
                $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopSister()->getCdLocalLoop());                               // Redundant LL Ref
            else
                $column++;
            
            $this->addCellule($sheet, $column, $row, $localLoop->getIdCapacity());                                                            // Capacitiy Code  
            $this->addCellule($sheet, $column, $row, $localLoop->getIdTransactionStatus());                                                   // LL Status
            $this->addCellule($sheet, $column, $row, $localLoop->getCdLocalLoop());                                                           // Local loop Ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdAdministrativeRef());                                                   // Administrative ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef());                                                        // Technical ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef2());                                                       // Technical ref2
            $this->addCellule($sheet, $column, $row, $this->numberOfConnectedService($localLoop->getIdServiceExtremityTech()));               // Number of connected services         
            $this->addCellule($sheet, $column, $row, $localLoop->getIdOldBandwidth());                                                        // Bandwidth
            $this->addCellule($sheet, $column, $row, $localLoop->getIdBandwidth());                                                           // New bandwidth
            $this->addCellule($sheet, $column, $row, $localLoop->getDtOrder());                                                               // LL Order Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtDeliveryRequested());                                                   // LL Requested Delivery Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtScheduledDelivery());                                                   // LL Scheduled Delivery Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtDelivery());                                                            // Real Delivery Date 
            
            $localLoopExtremityTechs = $localLoop->getIdLocalLoopExtremityTech();
            $localLoopExtremityTech = null;
            if($localLoopExtremityTechs){
                foreach($localLoopExtremityTechs as $value){
                    if($value->getDtOldLlTested() != null)
                        $localLoopExtremityTech = $value;
                }
                if(!empty($localLoopExtremityTech)){
                    $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtOldLlTested());                                     // LL Tested Date
                    $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtLlTested());                                        // New LL Tested Date
                }else
                    $column += 2;
            }else
                $column += 2;
              
            $this->addCellule($sheet, $column, $row, $localLoop->getDtRequestTerminate());                                                     // Requested termination Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtRealTerminate());                                                        // Real termination Date
            
            $costingLocalLoopLines = $localLoop->getIdCostingLocalLoopLine();
            $costingLocalLoopLine = $costingLocalLoopLines->first();
            
            if($costingLocalLoopLine){
                $dtStart = null;               
                foreach($costingLocalLoopLines as $value){
                    if($value->getDtStart() && (!$dtStart || ($value->getDtStart()>$dtStart))){
                        $costingLocalLoopLine = $value;
                        $dtStart = $value->getDtStart();
                    }
                }               
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getDtStart());                                                 // LL Start Billing Date
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getDtEnd());                                                   // LL End Billing Date         
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdCurrency());                                              // Currency 
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtMrc());                                                   // MRC
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getLbMrc());                                                   // MRC Details
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtMrcEuro());                                               // MRC EUR
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtNrc());                                                   // NRC
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getLbNrc());                                                   // NRC details
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtNrcEuro());                                               // NRC in EUR
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdNoticePeriod());                                          // Notice Period  
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdBillingFrequency());                                      // Billing frequency 

                $MrcEuroTotal += $costingLocalLoopLine->getMtMrcEuro();
                $NrcEuroTotal += $costingLocalLoopLine->getMtNrcEuro();
                    
           }else
                $column += 11;
           
           $localLoopExtremitys = $localLoop->getIdLocalLoopExtremity();
           $extremityA = null;
           $extremityB = null;
           
            if($localLoopExtremitys){
                $extremityA = $localLoopExtremitys->first();
                $extremityB = $localLoopExtremitys->first();
                
                foreach($localLoopExtremitys as $value){
                    if($extremityB->getIdLocalLoopExtremity() < $value->getIdLocalLoopExtremity())
                        $extremityB = $value;
                    if($extremityA->getIdLocalLoopExtremity() > $value->getIdLocalLoopExtremity())
                        $extremityA = $value;                  
                }
                
                $this->addCellule($sheet, $column, $row, $extremityA->getIdCustomer());                                                         // Extremity A customer

                $extremityAdressA = $extremityA->getIdDeliveryAddress();
                
                if($extremityAdressA && $extremityAdressA->getBlStatus())
                    $this->addCellule($sheet, $column, $row, $extremityAdressA);                                                                // Extremity A Address
                else
                    $column++;

                $extremityTechA = $extremityA->getIdLocalLoopExtremityTech();
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($extremityTechA->getLbConnectionPath(), $extremityTechA->getIdPortInstance()) ); // A-End Incoming connection path
                $outConnectionPath = $extremityTechA->getIdOutConnectionPath();
                $outPortInstance = $extremityTechA->getIdOutPortInstance();

                if($outConnectionPath->first() && $outPortInstance->first())
                    $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($outConnectionPath->first()->getLbConnectionPath(), $outPortInstance->first()->getIdPortInstance()) ); // A-End Outgoing connection path
                else
                    $column++;    

                $this->addCellule($sheet, $column, $row, $extremityB->getIdCustomer());                                                         // Extremity B Customer

                $extremityAdressB = $extremityB->getIdDeliveryAddress();
                if($extremityAdressB && $extremityAdressB->getBlStatus())
                    $this->addCellule($sheet, $column, $row, $extremityAdressB);                                                                // Extremity B Address
                else
                    $column++;

                $extremityTechB = $extremityB->getIdLocalLoopExtremityTech();
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($extremityTechB->getLbConnectionPath(), $extremityTechB->getIdPortInstance()) ); // B-End Incoming connection path
                $outConnectionPath = $extremityTechB->getIdOutConnectionPath();
                $outPortInstance = $extremityTechB->getIdOutPortInstance();

                if($outConnectionPath->first() && $outPortInstance->first())
                    $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($outConnectionPath->first()->getLbConnectionPath(), $outPortInstance->first()->getIdPortInstance()) ); // B-End Outpoing connection path
                else
                    $column++;        
            }else
                $column+= 8;
           
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopParent());                                                        // Parent Local Loop
            $this->addCellule($sheet, $column, $row, $localLoop->getBlFrench());                                                                 // French Local Loop 
           
            $this->columnsExtremityAOrB($sheet, $column, $row, $extremityA);                                                                    // column of extremity A
            $this->columnsExtremityAOrB($sheet, $column, $row, $extremityB);                                                                    // column of extremity B                    
            
            $dtCreate = null;           
            $localLoopOption = null;

            foreach($localLoop->getIdLocalLoopOption() as $value){
                if($value->getBlDeactivated() && ( !$dtCreate || ($value->getDtCreate() && $value->getDtCreate()>$dtCreate))){
                    $localLoopOption = $value;
                    $dtCreate = $value->getDtCreate();
                }                
            }
            
            if($localLoopOption){
                $this->addCellule($sheet, $column, $row, $localLoopOption->getIdOptionType());                                                   // Option type
                $this->addCellule($sheet, $column, $row, $localLoopOption->getCdOption());                                                       // Option code
                $this->addCellule($sheet, $column, $row, $localLoopOption->getLbOption());                                                       // Option description
                $this->addCellule($sheet, $column, $row, $localLoopOption->getNbQuantity());                                                     // Quantity
                $this->addCellule($sheet, $column, $row, "".$localLoopOption->getBlDeactivated());                                               // Active(Yes/No)
                $this->addCellule($sheet, $column, $row, $localLoopOption->getDtCreate());                                                       // Option Creation Date
                $this->addCellule($sheet, $column, $row, $localLoopOption->getDtUpdate());                                                       // Option Update
                
                $costingLocalLoopOptionLines = $localLoopOption->getIdCostingLocalLoopLine();
                $costingLocalLoopOptionLine = $costingLocalLoopOptionLines->first();

                if($costingLocalLoopOptionLine){
                    $dtStart = null;
                    
                    foreach($costingLocalLoopOptionLines as $value){
                        if($value->getDtStart() && (!$dtStart || ($value->getDtStart()>$dtStart))){
                            $costingLocalLoopOptionLine = $value;
                            $dtStart = $value->getDtStart();
                        }
                    }                   
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getIdCurrency());                                     // Currency  
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getDtStartMrc());                                     // MRC Start Date
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getDtEndMrc());                                       // MRC End Date
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getMtMrc());                                          // MRC 
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getLbMrc());                                          // MRC Details 
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getMtMrcEuro());                                      // MRC EUR 
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getMtNrc());                                          // NRC 
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getLbNrc());                                          // NRC details 
                    $this->addCellule($sheet, $column, $row, $costingLocalLoopOptionLine->getMtNrcEuro());                                      // NRC in EUR                                      
               }else
                    $column += 9;               
            }else
                $column += 16;
            
            
            $column=0;
            $row++;
        }  
        
        $columnMrcEuroTotal = 30;
        $columnNrcEuroTotal = 33;
        
        $this->getStyleCellule($sheet, $row, $column, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMrcEuroTotal, true, 9);
        $this->getStyleCellule($sheet, $row, $columnNrcEuroTotal, true, 9);
        
        $this->addCellule($sheet, $column, $row, "Total: ".count($localLoops));
        $this->addCellule($sheet, $columnMrcEuroTotal, $row, "Total: ".number_format($MrcEuroTotal, 2, ',', ''));
        $this->addCellule($sheet, $columnNrcEuroTotal, $row, "Total: ".number_format($NrcEuroTotal, 2, ',', ''));
        
     }
     
    /**
     * 
     * @param type $sheet
     * @param array $localLoops
     * @param array $post
     */
    public function createdSheetLocalLoop(&$sheet, $localLoops, $post){
        
        $MrcEuroTotal = 0;
        $NrcEuroTotal = 0;
        $column=0; 
        $title = "Local Loop Report: Data extraction date ".date("d-m-Y");
        $labels=array(
                        "Nb Local loop",
                        "Branch",
                        "Owner",
                        "Carrier",
                        "Carrier Address",
                        "Link function",
                        "LL usage",
                        "Redundant LL Ref",
                        "Capacitiy Code",
                        "LL Status",
                        "Local loop Ref",
                        "Administrative ref",
                        "Technical ref",
                        "Technical ref2",
                        "Number of connected services",
                        "Bandwidth",
                        "New bandwidth",
                        "LL Order Date",
                        "LL Requested Delivery Date",
                        "LL Scheduled Delivery Date",
                        "Real Delivery Date",
                        "LL Tested Date",
                        "New LL Tested Date",
                        "Requested termination Date",
                        "Real termination Date",
                        "LL Start Billing Date",
                        "LL End Billing Date",
                        "Currency",
                        "MRC",
                        "MRC Details",
                        "MRC EUR",
                        "NRC",
                        "NRC details",
                        "NRC in EUR",
                        "Notice Period",
                        "Billing frequency",
                        "Extremity A customer",
                        "Extremity A Address",
                        "A-End Incoming connection path",
                        "A-End Outgoing connection path",
                        "Extremity B Customer",
                        "Extremity B Address",
                        "B-End Incoming connection path",
                        "B-End Outpoing connection path",
                        "Parent Local Loop",
                        "French Local Loop"
                      ); 
                             
        $filtres = array(   
                            array("valeur"=>isset($post['branch'])? $post['branch']: null,                            "entity"=>"Branch",                        "label"=>"Branch: "),
                            array("valeur"=>isset($post['carrier'])? $post['carrier']: null,                          "entity"=>"Provider",                      "label"=>"Carrier: "),
                            array("valeur"=>isset($post['linkFunction'])? $post['linkFunction']: null,                "entity"=>"LinkFunction",                  "label"=>"Link function: "),
                            array("valeur"=>isset($post['localLoopStatus'])? $post['localLoopStatus']: null,          "entity"=>"TransactionStatus",             "label"=>"Local Loop Status: "),
                            array("valeur"=>isset($post['customer'])? $post['customer']: null,                        "entity"=>"Customer",                      "label"=>"Extremity customer: "),
                            array("valeur"=>isset($post['provider'])? $post['provider']: null,                        "entity"=>"Provider",                      "label"=>"Extremity provider: "),
                            array("valeur"=>isset($post['pop'])? $post['pop']: null,                                  "entity"=>"Pop",                           "label"=>"Extremity pop: ")

                       );
         
        $row = $this->createdEntete($sheet, $labels, $title, $filtres);  
        
        foreach ($localLoops as $localLoop){ 
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            
            $this->addCellule($sheet, $column, $row, null);                                                                                    // Nb Local loop
            $this->addCellule($sheet, $column, $row, $localLoop->getIdBranch()->getLbBranch());                                                // Branch
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopOwner());                                                       // Owner
            $this->addCellule($sheet, $column, $row, $localLoop->getIdProviderOfCarrier());                                                    // Carrier  
            
            $AddressProviders = $localLoop->getIdProviderOfCarrier()->getIdAddressProvider();
            $Addres = null;
            if($AddressProviders){
                foreach($AddressProviders as $value){
                    if($value->getBlStatus() && $value->getIdAddressType()->getIdAddressType()==ReportingController::ADDRESS_TYPE_BILLING)
                        $Addres = $value;
                }
                $this->addCellule($sheet, $column, $row, $Addres);                                                                            // Carrier Address  
            }else
                $column++;
 
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLinkFunction());                                                        // Link function
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopType());                                                       // LL usage
            
            if($localLoop->getIdLocalLoopSister())
                $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopSister()->getCdLocalLoop());                               // Redundant LL Ref
            else
                $column++;
            
            $this->addCellule($sheet, $column, $row, $localLoop->getIdCapacity());                                                            // Capacitiy Code  
            $this->addCellule($sheet, $column, $row, $localLoop->getIdTransactionStatus());                                                   // LL Status
            $this->addCellule($sheet, $column, $row, $localLoop->getCdLocalLoop());                                                           // Local loop Ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdAdministrativeRef());                                                   // Administrative ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef());                                                        // Technical ref
            $this->addCellule($sheet, $column, $row, $localLoop->getCdTechnicalRef2());                                                       // Technical ref2
            $this->addCellule($sheet, $column, $row, $this->numberOfConnectedService($localLoop->getIdServiceExtremityTech()));               // Number of connected services         
            $this->addCellule($sheet, $column, $row, $localLoop->getIdOldBandwidth());                                                        // Bandwidth
            $this->addCellule($sheet, $column, $row, $localLoop->getIdBandwidth());                                                           // New bandwidth
            $this->addCellule($sheet, $column, $row, $localLoop->getDtOrder());                                                               // LL Order Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtDeliveryRequested());                                                   // LL Requested Delivery Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtScheduledDelivery());                                                   // LL Scheduled Delivery Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtDelivery());                                                            // Real Delivery Date 
            
            $localLoopExtremityTechs = $localLoop->getIdLocalLoopExtremityTech();
            $localLoopExtremityTech = null;
            if($localLoopExtremityTechs){
                foreach($localLoopExtremityTechs as $value){
                    if($value->getDtOldLlTested() != null)
                        $localLoopExtremityTech = $value;
                }
                if(!empty($localLoopExtremityTech)){
                    $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtOldLlTested());                                     // LL Tested Date
                    $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtLlTested());                                        // New LL Tested Date
                }else
                    $column += 2;
            }else
                $column += 2;
              
            $this->addCellule($sheet, $column, $row, $localLoop->getDtRequestTerminate());                                                     // Requested termination Date
            $this->addCellule($sheet, $column, $row, $localLoop->getDtRealTerminate());                                                        // Real termination Date
            
            $costingLocalLoopLines = $localLoop->getIdCostingLocalLoopLine();
            $costingLocalLoopLine = $costingLocalLoopLines->first();
            
            if($costingLocalLoopLine){
                $dtStart = null;               
                foreach($costingLocalLoopLines as $value){
                    if($value->getDtStart() && (!$dtStart || ($value->getDtStart()>$dtStart))){
                        $costingLocalLoopLine = $value;
                        $dtStart = $value->getDtStart();
                    }
                }               
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getDtStart());                                                 // LL Start Billing Date
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getDtEnd());                                                   // LL End Billing Date         
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdCurrency());                                              // Currency 
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtMrc());                                                   // MRC
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getLbMrc());                                                   // MRC Details
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtMrcEuro());                                               // MRC EUR
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtNrc());                                                   // NRC
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getLbNrc());                                                   // NRC details
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getMtNrcEuro());                                               // NRC in EUR
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdNoticePeriod());                                          // Notice Period  
                $this->addCellule($sheet, $column, $row, $costingLocalLoopLine->getIdBillingFrequency());                                      // Billing frequency 

                $MrcEuroTotal += $costingLocalLoopLine->getMtMrcEuro();
                $NrcEuroTotal += $costingLocalLoopLine->getMtNrcEuro();
                    
           }else
                $column += 11;
           
           $localLoopExtremitys = $localLoop->getIdLocalLoopExtremity();
           $extremityA = null;
           $extremityB = null;
           
            if($localLoopExtremitys){
                $extremityA = $localLoopExtremitys->first();
                $extremityB = $localLoopExtremitys->first();
                
                foreach($localLoopExtremitys as $value){
                    if($extremityB->getIdLocalLoopExtremity() < $value->getIdLocalLoopExtremity())
                        $extremityB = $value;
                    if($extremityA->getIdLocalLoopExtremity() > $value->getIdLocalLoopExtremity())
                        $extremityA = $value;                  
                }
                
                $this->addCellule($sheet, $column, $row, $extremityA->getIdCustomer());                                                         // Extremity A customer

                $extremityAdressA = $extremityA->getIdDeliveryAddress();
                
                if($extremityAdressA && $extremityAdressA->getBlStatus())
                    $this->addCellule($sheet, $column, $row, $extremityAdressA);                                                                // Extremity A Address
                else
                    $column++;

                $extremityTechA = $extremityA->getIdLocalLoopExtremityTech();
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($extremityTechA->getLbConnectionPath(), $extremityTechA->getIdPortInstance()) ); // A-End Incoming connection path
                $outConnectionPath = $extremityTechA->getIdOutConnectionPath();
                $outPortInstance = $extremityTechA->getIdOutPortInstance();

                if($outConnectionPath->first() && $outPortInstance->first())
                    $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($outConnectionPath->first()->getLbConnectionPath(), $outPortInstance->first()->getIdPortInstance()) ); // A-End Outgoing connection path
                else
                    $column++;    

                $this->addCellule($sheet, $column, $row, $extremityB->getIdCustomer());                                                         // Extremity B Customer

                $extremityAdressB = $extremityB->getIdDeliveryAddress();
                if($extremityAdressB && $extremityAdressB->getBlStatus())
                    $this->addCellule($sheet, $column, $row, $extremityAdressB);                                                                // Extremity B Address
                else
                    $column++;

                $extremityTechB = $extremityB->getIdLocalLoopExtremityTech();
                $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($extremityTechB->getLbConnectionPath(), $extremityTechB->getIdPortInstance()) ); // B-End Incoming connection path
                $outConnectionPath = $extremityTechB->getIdOutConnectionPath();
                $outPortInstance = $extremityTechB->getIdOutPortInstance();

                if($outConnectionPath->first() && $outPortInstance->first())
                    $this->addCellule($sheet, $column, $row, EtraliGinangBundle::getUnlinkedConnectionPath($outConnectionPath->first()->getLbConnectionPath(), $outPortInstance->first()->getIdPortInstance()) ); // B-End Outpoing connection path
                else
                    $column++;        
            }else
                $column+= 8;
           
            $this->addCellule($sheet, $column, $row, $localLoop->getIdLocalLoopParent());                                                        // Parent Local Loop
            $this->addCellule($sheet, $column, $row, $localLoop->getBlFrench());                                                                 // French Local Loop 
                      
            $column=0;
            $row++;
        }  
        
        $columnMrcEuroTotal = 30;
        $columnNrcEuroTotal = 33;
        
        $this->getStyleCellule($sheet, $row, $column, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMrcEuroTotal, true, 9);
        $this->getStyleCellule($sheet, $row, $columnNrcEuroTotal, true, 9);
        
        $this->addCellule($sheet, $column, $row, "Total: ".count($localLoops));
        $this->addCellule($sheet, $columnMrcEuroTotal, $row, "Total: ".number_format($MrcEuroTotal, 2, ',', ''));
        $this->addCellule($sheet, $columnNrcEuroTotal, $row, "Total: ".number_format($NrcEuroTotal, 2, ',', ''));
        
     }
          
    /**
     * 
     * @param type $sheet
     * @param array $extremityTerminationsMultipoint
     * @param array $post
     */
    public function createdSheetExtremityTerminatedMultipoint(&$sheet, $extremityTerminationsMultipoint, $post){
        $totalMtMrcEuro = 0;
        $totalMtNrcEuro = 0;
        $nbMtMrcEuro = 0;
        $nbMtNrcEuro = 0;       
        $column=0; 
        
        if(!empty($post['periodEndDate']) && !empty($post['periodStartDate']))
             $title = "New orders switched into 'Terminated' (Multipoint) in periode from ".$post['periodStartDate']." to ".$post['periodEndDate'];      //$sheet->setCellValueByColumnAndRow(0,4,"Selected Period: ".$post['periodStartDate'].' - '.$post['periodEndDate']);       
        else
             $title = "New orders switched into 'Terminated' (Multipoint)";
        
        $labels=array(
                        "Nb extremities",
                        "Billing branch",
                        "Product name",
                        "Product type",
                        "Billed Customer",
                        "Billed extremities",
                        "Service reference",
                        "Extremity reference of terminated extremity",
                        "In Service Date of Service",
                        "Extremity in Service date",
                        "Extremity Real Termination Date",
                        "Extremity Requested Termination",
                        "Extremity Initiation Termination",
                        "Start Billing Date",
                        "End Billing Line",
                        "Billing Currency",
                        "MRC in Billing currency",
                        "MRC EUR",
                        "NRC in Billing currency",
                        "NRC in EUR",
                        "Customer name",
                        "Commercial Route of the extremity",
                        "Technical route of the extremity",
                        "Sequential Service number"
                      ); 
                             
        $filtres = array(array("valeur"=>isset($post['idBranch'])? $post['idBranch']: null,  "entity"=>"Branch",  "label"=>"Selected Billing branches: "));
         
        $row = $this->createdEntete($sheet, $labels, $title, $filtres); 
               
        foreach ($extremityTerminationsMultipoint as $serviceExtremity){
            $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
            
            $service = $serviceExtremity->getIdService();
            $billingServiceLines = $serviceExtremity->getIdBillingServiceLine();
            $billingServiceLine = null;
            $billingService = null;
            
            if($billingServiceLines){
                $dtStartMrc = null;
                
                foreach($billingServiceLines as $value){
                    if($value->getDtStartMrc() && (!$dtStartMrc || ($value->getDtStartMrc() > $dtStartMrc))){
                        $billingServiceLine = $value;
                        $dtStartMrc = $value->getDtStartMrc();
                    }
                }
            }
            if(!empty($billingServiceLine))
                $billingService = $billingServiceLine->getIdBillingService();

            $this->addCellule($sheet, $column, $row, null);                                                                 // Nb extremities
            $this->addCellule($sheet, $column, $row, $service->getIdBranch()->getLbBranch());                               // Billing branch
            $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getlbProduct());                             // Product name
            $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getIdProductType()->getLbProductType());     // Product type
            
            if(!empty($billingService))
                $this->addCellule($sheet, $column, $row, $billingService);                                                  // Billed Customer
            else
                $column++;
            
            $this->addCellule($sheet, $column, $row, $serviceExtremity);                                                    // Billed extremities
            $this->addCellule($sheet, $column, $row, $service->getCdService());                                             // Service reference
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getCdServiceExtremity());                           // Extremity reference of terminated extremity  
            $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                            // In Service Date of Service  
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtInservice());                                  // Extremity in Service date
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtRealTerminate());                              // Extremity Real Termination Date
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtRequestTerminate());                           // Extremity Requested Termination
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getDtInitTerminate());                              // Extremity Initiation Termination

            if(!empty($billingServiceLine)){
                if(!empty($billingService)){
                    $this->addCellule($sheet, $column, $row, $billingService->getDtStart());                                // Start Billing Date  
                    $this->addCellule($sheet, $column, $row, $billingService->getDtEnd());                                  // End Billing Line                      
                }else
                    $column +=2;
                
                $this->addCellule($sheet, $column, $row, $billingServiceLine->getIdCurrency());                             // Billing Currency                   
                $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrc());                                  // MRC in Billing currency
                $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrcEuro());                              // MRC EUR
                $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrc());                                  // NRC in Billing currency
                $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrcEuro());                              // NRC in EUR
            }else 
                $column +=7;
            
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdCustomer());                                   // Customer name
            $this->addCellule($sheet, $column, $row, $service->getIdCommercialRoute());                                     // Commercial Route of the extremity
            $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdServiceExtremityTech()->retreiveTechnicalRoute()); // Technical route of the extremity
            $this->addCellule($sheet, $column, $row, $service->getIdService());                                             // Sequential Service number

            if(!empty($billingServiceLine)){
                $totalMtMrcEuro += $billingServiceLine->getMtMrcEuro();
                $totalMtNrcEuro += $billingServiceLine->getMtNrcEuro();

                if($billingServiceLine->getMtMrcEuro())
                    $nbMtMrcEuro++;
                if($billingServiceLine->getMtNrcEuro())
                    $nbMtNrcEuro++; 
            }

            $column=0;
            $row++;
        }  
                
        $this->addCellule($sheet, $column, $row, "Total: ".count($extremityTerminationsMultipoint));
        
        $columnMtMrcEuro = 0 ;
        $columnMtNrcEuro = 0 ;  
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_TERMINATED_MULTIPOINT);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        $this->addCellule($sheet, $columnMtMrcEuro, $row, "Total: ".number_format($totalMtMrcEuro, 2, ',', ''));
        $this->addCellule($sheet, $columnMtNrcEuro, $row, "Total: ".number_format($totalMtNrcEuro, 2, ',', ''));

        $row++;   
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_TERMINATED_MULTIPOINT);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        
        if($nbMtMrcEuro)
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: ".number_format($totalMtMrcEuro/$nbMtMrcEuro, 2, ',', ''));
        else
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: 0,00 ");

        if($nbMtNrcEuro)
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: ".number_format($totalMtNrcEuro/$nbMtNrcEuro, 2, ',', ''));           
        else              
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: 0,00 ");    

    }
    
    /**
     * 
     * @param type $sheet
     * @param array $services
     * @param array $post
     */
    public function createdSheetServiceInService(&$sheet, $services, $post){
        $totalMtMrcEuro = 0;
        $totalMtNrcEuro = 0;
        $nbMtMrcEuro = 0;
        $nbMtNrcEuro = 0;
        $column=0; 
        $servcount=array();
        $maxNbCustomer  = $this->maxNbCustomer($services);
        
        if(!empty($post['periodEndDate']) && !empty($post['periodStartDate']))
             $title = "New orders switched into 'In Service' in periode from ".$post['periodStartDate']." to ".$post['periodEndDate'];      //"Selected Period: ".$post['periodStartDate'].' - '.$post['periodEndDate']
        else
             $title = "New orders switched into 'In Service'";   //"Selected Period: ALL"
       
        $labels=array(
                        "Id service",
                        "Billing branch",
                        "Product name",
                        "Product type",
                        "Billed Customer",
                        "Billed extremities",
                        "Service reference",
                        "In Service Date",
                        "Start Billing Date",
                        "Billing Currency",
                        "MRC in Billing currency",
                        "MRC EUR",
                        "NRC in Billing currency",
                        "NRC in EUR"
                     );

        for($i=0; $i<$maxNbCustomer; $i++)
            $labels[]="Customer name";

        $labels[]="Commercial Route";
        $labels[]="Technical route";
        $labels[]="Sequential Service number";
        
        $filtres = array(array("valeur"=>isset($post['idBranch'])? $post['idBranch']: null,  "entity"=>"Branch",  "label"=>"Selected Billing branches: "));
        $row = $this->createdEntete($sheet, $labels, $title, $filtres);
      
        foreach ($services as $service){
            foreach ($service->getIdBillingService() as $billingService){
                foreach ($billingService->getIdBillingServiceLine() as $billingServiceLine){
                    $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
                    
                    $servcount[$service->getIdService()]=1;
                    $this->addCellule($sheet, $column, $row, $service->getIdService());                                                // Id services
                    $this->addCellule($sheet, $column, $row, $service->getIdBranch()->getLbBranch());                                  // Billing branch
                    $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getlbProduct());                                // Product name
                    $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getIdProductType()->getLbProductType());        // Product type
                    $this->addCellule($sheet, $column, $row, $billingService);                                                         // Billed Customer 
                    $this->addCellule($sheet, $column, $row, $this->billedExtremities($billingServiceLine->getIdServiceExtremity()));  // Billed extremities
                    $this->addCellule($sheet, $column, $row, $service->getCdService());                                                // Service reference                          
                    $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                               // In Service Date               
                    $this->addCellule($sheet, $column, $row, $billingService->getDtStart());                                           // Start Billing Date
                    $this->addCellule($sheet, $column, $row, $billingServiceLine->getIdCurrency());                                    // Billing Currency
                    $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrc());                                         // MRC in Billing currency
                    $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrcEuro());                                     // MRC EUR
                    $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrc());                                         // NRC in Billing currency
                    $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrcEuro());                                     // NRC in EUR

                    foreach ($billingServiceLine->getIdServiceExtremity() as $serviceExtremity)
                       $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdCustomer());                                   // Customer name

                    $column += $maxNbCustomer - count($billingServiceLine->getIdServiceExtremity());                                   // vide
                       
                    $this->addCellule($sheet, $column, $row, $service->getIdCommercialRoute());                                        // Commercial Route
                    $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdServiceExtremityTech()->retreiveTechnicalRoute());  // Technical route
                    $this->addCellule($sheet, $column, $row, $service->getIdService());                                                // Sequential Service number

                    $totalMtMrcEuro += $billingServiceLine->getMtMrcEuro();
                    $totalMtNrcEuro += $billingServiceLine->getMtNrcEuro();

                    if($billingServiceLine->getMtMrcEuro())
                        $nbMtMrcEuro++;
                    if($billingServiceLine->getMtNrcEuro())
                        $nbMtNrcEuro++;

                    $column=0;
                    $row++;
                }
             }
        }
        
        $this->addCellule($sheet, $column, $row, "Total: ".count($servcount));
        
        $columnMtMrcEuro = 0 ;
        $columnMtNrcEuro = 0 ;  
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_IN_SERVICE);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        $this->addCellule($sheet, $columnMtMrcEuro, $row, "Total: ".number_format($totalMtMrcEuro, 2, ',', ''));
        $this->addCellule($sheet, $columnMtNrcEuro, $row, "Total: ".number_format($totalMtNrcEuro, 2, ',', ''));

        $row++;   
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_IN_SERVICE);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        
        if($nbMtMrcEuro)
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: ".number_format($totalMtMrcEuro/$nbMtMrcEuro, 2, ',', ''));
        else
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: 0,00 ");

        if($nbMtNrcEuro)
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: ".number_format($totalMtNrcEuro/$nbMtNrcEuro, 2, ',', ''));           
        else              
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: 0,00 ");    
    }
    
    /**
     * 
     * @param type $sheet
     * @param array $services
     * @param array $post
     */
    public function createdSheetServiceTerminated(&$sheet, $services, $post){
        $totalMtMrcEuro = 0;
        $totalMtNrcEuro = 0;
        $nbMtMrcEuro = 0;
        $nbMtNrcEuro = 0;
        $column=0; 
        $maxNbCustomer  = $this->maxNbCustomer($services);
        
        if(!empty($post['periodEndDate']) && !empty($post['periodStartDate']))
             $title = "New orders switched into 'Terminated' in periode from ".$post['periodStartDate']." to ".$post['periodEndDate'];      //$sheet->setCellValueByColumnAndRow(0,4,"Selected Period: ".$post['periodStartDate'].' - '.$post['periodEndDate']);       
        else
             $title = "New orders switched into 'Terminated'";
       
        $labels=array(
                        "Id service",
                        "Billing branch",
                        "Product name",
                        "Product type",
                        "Billed Customer",
                        "Billed extremities",
                        "Service reference",
                        "In Service Date",
                        "Real Termination Date",
                        "Requested Termination Date",
                        "Initiation Termination Date",
                        "Start Billing Date",
                        "Billing Currency",
                        "MRC in Billing currency",
                        "MRC EUR",
                        "NRC in Billing currency",
                        "NRC in EUR"
                     );

        for($i=0; $i<$maxNbCustomer; $i++)
            $labels[]="Customer name";

        $labels[]="Commercial Route";
        $labels[]="Technical route";
        $labels[]="Sequential Service number";
        
        $filtres = array(array("valeur"=>isset($post['idBranch'])? $post['idBranch']: null,  "entity"=>"Branch",  "label"=>"Selected Billing branches: "));
        $row = $this->createdEntete($sheet, $labels, $title, $filtres);
        
        $serviceCount=array();
        foreach ($services as $service){
           foreach ($service->getIdBillingService() as $billingService){
                    foreach ($billingService->getIdBillingServiceLine() as $billingServiceLine){
                        $this->getStyleCellule($sheet,$row, $column, false, 10, 'Arial', 'FF000000', 'solid', 'FCFAE1');
                        
                        $serviceCount[$service->getIdService()]=1;
                        $this->addCellule($sheet, $column, $row, $service->getIdService());                                                 // Id services
                        $this->addCellule($sheet, $column, $row, $service->getIdBranch()->getLbBranch());                                   // Billing branch
                        $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getlbProduct());                                 // Product name
                        $this->addCellule($sheet, $column, $row, $service->getIdProduct()->getIdProductType()->getLbProductType());         // Product type
                        $this->addCellule($sheet, $column, $row, $billingService);                                                          // Billed Customer
                        $this->addCellule($sheet, $column, $row, $this->billedExtremities($billingServiceLine->getIdServiceExtremity()));   // Billed extremities
                        $this->addCellule($sheet, $column, $row, $service->getCdService());                                                 // Service reference                
                        $this->addCellule($sheet, $column, $row, $service->getDtDelivery());                                                // In Service Date
                        $this->addCellule($sheet, $column, $row, $service->getDtRealTerminate());                                           // Real Termination Date
                        $this->addCellule($sheet, $column, $row, $service->getDtRequestTerminate());                                        // Requested Termination Date
                        $this->addCellule($sheet, $column, $row, $service->getDtInitTerminate());                                           // Initiation Termination Date                            
                        $this->addCellule($sheet, $column, $row, $billingService->getDtStart());                                            // Start Billing Date
                        $this->addCellule($sheet, $column, $row, $billingServiceLine->getIdCurrency());                                     // Billing Currency
                        $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrc());                                          // MRC in Billing currency
                        $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtMrcEuro());                                      // MRC EUR
                        $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrc());                                          // NRC in Billing currency
                        $this->addCellule($sheet, $column, $row, $billingServiceLine->getMtNrcEuro());                                      // NRC in EUR


                        foreach ($billingServiceLine->getIdServiceExtremity() as $serviceExtremity)
                           $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdCustomer());                                    // Customer name

                        $column += $maxNbCustomer - count($billingServiceLine->getIdServiceExtremity());                                    // vide

                        $this->addCellule($sheet, $column, $row, $service->getIdCommercialRoute());                                         // Commercial Route
                        $this->addCellule($sheet, $column, $row, $serviceExtremity->getIdServiceExtremityTech()->retreiveTechnicalRoute()); // Technical route
                        $this->addCellule($sheet, $column, $row, $service->getIdService());                                                 // Sequential Service number

                        $totalMtMrcEuro += $billingServiceLine->getMtMrcEuro();
                        $totalMtNrcEuro += $billingServiceLine->getMtNrcEuro();

                        if($billingServiceLine->getMtMrcEuro())
                            $nbMtMrcEuro++;
                        if($billingServiceLine->getMtNrcEuro())
                            $nbMtNrcEuro++;

                        $column=0;
                        $row++;
                }
            }
        }
             
        $this->addCellule($sheet, $column, $row, "Total: ".count($serviceCount));
        
        $columnMtMrcEuro = 0 ;
        $columnMtNrcEuro = 0 ;  
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_TERMINATED);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        $this->addCellule($sheet, $columnMtMrcEuro, $row, "Total: ".number_format($totalMtMrcEuro, 2, ',', ''));
        $this->addCellule($sheet, $columnMtNrcEuro, $row, "Total: ".number_format($totalMtNrcEuro, 2, ',', ''));

        $row++;   
        $this->InitPositionTotalMtMrcNrc($columnMtMrcEuro, $columnMtNrcEuro, ReportingController::TYPE_SHEET_TERMINATED);
        $this->getStyleCellule($sheet, $row, $columnMtMrcEuro, true, 9);
        $this->getStyleCellule($sheet, $row, $columnMtNrcEuro, true, 9);
        
        if($nbMtMrcEuro)
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: ".number_format($totalMtMrcEuro/$nbMtMrcEuro, 2, ',', ''));
        else
            $this->addCellule($sheet, $columnMtMrcEuro, $row, "Average: 0,00 ");

        if($nbMtNrcEuro)
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: ".number_format($totalMtNrcEuro/$nbMtNrcEuro, 2, ',', ''));           
        else              
            $this->addCellule($sheet, $columnMtNrcEuro, $row, "Average: 0,00 ");    

    }
  
    /**
     * 
     * @param array $post
     * @param string $title
     * @param array $sheetParametre
     * 
     * @return Response
     */
    public function export($post, $title, $sheetParametre){
        // ask the service for a Excel2007
        $excelService = $this->get('xls.service_xls2007');

        // create the object see http://phpexcel.codeplex.com documentation
        $excelService->excelObj->getProperties()->setCreator("Gina NG")->setTitle($title);
        
        $this->Excel = $excelService->excelObj;
        for($i=0; $i< count($sheetParametre); $i++){
            if($i){               
                $excelService->excelObj->createSheet();
                $sheet_i = $excelService->excelObj->getSheet($i);
            }else
                $sheet_i = $excelService->excelObj->setActiveSheetIndex(0);
            
            $this->{$sheetParametre[$i]['method_name']}($sheet_i, $sheetParametre[$i]['list'], $post);
            $sheet_i->setTitle($sheetParametre[$i]['title']);
        }
              
        //create the response
        $response = $excelService->getResponse();
        $response->headers->set('Content-Type', 'text/vnd.ms-excel; charset=utf-8');
        $response->headers->set('Content-Disposition', 'attachment;filename=Service.xlsx');

        // If you are using a https connection, you have to set those two headers for compatibility with IE <9
        $response->headers->set('Pragma', 'public');
        $response->headers->set('Cache-Control', 'maxage=1');
        
        return $response;    
      }
     
    /**
     * 
     * @param type &$sheet
     * @param int &$column
     * @param int $row
     * @param object $cellule
     */
    public function addCellule(&$sheet, &$column, $row, $cellule){
       if ($cellule !==null)
       {            
           if (!is_a($cellule, 'datetime'))
               $sheet->setCellValueByColumnAndRow($column,$row,$cellule."") ;
           else
               $sheet->setCellValueByColumnAndRow($column,$row,$cellule->format('d/m/Y')) ;
       }else
           $sheet->setCellValueByColumnAndRow($column,$row,null) ;
       $column++;
    }  
    
    /**
     * 
     * @param type $sheet
     * @param int $row
     * @param int $column
     * @param string $bold
     * @param int $size
     * @param string $fontName
     * @param string $fontColor
     * @param string $fillType
     * @param string $fillColor
     */
    public function getStyleCellule(&$sheet, $row, $column, $bold=false, $size=12, $fontName='Arial', $fontColor='FF000000', $fillType='solid', $fillColor ='FFFFFFFF'){
        $style = $sheet->getStyle($row, $column);
        $styleFont = $style->getFont();
        $styleFont->setBold($bold);
        $styleFont->setSize($size);
        $styleFont->setName($fontName);
        $styleFont->getColor()->setARGB($fontColor);
        $style->applyFromArray(array('fill'=>array('type'=> $fillType,'color'=>array('argb'=>$fillColor))));
    }    
    
    /**
     * 
     * @param array $services
     * @return int
     */
    public function maxNbCustomer($services){
        $max = 0;
        foreach ($services as $service){
            foreach ($service->getIdBillingService() as $billingService){
                foreach ($billingService->getIdBillingServiceLine() as $billingServiceLine){
                    $m = count($billingServiceLine->getIdServiceExtremity());
                    if($max < $m)
                        $max = $m;
                }
            }                 
        }
        return $max;
    }
         
    /**
     * 
     * @param array $ServiceExtremitys
     * @return string
     */
    public function billedExtremities($ServiceExtremitys){
        $return = "";
        foreach ($ServiceExtremitys as $ServiceExtremity)
            $return .= $ServiceExtremity.", ";
        
        return  substr($return,0,strlen($return)-2);  
    } 
    
    /**
     * 
     * @param int &$columnMtMrcEuro
     * @param int &$columnMtNrcEuro
     * @param int $typeSheet
     */
    public function InitPositionTotalMtMrcNrc(&$columnMtMrcEuro, &$columnMtNrcEuro, $typeSheet){      
        switch($typeSheet){
             case ReportingController::TYPE_SHEET_IN_SERVICE :
                $columnMtMrcEuro = 11;
                $columnMtNrcEuro = 13;
                break;
             case ReportingController::TYPE_SHEET_TERMINATED :
                $columnMtMrcEuro = 14;
                $columnMtNrcEuro = 16;
                break;
             case ReportingController::TYPE_SHEET_TERMINATED_MULTIPOINT: 
                $columnMtMrcEuro = 17;
                $columnMtNrcEuro = 19;
                break;
             default :               
        }
    }
    
    /**
     * 
     * @param type $vals
     * @param type $entity
     * @param type $text
     * @param type $sheet
     * @param type $row
     */
    public function lineCriteriaFilter($vals, $entity, $text, &$sheet, $row){
        if($entity){
            if($vals){
                 $repository = $this->getDoctrine()
                      ->getManager()
                      ->getRepository('EtraliGinangBundle:'.$entity);
                 $list = "";
                 foreach ($vals as $id)
                     $list.= $repository->find($id).", ";               

                 $sheet->setCellValueByColumnAndRow(0,$row,$text.substr($list, 0, strlen($list)-2));  
            }else
                $sheet->setCellValueByColumnAndRow(0,$row,$text."ALL");
        }else
            $sheet->setCellValueByColumnAndRow(0,$row,$text);
    }
    
    /**
     * 
     * @param array $vals
     * @param string $entity
     * 
     * @return string
     */
    public function listValue($vals, $entity, &$list){
         if($vals){
            $repository = $this->getDoctrine()
                  ->getManager()
                  ->getRepository('EtraliGinangBundle:'.$entity);           
             foreach ($vals as $id)
                 $list.= $repository->find($id).", ";
         }
    }
   
    /**
     * 
     * @param array $idServiceExtremityTech
     * 
     * @return int
     */
    public function numberOfConnectedService($ServiceExtremityTechs){       
        if($ServiceExtremityTechs){
            $tab = array();
            foreach ($ServiceExtremityTechs as $serviceExtremityTech ){
                if(!in_array($serviceExtremityTech->getIdServiceExtremityTech(), $tab))
                       $tab[] = $serviceExtremityTech->getIdServiceExtremityTech();
            }
            
            if(count($tab))
                return count($tab); 
            else 
                return "0";
        }
        return "0";
    }

    /**
     * 
     * @param type $sheet
     * @param int $column
     * @param int $row
     * @param LocalLoopExtremity $extremity
     */
    public function columnsExtremityAOrB(&$sheet, &$column, $row, $extremity){  
        if($extremity){
            $this->addCellule($sheet, $column, $row, $extremity);                                                           // LL Extremity
            $this->addCellule($sheet, $column, $row, $extremity->getLbSiret());                                             // SIRET
            $this->addCellule($sheet, $column, $row, $extremity->getLbLsAccount());                                         // Compte LS               
            $this->addCellule($sheet, $column, $row, $extremity->getIdLocalLoopExtremitySituation());                       // Situation
            $this->addCellule($sheet, $column, $row, $extremity->getDtPtt());                                               // Envoi PTT
            $this->addCellule($sheet, $column, $row, $extremity->getDtOrdreRacc());                                         // Ordre Racc
            $this->addCellule($sheet, $column, $row, $extremity->getDtFinTech());                                           // Date fin technique
            
            $localLoopExtremityTech = $extremity->getIdLocalLoopExtremityTech();
            if($localLoopExtremityTech){
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getConstit1());                           // Constitution 1
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getConstitReception());                   // Constitution Réception
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getDtConstit());                          // Date envoi constitution
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getEquipement());                         // Equipement
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getCarteNature());                        // Carte nature
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getNombreIt());                           // Nombre IT
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getRaccordement());                       // Raccordement
                $this->addCellule($sheet, $column, $row, $localLoopExtremityTech->getPenetration());                        // Pénétration
            }else
                $column += 8;
           
            $this->addCellule($sheet, $column, $row, $extremity->getNbChrono());                                            // N° Chrono
        }else
            $column += 16;
          
    }
    
    /**
     * 
     * @param string $date
     * @return string
     */
    public function dateToMysql($date){
        $tab=explode("/",$date);
        return $tab[2]."-".$tab[1]."-".$tab[0];
    }
    
    /**
     * 
     * @param sheet &$sheet
     * @param array $labelsTitleTab
     * @param string $title
     * @param array $filtres
     * @param int $marge
     * @return int
     */
    public function createdEntete(&$sheet, $labelsTitleTab, $title, $filtres, $row=4, $enteteTab=true){
        $this->getStyleCellule($sheet, 2, 0, true, 26); 
        $sheet->setCellValueByColumnAndRow(0, 2, $title);
                
        foreach($filtres as $filtre){
            $this->getStyleCellule($sheet, $row, 0, true, 15);
            $this->lineCriteriaFilter($filtre["valeur"], $filtre["entity"], $filtre["label"], $sheet, $row);           
            $row ++;
        } 
        if($enteteTab){
            $row+=3;
            $this->createdEnteteTab($sheet, $labelsTitleTab, $row);  
        }
        return $row;
    }
    
    /**
     * 
     * @param type $sheet
     * @param array $labels
     * @param int &$row
     */
    public function createdEnteteTab(&$sheet, $labels, &$row){
        $column=0;
        
        $sheet->getRowDimension(''.$row)
              ->setRowHeight(40);
        
        foreach ($labels as $column_title)
        {   $this->getStyleCellule($sheet,$row, $column, true, 12, 'Arial', 'FFFFFFFF', 'solid', '046380');
        
            if($column)
                $sheet->getColumnDimensionByColumn($column)->setAutoSize(true);
            
            $sheet->setCellValueByColumnAndRow($column, $row, $column_title);
            $column++;
        }

        $row++;      
    }
}
