<?php

namespace Etrali\GinangBundle\Controller\Service;

use Admingenerated\EtraliGinangBundle\BaseServiceController\EditController as BaseEditController;
use DateInterval;
use Etrali\GinangBundle\Entity\Service;
use Etrali\GinangBundle\Entity\ServiceCaracs;
use Etrali\GinangBundle\Entity\ServiceTransactions;
use Etrali\GinangBundle\Form\Type\Service\CustomValidator;
use Etrali\GinangBundle\SendMail;
use Symfony\Component\Form\Form;
use Symfony\Component\HttpFoundation\RedirectResponse;

class EditController extends BaseEditController
{    
    public function getReturnFunction($pk)
    {
        $Service=$this->getObject($pk);
        if ($this->get('request')->query->get('reedit'))
           return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit",array("pk"=>$pk)));
        else
            return parent::getReturnFunction($pk);
    }
    
    public function getEntityData($Service)
    {
        $products=array(1,2,3,4,17,18,19,10,11,12,13,14,22,23,27);
        $statuses=array(47,58,69,79,89);
        $idProductType=$Service->getIdProduct()->getIdProductType()->getIdProductType();
        $id_status=$Service->getIdTransactionStatus()->getIdTransactionStatus();
        
        return (in_array($idProductType,$products) && in_array($id_status,$statuses) && !$Service->getBlValidated());
    }

    
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    }
    
    public function upgradeAction($pk)
    {
        $serv=$this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(66);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(11);        
        $serv->setIdTransactionType($TransType);
        $serv->setIdTransactionStatus($TransStatus); 
        $serv->setIdOldBandwidth($serv->getIdBandwidth());  
        $serv->setIdBandwidth(NULL); 
        $serv->setNbOperation($serv->getNbOperation()+1); 
        $serv->setIdSelectedExtremity(NULL);
        $serv->setDtInitUpdown(NULL);
        $serv->setDtRequestedUpdown(NULL);
        $serv->setDtRealUpdown(NULL);
        $serv->setBlValidated(false);
        $serv->setBlLlstatus(false);
        $serv->setBlBbstatus(false);         
        $em->persist($serv);
        
        $techCaracs=array(30,31,32,33,38,41,42);
        foreach ($serv->getIdServiceExtremityTech() as $extr)
        {
            $extr->setIdLocalLoop(NULL);
            $extr->setIdLocalLoopExtremityTech(NULL);
            foreach ($extr->getIdServiceCaracs() as $carac)
            {
                if (in_array($carac->getIdProductCaracs()->getIdProductCaracs(),$techCaracs))   
                {
                    $carac->setValeur(NULL);
                    $em->persist($carac);
                }
            }
                    
            $em->persist($extr);
        }
        $em->flush();
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit" ,array("pk"=>$pk)));
    }    
    
     public function terminateAction($pk)
    {
        $bbl = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(106);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(17);        
        $bbl->setIdTransactionType($TransType);
        $bbl->setIdTransactionStatus($TransStatus); 
        $bbl->setNbOperation($bbl->getNbOperation()+1);  
        $em->flush();        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit" ,array("pk"=>$pk)));
    }  
    
    public function preForm($Service)
    {
        if ($Service->getIdProduct()->getIdBandwidthAssignee()!=NULL)
            $Service->setIdBandwidth($Service->getIdProduct()->getIdBandwidthAssignee());
    }    
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param Service $Service your \Etrali\GinangBundle\Entity\Service object
     */
    public function preSave(Form $form, Service $Service)
    {
        $foundConnected=false;
        foreach ($Service->getIdServiceCaracs() as $service_carac)
        {
            if ($service_carac->getIdProductCaracs()->getNbLocation()==0 && isset($form[$service_carac->getIdProductCaracs()->getLbField()]))
            {
                if (is_object($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()) && substr(get_class($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()),0,27)=="Etrali\\GinangBundle\\Entity\\")
                {
                    $getter="get".ucfirst($service_carac->getIdProductCaracs()->getLbField());
                    if (method_exists($form[$service_carac->getIdProductCaracs()->getLbField()]->getData(),$getter ))
                        $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->$getter());
                    else
                        $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->getId());
                    
                    /** handle connected services * /
                     * 
                     */
                    $connected=array(46,47,48,49,50);
                    if (in_array($service_carac->getIdProductCaracs()->getIdProductCaracs(),$connected)  && !$Service->hasParentService($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()))
                    {
                        $foundConnected=true;
                        $form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->addIdConnectedService($Service);
                        $this->getDoctrine()->getManager()->persist($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
                        $Service->addIdParentService($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
                    }
                }   
                else if ($form[$service_carac->getIdProductCaracs()->getLbField()]->getData() instanceof \Datetime)
                    $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->format("Y-m-d H:i:s"));                
                else
                    $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
            }
        }
        if (!$foundConnected)
        {
            foreach ($Service->getIdParentServices() as $parent)
            {
                if ($parent->getIdProduct()->getIdProductType()->getBlConnected() && $parent->getIdProduct()->getIdProductType()->getIdProductType()!=5)
                {
                    $Service->removeIdParentService($parent);
                    $parent->removeIdConnectedService($Service);
                    $this->getDoctrine()->getManager()->persist($parent);
                }
            }
        }
    }
    
    private function handleProductChange(Service $Service,$em)
    {
        /* code for product change. To move elsewhere */
        $ProductCaracs=$Service->getIdProduct()->getIdProductType()->getIdProductCaracs();
        foreach ($Service->getIdServiceCaracs() as $service_carac)
        {
            $em->persist($service_carac);
        }
        foreach ($ProductCaracs as $carac)
        {
            switch ($carac->getNbLocation())
            {
                case 0:
                    $found=false;
                    foreach ($Service->getIdServiceCaracs() as $service_carac)
                    {
                        if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                        {
                            $found=true;
                            break;
                        }
                    }
                    if (!$found)
                    {
                        $s_carac=new ServiceCaracs();
                        $s_carac->setIdProductCaracs($carac);
                        $s_carac->setIdService($Service);
                        $em->persist($s_carac);                
                    }                
                    break;
                case 1:
                    foreach ($Service->getIdServiceExtremity() as $extr)
                    {
                        $found=false;
                        foreach ($extr->getIdServiceCaracs() as $service_carac)
                        {
                            if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                            {
                                $found=true;
                                break;
                            }
                        }
                        if (!$found)
                        {
                            $s_carac=new ServiceCaracs();
                            $s_carac->setIdProductCaracs($carac);
                            $s_carac->setIdServiceExtremity($extr);
                            $em->persist($s_carac);                
                        }                
                    }
                    break;
                case 2:
                    foreach ($Service->getIdServiceExtremityTech() as $extr)
                    {
                        $found=false;
                        foreach ($extr->getIdServiceCaracs() as $service_carac)
                        {
                            if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                            {
                                $found=true;
                                break;
                            }
                        }
                        if (!$found)
                        {
                            $s_carac=new ServiceCaracs();
                            $s_carac->setIdProductCaracs($carac);
                            $s_carac->setIdServiceExtremityTech($extr);
                            $em->persist($s_carac);                
                        }                
                    }
                    break;                                                         
            }
        }
        foreach ($Service->getIdServiceCaracs() as $service_carac)
        {
                $found=false;
                foreach ($ProductCaracs as $carac)
                {
                    if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                    {
                        $found=true;
                        break;
                    }
                } 
                if (!$found)
                {
                    $em->remove($service_carac);
                }
        }
        foreach ($Service->getIdServiceExtremity() as $extr)
        {        
            foreach ($extr->getIdServiceCaracs() as $service_carac)
            {
                    $found=false;
                    foreach ($ProductCaracs as $carac)
                    {
                        if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                        {
                            $found=true;
                            break;
                        }
                    } 
                    if (!$found)
                    {
                        $em->remove($service_carac);
                    }
            }    
        }
        foreach ($Service->getIdServiceExtremityTech() as $extr)
        {          
            foreach ($extr->getIdServiceCaracs() as $service_carac)
            {
                    $found=false;
                    foreach ($ProductCaracs as $carac)
                    {
                        if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==$carac->getIdProductCaracs())
                        {
                            $found=true;
                            break;
                        }
                    } 
                    if (!$found)
                    {
                        $em->remove($service_carac);
                    }
            }    
        }

        $em->flush();        
    }
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param Service $Service your \Etrali\GinangBundle\Entity\Service object
     */
    public function postSave(Form $form, Service $Service)
    {
        $em=$this->getDoctrine()->getManager();

        $this->handleProductChange($Service,$em);
        $chaineret="";
        /******/
        $id_status=$Service->getIdTransactionStatus()->getIdTransactionStatus();  
        $statuses=array(49,50,51,60,61,62,71,72,73,81,82,83,91,92,93);
        $endstatus=$id_status;
        $loopstatus=$id_status;
        $savestatus=0;


        while ($chaineret=="" && $loopstatus!=$savestatus && $loopstatus!=107 && $loopstatus!=98 && $loopstatus!=104)
        {
            $savestatus=$loopstatus;
            if (in_array($id_status,$statuses))
            {
                /* Notice : $endstatus is passed by reference */
                $endstatus=$loopstatus;
                $chaineret=CustomValidator::isValidBBFrameToFrame($Service,$em,$this,$endstatus);
                if ($endstatus!="")
                {    
                    if (strpos($endstatus,":")!==FALSE)
                    {
                        $tab=explode(":",$endstatus);
                        foreach ($tab as $ids)
                        {
                           CustomValidator::handlePostSaveService($Service, $this, $ids,$em,$this->container); 
                           $loopstatus=$ids;
                        }
                    }
                    else
                    {
                        CustomValidator::handlePostSaveService($Service, $this, $endstatus,$em,$this->container);
                        $loopstatus=$endstatus;
                    }
                    if ($chaineret!="NA" && $chaineret!="")
                        $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );

                }
                else if ($chaineret!="NA")
                    $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );

            }
            else
            {
                /* Notice : $endstatus is passed by reference */            
                $chaineret=CustomValidator::isValidForNextStep($Service,$em,$this,$endstatus);
                if ($chaineret=="")
                {
                    CustomValidator::handlePostSaveService($Service, $this, $endstatus,$em,$this->container);                
                    $loopstatus=$endstatus;
                }
                else if ($chaineret!="NA")
                    $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );

            }
        }

    }
    
    /**
     * 
     * @param int $pk
     * @return 
     */
    public function forceStatutInServiceAction($pk){
            $Service=$this->getObject($pk);
            $em = $this->getDoctrine()->getManager();
            $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(54);
            $Service->setIdTransactionStatus($TransStatus);

           if ($Service->getDtDelivery()==NULL)
                   $Service->setDtDelivery(new \Datetime());
            foreach ($Service->getIdBillingServiceLine() as $bsl)
            {
                    if ($bsl->getDtStartMrc()==NULL)
                    {
                        $bsl->setDtStartMrc(new \Datetime());
                        $em->persist($bsl);
                    }
            }               
                                                        
            $em->persist($Service);
            $em->flush();
            SendMail::send($this,$this->container,"jconan@protego.net",16,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));  
            
            return $this->redirect($this->generateUrl("Etrali_GinangBundle_Service_list"));
    }
}
