<?php

namespace Etrali\GinangBundle\Controller\Service;

use Admingenerated\EtraliGinangBundle\BaseServiceController\ListController as BaseListController;
use Etrali\GinangBundle\Entity\Service;

class ListController extends BaseListController
{
    private function selectBundle($query,$condition)
    {
       $q=$this->getDoctrine()
                    ->getManager()
                    ->getRepository('Etrali\GinangBundle\Entity\Service')
                    ->createQueryBuilder('q');
        $q=$q->innerJoin("q.idProduct","p")->innerJoin("p.idProductType","pt")->andWhere($condition);
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=Service::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $q=$q->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }
        
        $services=$q->getQuery()->getResult();
        $inids=array();
        foreach ($services as $serv)
        {
            $maxnb=100000;
            foreach ($serv->getIdServiceCaracs() as $carac)
            {
                if ($carac->getIdProductCaracs()->getIdProductCaracs()==10 && $carac->getValeur()!=NULL)                    
                    $maxnb=$carac->getValeur();
                    
            }
            if ($serv->getIdConnectedServices()->count()<$maxnb)
                $inids[]=$serv->getIdService();
        }
        if (count($inids)>0)
            return $query->andWhere("q.idService in (".implode(",",$inids).")");
        else
            return $query->andWhere("1=2");        
    }
    
    public function selectInterBundlesAction($query)
    {
        return $this->selectBundle($query,"pt.idProductType=9");
    }
    
    public function getInterBundlesAction()
    {
        $this->addToQuery="selectInterBundlesAction";
        return $this->indexAction();
    }       
    
    public function selectAreaInterBundlesAction($query)
    {
        return $this->selectBundle($query,"pt.idProductType=8 or pt.idProductType=9");        
    }
    
    public function getAreaInterBundlesAction()
    {
        $this->addToQuery="selectAreaInterBundlesAction";
        return $this->indexAction();
    }       

    
    public function selectAllBundlesAction($query)
    {
        return $this->selectBundle($query,"pt.idProductType=7 or pt.idProductType=8 or pt.idProductType=9");          
    }
    
    public function getAllBundlesAction()
    {
        $this->addToQuery="selectAllBundlesAction";
        return $this->indexAction();
    }  
    
    public function selectMembershipsAction($query)
    {
        $query=$query->innerJoin("q.idProduct","p")->innerJoin("p.idProductType","pt")->andWhere("pt.idProductType=6");
        return $query;
    }
    
    public function getMembershipsAction()
    {
        $this->addToQuery="selectMembershipsAction";
        return $this->indexAction();
    }     
    
    public function selectNetrecovaAction($query)
    {
        if ($this->getRequest()->get('motherid')!="undefined")
            $query=$query->innerJoin("q.idServiceExtremity","e")->innerJoin("e.idDeliveryAddress","a")->andWhere("a.idAddress=".$this->getRequest()->get('motherid'));        
        $query=$query->innerJoin("q.idProduct","p")->innerJoin("p.idProductType","pt")->andWhere("pt.idProductType=5");
        
        return $query;
    }    
    
    public function getNetrecovaAction()
    {
        $this->addToQuery="selectNetrecovaAction";
        return $this->indexAction();
    }      
    
    public function buildQuery()
    {
        $q=parent::buildQuery();
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=Service::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $q=$q->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }

        return $q;
    }   
    
    public function selectSearchPipeId($query)
    {
        $cdPipeId=$this->get('request')->query->get('cdpipeid');
        if ($cdPipeId!="")
            $query=$query->innerJoin("q.idServiceExtremityTech",'extr')->innerJoin("extr.idServiceCaracs","scar")->innerJoin("scar.idProductCaracs","pcar")->andWhere("scar.valeur='".$cdPipeId."'")->andWhere("pcar.lbField='cdPipeId'");        
        return $query;
    }
    
    public function searchPipeIdAction()
    {
        $this->addToQuery="selectSearchPipeId";      
        return $this->indexAction();        
        
    }
}
