<?php

namespace Etrali\GinangBundle\Controller\ServiceConnected;

use Admingenerated\EtraliGinangBundle\BaseServiceConnectedController\ListController as BaseListController;

class ListController extends BaseListController
{
    private function parseFormula($formula,$id_array)
    {
        $array_retour=array();
        $formula=trim($formula);
        if (strlen($formula)>0)
        {
            if (substr($formula,0,1)=="(" && substr($formula,-1)==")")
                return array_merge($id_array,$this->parseFormula(substr($formula,1,-1),$id_array));
            else {
                if (strpos($formula,'&')===FALSE && strpos($formula,'|')===FALSE)
                {
                    $array_retour[]="'".substr($formula,0,-2)."'";
                    return array_merge($id_array,$array_retour);
                }
                else
                {
                    $tab=preg_split("\\&\\|",$formula);
                    foreach ($tab as $partie)
                    {
                        $array_retour=array_merge($id_array,$this->parseFormula($trim($partie),$id_array));
                    }
                    return $array_retour;
                }
            }
        }
        else
            return $id_array;
    }
    
    public function buildQuery()
    {
        $query=parent::buildQuery();
        $Service=$this->getDoctrine()->getRepository('EtraliGinangBundle:Service')->find($this->get('request')->query->get('serviceid'));
        $ProductType=$Service->getIdProduct()->getIdProductType();
        $depString=$ProductType->getLbDependenceTypes();
        if ($depString!=NULL && $depString!="")
        {
            $id_array=$this->parseFormula($depString,array());        
            $query=$query->innerJoin("q.idProduct","p")->innerJoin("p.idProductType","pt")->where("pt.cdProductType in (".implode(",",$id_array).")");
        }
        return $query;
    }
    
    public function getEntityData()
    {
        return $this->getDoctrine()->getRepository('EtraliGinangBundle:Service')->find($this->get('request')->query->get('serviceid'));
    }    
}
