<?php

namespace Etrali\GinangBundle\Controller\ServiceExtremity;

use Admingenerated\EtraliGinangBundle\BaseServiceExtremityController\EditController as BaseEditController;
use Etrali\GinangBundle\Entity\ServiceExtremity;
use Etrali\GinangBundle\Entity\ServiceExtremityTech;
use Symfony\Component\Form\Form;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Entity\TransferPrice;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    }    
    
    public function upgradeAction($pk)
    {
        $extr = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(76);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(12);    
        $serv=$extr->getIdService();
        $serv->setIdTransactionType($TransType);
        $serv->setIdTransactionStatus($TransStatus); 
        $serv->setNbOperation($serv->getNbOperation()+1); 
        $serv->setIdSelectedExtremity(NULL);
        $serv->setIdTransferExtremity($extr);  
        $serv->setBlValidated(false);  
        $serv->setBlLlstatus(false);
        $serv->setBlBbstatus(false);         
        $em->persist($serv);
        
        $techCaracs=array(30,31,32,33,38,41,42); 
        
        $extr->setDtInitUpdown(NULL);
        $extr->setDtRequestUpdown(NULL);
        $extr->setDtRealUpdown(NULL);   
        $extr->getIdServiceExtremityTech()->setIdLocalLoop(NULL);
        $extr->getIdServiceExtremityTech()->setIdLocalLoopExtremityTech(NULL);
        foreach ($extr->getIdServiceExtremityTech()->getIdServiceCaracs() as $carac)
        {
            if (in_array($carac->getIdProductCaracs()->getIdProductCaracs(),$techCaracs))                        
            {
                $carac->setValeur(NULL);
                $em->persist($carac);
            }
        }
                    
        $em->persist($extr);        
        $em->flush();
        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit", array('pk' => $oldExtremity->getIdService()->getIdService()) ));
    } 
    
    public function terminateAction($pk)
    {
        $extr = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(97);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(16);   
        $serv=$extr->getIdService();
        $serv->setIdTransactionType($TransType);
        $serv->setIdTransactionStatus($TransStatus); 
        $serv->setNbOperation($serv->getNbOperation()+1); 
        $serv->setIdSelectedExtremity(NULL);
        $serv->setIdTransferExtremity($extr);            
        $em->persist($serv);       
        
        $em->flush();        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit", array('pk' => $serv->getIdService()) ));
    }      
    
    public function transferAction($pk)
    {
        $oldExtremity = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $extr=  new ServiceExtremity();
        $extr->setIdService($oldExtremity->getIdService());
        $extr->setIdOldExtremity($oldExtremity);
        $extr->setCdServiceExtremity($oldExtremity->getCdServiceExtremity()."New");
        
        if ($oldExtremity->getIdService()->getIdProduct()->getIdProductType()->getIdProductType()!=21)
        {        
            $Currency=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Currency')->findOneByCdCurrency("EUR");           
            $tp=new TransferPrice();
            $tp->setIdServiceExtremity($extr);
            $tp->setIdCurrency($Currency);
            $em->persist($tp);            
        }
        
       
        $tech=  new ServiceExtremityTech();
        $tech->setIdService($oldExtremity->getIdService());
        $tech->setIdServiceExtremity($extr); 
        
        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(55);        
        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(10); 
        
        $oldExtremity->setBlOld(true);
        $bblink=$oldExtremity->getIdService();
        $bblink->setIdTransferExtremity($extr);   
        $bblink->setIdSelectedExtremity(NULL);        
        $bblink->setIdTransactionType($TransType);
        $bblink->setIdTransactionStatus($TransStatus);
        $bblink->setBlValidated(false); 
        $bblink->setBlLlstatus(false);
        $bblink->setBlBbstatus(false);         
                
        $bblink->setNbOperation($bblink->getNbOperation()+1); 
              
        $em = $this->getDoctrine()->getManager();
        $em->persist($oldExtremity);
        $em->persist($bblink);
        $em->persist($extr);
        $em->persist($tech);

        $em->flush();
        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit", array('pk' => $oldExtremity->getIdService()->getIdService()) ));

    }  
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param ServiceExtremity $ServiceExtremity your \Etrali\GinangBundle\Entity\ServiceExtremity object
     */
    public function preSave(Form $form, ServiceExtremity $ServiceExtremity)
    {
        $ServiceExtremity->preSave($form,$this->getDoctrine()->getManager());
    }
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param ServiceExtremity $ServiceExtremity your \Etrali\GinangBundle\Entity\ServiceExtremity object
     */
    public function postSave(Form $form, ServiceExtremity $ServiceExtremity)
    {
        $ServiceExtremity->postSave($form,$this->getDoctrine()->getManager());
    }     
}
