<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BackboneLink
 *
 * @ORM\Table(name="backbone_link")
 * @ORM\Entity
 */
class BackboneLink
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_backbone_link", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBackboneLink;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_backbone_link", type="string", length=15, nullable=true)
     */
    private $cdBackboneLink;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_backbone_link", type="string", length=100, nullable=true)
     */
    private $lbBackboneLink;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_administrative_ref", type="string", length=15, nullable=true)
     */
    private $cdAdministrativeRef;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_technical_ref", type="string", length=30, nullable=true)
     */
    private $cdTechnicalRef;


    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_order", type="datetime", nullable=true)
     */
    private $dtOrder;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery_requested", type="datetime", nullable=true)
     */
    private $dtDeliveryRequested;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery", type="datetime", nullable=true)
     */
    private $dtDelivery;



    /**
     * @var string
     *
     * @ORM\Column(name="cm_backbone_link", type="string", length=255, nullable=true)
     */
    private $cmBackboneLink;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_rtd", type="string", length=45, nullable=true)
     */
    private $cdRtd;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_routing", type="string", length=45, nullable=true)
     */
    private $cdRouting;    

    /**
     * @var string
     *
     * @ORM\Column(name="cd_technical_ref2", type="string", length=255, nullable=true)
     */
    private $cdTechnicalRef2;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_sla_percent", type="float", nullable=true)
     */
    private $nbSlaPercent;


    /**
     * @var string
     *
     * @ORM\Column(name="cd_etrali_order_ref", type="string", length=30, nullable=true)
     */
    private $cdEtraliOrderRef;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_terminate", type="datetime", nullable=true)
     */
    private $dtInitTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_updown", type="datetime", nullable=true)
     */
    private $dtInitUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_requested_updown", type="datetime", nullable=true)
     */
    private $dtRequestedUpdown;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_requested_terminate", type="datetime", nullable=true)
     */
    private $dtRequestedTerminate;    

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_scheduled_delivery", type="datetime", nullable=true)
     */
    private $dtScheduledDelivery;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_scheduled_updown_delivery", type="datetime", nullable=true)
     */
    private $dtScheduledUpdownDelivery;    

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_terminate", type="datetime", nullable=true)
     */
    private $dtRealTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_updown", type="datetime", nullable=true)
     */
    private $dtRealUpdown;

    /**
     * @var \BandwidthAssignee
     *
     * @ORM\ManyToOne(targetEntity="BandwidthAssignee")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_bandwidth", referencedColumnName="id_bandwidth_assignee")
     * })
     */
    private $idBandwidth;
    
    /**
     * @var \BandwidthAssignee
     *
     * @ORM\ManyToOne(targetEntity="BandwidthAssignee")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_old_bandwidth", referencedColumnName="id_bandwidth_assignee")
     * })
     */
    private $idOldBandwidth; 

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Interfaces
     *
     * @ORM\ManyToOne(targetEntity="Interfaces")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_interface", referencedColumnName="id_interface")
     * })
     */
    private $idInterface;

    /**
     * @var \LinkFunction
     *
     * @ORM\ManyToOne(targetEntity="LinkFunction")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_function", referencedColumnName="id_link_function")
     * })
     */
    private $idLinkFunction;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider_of_carrier", referencedColumnName="id_provider")
     * })
     */
    private $idProviderOfCarrier;

    /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;    

    /**
     * @var \Protocol
     *
     * @ORM\ManyToOne(targetEntity="Protocol")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_protocol", referencedColumnName="id_protocol")
     * })
     */
    private $idProtocol;

    /**
     * @var \BackboneLinkExtremity
     *
     * @ORM\OneToMany(targetEntity="BackboneLinkExtremity", mappedBy="idBackboneLink",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"blOld"="asc","blTransferred"="asc","idBackboneLinkExtremity" = "asc"})
     */
    private $idBackboneLinkExtremity;
    
    /**
     * @var \BackboneLinkExtremityTech
     *
     * @ORM\OneToMany(targetEntity="BackboneLinkExtremityTech", mappedBy="idBackboneLink",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"blOld"="asc","blTransferred"="asc","idBackboneLinkExtremityTech" = "asc"})
     */
    private $idBackboneLinkExtremityTech;    

    /**
     * @var \BackboneLinkOption
     *
     * @ORM\OneToMany(targetEntity="BackboneLinkOption", mappedBy="idBackboneLink",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idBackboneLinkOption" = "asc"})         
     */
    private $idBackboneLinkOption;  
    
    /**
     * @var \BackboneLinkTransactions
     *
     * @ORM\OneToMany(targetEntity="BackboneLinkTransactions",mappedBy="idBackboneLink", cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idBackboneLinkTransactions" = "desc"})
     */
    private $idBackboneLinkTransactions;    
    
    /**
     * @var \CostingBackboneLinkLine
     *
     * @ORM\OneToMany(targetEntity="CostingBackboneLinkLine",mappedBy="idBackboneLink",cascade={"persist","remove"}, orphanRemoval=true )  
     */
    private $idCostingBackboneLinkLine;       


    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_operation", type="integer", nullable=true)
     */
    private $nbOperation=1;    

    /**
     * @var \BackboneLinkExtremity
     *
     * @ORM\ManyToOne(targetEntity="BackboneLinkExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transfer_extremity", referencedColumnName="id_backbone_link_extremity")
     * })
     */
    private $idTransferExtremity;        
    

    /**
     * @var \Note
     *
     * @ORM\OneToMany(targetEntity="Note", mappedBy="idBackboneLink",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idNote" = "asc"})         
     */
    private $idNote; 
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     
    
    public static function getModifierRoles()
    {
        return array("ROLE_SUPER_ADMINISTRATOR","ROLE_BACKBONE_LINK_ADMINISTRATOR");
    }
    
    public static function getReaderRoles()
    {
        return array("ROLE_SUPER_ADMINISTRATOR","ROLE_ENTMC_INDIA", "ROLE_CSC_FRANCE", "ROLE_NETWORK_ENGINEER_ADMIN","ROLE_NETWORK_ENGINEER","ROLE_BACKBONE_LINK_ADMINISTRATOR");
    } 
    
    
    public function __toString()
    {
        return $this->getCdBackboneLink().":".$this->getLbBackboneLink()."";
    }
    /**
     * 
     * @return array
     */
    public function getCollections()
    {
        $role=$GLOBALS['kernel']->getContainer()->get('etrali.security.context');     
        if ($role->isGranted("ROLE_SUPER_ADMINISTRATOR", $this))
            return array("Extremities"=>"BackboneLinkExtremity","Costings"=>"CostingBackboneLinkLine", "Technical"=>"BackboneLinkExtremityTech","Options"=>"BackboneLinkOption", "Progression"=>"BackboneLinkTransactions","Notes"=>"Note"); 
        else if($role->isGranted("ROLE_ENTMC_INDIA", $this)||$role->isGranted("ROLE_CSC_FRANCE", $this)||$role->isGranted("ROLE_NETWORK_ENGINEER_ADMIN", $this)||
          $role->isGranted("ROLE_NETWORK_ENGINEER", $this)||$role->isGranted("ROLE_BACKBONE_LINK_ADMINISTRATOR", $this)) 
        {
            if($role->isGranted('ROLE_ENTMC_INDIA',$this)||$role->isGranted('ROLE_CSC_FRANCE',$this))
                return array("Extremities"=>"BackboneLinkExtremity","Technical"=>"BackboneLinkExtremityTech","Options"=>"BackboneLinkOption", "Progression"=>"BackboneLinkTransactions");       
            else
                return array("Extremities"=>"BackboneLinkExtremity","Costings"=>"CostingBackboneLinkLine","Technical"=>"BackboneLinkExtremityTech","Options"=>"BackboneLinkOption", "Progression"=>"BackboneLinkTransactions","Notes"=>"Note");        
        }
        return array();
        
    }   
    /**
     * 
     * @param type $type
     * @return type
     */
    public function getEditType($type)
    {
        $idtrans=$this->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans); 
        $type->setObject($this);
        return $type;
    }

  
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBackboneLinkExtremity = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBackboneLinkExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBackboneLinkOption = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBackboneLinkTransactions = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idCostingBackboneLinkLine = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idBackboneLink
     *
     * @return integer 
     */
    public function getIdBackboneLink()
    {
        return $this->idBackboneLink;
    }

    /**
     * Set cdBackboneLink
     *
     * @param string $cdBackboneLink
     * @return BackboneLink
     */
    public function setCdBackboneLink($cdBackboneLink)
    {
        $this->cdBackboneLink = $cdBackboneLink;
    
        return $this;
    }

    /**
     * Get cdBackboneLink
     *
     * @return string 
     */
    public function getCdBackboneLink()
    {
        return $this->cdBackboneLink;
    }

    /**
     * Set lbBackboneLink
     *
     * @param string $lbBackboneLink
     * @return BackboneLink
     */
    public function setLbBackboneLink($lbBackboneLink)
    {
        $this->lbBackboneLink = $lbBackboneLink;
    
        return $this;
    }

    /**
     * Get lbBackboneLink
     *
     * @return string 
     */
    public function getLbBackboneLink()
    {
        return $this->lbBackboneLink;
    }

    /**
     * Set cdAdministrativeRef
     *
     * @param string $cdAdministrativeRef
     * @return BackboneLink
     */
    public function setCdAdministrativeRef($cdAdministrativeRef)
    {
        $this->cdAdministrativeRef = $cdAdministrativeRef;
    
        return $this;
    }

    /**
     * Get cdAdministrativeRef
     *
     * @return string 
     */
    public function getCdAdministrativeRef()
    {
        return $this->cdAdministrativeRef;
    }

    /**
     * Set cdTechnicalRef
     *
     * @param string $cdTechnicalRef
     * @return BackboneLink
     */
    public function setCdTechnicalRef($cdTechnicalRef)
    {
        $this->cdTechnicalRef = $cdTechnicalRef;
    
        return $this;
    }

    /**
     * Get cdTechnicalRef
     *
     * @return string 
     */
    public function getCdTechnicalRef()
    {
        return $this->cdTechnicalRef;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return BackboneLink
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtOrder
     *
     * @param \DateTime $dtOrder
     * @return BackboneLink
     */
    public function setDtOrder($dtOrder)
    {
        $this->dtOrder = $dtOrder;
    
        return $this;
    }

    /**
     * Get dtOrder
     *
     * @return \DateTime 
     */
    public function getDtOrder()
    {
        return $this->dtOrder;
    }

    /**
     * Set dtDeliveryRequested
     *
     * @param \DateTime $dtDeliveryRequested
     * @return BackboneLink
     */
    public function setDtDeliveryRequested($dtDeliveryRequested)
    {
        $this->dtDeliveryRequested = $dtDeliveryRequested;
    
        return $this;
    }

    /**
     * Get dtDeliveryRequested
     *
     * @return \DateTime 
     */
    public function getDtDeliveryRequested()
    {
        return $this->dtDeliveryRequested;
    }

    /**
     * Set dtDelivery
     *
     * @param \DateTime $dtDelivery
     * @return BackboneLink
     */
    public function setDtDelivery($dtDelivery)
    {
        $this->dtDelivery = $dtDelivery;
    
        return $this;
    }

    /**
     * Get dtDelivery
     *
     * @return \DateTime 
     */
    public function getDtDelivery()
    {
        return $this->dtDelivery;
    }

    /**
     * Set cmBackboneLink
     *
     * @param string $cmBackboneLink
     * @return BackboneLink
     */
    public function setCmBackboneLink($cmBackboneLink)
    {
        $this->cmBackboneLink = $cmBackboneLink;
    
        return $this;
    }

    /**
     * Get cmBackboneLink
     *
     * @return string 
     */
    public function getCmBackboneLink()
    {
        return $this->cmBackboneLink;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return BackboneLink
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set cdRtd
     *
     * @param string $cdRtd
     * @return BackboneLink
     */
    public function setCdRtd($cdRtd)
    {
        $this->cdRtd = $cdRtd;
    
        return $this;
    }

    /**
     * Get cdRtd
     *
     * @return string 
     */
    public function getCdRtd()
    {
        return $this->cdRtd;
    }

    /**
     * Set cdRouting
     *
     * @param string $cdRouting
     * @return BackboneLink
     */
    public function setCdRouting($cdRouting)
    {
        $this->cdRouting = $cdRouting;
    
        return $this;
    }

    /**
     * Get cdRouting
     *
     * @return string 
     */
    public function getCdRouting()
    {
        return $this->cdRouting;
    }

    /**
     * Set cdTechnicalRef2
     *
     * @param string $cdTechnicalRef2
     * @return BackboneLink
     */
    public function setCdTechnicalRef2($cdTechnicalRef2)
    {
        $this->cdTechnicalRef2 = $cdTechnicalRef2;
    
        return $this;
    }

    /**
     * Get cdTechnicalRef2
     *
     * @return string 
     */
    public function getCdTechnicalRef2()
    {
        return $this->cdTechnicalRef2;
    }

    /**
     * Set nbSlaPercent
     *
     * @param float $nbSlaPercent
     * @return BackboneLink
     */
    public function setNbSlaPercent($nbSlaPercent)
    {
        $this->nbSlaPercent = $nbSlaPercent;
    
        return $this;
    }

    /**
     * Get nbSlaPercent
     *
     * @return float 
     */
    public function getNbSlaPercent()
    {
        return $this->nbSlaPercent;
    }

    /**
     * Set cdEtraliOrderRef
     *
     * @param string $cdEtraliOrderRef
     * @return BackboneLink
     */
    public function setCdEtraliOrderRef($cdEtraliOrderRef)
    {
        $this->cdEtraliOrderRef = $cdEtraliOrderRef;
    
        return $this;
    }

    /**
     * Get cdEtraliOrderRef
     *
     * @return string 
     */
    public function getCdEtraliOrderRef()
    {
        return $this->cdEtraliOrderRef;
    }

    /**
     * Set dtInitTerminate
     *
     * @param \DateTime $dtInitTerminate
     * @return BackboneLink
     */
    public function setDtInitTerminate($dtInitTerminate)
    {
        $this->dtInitTerminate = $dtInitTerminate;
    
        return $this;
    }

    /**
     * Get dtInitTerminate
     *
     * @return \DateTime 
     */
    public function getDtInitTerminate()
    {
        return $this->dtInitTerminate;
    }

    /**
     * Set dtInitUpdown
     *
     * @param \DateTime $dtInitUpdown
     * @return BackboneLink
     */
    public function setDtInitUpdown($dtInitUpdown)
    {
        $this->dtInitUpdown = $dtInitUpdown;
    
        return $this;
    }

    /**
     * Get dtInitUpdown
     *
     * @return \DateTime 
     */
    public function getDtInitUpdown()
    {
        return $this->dtInitUpdown;
    }

    /**
     * Set dtRequestedUpdown
     *
     * @param \DateTime $dtRequestedUpdown
     * @return BackboneLink
     */
    public function setDtRequestedUpdown($dtRequestedUpdown)
    {
        $this->dtRequestedUpdown = $dtRequestedUpdown;
    
        return $this;
    }

    /**
     * Get dtRequestedUpdown
     *
     * @return \DateTime 
     */
    public function getDtRequestedUpdown()
    {
        return $this->dtRequestedUpdown;
    }

    /**
     * Set dtRequestedTerminate
     *
     * @param \DateTime $dtRequestedTerminate
     * @return BackboneLink
     */
    public function setDtRequestedTerminate($dtRequestedTerminate)
    {
        $this->dtRequestedTerminate = $dtRequestedTerminate;
    
        return $this;
    }

    /**
     * Get dtRequestedTerminate
     *
     * @return \DateTime 
     */
    public function getDtRequestedTerminate()
    {
        return $this->dtRequestedTerminate;
    }

    /**
     * Set dtScheduledDelivery
     *
     * @param \DateTime $dtScheduledDelivery
     * @return BackboneLink
     */
    public function setDtScheduledDelivery($dtScheduledDelivery)
    {
        $this->dtScheduledDelivery = $dtScheduledDelivery;
    
        return $this;
    }

    /**
     * Get dtScheduledDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduledDelivery()
    {
        return $this->dtScheduledDelivery;
    }

    /**
     * Set dtScheduledUpdownDelivery
     *
     * @param \DateTime $dtScheduledUpdownDelivery
     * @return BackboneLink
     */
    public function setDtScheduledUpdownDelivery($dtScheduledUpdownDelivery)
    {
        $this->dtScheduledUpdownDelivery = $dtScheduledUpdownDelivery;
    
        return $this;
    }

    /**
     * Get dtScheduledUpdownDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduledUpdownDelivery()
    {
        return $this->dtScheduledUpdownDelivery;
    }

    /**
     * Set dtRealTerminate
     *
     * @param \DateTime $dtRealTerminate
     * @return BackboneLink
     */
    public function setDtRealTerminate($dtRealTerminate)
    {
        $this->dtRealTerminate = $dtRealTerminate;
    
        return $this;
    }

    /**
     * Get dtRealTerminate
     *
     * @return \DateTime 
     */
    public function getDtRealTerminate()
    {
        return $this->dtRealTerminate;
    }

    /**
     * Set dtRealUpdown
     *
     * @param \DateTime $dtRealUpdown
     * @return BackboneLink
     */
    public function setDtRealUpdown($dtRealUpdown)
    {
        $this->dtRealUpdown = $dtRealUpdown;
    
        return $this;
    }

    /**
     * Get dtRealUpdown
     *
     * @return \DateTime 
     */
    public function getDtRealUpdown()
    {
        return $this->dtRealUpdown;
    }

    /**
     * Set nbOperation
     *
     * @param integer $nbOperation
     * @return BackboneLink
     */
    public function setNbOperation($nbOperation)
    {
        $this->nbOperation = $nbOperation;
    
        return $this;
    }

    /**
     * Get nbOperation
     *
     * @return integer 
     */
    public function getNbOperation()
    {
        return $this->nbOperation;
    }

    /**
     * Set idBandwidth
     *
     * @param \Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidth
     * @return BackboneLink
     */
    public function setIdBandwidth(\Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidth = null)
    {
        $this->idBandwidth = $idBandwidth;
    
        return $this;
    }

    /**
     * Get idBandwidth
     *
     * @return \Etrali\GinangBundle\Entity\BandwidthAssignee 
     */
    public function getIdBandwidth()
    {
        return $this->idBandwidth;
    }

    /**
     * Set idOldBandwidth
     *
     * @param \Etrali\GinangBundle\Entity\BandwidthAssignee $idOldBandwidth
     * @return BackboneLink
     */
    public function setIdOldBandwidth(\Etrali\GinangBundle\Entity\BandwidthAssignee $idOldBandwidth = null)
    {
        $this->idOldBandwidth = $idOldBandwidth;
    
        return $this;
    }

    /**
     * Get idOldBandwidth
     *
     * @return \Etrali\GinangBundle\Entity\BandwidthAssignee 
     */
    public function getIdOldBandwidth()
    {
        return $this->idOldBandwidth;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return BackboneLink
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idInterface
     *
     * @param \Etrali\GinangBundle\Entity\Interfaces $idInterface
     * @return BackboneLink
     */
    public function setIdInterface(\Etrali\GinangBundle\Entity\Interfaces $idInterface = null)
    {
        $this->idInterface = $idInterface;
    
        return $this;
    }

    /**
     * Get idInterface
     *
     * @return \Etrali\GinangBundle\Entity\Interfaces 
     */
    public function getIdInterface()
    {
        return $this->idInterface;
    }

    /**
     * Set idLinkFunction
     *
     * @param \Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction
     * @return BackboneLink
     */
    public function setIdLinkFunction(\Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction = null)
    {
        $this->idLinkFunction = $idLinkFunction;
    
        return $this;
    }

    /**
     * Get idLinkFunction
     *
     * @return \Etrali\GinangBundle\Entity\LinkFunction 
     */
    public function getIdLinkFunction()
    {
        return $this->idLinkFunction;
    }

    /**
     * Set idProviderOfCarrier
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProviderOfCarrier
     * @return BackboneLink
     */
    public function setIdProviderOfCarrier(\Etrali\GinangBundle\Entity\Provider $idProviderOfCarrier = null)
    {
        $this->idProviderOfCarrier = $idProviderOfCarrier;
    
        return $this;
    }

    /**
     * Get idProviderOfCarrier
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProviderOfCarrier()
    {
        return $this->idProviderOfCarrier;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return BackboneLink
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return BackboneLink
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idProtocol
     *
     * @param \Etrali\GinangBundle\Entity\Protocol $idProtocol
     * @return BackboneLink
     */
    public function setIdProtocol(\Etrali\GinangBundle\Entity\Protocol $idProtocol = null)
    {
        $this->idProtocol = $idProtocol;
    
        return $this;
    }

    /**
     * Get idProtocol
     *
     * @return \Etrali\GinangBundle\Entity\Protocol 
     */
    public function getIdProtocol()
    {
        return $this->idProtocol;
    }

    /**
     * Add idBackboneLinkExtremity
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity
     * @return BackboneLink
     */
    public function addIdBackboneLinkExtremity(\Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity)
    {
        $this->idBackboneLinkExtremity[] = $idBackboneLinkExtremity;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkExtremity
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity
     */
    public function removeIdBackboneLinkExtremity(\Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity)
    {
        $this->idBackboneLinkExtremity->removeElement($idBackboneLinkExtremity);
    }

    /**
     * Get idBackboneLinkExtremity
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkExtremity()
    {
        return $this->idBackboneLinkExtremity;
    }

    /**
     * Add idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return BackboneLink
     */
    public function addIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech[] = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     */
    public function removeIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech->removeElement($idBackboneLinkExtremityTech);
    }

    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkExtremityTech()
    {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Add idBackboneLinkOption
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkOption $idBackboneLinkOption
     * @return BackboneLink
     */
    public function addIdBackboneLinkOption(\Etrali\GinangBundle\Entity\BackboneLinkOption $idBackboneLinkOption)
    {
        $this->idBackboneLinkOption[] = $idBackboneLinkOption;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkOption
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkOption $idBackboneLinkOption
     */
    public function removeIdBackboneLinkOption(\Etrali\GinangBundle\Entity\BackboneLinkOption $idBackboneLinkOption)
    {
        $this->idBackboneLinkOption->removeElement($idBackboneLinkOption);
    }

    /**
     * Get idBackboneLinkOption
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkOption()
    {
        return $this->idBackboneLinkOption;
    }

    /**
     * Add idBackboneLinkTransactions
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkTransactions $idBackboneLinkTransactions
     * @return BackboneLink
     */
    public function addIdBackboneLinkTransaction(\Etrali\GinangBundle\Entity\BackboneLinkTransactions $idBackboneLinkTransactions)
    {
        $this->idBackboneLinkTransactions[] = $idBackboneLinkTransactions;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkTransactions
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkTransactions $idBackboneLinkTransactions
     */
    public function removeIdBackboneLinkTransaction(\Etrali\GinangBundle\Entity\BackboneLinkTransactions $idBackboneLinkTransactions)
    {
        $this->idBackboneLinkTransactions->removeElement($idBackboneLinkTransactions);
    }

    /**
     * Get idBackboneLinkTransactions
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkTransactions()
    {
        return $this->idBackboneLinkTransactions;
    }

    /**
     * Add idCostingBackboneLinkLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingBackboneLinkLine $idCostingBackboneLinkLine
     * @return BackboneLink
     */
    public function addIdCostingBackboneLinkLine(\Etrali\GinangBundle\Entity\CostingBackboneLinkLine $idCostingBackboneLinkLine)
    {
        $this->idCostingBackboneLinkLine[] = $idCostingBackboneLinkLine;
    
        return $this;
    }

    /**
     * Remove idCostingBackboneLinkLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingBackboneLinkLine $idCostingBackboneLinkLine
     */
    public function removeIdCostingBackboneLinkLine(\Etrali\GinangBundle\Entity\CostingBackboneLinkLine $idCostingBackboneLinkLine)
    {
        $this->idCostingBackboneLinkLine->removeElement($idCostingBackboneLinkLine);
    }

    /**
     * Get idCostingBackboneLinkLine
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCostingBackboneLinkLine()
    {
        return $this->idCostingBackboneLinkLine;
    }

    /**
     * Set idTransferExtremity
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $idTransferExtremity
     * @return BackboneLink
     */
    public function setIdTransferExtremity(\Etrali\GinangBundle\Entity\BackboneLinkExtremity $idTransferExtremity = null)
    {
        $this->idTransferExtremity = $idTransferExtremity;
    
        return $this;
    }

    /**
     * Get idTransferExtremity
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLinkExtremity 
     */
    public function getIdTransferExtremity()
    {
        return $this->idTransferExtremity;
    }

    /**
     * Add idNote
     *
     * @param \Etrali\GinangBundle\Entity\Note $idNote
     * @return BackboneLink
     */
    public function addIdNote(\Etrali\GinangBundle\Entity\Note $idNote)
    {
        $this->idNote[] = $idNote;
    
        return $this;
    }

    /**
     * Remove idNote
     *
     * @param \Etrali\GinangBundle\Entity\Note $idNote
     */
    public function removeIdNote(\Etrali\GinangBundle\Entity\Note $idNote)
    {
        $this->idNote->removeElement($idNote);
    }

    /**
     * Get idNote
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdNote()
    {
        return $this->idNote;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return BackboneLink
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}