<?php

namespace Etrali\GinangBundle\Entity;

use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BackboneLinkExtremity
 *
 * @ORM\Table(name="backbone_link_extremity")
 * @ORM\Entity
 */
class BackboneLinkExtremity {

    /**
     * @var integer
     *
     * @ORM\Column(name="id_backbone_link_extremity", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBackboneLinkExtremity;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="text", nullable=true)
     */
    private $cmComment;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_transfer", type="datetime", nullable=true)
     */
    private $dtInitTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_transfer", type="datetime", nullable=true)
     */
    private $dtRequestTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_schedule_delivery", type="datetime", nullable=true)
     */
    private $dtScheduleDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_transfer_real_delivery", type="datetime", nullable=true)
     */
    private $dtTransferRealDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_transfer_complete", type="datetime", nullable=true)
     */
    private $dtTransferComplete;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_old_terminate", type="datetime", nullable=true)
     */
    private $dtOldTerminate;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_backbone_link_extremity_ref", type="string", length=45, nullable=true)
     * @Assert\NotBlank()      
     */
    private $cdBackboneLinkExtremityRef;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     * @Assert\NotNull()
     */
    private $idPop;

    /**
     * @var \ContactPop
     *
     * @ORM\ManyToOne(targetEntity="ContactPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_admin_contact", referencedColumnName="id_contact_pop")
     * })
     */
    private $idAdminContact;

    /**
     * @var \AddressPop
     *
     * @ORM\ManyToOne(targetEntity="AddressPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_delivery_address", referencedColumnName="id_address_pop")
     * })
     */
    private $idDeliveryAddress;

    /**
     * @var \BackboneLink
     *
     * @ORM\ManyToOne(targetEntity="BackboneLink", inversedBy="idBackboneLinkExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link", referencedColumnName="id_backbone_link")
     * })
     */
    private $idBackboneLink;

    /**
     * @var \BackboneLinkExtremityTech
     *
     * @ORM\OneToOne(targetEntity="BackboneLinkExtremityTech", mappedBy="idBackboneLinkExtremity")
     */
    private $idBackboneLinkExtremityTech;

    /**
     * @var \BackboneLinkExtremity
     *
     * @ORM\OneToOne(targetEntity="BackboneLinkExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_old_extremity", referencedColumnName="id_backbone_link_extremity")
     * })
     */
    private $idOldExtremity;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old", type="boolean", nullable=true)
     */
    private $blOld = false;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_transferred", type="boolean", nullable=true)
     */
    private $blTransferred = false;

    public function __toString() {
        return $this->getCdBackboneLinkExtremityRef() . "";
    }

    public function getHeadInfo() {
        $retour = "<td >" . $this->getCdBackboneLinkExtremityRef() . "</td><td>" . $this->getIdPop() . "</td><td>" . $this->getIdDeliveryAddress() . "</td><td>" . $this->getIdAdminContact() . "</td>";
        if (!$this->getBlOld() && ($this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 5 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 11 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 17 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 20 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 21))
            $retour.="<td><button type='button' id='bb_transfer_button' class='transfer_button btn btn-link' data-id='" . $this->getIdBackboneLinkExtremity() . "'><i class='icones_actions_synchro'></i></button></td>";
        else
            $retour.="<td></td>";
        return $retour;
    }

    public function getHeadColumns() {
        $retour = "<th>Extremity ref</th><th>Pop name</th><th>Delivery address</th><th>Administrative Contact</th>";
        if ($this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 5 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 11 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 17 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 20 || $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus() == 21)
            $retour.="<th>Transfer</th>";
        else
            $retour.="<td></td>";
        return $retour;
    }

    public function getEditType($type) {
        $idtrans = $this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype = $this->getIdBackboneLink()->getIdTransactionType()->getIdTransactionType();
        $type->setTransaction($idtype, $idtrans);
        $type->setOld($this->getIdBackboneLink()->getIdTransferExtremity() != NULL && $this->getIdBackboneLink()->getIdTransferExtremity()->getIdOldExtremity()->getIdBackboneLinkExtremity() == $this->getIdBackboneLinkExtremity());
        $type->setTransfer($this->getIdBackboneLink()->getIdTransferExtremity() != NULL && $this->getIdBackboneLink()->getIdTransferExtremity()->getIdBackboneLinkExtremity() == $this->getIdBackboneLinkExtremity());
        $type->setObject($this);
        return $type;
    }

    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     */
    public function postSave(\Symfony\Component\Form\Form $form, $em) {
        $tech = $this->getIdBackboneLinkExtremityTech();
        $tech->setIdPop($this->getIdPop());
        if ($this->getIdPop() != NULL) {
            $found = false;
            $techContact = null;
            $cpt = 0;
            foreach ($this->getIdPop()->getTechnicalContacts() as $contact) {
                $techContact = $contact;
                if ($contact->getBlDefault()) {
                    $found = true;
                    break;
                }
                $cpt++;
            }
            if ($found || $cpt == 1)
                $tech->setIdTechnicalContact($techContact);
        }

        $em->persist($tech);
        $em->flush();
    }

    /**
     * Get idBackboneLinkExtremity
     *
     * @return integer 
     */
    public function getIdBackboneLinkExtremity() {
        return $this->idBackboneLinkExtremity;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return BackboneLinkExtremity
     */
    public function setCmComment($cmComment) {
        $this->cmComment = $cmComment;

        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment() {
        return $this->cmComment;
    }

    /**
     * Set dtInitTransfer
     *
     * @param \DateTime $dtInitTransfer
     * @return BackboneLinkExtremity
     */
    public function setDtInitTransfer($dtInitTransfer) {
        $this->dtInitTransfer = $dtInitTransfer;

        return $this;
    }

    /**
     * Get dtInitTransfer
     *
     * @return \DateTime 
     */
    public function getDtInitTransfer() {
        return $this->dtInitTransfer;
    }

    /**
     * Set dtRequestTransfer
     *
     * @param \DateTime $dtRequestTransfer
     * @return BackboneLinkExtremity
     */
    public function setDtRequestTransfer($dtRequestTransfer) {
        $this->dtRequestTransfer = $dtRequestTransfer;

        return $this;
    }

    /**
     * Get dtRequestTransfer
     *
     * @return \DateTime 
     */
    public function getDtRequestTransfer() {
        return $this->dtRequestTransfer;
    }

    /**
     * Set dtScheduleDelivery
     *
     * @param \DateTime $dtScheduleDelivery
     * @return BackboneLinkExtremity
     */
    public function setDtScheduleDelivery($dtScheduleDelivery) {
        $this->dtScheduleDelivery = $dtScheduleDelivery;

        return $this;
    }

    /**
     * Get dtScheduleDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduleDelivery() {
        return $this->dtScheduleDelivery;
    }

    /**
     * Set dtTransferRealDelivery
     *
     * @param \DateTime $dtTransferRealDelivery
     * @return BackboneLinkExtremity
     */
    public function setDtTransferRealDelivery($dtTransferRealDelivery) {
        $this->dtTransferRealDelivery = $dtTransferRealDelivery;

        return $this;
    }

    /**
     * Get dtTransferRealDelivery
     *
     * @return \DateTime 
     */
    public function getDtTransferRealDelivery() {
        return $this->dtTransferRealDelivery;
    }

    /**
     * Set dtTransferComplete
     *
     * @param \DateTime $dtTransferComplete
     * @return BackboneLinkExtremity
     */
    public function setDtTransferComplete($dtTransferComplete) {
        $this->dtTransferComplete = $dtTransferComplete;

        return $this;
    }

    /**
     * Get dtTransferComplete
     *
     * @return \DateTime 
     */
    public function getDtTransferComplete() {
        return $this->dtTransferComplete;
    }

    /**
     * Set dtOldTerminate
     *
     * @param \DateTime $dtOldTerminate
     * @return BackboneLinkExtremity
     */
    public function setDtOldTerminate($dtOldTerminate) {
        $this->dtOldTerminate = $dtOldTerminate;

        return $this;
    }

    /**
     * Get dtOldTerminate
     *
     * @return \DateTime 
     */
    public function getDtOldTerminate() {
        return $this->dtOldTerminate;
    }

    /**
     * Set cdBackboneLinkExtremityRef
     *
     * @param string $cdBackboneLinkExtremityRef
     * @return BackboneLinkExtremity
     */
    public function setCdBackboneLinkExtremityRef($cdBackboneLinkExtremityRef) {
        $this->cdBackboneLinkExtremityRef = $cdBackboneLinkExtremityRef;

        return $this;
    }

    /**
     * Get cdBackboneLinkExtremityRef
     *
     * @return string 
     */
    public function getCdBackboneLinkExtremityRef() {
        return $this->cdBackboneLinkExtremityRef;
    }

    /**
     * Set blOld
     *
     * @param boolean $blOld
     * @return BackboneLinkExtremity
     */
    public function setBlOld($blOld) {
        $this->blOld = $blOld;

        return $this;
    }

    /**
     * Get blOld
     *
     * @return boolean 
     */
    public function getBlOld() {
        return $this->blOld;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return BackboneLinkExtremity
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null) {
        $this->idPop = $idPop;

        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop() {
        return $this->idPop;
    }

    /**
     * Set idAdminContact
     *
     * @param \Etrali\GinangBundle\Entity\ContactPop $idAdminContact
     * @return BackboneLinkExtremity
     */
    public function setIdAdminContact(\Etrali\GinangBundle\Entity\ContactPop $idAdminContact = null) {
        $this->idAdminContact = $idAdminContact;

        return $this;
    }

    /**
     * Get idAdminContact
     *
     * @return \Etrali\GinangBundle\Entity\ContactPop 
     */
    public function getIdAdminContact() {
        return $this->idAdminContact;
    }

    /**
     * Set idBackboneLink
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink
     * @return BackboneLinkExtremity
     */
    public function setIdBackboneLink(\Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink = null) {
        $this->idBackboneLink = $idBackboneLink;

        return $this;
    }

    /**
     * Get idBackboneLink
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLink 
     */
    public function getIdBackboneLink() {
        return $this->idBackboneLink;
    }

    /**
     * Set idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return BackboneLinkExtremity
     */
    public function setIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech = null) {
        $this->idBackboneLinkExtremityTech = $idBackboneLinkExtremityTech;

        return $this;
    }

    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech 
     */
    public function getIdBackboneLinkExtremityTech() {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Set idOldExtremity
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $idOldExtremity
     * @return BackboneLinkExtremity
     */
    public function setIdOldExtremity(\Etrali\GinangBundle\Entity\BackboneLinkExtremity $idOldExtremity = null) {
        $this->idOldExtremity = $idOldExtremity;

        return $this;
    }

    /**
     * Get idOldExtremity
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLinkExtremity 
     */
    public function getIdOldExtremity() {
        return $this->idOldExtremity;
    }

    /**
     * Set idDeliveryAddress
     *
     * @param \Etrali\GinangBundle\Entity\AddressPop $idDeliveryAddress
     * @return BackboneLinkExtremity
     */
    public function setIdDeliveryAddress(\Etrali\GinangBundle\Entity\AddressPop $idDeliveryAddress = null) {
        $this->idDeliveryAddress = $idDeliveryAddress;

        return $this;
    }

    /**
     * Get idDeliveryAddress
     *
     * @return \Etrali\GinangBundle\Entity\AddressPop 
     */
    public function getIdDeliveryAddress() {
        return $this->idDeliveryAddress;
    }

    /**
     * Set blTransfered
     *
     * @param boolean $blTransfered
     * @return BackboneLinkExtremity
     */
    public function setBlTransfered($blTransfered) {
        $this->blTransfered = $blTransfered;

        return $this;
    }

    /**
     * Get blTransfered
     *
     * @return boolean 
     */
    public function getBlTransfered() {
        return $this->blTransfered;
    }

    /**
     * Set blTransferred
     *
     * @param boolean $blTransferred
     * @return BackboneLinkExtremity
     */
    public function setBlTransferred($blTransferred) {
        $this->blTransferred = $blTransferred;

        return $this;
    }

    /**
     * Get blTransferred
     *
     * @return boolean 
     */
    public function getBlTransferred() {
        return $this->blTransferred;
    }
    
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdBackboneLink()!=null)
            return $this->getIdBackboneLink()->getIdBranch();
        return NULL;
    }
}