<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BackboneLinkExtremityTech
 *
 * @ORM\Table(name="backbone_link_extremity_tech")
 * @ORM\Entity
 */
class BackboneLinkExtremityTech
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_backbone_link_extremity_tech", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBackboneLinkExtremityTech;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_bb_tested", type="datetime", nullable=true)
     */
    private $dtBbTested;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_old_bb_tested", type="datetime", nullable=true)
     */
    private $dtOldBbTested;    

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment_technical", type="text", nullable=true)
     */
    private $cmCommentTechnical;
      

    /**
     * @var \Ts
     *
     * @ORM\OneToMany(targetEntity="Ts",mappedBy="idInBackboneLinkExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idTs;
    
        /**
     * @var \Vlan
     *
     * @ORM\OneToOne(targetEntity="Vlan", mappedBy="idInBackboneLinkExtremityTech")
     */
    private $idVlan;    
    
    /**
     * @var \PortInstance
     *
     * @ORM\ManyToOne(targetEntity="PortInstance", inversedBy="idInBackboneLinkExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_instance", referencedColumnName="id_port_instance")
     * })
     */
    private $idPortInstance;  
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_connection_path", type="string", length=1000, nullable=true)
     */
    private $lbConnectionPath;    
    
    /**
     * @ORM\OneToMany(targetEntity="Ts", mappedBy="idBackboneLinkExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)

     */
    private $idOutTs;
    
    /**
     * @var \PortInstance
     *
     * @ORM\OneToMany(targetEntity="PortInstance", mappedBy="idBackboneLinkExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutPortInstance;      

    /**
     * @ORM\OneToMany(targetEntity="Vlan", mappedBy="idBackboneLinkExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)

     */
    private $idOutVlan;
    
    /**
     * @var \ConnectionPath
     *
     * @ORM\OneToMany(targetEntity="ConnectionPath", mappedBy="idBackboneLinkExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutConnectionPath;
    

    
    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="ContactPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_technical_contact", referencedColumnName="id_contact_pop")
     * })
     */
    private $idTechnicalContact;
    
    /**
     * @var \BackboneLink
     *
     * @ORM\ManyToOne(targetEntity="BackboneLink", inversedBy="idBackboneLinkExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link", referencedColumnName="id_backbone_link")
     * })
     */    
    private $idBackboneLink;
    
    /**
     * @var \BackboneLinkExtremity
     *
     * @ORM\OneToOne(targetEntity="BackboneLinkExtremity", inversedBy="idBackboneLinkExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link_extremity", referencedColumnName="id_backbone_link_extremity")
     * })
     */    
    private $idBackboneLinkExtremity; 
    
    
    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old", type="boolean", nullable=true)
     */
    private $blOld=false;  
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_transferred", type="boolean", nullable=true)
     */
    private $blTransferred=false;      
    
    
    public function __toString() {
        return $this->getIdTechnicalContact()."";
    }
    

    public function getHeadInfo()
    {
            $path=$this->getIdPortInstance()!=NULL?\Etrali\GinangBundle\EtraliGinangBundle::getUnlinkedConnectionPath($this->getLbConnectionPath(), $this->getIdPortInstance()):"";
            return "<td>".$this->getIdBackboneLinkExtremity()->getCdBackboneLinkExtremityRef()."</td><td>".$this->getIdBackboneLinkExtremity()->getIdPop()."</td><td>".($this->getDtBbTested()?$this->getDtBbTested()->format("d/m/Y"):"&nbsp;")."</td><td>".$path."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Extremity Ref</th><th>Pop name</th><th>BB tested date</th><th>Incoming connection path</th>";
    }     

    public function getEditType($type)
    {
        $idtrans=$this->getIdBackboneLink()->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdBackboneLink()->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans);  
        $type->setOld($this->getIdBackboneLink()->getIdTransferExtremity()!=NULL &&  $this->getIdBackboneLink()->getIdTransferExtremity()->getIdOldExtremity()->getIdBackboneLinkExtremity()==$this->getIdBackboneLinkExtremity()->getIdBackboneLinkExtremity());        
        $type->setTransfer($this->getIdBackboneLink()->getIdTransferExtremity()!=NULL &&  $this->getIdBackboneLink()->getIdTransferExtremity()->getIdBackboneLinkExtremity()==$this->getIdBackboneLinkExtremity()->getIdBackboneLinkExtremity());                
        $type->setObject($this); 
        return $type;
    }
   
    public function hasTsByNumber($number)
    {
        foreach ($this->getIdTs() as $bbts) {
            if ($bbts->getNbTs() == $number)
                return true;
        }
        return false;
    }
    
    public function hasOutTsByNumber($number)
    {
        foreach ($this->getIdOutTs() as $bbts) {
            if ($bbts->getNbTs() == $number)
                return true;
        }
        return false;
    }    
    
    public function hasOutVlan($vlanref)
    {
        foreach ($this->getIdOutVlan() as $vlan)
        {
            if ($vlan->getLbVlan()==$vlanref)
                return true;
        }
        return false;
    }
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdBackboneLink()!=null)
            return $this->getIdBackboneLink()->getIdBranch();
        return NULL;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idOutTs = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idOutPortInstance = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idOutVlan = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return integer 
     */
    public function getIdBackboneLinkExtremityTech()
    {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Set dtBbTested
     *
     * @param \DateTime $dtBbTested
     * @return BackboneLinkExtremityTech
     */
    public function setDtBbTested($dtBbTested)
    {
        $this->dtBbTested = $dtBbTested;
    
        return $this;
    }

    /**
     * Get dtBbTested
     *
     * @return \DateTime 
     */
    public function getDtBbTested()
    {
        return $this->dtBbTested;
    }

    /**
     * Set dtOldBbTested
     *
     * @param \DateTime $dtOldBbTested
     * @return BackboneLinkExtremityTech
     */
    public function setDtOldBbTested($dtOldBbTested)
    {
        $this->dtOldBbTested = $dtOldBbTested;
    
        return $this;
    }

    /**
     * Get dtOldBbTested
     *
     * @return \DateTime 
     */
    public function getDtOldBbTested()
    {
        return $this->dtOldBbTested;
    }

    /**
     * Set cmCommentTechnical
     *
     * @param string $cmCommentTechnical
     * @return BackboneLinkExtremityTech
     */
    public function setCmCommentTechnical($cmCommentTechnical)
    {
        $this->cmCommentTechnical = $cmCommentTechnical;
    
        return $this;
    }

    /**
     * Get cmCommentTechnical
     *
     * @return string 
     */
    public function getCmCommentTechnical()
    {
        return $this->cmCommentTechnical;
    }

    /**
     * Set lbConnectionPath
     *
     * @param string $lbConnectionPath
     * @return BackboneLinkExtremityTech
     */
    public function setLbConnectionPath($lbConnectionPath)
    {
        $this->lbConnectionPath = $lbConnectionPath;
    
        return $this;
    }

    /**
     * Get lbConnectionPath
     *
     * @return string 
     */
    public function getLbConnectionPath()
    {
        return $this->lbConnectionPath;
    }

    /**
     * Set lbOutConnectionPath
     *
     * @param string $lbOutConnectionPath
     * @return BackboneLinkExtremityTech
     */
    public function setLbOutConnectionPath($lbOutConnectionPath)
    {
        $this->lbOutConnectionPath = $lbOutConnectionPath;
    
        return $this;
    }

    /**
     * Get lbOutConnectionPath
     *
     * @return string 
     */
    public function getLbOutConnectionPath()
    {
        return $this->lbOutConnectionPath;
    }

    /**
     * Set blOld
     *
     * @param boolean $blOld
     * @return BackboneLinkExtremityTech
     */
    public function setBlOld($blOld)
    {
        $this->blOld = $blOld;
    
        return $this;
    }

    /**
     * Get blOld
     *
     * @return boolean 
     */
    public function getBlOld()
    {
        return $this->blOld;
    }

    /**
     * Set blTransferred
     *
     * @param boolean $blTransferred
     * @return BackboneLinkExtremityTech
     */
    public function setBlTransferred($blTransferred)
    {
        $this->blTransferred = $blTransferred;
    
        return $this;
    }

    /**
     * Get blTransferred
     *
     * @return boolean 
     */
    public function getBlTransferred()
    {
        return $this->blTransferred;
    }

    /**
     * Set idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     * @return BackboneLinkExtremityTech
     */
    public function setIdTs(\Etrali\GinangBundle\Entity\Ts $idTs = null)
    {
        $this->idTs = $idTs;
    
        return $this;
    }

    /**
     * Get idTs
     *
     * @return \Etrali\GinangBundle\Entity\Ts 
     */
    public function getIdTs()
    {
        return $this->idTs;
    }

    /**
     * Set idVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idVlan
     * @return BackboneLinkExtremityTech
     */
    public function setIdVlan(\Etrali\GinangBundle\Entity\Vlan $idVlan = null)
    {
        $this->idVlan = $idVlan;
    
        return $this;
    }

    /**
     * Get idVlan
     *
     * @return \Etrali\GinangBundle\Entity\Vlan 
     */
    public function getIdVlan()
    {
        return $this->idVlan;
    }

    /**
     * Set idPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idPortInstance
     * @return BackboneLinkExtremityTech
     */
    public function setIdPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idPortInstance = null)
    {
        $this->idPortInstance = $idPortInstance;
    
        return $this;
    }

    /**
     * Get idPortInstance
     *
     * @return \Etrali\GinangBundle\Entity\PortInstance 
     */
    public function getIdPortInstance()
    {
        return $this->idPortInstance;
    }

    /**
     * Add idOutTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idOutTs
     * @return BackboneLinkExtremityTech
     */
    public function addIdOutT(\Etrali\GinangBundle\Entity\Ts $idOutTs)
    {
        $this->idOutTs[] = $idOutTs;
    
        return $this;
    }

    /**
     * Remove idOutTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idOutTs
     */
    public function removeIdOutT(\Etrali\GinangBundle\Entity\Ts $idOutTs)
    {
        $this->idOutTs->removeElement($idOutTs);
    }

    /**
     * Get idOutTs
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutTs()
    {
        return $this->idOutTs;
    }

    /**
     * Add idOutPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance
     * @return BackboneLinkExtremityTech
     */
    public function addIdOutPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance)
    {
        $this->idOutPortInstance[] = $idOutPortInstance;
    
        return $this;
    }

    /**
     * Remove idOutPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance
     */
    public function removeIdOutPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance)
    {
        $this->idOutPortInstance->removeElement($idOutPortInstance);
    }

    /**
     * Get idOutPortInstance
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutPortInstance()
    {
        return $this->idOutPortInstance;
    }

    /**
     * Add idOutVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idOutVlan
     * @return BackboneLinkExtremityTech
     */
    public function addIdOutVlan(\Etrali\GinangBundle\Entity\Vlan $idOutVlan)
    {
        $this->idOutVlan[] = $idOutVlan;
    
        return $this;
    }

    /**
     * Remove idOutVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idOutVlan
     */
    public function removeIdOutVlan(\Etrali\GinangBundle\Entity\Vlan $idOutVlan)
    {
        $this->idOutVlan->removeElement($idOutVlan);
    }

    /**
     * Get idOutVlan
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutVlan()
    {
        return $this->idOutVlan;
    }

    /**
     * Set idTechnicalContact
     *
     * @param \Etrali\GinangBundle\Entity\ContactPop $idTechnicalContact
     * @return BackboneLinkExtremityTech
     */
    public function setIdTechnicalContact(\Etrali\GinangBundle\Entity\ContactPop $idTechnicalContact = null)
    {
        $this->idTechnicalContact = $idTechnicalContact;
    
        return $this;
    }

    /**
     * Get idTechnicalContact
     *
     * @return \Etrali\GinangBundle\Entity\ContactPop 
     */
    public function getIdTechnicalContact()
    {
        return $this->idTechnicalContact;
    }

    /**
     * Set idBackboneLink
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink
     * @return BackboneLinkExtremityTech
     */
    public function setIdBackboneLink(\Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink = null)
    {
        $this->idBackboneLink = $idBackboneLink;
    
        return $this;
    }

    /**
     * Get idBackboneLink
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLink 
     */
    public function getIdBackboneLink()
    {
        return $this->idBackboneLink;
    }

    /**
     * Set idBackboneLinkExtremity
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity
     * @return BackboneLinkExtremityTech
     */
    public function setIdBackboneLinkExtremity(\Etrali\GinangBundle\Entity\BackboneLinkExtremity $idBackboneLinkExtremity = null)
    {
        $this->idBackboneLinkExtremity = $idBackboneLinkExtremity;
    
        return $this;
    }

    /**
     * Get idBackboneLinkExtremity
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLinkExtremity 
     */
    public function getIdBackboneLinkExtremity()
    {
        return $this->idBackboneLinkExtremity;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return BackboneLinkExtremityTech
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Add idOutConnectionPath
     *
     * @param \Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath
     * @return BackboneLinkExtremityTech
     */
    public function addIdOutConnectionPath(\Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath)
    {
        $this->idOutConnectionPath[] = $idOutConnectionPath;
    
        return $this;
    }

    /**
     * Remove idOutConnectionPath
     *
     * @param \Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath
     */
    public function removeIdOutConnectionPath(\Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath)
    {
        $this->idOutConnectionPath->removeElement($idOutConnectionPath);
    }

    /**
     * Get idOutConnectionPath
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutConnectionPath()
    {
        return $this->idOutConnectionPath;
    }

    /**
     * Add idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     * @return BackboneLinkExtremityTech
     */
    public function addIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs[] = $idTs;
    
        return $this;
    }

    /**
     * Remove idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     */
    public function removeIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs->removeElement($idTs);
    }
}