<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BackboneLinkOption
 *
 * @ORM\Table(name="backbone_link_option")
 * @ORM\Entity
 */
class BackboneLinkOption
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_backbone_link_option", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBackboneLinkOption;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_option", type="string", nullable=true)
     * @Assert\NotBlank()
     */
    private $cdOption;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_option", type="string", nullable=true)
     */
    private $lbOption;

    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_quantity", type="integer", nullable=true)
     */
    private $nbQuantity;
    
    
    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=false)
     */
    private $blDeactivated=true;

    /**
     * @var \BackboneLink
     *
     * @ORM\ManyToOne(targetEntity="BackboneLink", inversedBy="idBackboneLinkOption")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link", referencedColumnName="id_backbone_link")
     * })
     */
    private $idBackboneLink;

    /**
     * @var \OptionType
     *
     * @ORM\ManyToOne(targetEntity="OptionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_option_type", referencedColumnName="id_option_type")
     * })
     */
    private $idOptionType;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

    public function __toString()
    {
        return $this->getCdOption().":".$this->getLbOption();
    }
    
    

    public function getHeadInfo()
    {
            return "<td>".$this->getCdOption()."</td><td >".$this->getLbOption()."</td><td >".$this->getNbQuantity()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Ref</th><th>Description</th><th>Quantity</th>";
    }     
        

    /**
     * Get idBackboneLinkOption
     *
     * @return integer 
     */
    public function getIdBackboneLinkOption()
    {
        return $this->idBackboneLinkOption;
    }

    /**
     * Set nbQuantity
     *
     * @param integer $nbQuantity
     * @return BackboneLinkOption
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return integer 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return BackboneLinkOption
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return BackboneLinkOption
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return BackboneLinkOption
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idBackboneLink
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink
     * @return BackboneLinkOption
     */
    public function setIdBackboneLink(\Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink = null)
    {
        $this->idBackboneLink = $idBackboneLink;
    
        return $this;
    }

    /**
     * Get idBackboneLink
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLink 
     */
    public function getIdBackboneLink()
    {
        return $this->idBackboneLink;
    }

    /**
     * Set idOptionType
     *
     * @param \Etrali\GinangBundle\Entity\OptionType $idOptionType
     * @return BackboneLinkOption
     */
    public function setIdOptionType(\Etrali\GinangBundle\Entity\OptionType $idOptionType = null)
    {
        $this->idOptionType = $idOptionType;
    
        return $this;
    }

    /**
     * Get idOptionType
     *
     * @return \Etrali\GinangBundle\Entity\OptionType 
     */
    public function getIdOptionType()
    {
        return $this->idOptionType;
    }

    /**
     * Set cdOption
     *
     * @param string $cdOption
     * @return BackboneLinkOption
     */
    public function setCdOption($cdOption)
    {
        $this->cdOption = $cdOption;
    
        return $this;
    }

    /**
     * Get cdOption
     *
     * @return string 
     */
    public function getCdOption()
    {
        return $this->cdOption;
    }

    /**
     * Set lbOption
     *
     * @param string $lbOption
     * @return BackboneLinkOption
     */
    public function setLbOption($lbOption)
    {
        $this->lbOption = $lbOption;
    
        return $this;
    }

    /**
     * Get lbOption
     *
     * @return string 
     */
    public function getLbOption()
    {
        return $this->lbOption;
    }
    
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdBackboneLink()!=null)
            return $this->getIdBackboneLink()->getIdBranch();
        return NULL;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return BackboneLinkOption
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}