<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; 
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BackboneLinkTransactions
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Etrali\GinangBundle\Entity\BackboneLinkTransactionsRepository")
 */
class BackboneLinkTransactions
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_backbone_link_transactions", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $idBackboneLinkTransactions;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_extremity_ref", type="string", length=45, nullable=true)
     */
    private $cdExtremityRef;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_operation", type="string", length=45, nullable=true)
     */
    private $lbOperation;    
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;
    
    /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;   
    
    /**
     * @var \BackboneLink
     *
     * @ORM\ManyToOne(targetEntity="BackboneLink", inversedBy="idBackboneLinkTransactions")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link", referencedColumnName="id_backbone_link")
     * })
     */    
    private $idBackboneLink; 
    
    
    public function getHeadInfo()
    {
            return "<td>".$this->getDtCreate()->format("d/m/Y H:i")."</td><td >".$this->getCdExtremityRef()."</td><td>".$this->getLbOperation()."</td><td>".$this->getIdTransactionType()."</td><td>".$this->getIdTransactionStatus()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Date</th><th>Extremity ref</th><th>Operation</th><th>Transaction type</th><th>Transaction status</th>";
    }   
    
    public function __toString()
    {
        return $this->getDtCreate()->format("d/m/Y H:i")."-".$this->getCdExtremityRef()."-".$this->getIdTransactionType()." : ".$this->getIdTransactionStatus();
    }

    /**
     * Get idBackboneLinkTransactions
     *
     * @return integer 
     */
    public function getIdBackboneLinkTransactions()
    {
        return $this->idBackboneLinkTransactions;
    }


    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return BackboneLinkTransactions
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set cdBackboneLink
     *
     * @param string $cdBackboneLink
     * @return BackboneLinkTransactions
     */
    public function setCdBackboneLink($cdBackboneLink)
    {
        $this->cdBackboneLink = $cdBackboneLink;
    
        return $this;
    }

    /**
     * Get cdBackboneLink
     *
     * @return string 
     */
    public function getCdBackboneLink()
    {
        return $this->cdBackboneLink;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return BackboneLinkTransactions
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return BackboneLinkTransactions
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set cdExtremityRef
     *
     * @param string $cdExtremityRef
     * @return BackboneLinkTransactions
     */
    public function setCdExtremityRef($cdExtremityRef)
    {
        $this->cdExtremityRef = $cdExtremityRef;
    
        return $this;
    }

    /**
     * Get cdExtremityRef
     *
     * @return string 
     */
    public function getCdExtremityRef()
    {
        return $this->cdExtremityRef;
    }

    /**
     * Set idBackboneLink
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink
     * @return BackboneLinkTransactions
     */
    public function setIdBackboneLink(\Etrali\GinangBundle\Entity\BackboneLink $idBackboneLink = null)
    {
        $this->idBackboneLink = $idBackboneLink;
    
        return $this;
    }

    /**
     * Get idBackboneLink
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLink 
     */
    public function getIdBackboneLink()
    {
        return $this->idBackboneLink;
    }

    /**
     * Set lbOperation
     *
     * @param string $lbOperation
     * @return BackboneLinkTransactions
     */
    public function setLbOperation($lbOperation)
    {
        $this->lbOperation = $lbOperation;
    
        return $this;
    }

    /**
     * Get lbOperation
     *
     * @return string 
     */
    public function getLbOperation()
    {
        return $this->lbOperation;
    }public function getParentBranch() { return NULL; }  }