<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingFrequency
 *
 * @ORM\Table(name="billing_frequency")
 * @ORM\Entity
 */
class BillingFrequency
{
    /**
     * @var integer $idBillingFrequency
     *
     * @ORM\Column(name="id_billing_frequency", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingFrequency;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_frequency", type="string", length=15, nullable=true)
     */
    private $cdFrequency;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_frequency", type="string", length=255, nullable=true)
     */
    private $lbFrequency;
    
    /**
     * @ORM\ManyToMany(targetEntity="BillingPeriodRef", mappedBy="idBillingFrequency")
     */
    private $idBillingPeriodRef;    

    /**
     * @var integer $interval
     *
     * @ORM\Column(name="interval", type="integer", nullable=false)
     */
    private $interval=1;

    /**
     * @return string
     *
     */
    public function __toString()
    {
        return $this->getLbFrequency().'';
    } 


    /**
     * Get idBillingFrequency
     *
     * @return integer 
     */
    public function getIdBillingFrequency()
    {
        return $this->idBillingFrequency;
    }

    /**
     * Set cdFrequency
     *
     * @param string $cdFrequency
     * @return BillingFrequency
     */
    public function setCdFrequency($cdFrequency)
    {
        $this->cdFrequency = $cdFrequency;
    
        return $this;
    }

    /**
     * Get cdFrequency
     *
     * @return string 
     */
    public function getCdFrequency()
    {
        return $this->cdFrequency;
    }

    /**
     * Set lbFrequency
     *
     * @param string $lbFrequency
     * @return BillingFrequency
     */
    public function setLbFrequency($lbFrequency)
    {
        $this->lbFrequency = $lbFrequency;
    
        return $this;
    }

    /**
     * Get lbFrequency
     *
     * @return string 
     */
    public function getLbFrequency()
    {
        return $this->lbFrequency;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBillingPeriod = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     * @return BillingFrequency
     */
    public function addIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod)
    {
        $this->idBillingPeriod[] = $idBillingPeriod;
    
        return $this;
    }

    /**
     * Remove idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     */
    public function removeIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod)
    {
        $this->idBillingPeriod->removeElement($idBillingPeriod);
    }

    /**
     * Get idBillingPeriod
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingPeriod()
    {
        return $this->idBillingPeriod;
    }

    /**
     * Set interval
     *
     * @param integer $interval
     * @return BillingFrequency
     */
    public function setInterval($interval)
    {
        $this->interval = $interval;
    
        return $this;
    }

    /**
     * Get interval
     *
     * @return integer 
     */
    public function getInterval()
    {
        return $this->interval;
    }

    /**
     * Add idBillingPeriodRef
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef
     * @return BillingFrequency
     */
    public function addIdBillingPeriodRef(\Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef)
    {
        $this->idBillingPeriodRef[] = $idBillingPeriodRef;
    
        return $this;
    }

    /**
     * Remove idBillingPeriodRef
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef
     */
    public function removeIdBillingPeriodRef(\Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef)
    {
        $this->idBillingPeriodRef->removeElement($idBillingPeriodRef);
    }

    /**
     * Get idBillingPeriodRef
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingPeriodRef()
    {
        return $this->idBillingPeriodRef;
    }public function getParentBranch() { return NULL; }  }