<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingOneShot
 *
 * @ORM\Table(name="billing_one_shot")
 * @ORM\Entity
 */
class BillingOneShot
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_billing_one_shot", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingOneShot;
    
    
    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     * @Assert\NotNull() 
     */
    private $idCurrency;


    /**
     * @var \BillingService
     *
     * @ORM\ManyToOne(targetEntity="BillingService", inversedBy="idBillingOneShot")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_service", referencedColumnName="id_billing_service")
     * })
     */
    private $idBillingService;
    
    /**
     * @var \ServiceExtremity
     *
     * @ORM\ManyToMany(targetEntity="ServiceExtremity", inversedBy="idBillingOneShot")
     * @ORM\JoinTable(name="billing_one_shot_service_extremity",
     *      joinColumns={@ORM\JoinColumn(name="id_billing_one_shot", referencedColumnName="id_billing_one_shot",onDelete="CASCADE")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_service_extremity", referencedColumnName="id_service_extremity")}
     *      )
     */
    private $idServiceExtremity;  
    
   /**
     * @var \ServiceExtremityOption
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremityOption", inversedBy="idBillingOneShot")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity_option", referencedColumnName="id_service_extremity_option")
     * })
     */
    private $idServiceExtremityOption;    
    
    /**
     * @var \ServiceOption
     *
     * @ORM\ManyToOne(targetEntity="ServiceOption", cascade={"persist","remove"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_option", referencedColumnName="id_service_option")
     * })
     */
    private $idServiceOption;    

    
   /**
     * @var float
     *
     * @ORM\Column(name="mt_nrc", type="decimal", nullable=true)
     */
    private $mtNrc;

  
    /**
     * @var integer
     *
     * @ORM\Column(name="mt_nrc_euro", type="integer", nullable=true)
     */
    private $mtNrcEuro;
    
        /**
     * @var \BillingPeriod
     *
     * @ORM\ManyToOne(targetEntity="BillingPeriod")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_period", referencedColumnName="id_billing_period")
     * })
     * @Assert\NotNull()
     */
    private $idBillingPeriod;

    
    
    public function __toString()
    {
        return "";
    }    
    
    
    public function getHeadInfo()
    {
            return "<td>".$this->getMtNrcEuro()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Nrc</th>";
    }  


    /**
     * Get idBillingOneShot
     *
     * @return integer 
     */
    public function getIdBillingOneShot()
    {
        return $this->idBillingOneShot;
    }

    /**
     * Set mtNrc
     *
     * @param float $mtNrc
     * @return BillingOneShot
     */
    public function setMtNrc($mtNrc)
    {
        $this->mtNrc = $mtNrc;
    
        return $this;
    }

    /**
     * Get mtNrc
     *
     * @return float 
     */
    public function getMtNrc()
    {
        return $this->mtNrc;
    }

    /**
     * Set mtNrcEuro
     *
     * @param integer $mtNrcEuro
     * @return BillingOneShot
     */
    public function setMtNrcEuro($mtNrcEuro)
    {
        $this->mtNrcEuro = $mtNrcEuro;
    
        return $this;
    }

    /**
     * Get mtNrcEuro
     *
     * @return integer 
     */
    public function getMtNrcEuro()
    {
        return $this->mtNrcEuro;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return BillingOneShot
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return BillingOneShot
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Set idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return BillingOneShot
     */
    public function setIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity = null)
    {
        $this->idServiceExtremity = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Get idServiceExtremity
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremity 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Set idServiceExtremityOption
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityOption $idServiceExtremityOption
     * @return BillingOneShot
     */
    public function setIdServiceExtremityOption(\Etrali\GinangBundle\Entity\ServiceExtremityOption $idServiceExtremityOption = null)
    {
        $this->idServiceExtremityOption = $idServiceExtremityOption;
    
        return $this;
    }

    /**
     * Get idServiceExtremityOption
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremityOption 
     */
    public function getIdServiceExtremityOption()
    {
        return $this->idServiceExtremityOption;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     * @return BillingOneShot
     */
    public function setIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod = null)
    {
        $this->idBillingPeriod = $idBillingPeriod;
    
        return $this;
    }

    /**
     * Get idBillingPeriod
     *
     * @return \Etrali\GinangBundle\Entity\BillingPeriod 
     */
    public function getIdBillingPeriod()
    {
        return $this->idBillingPeriod;
    }

    /**
     * Set idBillingService
     *
     * @param \Etrali\GinangBundle\Entity\BillingService $idBillingService
     * @return BillingOneShot
     */
    public function setIdBillingService(\Etrali\GinangBundle\Entity\BillingService $idBillingService = null)
    {
        $this->idBillingService = $idBillingService;
    
        return $this;
    }

    /**
     * Get idBillingService
     *
     * @return \Etrali\GinangBundle\Entity\BillingService 
     */
    public function getIdBillingService()
    {
        return $this->idBillingService;
    }

    /**
     * Set idServiceOption
     *
     * @param \Etrali\GinangBundle\Entity\ServiceOption $idServiceOption
     * @return BillingOneShot
     */
    public function setIdServiceOption(\Etrali\GinangBundle\Entity\ServiceOption $idServiceOption = null)
    {
        $this->idServiceOption = $idServiceOption;
    
        return $this;
    }

    /**
     * Get idServiceOption
     *
     * @return \Etrali\GinangBundle\Entity\ServiceOption 
     */
    public function getIdServiceOption()
    {
        return $this->idServiceOption;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idServiceExtremity = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return BillingOneShot
     */
    public function addIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity)
    {
        $this->idServiceExtremity[] = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Remove idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     */
    public function removeIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity)
    {
        $this->idServiceExtremity->removeElement($idServiceExtremity);
    }
}