<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingPeriod
 *
 * @ORM\Table(name="billing_period")
 * @ORM\Entity
 */
class BillingPeriod
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_billing_period", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingPeriod;

    /**
     * @var \BillingPeriodRef
     *    
     * @ORM\ManyToOne(targetEntity="BillingPeriodRef",inversedBy="idBillingPeriod")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_period_ref", referencedColumnName="id_billing_period_ref", onDelete="CASCADE")
     * })     
     */
    private $idBillingPeriodRef;     
        
    /**
     * @var \BillingFrequency  
     *    
     * @ORM\ManyToOne(targetEntity="BillingFrequency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_frequency", referencedColumnName="id_billing_frequency")
     * })     
     */    
    
    private $idBillingFrequency; 
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_billing_period", type="string", length=100, nullable=true)
     */
    private $lbBillingPeriod;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_billing_start", type="datetime", nullable=false)
     */
    private $dtBillingStart;    
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_billing_end", type="datetime", nullable=false)
     */
    private $dtBillingEnd;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_ref_end", type="datetime", nullable=false)
     */
    private $dtRefEnd;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_ref_start", type="datetime", nullable=false)
     */
    private $dtRefStart;    

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch", onDelete="CASCADE")
     * })
     */
    private $idBranch;
    

   public function __toString() {
       return $this->getLbBillingPeriod()."";
   }

  

    /**
     * Get idBillingPeriod
     *
     * @return integer 
     */
    public function getIdBillingPeriod()
    {
        return $this->idBillingPeriod;
    }

    /**
     * Set dtBillingEnd
     *
     * @param \DateTime $dtBillingEnd
     * @return BillingPeriod
     */
    public function setDtBillingEnd($dtBillingEnd)
    {
        $this->dtBillingEnd = $dtBillingEnd;
    
        return $this;
    }

    /**
     * Get dtBillingEnd
     *
     * @return \DateTime 
     */
    public function getDtBillingEnd()
    {
        return $this->dtBillingEnd;
    }

    /**
     * Set dtRefEnd
     *
     * @param \DateTime $dtRefEnd
     * @return BillingPeriod
     */
    public function setDtRefEnd($dtRefEnd)
    {
        $this->dtRefEnd = $dtRefEnd;
    
        return $this;
    }

    /**
     * Get dtRefEnd
     *
     * @return \DateTime 
     */
    public function getDtRefEnd()
    {
        return $this->dtRefEnd;
    }

    /**
     * Set dtRefStart
     *
     * @param \DateTime $dtRefStart
     * @return BillingPeriod
     */
    public function setDtRefStart($dtRefStart)
    {
        $this->dtRefStart = $dtRefStart;
    
        return $this;
    }

    /**
     * Get dtRefStart
     *
     * @return \DateTime 
     */
    public function getDtRefStart()
    {
        return $this->dtRefStart;
    }

    /**
     * Set idBillingPeriodRef
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef
     * @return BillingPeriod
     */
    public function setIdBillingPeriodRef(\Etrali\GinangBundle\Entity\BillingPeriodRef $idBillingPeriodRef = null)
    {
        $this->idBillingPeriodRef = $idBillingPeriodRef;
    
        return $this;
    }

    /**
     * Get idBillingPeriodRef
     *
     * @return \Etrali\GinangBundle\Entity\BillingPeriodRef 
     */
    public function getIdBillingPeriodRef()
    {
        return $this->idBillingPeriodRef;
    }

    /**
     * Set idBillingFrequency
     *
     * @param \Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency
     * @return BillingPeriod
     */
    public function setIdBillingFrequency(\Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency = null)
    {
        $this->idBillingFrequency = $idBillingFrequency;
    
        return $this;
    }

    /**
     * Get idBillingFrequency
     *
     * @return \Etrali\GinangBundle\Entity\BillingFrequency 
     */
    public function getIdBillingFrequency()
    {
        return $this->idBillingFrequency;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return BillingPeriod
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set dtBillingStart
     *
     * @param \DateTime $dtBillingStart
     * @return BillingPeriod
     */
    public function setDtBillingStart($dtBillingStart)
    {
        $this->dtBillingStart = $dtBillingStart;
    
        return $this;
    }

    /**
     * Get dtBillingStart
     *
     * @return \DateTime 
     */
    public function getDtBillingStart()
    {
        return $this->dtBillingStart;
    }

    /**
     * Set lbBillingPeriod
     *
     * @param string $lbBillingPeriod
     * @return BillingPeriod
     */
    public function setLbBillingPeriod($lbBillingPeriod)
    {
        $this->lbBillingPeriod = $lbBillingPeriod;
    
        return $this;
    }

    /**
     * Get lbBillingPeriod
     *
     * @return string 
     */
    public function getLbBillingPeriod()
    {
        return $this->lbBillingPeriod;
    }public function getParentBranch() { return NULL; }  }