<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingPeriodRef
 *
 * @ORM\Table(name="billing_period_ref")
 * @ORM\Entity
 */
class BillingPeriodRef
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_billing_period_ref", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingPeriodRef;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_billing_period", type="string", length=15, nullable=false)
     */
    private $cdBillingPeriod;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_billing_period", type="string", length=100, nullable=true)
     */
    private $lbBillingPeriod;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_billing_start", type="datetime", nullable=false)
     */
    private $dtBillingStart;

        
    /**
     * @var \BillingFrequency  
     *    
     * @ORM\ManyToMany(targetEntity="BillingFrequency", inversedBy="idBillingPeriodRef", cascade={"persist"})
     * @ORM\JoinTable(name="billing_period_billing_frequency",
     *      joinColumns={@ORM\JoinColumn(name="id_billing_period_ref", referencedColumnName="id_billing_period_ref",onDelete="CASCADE")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_billing_frequency", referencedColumnName="id_billing_frequency")}
     *      )
     */
    private $idBillingFrequency; 
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch", inversedBy="idBillingPeriodRef")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch",onDelete="CASCADE")
     * })
     * @Assert\NotNull()
     */
    private $idBranch;
    
    /**
     * @var \BillingPeriod
     *
     * @ORM\OneToMany(targetEntity="BillingPeriod", mappedBy="idBillingPeriodRef")
     * @ORM\OrderBy({"dtBillingStart" = "asc"})       
     */
    
    private $idBillingPeriod;      
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
    
   public function __toString() {
       return $this->getLbBillingPeriod()."";
   }


    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBillingFrequency = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idBillingPeriodRef
     *
     * @return integer 
     */
    public function getIdBillingPeriodRef()
    {
        return $this->idBillingPeriodRef;
    }

    /**
     * Set cdBillingPeriod
     *
     * @param string $cdBillingPeriod
     * @return BillingPeriodRef
     */
    public function setCdBillingPeriod($cdBillingPeriod)
    {
        $this->cdBillingPeriod = $cdBillingPeriod;
    
        return $this;
    }

    /**
     * Get cdBillingPeriod
     *
     * @return string 
     */
    public function getCdBillingPeriod()
    {
        return $this->cdBillingPeriod;
    }

    /**
     * Set lbBillingPeriod
     *
     * @param string $lbBillingPeriod
     * @return BillingPeriodRef
     */
    public function setLbBillingPeriod($lbBillingPeriod)
    {
        $this->lbBillingPeriod = $lbBillingPeriod;
    
        return $this;
    }

    /**
     * Get lbBillingPeriod
     *
     * @return string 
     */
    public function getLbBillingPeriod()
    {
        return $this->lbBillingPeriod;
    }

    /**
     * Set dtBillingStart
     *
     * @param \DateTime $dtBillingStart
     * @return BillingPeriodRef
     */
    public function setDtBillingStart($dtBillingStart)
    {
        $this->dtBillingStart = $dtBillingStart;
    
        return $this;
    }

    /**
     * Get dtBillingStart
     *
     * @return \DateTime 
     */
    public function getDtBillingStart()
    {
        return $this->dtBillingStart;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return BillingPeriodRef
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Add idBillingFrequency
     *
     * @param \Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency
     * @return BillingPeriodRef
     */
    public function addIdBillingFrequency(\Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency)
    {
        $this->idBillingFrequency[] = $idBillingFrequency;
    
        return $this;
    }

    /**
     * Remove idBillingFrequency
     *
     * @param \Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency
     */
    public function removeIdBillingFrequency(\Etrali\GinangBundle\Entity\BillingFrequency $idBillingFrequency)
    {
        $this->idBillingFrequency->removeElement($idBillingFrequency);
    }

    /**
     * Get idBillingFrequency
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingFrequency()
    {
        return $this->idBillingFrequency;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return BillingPeriodRef
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Add idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     * @return BillingPeriodRef
     */
    public function addIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod)
    {
        $this->idBillingPeriod[] = $idBillingPeriod;
    
        return $this;
    }

    /**
     * Remove idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     */
    public function removeIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod)
    {
        $this->idBillingPeriod->removeElement($idBillingPeriod);
    }

    /**
     * Get idBillingPeriod
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingPeriod()
    {
        return $this->idBillingPeriod;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return BillingPeriodRef
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}