<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingServiceLine
 *
 * @ORM\Table(name="billing_service_line")
 * @ORM\Entity
 */
class BillingServiceLine
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_billing_service_line", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingServiceLine;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_customer_service", type="string", length=45, nullable=true)
     */
    private $cdCustomerService;
    
    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service", inversedBy="idBillingServiceLine")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     * @Assert\NotNull();      
     */
    private $idService;
    
    /**
     *    
     * @ORM\ManyToMany(targetEntity="ServiceExtremity", inversedBy="idBillingServiceLine", cascade={"persist"})
     * @ORM\JoinTable(name="billing_service_line_service_extremity",
     *      joinColumns={@ORM\JoinColumn(name="id_billing_service_line", referencedColumnName="id_billing_service_line",onDelete="CASCADE")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_service_extremity", referencedColumnName="id_service_extremity")}
     *      )
     */
    private $idServiceExtremity;  
    
    /**
     *    
     * @ORM\ManyToMany(targetEntity="ServiceDevice", inversedBy="idBillingServiceLine", cascade={"persist"})
     * @ORM\JoinTable(name="billing_service_line_service_device",
     *      joinColumns={@ORM\JoinColumn(name="id_billing_service_line", referencedColumnName="id_billing_service_line",onDelete="CASCADE")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_service_device", referencedColumnName="id_service_device")}
     *      )
     */
    private $idServiceDevice;      
    
   /**
     * @var \ServiceExtremityOption
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremityOption", inversedBy="idBillingServiceLine", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity_option", referencedColumnName="id_service_extremity_option")
     * })
     */
    private $idServiceExtremityOption;    
 
    /**
     * @var \BillingService
     *
     * @ORM\ManyToOne(targetEntity="BillingService", inversedBy="idBillingServiceLine")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_service", referencedColumnName="id_billing_service")
     * })
     */
    private $idBillingService;
    
   /**
     * @var float
     *
     * @ORM\Column(name="mt_nrc", type="decimal", nullable=true)      
     */
    private $mtNrc;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_mrc", type="decimal", nullable=true)
     * @Assert\NotBlank();         
     */
    private $mtMrc;
  
    /**
     * @var integer
     *
     * @ORM\Column(name="mt_nrc_euro", type="integer", nullable=true)   
     */
    private $mtNrcEuro;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_mrc_euro", type="decimal", nullable=true)      
     */
    private $mtMrcEuro;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start_mrc", type="datetime", nullable=true)         
     */
    private $dtStartMrc;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end_mrc", type="datetime", nullable=true)
     */
    private $dtEndMrc;

    /**
     * @var \ServiceOption
     *
     * @ORM\ManyToOne(targetEntity="ServiceOption", inversedBy="idBillingServiceLine", cascade={"persist","remove"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_option", referencedColumnName="id_service_option")
     * })
     */
    private $idServiceOption;
    
    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     * @Assert\NotNull();
     */
    private $idCurrency;    
    
    /**
     * Set idServiceDevice
     *
     * @param \Doctrine\Common\Collections\Collection  $idServiceDevice
     * @return BillingServiceLine
     */   
    public function setIdServiceDevice(\Doctrine\Common\Collections\Collection  $idServiceDevice)
    {
        $this->idServiceDevice = $idServiceDevice;
    
        return $this;
    }    
    
    public function __toString()
    {
        return "";
    }    
    


    
    /**
     * 
     * @return null
     */
    public function getParentBranch() 
    { 
        return NULL; 
    }     
    
   
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idServiceExtremity = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idServiceDevice = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idBillingServiceLine
     *
     * @return integer 
     */
    public function getIdBillingServiceLine()
    {
        return $this->idBillingServiceLine;
    }

    /**
     * Set cdCustomerService
     *
     * @param string $cdCustomerService
     * @return BillingServiceLine
     */
    public function setCdCustomerService($cdCustomerService)
    {
        $this->cdCustomerService = $cdCustomerService;
    
        return $this;
    }

    /**
     * Get cdCustomerService
     *
     * @return string 
     */
    public function getCdCustomerService()
    {
        return $this->cdCustomerService;
    }

    /**
     * Set mtNrc
     *
     * @param float $mtNrc
     * @return BillingServiceLine
     */
    public function setMtNrc($mtNrc)
    {
        $this->mtNrc = $mtNrc;
    
        return $this;
    }

    /**
     * Get mtNrc
     *
     * @return float 
     */
    public function getMtNrc()
    {
        return $this->mtNrc;
    }

    /**
     * Set mtMrc
     *
     * @param float $mtMrc
     * @return BillingServiceLine
     */
    public function setMtMrc($mtMrc)
    {
        $this->mtMrc = $mtMrc;
    
        return $this;
    }

    /**
     * Get mtMrc
     *
     * @return float 
     */
    public function getMtMrc()
    {
        return $this->mtMrc;
    }

    /**
     * Set mtNrcEuro
     *
     * @param integer $mtNrcEuro
     * @return BillingServiceLine
     */
    public function setMtNrcEuro($mtNrcEuro)
    {
        $this->mtNrcEuro = $mtNrcEuro;
    
        return $this;
    }

    /**
     * Get mtNrcEuro
     *
     * @return integer 
     */
    public function getMtNrcEuro()
    {
        return $this->mtNrcEuro;
    }

    /**
     * Set mtMrcEuro
     *
     * @param float $mtMrcEuro
     * @return BillingServiceLine
     */
    public function setMtMrcEuro($mtMrcEuro)
    {
        $this->mtMrcEuro = $mtMrcEuro;
    
        return $this;
    }

    /**
     * Get mtMrcEuro
     *
     * @return float 
     */
    public function getMtMrcEuro()
    {
        return $this->mtMrcEuro;
    }

    /**
     * Set dtStartMrc
     *
     * @param \DateTime $dtStartMrc
     * @return BillingServiceLine
     */
    public function setDtStartMrc($dtStartMrc)
    {
        $this->dtStartMrc = $dtStartMrc;
    
        return $this;
    }

    /**
     * Get dtStartMrc
     *
     * @return \DateTime 
     */
    public function getDtStartMrc()
    {
        return $this->dtStartMrc;
    }

    /**
     * Set dtEndMrc
     *
     * @param \DateTime $dtEndMrc
     * @return BillingServiceLine
     */
    public function setDtEndMrc($dtEndMrc)
    {
        $this->dtEndMrc = $dtEndMrc;
    
        return $this;
    }

    /**
     * Get dtEndMrc
     *
     * @return \DateTime 
     */
    public function getDtEndMrc()
    {
        return $this->dtEndMrc;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return BillingServiceLine
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Add idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return BillingServiceLine
     */
    public function addIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity)
    {
        $this->idServiceExtremity[] = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Remove idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     */
    public function removeIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity)
    {
        $this->idServiceExtremity->removeElement($idServiceExtremity);
    }

    /**
     * Get idServiceExtremity
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Add idServiceDevice
     *
     * @param \Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice
     * @return BillingServiceLine
     */
    public function addIdServiceDevice(\Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice)
    {
        $this->idServiceDevice[] = $idServiceDevice;
    
        return $this;
    }

    /**
     * Remove idServiceDevice
     *
     * @param \Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice
     */
    public function removeIdServiceDevice(\Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice)
    {
        $this->idServiceDevice->removeElement($idServiceDevice);
    }

    /**
     * Get idServiceDevice
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceDevice()
    {
        return $this->idServiceDevice;
    }
    

    
    /**
     * Set idServiceExtremityOption
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityOption $idServiceExtremityOption
     * @return BillingServiceLine
     */
    public function setIdServiceExtremityOption(\Etrali\GinangBundle\Entity\ServiceExtremityOption $idServiceExtremityOption = null)
    {
        $this->idServiceExtremityOption = $idServiceExtremityOption;
    
        return $this;
    }

    /**
     * Get idServiceExtremityOption
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremityOption 
     */
    public function getIdServiceExtremityOption()
    {
        return $this->idServiceExtremityOption;
    }

    /**
     * Set idBillingService
     *
     * @param \Etrali\GinangBundle\Entity\BillingService $idBillingService
     * @return BillingServiceLine
     */
    public function setIdBillingService(\Etrali\GinangBundle\Entity\BillingService $idBillingService = null)
    {
        $this->idBillingService = $idBillingService;
    
        return $this;
    }

    /**
     * Get idBillingService
     *
     * @return \Etrali\GinangBundle\Entity\BillingService 
     */
    public function getIdBillingService()
    {
        return $this->idBillingService;
    }

    /**
     * Set idServiceOption
     *
     * @param \Etrali\GinangBundle\Entity\ServiceOption $idServiceOption
     * @return BillingServiceLine
     */
    public function setIdServiceOption(\Etrali\GinangBundle\Entity\ServiceOption $idServiceOption = null)
    {
        $this->idServiceOption = $idServiceOption;
    
        return $this;
    }

    /**
     * Get idServiceOption
     *
     * @return \Etrali\GinangBundle\Entity\ServiceOption 
     */
    public function getIdServiceOption()
    {
        return $this->idServiceOption;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return BillingServiceLine
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }
}