<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BusinessConferenceGroup
 *
 * @ORM\Table(name="business_conference_group")
 * @ORM\Entity
 */
class BusinessConferenceGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_business_conference_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBusinessConferenceGroup;

   /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;
    
    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;
    
    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_business_conference_group", type="string", length=255, nullable=true)
     */
    private $lbBusinessConferenceGroup;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_business_conference_group", type="string", length=255, nullable=true)
     */
    private $cdBusinessConferenceGroup;  
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;
    
        /**
     * @var \Service
     *
     * @ORM\OneToMany(targetEntity="Service", mappedBy="idBusinessConferenceGroup")
     * @ORM\OrderBy({"cdService" = "asc"})         
     */
    private $idService;

   
public function __toString() {
        return '';
    }

    public function getParentBranch() {
        return NULL;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idService = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idBusinessConferenceGroup
     *
     * @return integer 
     */
    public function getIdBusinessConferenceGroup()
    {
        return $this->idBusinessConferenceGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return BusinessConferenceGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return BusinessConferenceGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return BusinessConferenceGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set lbBusinessConferenceGroup
     *
     * @param string $lbBusinessConferenceGroup
     * @return BusinessConferenceGroup
     */
    public function setLbBusinessConferenceGroup($lbBusinessConferenceGroup)
    {
        $this->lbBusinessConferenceGroup = $lbBusinessConferenceGroup;
    
        return $this;
    }

    /**
     * Get lbBusinessConferenceGroup
     *
     * @return string 
     */
    public function getLbBusinessConferenceGroup()
    {
        return $this->lbBusinessConferenceGroup;
    }

    /**
     * Set cdBusinessConferenceGroup
     *
     * @param string $cdBusinessConferenceGroup
     * @return BusinessConferenceGroup
     */
    public function setCdBusinessConferenceGroup($cdBusinessConferenceGroup)
    {
        $this->cdBusinessConferenceGroup = $cdBusinessConferenceGroup;
    
        return $this;
    }

    /**
     * Get cdBusinessConferenceGroup
     *
     * @return string 
     */
    public function getCdBusinessConferenceGroup()
    {
        return $this->cdBusinessConferenceGroup;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return BusinessConferenceGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Add idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return BusinessConferenceGroup
     */
    public function addIdService(\Etrali\GinangBundle\Entity\Service $idService)
    {
        $this->idService[] = $idService;
    
        return $this;
    }

    /**
     * Remove idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     */
    public function removeIdService(\Etrali\GinangBundle\Entity\Service $idService)
    {
        $this->idService->removeElement($idService);
    }

    /**
     * Get idService
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdService()
    {
        return $this->idService;
    }
}