<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CabinetSize
 *
 * @ORM\Table(name="cabinet_size")
 * @ORM\Entity
 */
class CabinetSize
{
    /**
     * @var integer $idCabinetSize
     *
     * @ORM\Column(name="id_cabinet_size", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $idCabinetSize;

    /**
     * @var string
     * @ORM\Column(name="cd_cabinet_size", type="string", length=15, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(15)
     */
    private $cdCabinetSize;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_cabinet_size", type="string", length=100, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)
     */
    private $lbCabinetSize;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    


    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @return string
     *
     */
    public function __toString()
    {
        return $this->lbCabinetSize.'';
    }
    
    /**
     * Get idCabinetSize
     *
     * @return integer 
     */
    public function getIdCabinetSize()
    {
        return $this->idCabinetSize;
    }


    /**
     * Set cdCabinetSize
     *
     * @param string $cdCabinetSize
     * @return CabinetSize
     */
    public function setCdCabinetSize($cdCabinetSize)
    {
        $this->cdCabinetSize = $cdCabinetSize;
    
        return $this;
    }

    /**
     * Get cdCabinetSize
     *
     * @return string 
     */
    public function getCdCabinetSize()
    {
        return $this->cdCabinetSize;
    }

    /**
     * Set lbCabinetSize
     *
     * @param string $lbCabinetSize
     * @return CabinetSize
     */
    public function setLbCabinetSize($lbCabinetSize)
    {
        $this->lbCabinetSize = $lbCabinetSize;
    
        return $this;
    }

    /**
     * Get lbCabinetSize
     *
     * @return string 
     */
    public function getLbCabinetSize()
    {
        return $this->lbCabinetSize;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CabinetSize
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CabinetSize
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return CabinetSize
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return CabinetSize
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function getParentBranch() { return NULL; }  }