<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CabinetType
 *
 * @ORM\Table(name="cabinet_type")
 * @ORM\Entity
 */
class CabinetType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_cabinet_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCabinetType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_cabinet_type", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(10)   
     */
    private $cdCabinetType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_cabinet_type", type="string", length=100, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(100)  
     */
    private $lbCabinetType;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_height", type="decimal", nullable=true)
     * @Assert\Regex("/^[0-9]*$/")
     * @Assert\Range(
     *      min = "1",
     *      minMessage = "Height of cabinet can not be zero")    
     */
    private $nbHeight;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_width", type="decimal", nullable=true)
     * @Assert\Regex("/^[0-9]*$/")
     * @Assert\Range(
     *      min = "1",
     *      minMessage = "Height of cabinet can not be zero")  
     */
    private $nbWidth;

    /**
     * @var string
     *
     * @ORM\Column(name="url_image", type="string", length=100, nullable=true)
     */
    private $urlImage;

    /**
     * @var string
     *
     * @ORM\Column(name="url_document", type="string", length=100, nullable=true)
     */
    private $urlDocument;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    

    /**
     * @return string
     *
     */
    public function __toString()
    {
        return $this->lbCabinetType.'';
    }

    

    /**
     * Get idCabinetType
     *
     * @return integer 
     */
    public function getIdCabinetType()
    {
        return $this->idCabinetType;
    }

    /**
     * Set cdCabinetType
     *
     * @param string $cdCabinetType
     * @return CabinetType
     */
    public function setCdCabinetType($cdCabinetType)
    {
        $this->cdCabinetType = $cdCabinetType;
    
        return $this;
    }

    /**
     * Get cdCabinetType
     *
     * @return string 
     */
    public function getCdCabinetType()
    {
        return $this->cdCabinetType;
    }

    /**
     * Set lbCabinetType
     *
     * @param string $lbCabinetType
     * @return CabinetType
     */
    public function setLbCabinetType($lbCabinetType)
    {
        $this->lbCabinetType = $lbCabinetType;
    
        return $this;
    }

    /**
     * Get lbCabinetType
     *
     * @return string 
     */
    public function getLbCabinetType()
    {
        return $this->lbCabinetType;
    }

    /**
     * Set nbHeight
     *
     * @param float $nbHeight
     * @return CabinetType
     */
    public function setNbHeight($nbHeight)
    {
        $this->nbHeight = $nbHeight;
    
        return $this;
    }

    /**
     * Get nbHeight
     *
     * @return float 
     */
    public function getNbHeight()
    {
        return $this->nbHeight;
    }

    /**
     * Set nbWidth
     *
     * @param float $nbWidth
     * @return CabinetType
     */
    public function setNbWidth($nbWidth)
    {
        $this->nbWidth = $nbWidth;
    
        return $this;
    }

    /**
     * Get nbWidth
     *
     * @return float 
     */
    public function getNbWidth()
    {
        return $this->nbWidth;
    }

    /**
     * Set urlImage
     *
     * @param string $urlImage
     * @return CabinetType
     */
    public function setUrlImage($urlImage)
    {
        $this->urlImage = $urlImage;
    
        return $this;
    }

    /**
     * Get urlImage
     *
     * @return string 
     */
    public function getUrlImage()
    {
        return $this->urlImage;
    }

    /**
     * Set urlDocument
     *
     * @param string $urlDocument
     * @return CabinetType
     */
    public function setUrlDocument($urlDocument)
    {
        $this->urlDocument = $urlDocument;
    
        return $this;
    }

    /**
     * Get urlDocument
     *
     * @return string 
     */
    public function getUrlDocument()
    {
        return $this->urlDocument;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return CabinetType
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return CabinetType
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CabinetType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CabinetType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }public function getParentBranch() { return NULL; }  }