<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Capacity
 *
 * @ORM\Table(name="capacity")
 * @ORM\Entity
 */
class Capacity
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_capacity", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCapacity;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_capacity", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)
     */
    private $cdCapacity;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_capacity", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(40)
     */
    private $lbCapacity;

    /**
     * @var integer
     *
     * @ORM\Column(name="max_capacity", type="integer", nullable=true)
     * @Assert\Regex("/^[0-9]+$/")
     * @Assert\Range(
     *      min = "1",
     *      minMessage = "Max capacity can not be zero")     
     */
    private $maxCapacity;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtUpdate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;

    /**
     * Get idCapacity
     *
     * @return integer 
     */
    public function getIdCapacity()
    {
        return $this->idCapacity;
    }

    /**
     * Set cdCapacity
     *
     * @param string $cdCapacity
     * @return Capacity
     */
    public function setCdCapacity($cdCapacity)
    {
        $this->cdCapacity = $cdCapacity;
    
        return $this;
    }

    /**
     * Get cdCapacity
     *
     * @return string 
     */
    public function getCdCapacity()
    {
        return $this->cdCapacity;
    }

    /**
     * Set lbCapacity
     *
     * @param string $lbCapacity
     * @return Capacity
     */
    public function setLbCapacity($lbCapacity)
    {
        $this->lbCapacity = $lbCapacity;
    
        return $this;
    }

    /**
     * Get lbCapacity
     *
     * @return string 
     */
    public function getLbCapacity()
    {
        return $this->lbCapacity;
    }

    /**
     * Set maxCapacity
     *
     * @param integer $maxCapacity
     * @return Capacity
     */
    public function setMaxCapacity($maxCapacity)
    {
        $this->maxCapacity = $maxCapacity;
    
        return $this;
    }

    /**
     * Get maxCapacity
     *
     * @return integer 
     */
    public function getMaxCapacity()
    {
        return $this->maxCapacity;
    }    
    
    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Capacity
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
    
/**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Capacity
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return Capacity
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }
    
    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtDeactivated
     * @return Capacity
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
    
    public function __toString()
    {
        return $this->getLbCapacity().'';
    }
public function getParentBranch() { return NULL; }  }