<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CardType
 *
 * @ORM\Table(name="card_type")
 * @ORM\Entity
 */
class CardType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_card_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCardType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_card_type", type="string", length=15, nullable=false)
     */
    private $cdCardType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_card_type", type="string", length=100, nullable=false)
     */
    private $lbCardType;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_orientation", type="integer", nullable=true)
     */
    private $idOrientation;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_height", type="decimal", nullable=true)
     */
    private $nbHeight;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_width", type="decimal", nullable=true)
     */
    private $nbWidth;

    /**
     * @var string
     *
     * @ORM\Column(name="url_image", type="string", length=100, nullable=true)
     */
    private $urlImage;

    /**
     * @var string
     *
     * @ORM\Column(name="url_document", type="string", length=100, nullable=true)
     */
    private $urlDocument;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_create_by", type="integer", nullable=true)
     */
    private $idUserCreateBy;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_update_by", type="integer", nullable=true)
     */
    private $idUserUpdateBy;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_port", type="integer", nullable=true)
     */
    private $nbPort;
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idCardType
     *
     * @return integer 
     */
    public function getIdCardType()
    {
        return $this->idCardType;
    }

    /**
     * Set cdCardType
     *
     * @param string $cdCardType
     * @return CardType
     */
    public function setCdCardType($cdCardType)
    {
        $this->cdCardType = $cdCardType;
    
        return $this;
    }

    /**
     * Get cdCardType
     *
     * @return string 
     */
    public function getCdCardType()
    {
        return $this->cdCardType;
    }

    /**
     * Set lbCardType
     *
     * @param string $lbCardType
     * @return CardType
     */
    public function setLbCardType($lbCardType)
    {
        $this->lbCardType = $lbCardType;
    
        return $this;
    }

    /**
     * Get lbCardType
     *
     * @return string 
     */
    public function getLbCardType()
    {
        return $this->lbCardType;
    }

    /**
     * Set idOrientation
     *
     * @param integer $idOrientation
     * @return CardType
     */
    public function setIdOrientation($idOrientation)
    {
        $this->idOrientation = $idOrientation;
    
        return $this;
    }

    /**
     * Get idOrientation
     *
     * @return integer 
     */
    public function getIdOrientation()
    {
        return $this->idOrientation;
    }

    /**
     * Set nbHeight
     *
     * @param float $nbHeight
     * @return CardType
     */
    public function setNbHeight($nbHeight)
    {
        $this->nbHeight = $nbHeight;
    
        return $this;
    }

    /**
     * Get nbHeight
     *
     * @return float 
     */
    public function getNbHeight()
    {
        return $this->nbHeight;
    }

    /**
     * Set nbWidth
     *
     * @param float $nbWidth
     * @return CardType
     */
    public function setNbWidth($nbWidth)
    {
        $this->nbWidth = $nbWidth;
    
        return $this;
    }

    /**
     * Get nbWidth
     *
     * @return float 
     */
    public function getNbWidth()
    {
        return $this->nbWidth;
    }

    /**
     * Set urlImage
     *
     * @param string $urlImage
     * @return CardType
     */
    public function setUrlImage($urlImage)
    {
        $this->urlImage = $urlImage;
    
        return $this;
    }

    /**
     * Get urlImage
     *
     * @return string 
     */
    public function getUrlImage()
    {
        return $this->urlImage;
    }

    /**
     * Set urlDocument
     *
     * @param string $urlDocument
     * @return CardType
     */
    public function setUrlDocument($urlDocument)
    {
        $this->urlDocument = $urlDocument;
    
        return $this;
    }

    /**
     * Get urlDocument
     *
     * @return string 
     */
    public function getUrlDocument()
    {
        return $this->urlDocument;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return CardType
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return CardType
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CardType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CardType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CardType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param integer $idUserCreateBy
     * @return CardType
     */
    public function setIdUserCreateBy($idUserCreateBy)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return integer 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param integer $idUserUpdateBy
     * @return CardType
     */
    public function setIdUserUpdateBy($idUserUpdateBy)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return integer 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set nbPort
     *
     * @param integer $nbPort
     * @return CardType
     */
    public function setNbPort($nbPort)
    {
        $this->nbPort = $nbPort;
    
        return $this;
    }

    /**
     * Get nbPort
     *
     * @return integer 
     */
    public function getNbPort()
    {
        return $this->nbPort;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CardType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}