<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CommercialRoute
 *
 * @ORM\Table(name="commercial_route")
 * @ORM\Entity
 */
class CommercialRoute
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_commercial_route", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCommercialRoute;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_commercial_route", type="string", length=15, nullable=true)
     *
     */
    private $cdCommercialRoute;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_commercial_route", type="string", length=100, nullable=true)
     */
    private $lbCommercialRoute;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    /**
     * @var \Route
     *
     * @ORM\OneToMany(targetEntity="Route", mappedBy="idCommercialRoute",cascade={"persist","remove"}, orphanRemoval=true)

     */
    private $idRoute;   


    /**
     * @var \City
     *
     * @ORM\ManyToOne(targetEntity="City")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_city_a", referencedColumnName="id_city")
     * })
     * @Assert\NotNull() 
     */
    private $idCityA;
    
    /**
     * @var \City
     *
     * @ORM\ManyToOne(targetEntity="City")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_city_b", referencedColumnName="id_city")
     * })
     * @Assert\NotNull() 
     */
    private $idCityB;    
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getCdCommercialRoute().'';
    }  

    /**
     * Get idCommercialRoute
     *
     * @return integer 
     */
    public function getIdCommercialRoute()
    {
        return $this->idCommercialRoute;
    }

    /**
     * Set cdCommercialRoute
     *
     * @param string $cdCommercialRoute
     * @return CommercialRoute
     */
    public function setCdCommercialRoute($cdCommercialRoute)
    {
        $this->cdCommercialRoute = $cdCommercialRoute;
    
        return $this;
    }

    /**
     * Get cdCommercialRoute
     *
     * @return string 
     */
    public function getCdCommercialRoute()
    {
        return "".($this->getIdCityA()!=NULL?$this->getIdCityA()->getCdCity():"").($this->getIdCityB()!=NULL?$this->getIdCityB()->getCdCity():"");
    }

    /**
     * Set lbCommercialRoute
     *
     * @param string $lbCommercialRoute
     * @return CommercialRoute
     */
    public function setLbCommercialRoute($lbCommercialRoute)
    {
        $this->lbCommercialRoute = $lbCommercialRoute;
    
        return $this;
    }

    /**
     * Get lbCommercialRoute
     *
     * @return string 
     */
    public function getLbCommercialRoute()
    {
        return $this->lbCommercialRoute;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CommercialRoute
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CommercialRoute
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CommercialRoute
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param integer $idUserCreateBy
     * @return CommercialRoute
     */
    public function setIdUserCreateBy($idUserCreateBy)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return integer 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param integer $idUserUpdateBy
     * @return CommercialRoute
     */
    public function setIdUserUpdateBy($idUserUpdateBy)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return integer 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function getParentBranch() { return NULL; }      /**
     * Constructor
     */
    public function __construct()
    {
        $this->idRoute = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idRoute
     *
     * @param \Etrali\GinangBundle\Entity\Route $idRoute
     * @return CommercialRoute
     */
    public function addIdRoute(\Etrali\GinangBundle\Entity\Route $idRoute)
    {
        $this->idRoute[] = $idRoute;
    
        return $this;
    }

    /**
     * Remove idRoute
     *
     * @param \Etrali\GinangBundle\Entity\Route $idRoute
     */
    public function removeIdRoute(\Etrali\GinangBundle\Entity\Route $idRoute)
    {
        $this->idRoute->removeElement($idRoute);
    }

    /**
     * Get idRoute
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdRoute()
    {
        return $this->idRoute;
    }

    /**
     * Set idCityA
     *
     * @param \Etrali\GinangBundle\Entity\City $idCityA
     * @return CommercialRoute
     */
    public function setIdCityA(\Etrali\GinangBundle\Entity\City $idCityA = null)
    {
        $this->idCityA = $idCityA;
    
        return $this;
    }

    /**
     * Get idCityA
     *
     * @return \Etrali\GinangBundle\Entity\City 
     */
    public function getIdCityA()
    {
        return $this->idCityA;
    }

    /**
     * Set idCityB
     *
     * @param \Etrali\GinangBundle\Entity\City $idCityB
     * @return CommercialRoute
     */
    public function setIdCityB(\Etrali\GinangBundle\Entity\City $idCityB = null)
    {
        $this->idCityB = $idCityB;
    
        return $this;
    }

    /**
     * Get idCityB
     *
     * @return \Etrali\GinangBundle\Entity\City 
     */
    public function getIdCityB()
    {
        return $this->idCityB;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CommercialRoute
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}