<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CommercialRoutePrice
 *
 * @ORM\Table(name="commercial_route_price")
 * @ORM\Entity
 */
class CommercialRoutePrice
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_commercial_price", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCommercialPrice;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_bandwidth", type="integer", nullable=true)
     */
    private $idBandwidth;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_product", type="integer", nullable=true)
     */
    private $idProduct;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_commercial_route", type="integer", nullable=true)
     */
    private $idCommercialRoute;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_transfer_price", type="decimal", nullable=true)
     */
    private $mtTransferPrice;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_install_price", type="decimal", nullable=true)
     */
    private $mtInstallPrice;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_create_by", type="integer", nullable=true)
     */
    private $idUserCreateBy;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_update_by", type="integer", nullable=true)
     */
    private $idUserUpdateBy;



    /**
     * Get idCommercialPrice
     *
     * @return integer 
     */
    public function getIdCommercialPrice()
    {
        return $this->idCommercialPrice;
    }

    /**
     * Set idBandwidth
     *
     * @param integer $idBandwidth
     * @return CommercialRoutePrice
     */
    public function setIdBandwidth($idBandwidth)
    {
        $this->idBandwidth = $idBandwidth;
    
        return $this;
    }

    /**
     * Get idBandwidth
     *
     * @return integer 
     */
    public function getIdBandwidth()
    {
        return $this->idBandwidth;
    }

    /**
     * Set idProduct
     *
     * @param integer $idProduct
     * @return CommercialRoutePrice
     */
    public function setIdProduct($idProduct)
    {
        $this->idProduct = $idProduct;
    
        return $this;
    }

    /**
     * Get idProduct
     *
     * @return integer 
     */
    public function getIdProduct()
    {
        return $this->idProduct;
    }

    /**
     * Set idCommercialRoute
     *
     * @param integer $idCommercialRoute
     * @return CommercialRoutePrice
     */
    public function setIdCommercialRoute($idCommercialRoute)
    {
        $this->idCommercialRoute = $idCommercialRoute;
    
        return $this;
    }

    /**
     * Get idCommercialRoute
     *
     * @return integer 
     */
    public function getIdCommercialRoute()
    {
        return $this->idCommercialRoute;
    }

    /**
     * Set mtTransferPrice
     *
     * @param float $mtTransferPrice
     * @return CommercialRoutePrice
     */
    public function setMtTransferPrice($mtTransferPrice)
    {
        $this->mtTransferPrice = $mtTransferPrice;
    
        return $this;
    }

    /**
     * Get mtTransferPrice
     *
     * @return float 
     */
    public function getMtTransferPrice()
    {
        return $this->mtTransferPrice;
    }

    /**
     * Set mtInstallPrice
     *
     * @param float $mtInstallPrice
     * @return CommercialRoutePrice
     */
    public function setMtInstallPrice($mtInstallPrice)
    {
        $this->mtInstallPrice = $mtInstallPrice;
    
        return $this;
    }

    /**
     * Get mtInstallPrice
     *
     * @return float 
     */
    public function getMtInstallPrice()
    {
        return $this->mtInstallPrice;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return CommercialRoutePrice
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return CommercialRoutePrice
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CommercialRoutePrice
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CommercialRoutePrice
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CommercialRoutePrice
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param integer $idUserCreateBy
     * @return CommercialRoutePrice
     */
    public function setIdUserCreateBy($idUserCreateBy)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return integer 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param integer $idUserUpdateBy
     * @return CommercialRoutePrice
     */
    public function setIdUserUpdateBy($idUserUpdateBy)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return integer 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }