<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ConnectionPath
 *
 * @ORM\Table(name="connection_path")
 * @ORM\Entity
 */
class ConnectionPath
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_connection_path", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idConnectionPath;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_connection_path", type="string", length=1000, nullable=false)
     */
    private $lbConnectionPath;
    
    /**
     * @var \BackboneLinkExtremityTech
     *
     * @ORM\ManyToOne(targetEntity="BackboneLinkExtremityTech", inversedBy="idOutConnectionPath", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link_extremity_tech", referencedColumnName="id_backbone_link_extremity_tech")
     * })
     */
    private $idBackboneLinkExtremityTech;      
    
    /**
     * @var \LocalLoopExtremityTech
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityTech", inversedBy="idOutConnectionPath", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_tech", referencedColumnName="id_local_loop_extremity_tech")
     * })
     */
    private $idLocalLoopExtremityTech;       


public function __toString() { return ''; } 

public function getParentBranch() { return NULL; }  


    /**
     * Get idConnectionPath
     *
     * @return integer 
     */
    public function getIdConnectionPath()
    {
        return $this->idConnectionPath;
    }

    /**
     * Set lbConnectionPath
     *
     * @param string $lbConnectionPath
     * @return ConnectionPath
     */
    public function setLbConnectionPath($lbConnectionPath)
    {
        $this->lbConnectionPath = $lbConnectionPath;
    
        return $this;
    }

    /**
     * Get lbConnectionPath
     *
     * @return string 
     */
    public function getLbConnectionPath()
    {
        return $this->lbConnectionPath;
    }

    /**
     * Set idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return ConnectionPath
     */
    public function setIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech = null)
    {
        $this->idBackboneLinkExtremityTech = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech 
     */
    public function getIdBackboneLinkExtremityTech()
    {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Set idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return ConnectionPath
     */
    public function setIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech = null)
    {
        $this->idLocalLoopExtremityTech = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityTech 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }
}