<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ContactType
 *
 * @ORM\Table(name="contact_type")
 * @ORM\Entity
 */
class ContactType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_contact_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idContactType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_contact_type", type="string", length=15, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(15)
     */
    private $cdContactType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_contact_type", type="string", length=100, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(30)
     */
    private $lbContactType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_customer", type="boolean", nullable=true)
     */
    private $blCustomer=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
    /**
     * Get idContactType
     *
     * @return integer 
     */
    public function getIdContactType()
    {
        return $this->idContactType;
    }

    /**
     * Set cdContactType
     *
     * @param string $cdContactType
     * @return ContactType
     */
    public function setCdContactType($cdContactType)
    {
        $this->cdContactType = $cdContactType;
    
        return $this;
    }

    /**
     * Get cdContactType
     *
     * @return string 
     */
    public function getCdContactType()
    {
        return $this->cdContactType;
    }

    /**
     * Set lbContactType
     *
     * @param string $lbContactType
     * @return ContactType
     */
    public function setLbContactType($lbContactType)
    {
        $this->lbContactType = $lbContactType;
    
        return $this;
    }

    /**
     * Get lbContactType
     *
     * @return string 
     */
    public function getLbContactType()
    {
        return $this->lbContactType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ContactType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ContactType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return ContactType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return ContactType
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return ContactType
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
    public function __toString()
    {
        return $this->getLbContactType().'';
    }

    /**
     * Set blCustomer
     *
     * @param boolean $blCustomer
     * @return ContactType
     */
    public function setBlCustomer($blCustomer)
    {
        $this->blCustomer = $blCustomer;
    
        return $this;
    }

    /**
     * Get blCustomer
     *
     * @return boolean 
     */
    public function getBlCustomer()
    {
        return $this->blCustomer;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ContactType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}