<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ContinentGroup
 *
 * @ORM\Table(name="continent_group")
 * @ORM\Entity
 */
class ContinentGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_continent_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idContinentGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_continent_group", type="string", length=15, nullable=false)
     */
    private $cdContinentGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_continent_group", type="string", length=100, nullable=true)
     */
    private $lbContinentGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    /**
     * @var \Continent
     *
     * @ORM\OneToMany(targetEntity="CustomerGroup", mappedBy="idContinentGroup",cascade={"persist","remove"}, orphanRemoval=true )   
     */
    private $idCustomerGroup;    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;
    
    /**
     * @var \WorldGroup
     *
     * @ORM\ManyToOne(targetEntity="WorldGroup",inversedBy="idContinentGroup")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_world_group", referencedColumnName="id_world_group")
     * })
     *
     */
    private $idWorldGroup;   
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbContinentGroup().'';
    }

  
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idContinent = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
 

    /**
     * Get idContinentGroup
     *
     * @return integer 
     */
    public function getIdContinentGroup()
    {
        return $this->idContinentGroup;
    }

    /**
     * Set cdContinentGroup
     *
     * @param string $cdContinentGroup
     * @return ContinentGroup
     */
    public function setCdContinentGroup($cdContinentGroup)
    {
        $this->cdContinentGroup = $cdContinentGroup;
    
        return $this;
    }

    /**
     * Get cdContinentGroup
     *
     * @return string 
     */
    public function getCdContinentGroup()
    {
        return $this->cdContinentGroup;
    }

    /**
     * Set lbContinentGroup
     *
     * @param string $lbContinentGroup
     * @return ContinentGroup
     */
    public function setLbContinentGroup($lbContinentGroup)
    {
        $this->lbContinentGroup = $lbContinentGroup;
    
        return $this;
    }

    /**
     * Get lbContinentGroup
     *
     * @return string 
     */
    public function getLbContinentGroup()
    {
        return $this->lbContinentGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ContinentGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ContinentGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return ContinentGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ContinentGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return ContinentGroup
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return ContinentGroup
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Add idCustomerGroup
     *
     * @param \Etrali\GinangBundle\Entity\CustomerGroup $idCustomerGroup
     * @return ContinentGroup
     */
    public function addIdCustomerGroup(\Etrali\GinangBundle\Entity\CustomerGroup $idCustomerGroup)
    {
        $this->idCustomerGroup[] = $idCustomerGroup;
    
        return $this;
    }

    /**
     * Remove idCustomerGroup
     *
     * @param \Etrali\GinangBundle\Entity\CustomerGroup $idCustomerGroup
     */
    public function removeIdCustomerGroup(\Etrali\GinangBundle\Entity\CustomerGroup $idCustomerGroup)
    {
        $this->idCustomerGroup->removeElement($idCustomerGroup);
    }

    /**
     * Get idCustomerGroup
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCustomerGroup()
    {
        return $this->idCustomerGroup;
    }

    /**
     * Set idWorldGroup
     *
     * @param \Etrali\GinangBundle\Entity\WorldGroup $idWorldGroup
     * @return ContinentGroup
     */
    public function setIdWorldGroup(\Etrali\GinangBundle\Entity\WorldGroup $idWorldGroup = null)
    {
        $this->idWorldGroup = $idWorldGroup;
    
        return $this;
    }

    /**
     * Get idWorldGroup
     *
     * @return \Etrali\GinangBundle\Entity\WorldGroup 
     */
    public function getIdWorldGroup()
    {
        return $this->idWorldGroup;
    }
}