<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Pop
 *
 * @ORM\Table(name="costing_pop")
 * @ORM\Entity
 */
class CostingPop
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_costing_pop", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCostingPop;


    /**
     * @var \CostingPopLine
     *
     * @ORM\OneToMany(targetEntity="CostingPopLine", mappedBy="idCostingPop",cascade={"persist","remove"}, orphanRemoval=true)

     */
    private $idCostingPopLine;   
    
    
    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     * @Assert\NotNull()        
     */
    private $idProvider;
    
    
    /**
     * @var \ContactProvider
     *
     * @ORM\ManyToOne(targetEntity="ContactProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact", referencedColumnName="id_contact_provider")
     * }) 
     * @Assert\NotNull()     
     */
    private $idContact;
    
    /**
     * @var \AddressProvider
     *
     * @ORM\ManyToOne(targetEntity="AddressProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address", referencedColumnName="id_address_provider")
     * }) 
     * @Assert\NotNull()     
     */
    private $idAddress;    
            
    /**
     * @var string
     *
     * @ORM\Column(name="cd_provider_account", type="string", length=45, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)   
     */
    private $cdProviderAccount;
    
    
    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop", inversedBy="idCostingPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;
   
    /**
     * @var string
     *
     * @ORM\Column(name="comment", type="text", nullable=true)
     */
    private $comment;
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getIdProvider()->getLbProvider().'';
    }
    
      public function getHeadInfo()
    {
            return "<td>".$this->getIdProvider()."</td><td >".$this->getIdContact()."</td><td>".$this->getIdAddress()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Provider</th><th>Contact</th><th>Address</th>";
    }  

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idCostingPopLine = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idCostingPop
     *
     * @return integer 
     */
    public function getIdCostingPop()
    {
        return $this->idCostingPop;
    }

    /**
     * Set cdProviderAccount
     *
     * @param string $cdProviderAccount
     * @return CostingPop
     */
    public function setCdProviderAccount($cdProviderAccount)
    {
        $this->cdProviderAccount = $cdProviderAccount;
    
        return $this;
    }

    /**
     * Get cdProviderAccount
     *
     * @return string 
     */
    public function getCdProviderAccount()
    {
        return $this->cdProviderAccount;
    }

    /**
     * Set comment
     *
     * @param string $comment
     * @return CostingPop
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    
        return $this;
    }

    /**
     * Get comment
     *
     * @return string 
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * Add idCostingPopLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingPopLine $idCostingPopLine
     * @return CostingPop
     */
    public function addIdCostingPopLine(\Etrali\GinangBundle\Entity\CostingPopLine $idCostingPopLine)
    {
        $this->idCostingPopLine[] = $idCostingPopLine;
    
        return $this;
    }

    /**
     * Remove idCostingPopLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingPopLine $idCostingPopLine
     */
    public function removeIdCostingPopLine(\Etrali\GinangBundle\Entity\CostingPopLine $idCostingPopLine)
    {
        $this->idCostingPopLine->removeElement($idCostingPopLine);
    }

    /**
     * Get idCostingPopLine
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCostingPopLine()
    {
        return $this->idCostingPopLine;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return CostingPop
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idContact
     *
     * @param \Etrali\GinangBundle\Entity\ContactProvider $idContact
     * @return CostingPop
     */
    public function setIdContact(\Etrali\GinangBundle\Entity\ContactProvider $idContact = null)
    {
        $this->idContact = $idContact;
    
        return $this;
    }

    /**
     * Get idContact
     *
     * @return \Etrali\GinangBundle\Entity\ContactProvider 
     */
    public function getIdContact()
    {
        return $this->idContact;
    }

    /**
     * Set idAddress
     *
     * @param \Etrali\GinangBundle\Entity\AddressProvider $idAddress
     * @return CostingPop
     */
    public function setIdAddress(\Etrali\GinangBundle\Entity\AddressProvider $idAddress = null)
    {
        $this->idAddress = $idAddress;
    
        return $this;
    }

    /**
     * Get idAddress
     *
     * @return \Etrali\GinangBundle\Entity\AddressProvider 
     */
    public function getIdAddress()
    {
        return $this->idAddress;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return CostingPop
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }
            
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdPop()!=null)
            return $this->getIdPop()->getIdBranch();
        return NULL;
    }
}