<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CountryProviderGroup
 *
 * @ORM\Table(name="country_provider_group")
 * @ORM\Entity
 */
class CountryProviderGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_country_provider_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCountryProviderGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_country_group", type="string", length=100, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)
     */
    private $lbCountryGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=false)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \Cluster
     *
     * @ORM\ManyToOne(targetEntity="Cluster")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_cluster", referencedColumnName="id_cluster")
     * })
     */
    private $idCluster;


    /**
     * @var \Country
     *
     * @ORM\ManyToOne(targetEntity="Country")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_country", referencedColumnName="id_country")
     * })
     */
    private $idCountry;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbCountryGroup()."";
    }  

    /**
     * Get idCountryProviderGroup
     *
     * @return integer 
     */
    public function getIdCountryProviderGroup()
    {
        return $this->idCountryProviderGroup;
    }

    /**
     * Set lbCountryGroup
     *
     * @param integer $lbCountryGroup
     * @return CountryProviderGroup
     */
    public function setLbCountryGroup($lbCountryGroup)
    {
        $this->lbCountryGroup = $lbCountryGroup;
    
        return $this;
    }

    /**
     * Get lbCountryGroup
     *
     * @return integer 
     */
    public function getLbCountryGroup()
    {
        return $this->lbCountryGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CountryProviderGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtDaectivated
     *
     * @param \DateTime $dtDaectivated
     * @return CountryProviderGroup
     */
    public function setDtDaectivated($dtDaectivated)
    {
        $this->dtDaectivated = $dtDaectivated;
    
        return $this;
    }

    /**
     * Get dtDaectivated
     *
     * @return \DateTime 
     */
    public function getDtDaectivated()
    {
        return $this->dtDaectivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CountryProviderGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CountryProviderGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idCluster
     *
     * @param \Etrali\GinangBundle\Entity\Cluster $idCluster
     * @return CountryProviderGroup
     */
    public function setIdCluster(\Etrali\GinangBundle\Entity\Cluster $idCluster = null)
    {
        $this->idCluster = $idCluster;
    
        return $this;
    }

    /**
     * Get idCluster
     *
     * @return \Etrali\GinangBundle\Entity\Cluster 
     */
    public function getIdCluster()
    {
        return $this->idCluster;
    }

    /**
     * Set idWorldwideGroup
     *
     * @param \Etrali\GinangBundle\Entity\WorldwideGroup $idWorldwideGroup
     * @return CountryProviderGroup
     */
    public function setIdWorldwideGroup(\Etrali\GinangBundle\Entity\WorldwideGroup $idWorldwideGroup = null)
    {
        $this->idWorldwideGroup = $idWorldwideGroup;
    
        return $this;
    }

    /**
     * Get idWorldwideGroup
     *
     * @return \Etrali\GinangBundle\Entity\WorldwideGroup 
     */
    public function getIdWorldwideGroup()
    {
        return $this->idWorldwideGroup;
    }

    /**
     * Set idCountry
     *
     * @param \Etrali\GinangBundle\Entity\Country $idCountry
     * @return CountryProviderGroup
     */
    public function setIdCountry(\Etrali\GinangBundle\Entity\Country $idCountry = null)
    {
        $this->idCountry = $idCountry;
    
        return $this;
    }

    /**
     * Get idCountry
     *
     * @return \Etrali\GinangBundle\Entity\Country 
     */
    public function getIdCountry()
    {
        return $this->idCountry;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return CountryProviderGroup
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return CountryProviderGroup
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CountryProviderGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
public function getParentBranch() { return NULL; }  }