<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Currency
 *
 * @ORM\Table(name="currency")
 * @ORM\Entity
 */
class Currency
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_currency", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCurrency;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_currency", type="string", length=15, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(3)
     */
    private $cdCurrency;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_currency", type="string", length=100, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(100)
     */
    private $lbCurrency;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtDeactivated;    

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_reactivated", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtReactivated;        

    /**
     * Get idCurrency
     *
     * @return integer 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }

    /**
     * Set cdCurrency
     *
     * @param string $cdCurrency
     * @return Currency
     */
    public function setCdCurrency($cdCurrency)
    {
        $this->cdCurrency = $cdCurrency;
    
        return $this;
    }

    /**
     * Get cdCurrency
     *
     * @return string 
     */
    public function getCdCurrency()
    {
        return $this->cdCurrency;
    }

    /**
     * Set lbCurrency
     *
     * @param string $lbCurrency
     * @return Currency
     */
    public function setLbCurrency($lbCurrency)
    {
        $this->lbCurrency = $lbCurrency;
    
        return $this;
    }

    /**
     * Get lbCurrency
     *
     * @return string 
     */
    public function getLbCurrency()
    {
        return $this->lbCurrency;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Currency
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
    
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Currendy
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
    
    /**
     * Set dtReactivated
     *
     * @param \DateTime $dtReactivated
     * @return Currency
     */
    public function setDtReactivated($dtReactivated)
    {
        $this->dtReactivated = $dtReactivated;
    
        return $this;
    }

    /**
     * Get dtReactivated
     *
     * @return \DateTime 
     */
    public function getDtReactivated()
    {
        return $this->dtReactivated;
    }
    
    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Currency
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }
    
    public function __toString()
    {
        return $this->getLbCurrency().'';
    }
public function getParentBranch() { return NULL; }  }