<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CurrencyConversion
 *
 * @ORM\Table(name="currency_conversion")
 * @ORM\Entity
 */
class CurrencyConversion
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_currency_conversion", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCurrencyConversion;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency_source", referencedColumnName="id_currency")
     * })
     * @Assert\NotNull()
     */
    private $idCurrencySource;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency_destination", referencedColumnName="id_currency")
     * })
     * @Assert\NotNull()     
     */
    private $idCurrencyDestination;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_currency_conversion", type="decimal", nullable=true)
     * @Assert\NotBlank()      
     */
    private $nbCurrencyConversion;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

 /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

    public function __toString()
    {
        return $this->getIdCurrencySource()."=>".$this->getIdCurrencyDestination()." : ".$this->getNbCurrencyConversion();
    }
    /**
     * Get idCurrencyConversion
     *
     * @return integer 
     */
    public function getIdCurrencyConversion()
    {
        return $this->idCurrencyConversion;
    }

    /**
     * Set idCurrencySource
     *
     * @param integer $idCurrencySource
     * @return CurrencyConversion
     */
    public function setIdCurrencySource($idCurrencySource)
    {
        $this->idCurrencySource = $idCurrencySource;
    
        return $this;
    }

    /**
     * Get idCurrencySource
     *
     * @return integer 
     */
    public function getIdCurrencySource()
    {
        return $this->idCurrencySource;
    }

    /**
     * Set idCurrencyDestination
     *
     * @param integer $idCurrencyDestination
     * @return CurrencyConversion
     */
    public function setIdCurrencyDestination($idCurrencyDestination)
    {
        $this->idCurrencyDestination = $idCurrencyDestination;
    
        return $this;
    }

    /**
     * Get idCurrencyDestination
     *
     * @return integer 
     */
    public function getIdCurrencyDestination()
    {
        return $this->idCurrencyDestination;
    }

    /**
     * Set nbCurrencyConversion
     *
     * @param float $nbCurrencyConversion
     * @return CurrencyConversion
     */
    public function setNbCurrencyConversion($nbCurrencyConversion)
    {
        $this->nbCurrencyConversion = $nbCurrencyConversion;
    
        return $this;
    }

    /**
     * Get nbCurrencyConversion
     *
     * @return float 
     */
    public function getNbCurrencyConversion()
    {
        return $this->nbCurrencyConversion;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return CurrencyConversion
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return CurrencyConversion
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CurrencyConversion
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CurrencyConversion
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CurrencyConversion
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return CurrencyConversion
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return CurrencyConversion
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CurrencyConversion
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}