<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CustomerGroup
 *
 * @ORM\Table(name="customer_group")
 * @ORM\Entity
 */
class CustomerGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_customer_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCustomerGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_customer_group", type="string", length=15, nullable=false)
     */
    private $cdCustomerGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_customer_group", type="string", length=100, nullable=true)
     */
    private $lbCustomerGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    /**
     * @var \Customer
     *
     * @ORM\OneToMany(targetEntity="Customer", mappedBy="idCustomerGroup",cascade={"persist","remove"}, orphanRemoval=true )   
     */
    private $idCustomer;    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;
    
    /**
     * @var \ContinentGroup
     *
     * @ORM\ManyToOne(targetEntity="ContinentGroup",inversedBy="idCustomerGroup")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_continent_group", referencedColumnName="id_continent_group")
     * })
     *
     */
    private $idContinentGroup;   
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getCdCustomerGroup()." : ".$this->getLbCustomerGroup().'';
    }

  
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idCustomer = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
 

    /**
     * Get idCustomerGroup
     *
     * @return integer 
     */
    public function getIdCustomerGroup()
    {
        return $this->idCustomerGroup;
    }

    /**
     * Set cdCustomerGroup
     *
     * @param string $cdCustomerGroup
     * @return CustomerGroup
     */
    public function setCdCustomerGroup($cdCustomerGroup)
    {
        $this->cdCustomerGroup = $cdCustomerGroup;
    
        return $this;
    }

    /**
     * Get cdCustomerGroup
     *
     * @return string 
     */
    public function getCdCustomerGroup()
    {
        return $this->cdCustomerGroup;
    }

    /**
     * Set lbCustomerGroup
     *
     * @param string $lbCustomerGroup
     * @return CustomerGroup
     */
    public function setLbCustomerGroup($lbCustomerGroup)
    {
        $this->lbCustomerGroup = $lbCustomerGroup;
    
        return $this;
    }

    /**
     * Get lbCustomerGroup
     *
     * @return string 
     */
    public function getLbCustomerGroup()
    {
        return $this->lbCustomerGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CustomerGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return CustomerGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return CustomerGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return CustomerGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return CustomerGroup
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return CustomerGroup
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Add idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return CustomerGroup
     */
    public function addIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer)
    {
        $this->idCustomer[] = $idCustomer;
    
        return $this;
    }

    /**
     * Remove idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     */
    public function removeIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer)
    {
        $this->idCustomer->removeElement($idCustomer);
    }

    /**
     * Get idCustomer
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idContinentGroup
     *
     * @param \Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup
     * @return CustomerGroup
     */
    public function setIdContinentGroup(\Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup = null)
    {
        $this->idContinentGroup = $idContinentGroup;
    
        return $this;
    }

    /**
     * Get idContinentGroup
     *
     * @return \Etrali\GinangBundle\Entity\ContinentGroup 
     */
    public function getIdContinentGroup()
    {
        return $this->idContinentGroup;
    }
}