<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * EquipmentCategory
 *
 * @ORM\Table(name="equipment_category")
 * @ORM\Entity
 */
class EquipmentCategory
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_equipment_category", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idEquipmentCategory;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_equipment_category", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)      
     */
    private $cdEquipmentCategory;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_equipment_category", type="string", length=100, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)      
     */
    private $lbEquipmentCategory;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;


    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;



    /**
     * Get idEquipmentCategory
     *
     * @return integer 
     */
    public function getIdEquipmentCategory()
    {
        return $this->idEquipmentCategory;
    }

    /**
     * Set cdEquipmentCategory
     *
     * @param string $cdEquipmentCategory
     * @return EquipmentCategory
     */
    public function setCdEquipmentCategory($cdEquipmentCategory)
    {
        $this->cdEquipmentCategory = $cdEquipmentCategory;
    
        return $this;
    }

    /**
     * Get cdEquipmentCategory
     *
     * @return string 
     */
    public function getCdEquipmentCategory()
    {
        return $this->cdEquipmentCategory;
    }

    /**
     * Set lbEquipmentCategory
     *
     * @param string $lbEquipmentCategory
     * @return EquipmentCategory
     */
    public function setLbEquipmentCategory($lbEquipmentCategory)
    {
        $this->lbEquipmentCategory = $lbEquipmentCategory;
    
        return $this;
    }

  

    /**
     * Get lbEquipmentCategory
     *
     * @return string 
     */
    public function getLbEquipmentCategory()
    {
        return $this->lbEquipmentCategory;
    }


    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return EquipmentCategory
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return EquipmentCategory
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return EquipmentCategory
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return EquipmentCategory
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return EquipmentCategory
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return EquipmentCategory
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }