<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * EsatpCost
 *
 * @ORM\Table(name="esatp_cost")
 * @ORM\Entity
 */
class EsatpCost
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_esatp_cost", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idEsatpCost;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_monthly", type="decimal", nullable=true)
     */
    private $mtMonthly;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_install", type="decimal", nullable=true)
     */
    private $mtInstall;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var \Product
     *
     * @ORM\ManyToOne(targetEntity="Product")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product", referencedColumnName="id_product")
     * })
     */
    private $idProduct;

    /**
     * @var \CommercialRoute
     *
     * @ORM\ManyToOne(targetEntity="CommercialRoute")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_commercial_route", referencedColumnName="id_commercial_route")
     * })
     */
    private $idCommercialRoute;

    /**
     * @var \Bandwidth
     *
     * @ORM\ManyToOne(targetEntity="Bandwidth")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_bandwidth", referencedColumnName="id_bandwidth")
     * })
     */
    private $idBandwidth;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idEsatpCost
     *
     * @return integer 
     */
    public function getIdEsatpCost()
    {
        return $this->idEsatpCost;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return EsatpCost
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set mtMonthly
     *
     * @param float $mtMonthly
     * @return EsatpCost
     */
    public function setMtMonthly($mtMonthly)
    {
        $this->mtMonthly = $mtMonthly;
    
        return $this;
    }

    /**
     * Get mtMonthly
     *
     * @return float 
     */
    public function getMtMonthly()
    {
        return $this->mtMonthly;
    }

    /**
     * Set mtInstall
     *
     * @param float $mtInstall
     * @return EsatpCost
     */
    public function setMtInstall($mtInstall)
    {
        $this->mtInstall = $mtInstall;
    
        return $this;
    }

    /**
     * Get mtInstall
     *
     * @return float 
     */
    public function getMtInstall()
    {
        return $this->mtInstall;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return EsatpCost
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return EsatpCost
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return EsatpCost
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return EsatpCost
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return EsatpCost
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set idProduct
     *
     * @param \Etrali\GinangBundle\Entity\Product $idProduct
     * @return EsatpCost
     */
    public function setIdProduct(\Etrali\GinangBundle\Entity\Product $idProduct = null)
    {
        $this->idProduct = $idProduct;
    
        return $this;
    }

    /**
     * Get idProduct
     *
     * @return \Etrali\GinangBundle\Entity\Product 
     */
    public function getIdProduct()
    {
        return $this->idProduct;
    }

    /**
     * Set idCommercialRoute
     *
     * @param \Etrali\GinangBundle\Entity\CommercialRoute $idCommercialRoute
     * @return EsatpCost
     */
    public function setIdCommercialRoute(\Etrali\GinangBundle\Entity\CommercialRoute $idCommercialRoute = null)
    {
        $this->idCommercialRoute = $idCommercialRoute;
    
        return $this;
    }

    /**
     * Get idCommercialRoute
     *
     * @return \Etrali\GinangBundle\Entity\CommercialRoute 
     */
    public function getIdCommercialRoute()
    {
        return $this->idCommercialRoute;
    }

    /**
     * Set idBandwidth
     *
     * @param \Etrali\GinangBundle\Entity\Bandwidth $idBandwidth
     * @return EsatpCost
     */
    public function setIdBandwidth(\Etrali\GinangBundle\Entity\Bandwidth $idBandwidth = null)
    {
        $this->idBandwidth = $idBandwidth;
    
        return $this;
    }

    /**
     * Get idBandwidth
     *
     * @return \Etrali\GinangBundle\Entity\Bandwidth 
     */
    public function getIdBandwidth()
    {
        return $this->idBandwidth;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return EsatpCost
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}