<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Event
 *
 * @ORM\Table(name="event")
 * @ORM\Entity
 */
class Event
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_event", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idEvent;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object_parent", type="integer", nullable=true)
     */
    private $idObjectParent;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_order", type="datetime", nullable=true)
     */
    private $dtOrder;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery", type="datetime", nullable=true)
     */
    private $dtDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery_requested", type="datetime", nullable=true)
     */
    private $dtDeliveryRequested;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_due", type="datetime", nullable=true)
     */
    private $dtDue;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_planned", type="datetime", nullable=true)
     */
    private $dtPlanned;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_acceptance_sent", type="datetime", nullable=true)
     */
    private $dtAcceptanceSent;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_acceptance_received", type="datetime", nullable=true)
     */
    private $dtAcceptanceReceived;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var \EventType
     *
     * @ORM\ManyToOne(targetEntity="EventType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_event_type", referencedColumnName="id_event_type")
     * })
     */
    private $idEventType;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type_parent", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectTypeParent;



    /**
     * Get idEvent
     *
     * @return integer 
     */
    public function getIdEvent()
    {
        return $this->idEvent;
    }

    /**
     * Set idObjectParent
     *
     * @param integer $idObjectParent
     * @return Event
     */
    public function setIdObjectParent($idObjectParent)
    {
        $this->idObjectParent = $idObjectParent;
    
        return $this;
    }

    /**
     * Get idObjectParent
     *
     * @return integer 
     */
    public function getIdObjectParent()
    {
        return $this->idObjectParent;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return Event
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set dtOrder
     *
     * @param \DateTime $dtOrder
     * @return Event
     */
    public function setDtOrder($dtOrder)
    {
        $this->dtOrder = $dtOrder;
    
        return $this;
    }

    /**
     * Get dtOrder
     *
     * @return \DateTime 
     */
    public function getDtOrder()
    {
        return $this->dtOrder;
    }

    /**
     * Set dtDelivery
     *
     * @param \DateTime $dtDelivery
     * @return Event
     */
    public function setDtDelivery($dtDelivery)
    {
        $this->dtDelivery = $dtDelivery;
    
        return $this;
    }

    /**
     * Get dtDelivery
     *
     * @return \DateTime 
     */
    public function getDtDelivery()
    {
        return $this->dtDelivery;
    }

    /**
     * Set dtDeliveryRequested
     *
     * @param \DateTime $dtDeliveryRequested
     * @return Event
     */
    public function setDtDeliveryRequested($dtDeliveryRequested)
    {
        $this->dtDeliveryRequested = $dtDeliveryRequested;
    
        return $this;
    }

    /**
     * Get dtDeliveryRequested
     *
     * @return \DateTime 
     */
    public function getDtDeliveryRequested()
    {
        return $this->dtDeliveryRequested;
    }

    /**
     * Set dtDue
     *
     * @param \DateTime $dtDue
     * @return Event
     */
    public function setDtDue($dtDue)
    {
        $this->dtDue = $dtDue;
    
        return $this;
    }

    /**
     * Get dtDue
     *
     * @return \DateTime 
     */
    public function getDtDue()
    {
        return $this->dtDue;
    }

    /**
     * Set dtPlanned
     *
     * @param \DateTime $dtPlanned
     * @return Event
     */
    public function setDtPlanned($dtPlanned)
    {
        $this->dtPlanned = $dtPlanned;
    
        return $this;
    }

    /**
     * Get dtPlanned
     *
     * @return \DateTime 
     */
    public function getDtPlanned()
    {
        return $this->dtPlanned;
    }

    /**
     * Set dtAcceptanceSent
     *
     * @param \DateTime $dtAcceptanceSent
     * @return Event
     */
    public function setDtAcceptanceSent($dtAcceptanceSent)
    {
        $this->dtAcceptanceSent = $dtAcceptanceSent;
    
        return $this;
    }

    /**
     * Get dtAcceptanceSent
     *
     * @return \DateTime 
     */
    public function getDtAcceptanceSent()
    {
        return $this->dtAcceptanceSent;
    }

    /**
     * Set dtAcceptanceReceived
     *
     * @param \DateTime $dtAcceptanceReceived
     * @return Event
     */
    public function setDtAcceptanceReceived($dtAcceptanceReceived)
    {
        $this->dtAcceptanceReceived = $dtAcceptanceReceived;
    
        return $this;
    }

    /**
     * Get dtAcceptanceReceived
     *
     * @return \DateTime 
     */
    public function getDtAcceptanceReceived()
    {
        return $this->dtAcceptanceReceived;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return Event
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return Event
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set idEventType
     *
     * @param \Etrali\GinangBundle\Entity\EventType $idEventType
     * @return Event
     */
    public function setIdEventType(\Etrali\GinangBundle\Entity\EventType $idEventType = null)
    {
        $this->idEventType = $idEventType;
    
        return $this;
    }

    /**
     * Get idEventType
     *
     * @return \Etrali\GinangBundle\Entity\EventType 
     */
    public function getIdEventType()
    {
        return $this->idEventType;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return Event
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set idObjectTypeParent
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectTypeParent
     * @return Event
     */
    public function setIdObjectTypeParent(\Etrali\GinangBundle\Entity\ObjectType $idObjectTypeParent = null)
    {
        $this->idObjectTypeParent = $idObjectTypeParent;
    
        return $this;
    }

    /**
     * Get idObjectTypeParent
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectTypeParent()
    {
        return $this->idObjectTypeParent;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }