<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Functionality
 *
 * @ORM\Table(name="functionality")
 * @ORM\Entity
 */
class Functionality
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_functionality", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idFunctionality;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_functionality", type="string", length=15, nullable=false)
     */
    private $cdFunctionality;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_functionality", type="string", length=100, nullable=false)
     */
    private $lbFunctionality;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Domain
     *
     * @ORM\ManyToOne(targetEntity="Domain")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_domain", referencedColumnName="id_domain")
     * })
     */
    private $idDomain;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idFunctionality
     *
     * @return integer 
     */
    public function getIdFunctionality()
    {
        return $this->idFunctionality;
    }

    /**
     * Set cdFunctionality
     *
     * @param string $cdFunctionality
     * @return Functionality
     */
    public function setCdFunctionality($cdFunctionality)
    {
        $this->cdFunctionality = $cdFunctionality;
    
        return $this;
    }

    /**
     * Get cdFunctionality
     *
     * @return string 
     */
    public function getCdFunctionality()
    {
        return $this->cdFunctionality;
    }

    /**
     * Set lbFunctionality
     *
     * @param string $lbFunctionality
     * @return Functionality
     */
    public function setLbFunctionality($lbFunctionality)
    {
        $this->lbFunctionality = $lbFunctionality;
    
        return $this;
    }

    /**
     * Get lbFunctionality
     *
     * @return string 
     */
    public function getLbFunctionality()
    {
        return $this->lbFunctionality;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Functionality
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idDomain
     *
     * @param \Etrali\GinangBundle\Entity\Domain $idDomain
     * @return Functionality
     */
    public function setIdDomain(\Etrali\GinangBundle\Entity\Domain $idDomain = null)
    {
        $this->idDomain = $idDomain;
    
        return $this;
    }

    /**
     * Get idDomain
     *
     * @return \Etrali\GinangBundle\Entity\Domain 
     */
    public function getIdDomain()
    {
        return $this->idDomain;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Functionality
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}