<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * History
 *
 * @ORM\Table(name="history")
 * @ORM\Entity
 */
class History
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_history", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idHistory;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="id_sec_object", type="integer", nullable=true)
     */
    private $idSecObject;    

    /**
     * @var string
     *
     * @ORM\Column(name="lb_component", type="string", length=255, nullable=true)
     */
    private $lbComponent;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_entity", type="string", length=255, nullable=true)
     */
    private $lbEntity;    
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_sec_entity", type="string", length=255, nullable=true)
     */
    private $lbSecEntity;      

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_effect", type="datetime", nullable=true)
     */
    private $dtEffect;

    /**
     * @var \HistoryType
     *
     * @ORM\ManyToOne(targetEntity="HistoryType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_history_type", referencedColumnName="id_history_type")
     * })
     */
    private $idHistoryType;


    /**
     * @var \Myuser
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_name", type="string", length=1000, nullable=true)
     */
    private $lbName;     

    public function __toString()
    {
        return $this->getLbEntity()." ".($this->getLbSecEntity()!=NULL?$this->getLbSecEntity()." ":"").$this->getIdHistoryType()->getLbHistoryType();
    }

    /**
     * Get idHistory
     *
     * @return integer 
     */
    public function getIdHistory()
    {
        return $this->idHistory;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return History
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set lbComponent
     *
     * @param string $lbComponent
     * @return History
     */
    public function setLbComponent($lbComponent)
    {
        $this->lbComponent = $lbComponent;
    
        return $this;
    }

    /**
     * Get lbComponent
     *
     * @return string 
     */
    public function getLbComponent()
    {
        return $this->lbComponent;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return History
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return History
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set idHistoryType
     *
     * @param \Etrali\GinangBundle\Entity\HistoryType $idHistoryType
     * @return History
     */
    public function setIdHistoryType(\Etrali\GinangBundle\Entity\HistoryType $idHistoryType = null)
    {
        $this->idHistoryType = $idHistoryType;
    
        return $this;
    }

    /**
     * Get idHistoryType
     *
     * @return \Etrali\GinangBundle\Entity\HistoryType 
     */
    public function getIdHistoryType()
    {
        return $this->idHistoryType;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return History
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return History
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }

    /**
     * Set lbEntity
     *
     * @param string $lbEntity
     * @return History
     */
    public function setLbEntity($lbEntity)
    {
        $this->lbEntity = $lbEntity;
    
        return $this;
    }

    /**
     * Get lbEntity
     *
     * @return string 
     */
    public function getLbEntity()
    {
        return $this->lbEntity;
    }

    /**
     * Set dtEffect
     *
     * @param \DateTime $dtEffect
     * @return History
     */
    public function setDtEffect($dtEffect)
    {
        $this->dtEffect = $dtEffect;
    
        return $this;
    }

    /**
     * Get dtEffect
     *
     * @return \DateTime 
     */
    public function getDtEffect()
    {
        return $this->dtEffect;
    }

    /**
     * Set idSecObject
     *
     * @param integer $idSecObject
     * @return History
     */
    public function setIdSecObject($idSecObject)
    {
        $this->idSecObject = $idSecObject;
    
        return $this;
    }

    /**
     * Get idSecObject
     *
     * @return integer 
     */
    public function getIdSecObject()
    {
        return $this->idSecObject;
    }

    /**
     * Set lbSecEntity
     *
     * @param string $lbSecEntity
     * @return History
     */
    public function setLbSecEntity($lbSecEntity)
    {
        $this->lbSecEntity = $lbSecEntity;
    
        return $this;
    }

    /**
     * Get lbSecEntity
     *
     * @return string 
     */
    public function getLbSecEntity()
    {
        return $this->lbSecEntity;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set lbName
     *
     * @param string $lbName
     * @return History
     */
    public function setLbName($lbName)
    {
        $this->lbName = $lbName;
    
        return $this;
    }

    /**
     * Get lbName
     *
     * @return string 
     */
    public function getLbName()
    {
        return $this->lbName;
    }
}