<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * HistoryModification
 *
 * @ORM\Table(name="history_modification")
 * @ORM\Entity
 */
class HistoryModification
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_history_modification", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idHistoryModification;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_field", type="string", length=100, nullable=true)
     */
    private $lbField;
    
   

    /**
     * @var string
     *
     * @ORM\Column(name="lb_old_value", type="string", length=255, nullable=true)
     */
    private $lbOldValue;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_new_value", type="string", length=255, nullable=true)
     */
    private $lbNewValue;

    /**
     * @var \History
     *
     * @ORM\ManyToOne(targetEntity="History", cascade={"persist"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_history", referencedColumnName="id_history")
     * })
     */
    private $idHistory;
    
 /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_effect", type="datetime", nullable=true)
     */
    private $dtEffect;


    /**
     * @var \Myuser
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;    

    
    /**
     * Get lbEntity
     *
     * @return string 
     */
    public function getLbEntity()
    {
        return $this->getIdHistory()->getLbEntity();
    }
    
    /**
     * Get lbComponent
     *
     * @return string 
     */
    public function getLbComponent()
    {
        return $this->getIdHistory()->getLbComponent();
    }    
    public function __toString()
    {
        return $this->lbField." : ".$this->lbOldValue." => ".$this->lbNewValue;        
    }

    

    /**
     * Get idHistoryModification
     *
     * @return integer 
     */
    public function getIdHistoryModification()
    {
        return $this->idHistoryModification;
    }

    /**
     * Set lbFieldLable
     *
     * @param string $lbFieldLable
     * @return HistoryModification
     */
    public function setLbFieldLable($lbFieldLable)
    {
        $this->lbFieldLable = $lbFieldLable;
    
        return $this;
    }

    /**
     * Get lbFieldLable
     *
     * @return string 
     */
    public function getLbFieldLable()
    {
        return $this->lbFieldLable;
    }

    /**
     * Set lbOldValue
     *
     * @param string $lbOldValue
     * @return HistoryModification
     */
    public function setLbOldValue($lbOldValue)
    {
        $this->lbOldValue = $lbOldValue;
    
        return $this;
    }

    /**
     * Get lbOldValue
     *
     * @return string 
     */
    public function getLbOldValue()
    {
        return $this->lbOldValue;
    }

    /**
     * Set lbNewValue
     *
     * @param string $lbNewValue
     * @return HistoryModification
     */
    public function setLbNewValue($lbNewValue)
    {
        $this->lbNewValue = $lbNewValue;
    
        return $this;
    }

    /**
     * Get lbNewValue
     *
     * @return string 
     */
    public function getLbNewValue()
    {
        return $this->lbNewValue;
    }

    /**
     * Set idHistory
     *
     * @param \Etrali\GinangBundle\Entity\History $idHistory
     * @return HistoryModification
     */
    public function setIdHistory(\Etrali\GinangBundle\Entity\History $idHistory = null)
    {
        $this->idHistory = $idHistory;
    
        return $this;
    }

    /**
     * Get idHistory
     *
     * @return \Etrali\GinangBundle\Entity\History 
     */
    public function getIdHistory()
    {
        return $this->idHistory;
    }

    /**
     * Set lbField
     *
     * @param string $lbField
     * @return HistoryModification
     */
    public function setLbField($lbField)
    {
        $this->lbField = $lbField;
    
        return $this;
    }

    /**
     * Get lbField
     *
     * @return string 
     */
    public function getLbField()
    {
        return $this->lbField;
    }

    /**
     * Set dtEffect
     *
     * @param \DateTime $dtEffect
     * @return HistoryModification
     */
    public function setDtEffect($dtEffect)
    {
        $this->dtEffect = $dtEffect;
    
        return $this;
    }

    /**
     * Get dtEffect
     *
     * @return \DateTime 
     */
    public function getDtEffect()
    {
        return $this->dtEffect;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return HistoryModification
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set lbName
     *
     * @param string $lbName
     * @return HistoryModification
     */
    public function setLbName($lbName)
    {
        $this->lbName = $lbName;
    
        return $this;
    }

    /**
     * Get lbName
     *
     * @return string 
     */
    public function getLbName()
    {
        return $this->lbName;
    }
}