<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Interfaces
 *
 * @ORM\Table(name="interfaces")
 * @ORM\Entity
 */
class Interfaces
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_interface", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idInterface;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_interface", type="string", length=45, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)
     */
    private $cdInterface;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_interface", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)
     */
    private $lbInterface;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtUpdate; 
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    


    /**
     * Get idInterface
     *
     * @return integer 
     */
    public function getIdInterface()
    {
        return $this->idInterface;
    }

    /**
     * Set cdInterface
     *
     * @param string $cdInterface
     * @return Interfaces
     */
    public function setCdInterface($cdInterface)
    {
        $this->cdInterface = $cdInterface;
    
        return $this;
    }

    /**
     * Get cdInterface
     *
     * @return string 
     */
    public function getCdInterface()
    {
        return $this->cdInterface;
    }

    /**
     * Set lbInterface
     *
     * @param string $lbInterface
     * @return Interfaces
     */
    public function setLbInterface($lbInterface)
    {
        $this->lbInterface = $lbInterface;
    
        return $this;
    }

    /**
     * Get lbInterface
     *
     * @return string 
     */
    public function getLbInterface()
    {
        return $this->lbInterface;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Interfaces
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
    
/**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Protocol
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return Protocol
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }
    public function __toString()
    {
        return $this->getLbInterface().'';
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Interfaces
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }public function getParentBranch() { return NULL; }  }