<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Iom
 *
 * @ORM\Table(name="iom")
 * @ORM\Entity
 */
class Iom
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_iom", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idIom;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_iom", type="string", length=45, nullable=true)
     */
    private $cdIom;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_iom", type="string", length=255, nullable=true)
     */
    private $lbIom;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_iom", type="string", length=255, nullable=true)
     */
    private $cmIom;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_serial_number", type="string", length=45, nullable=true)
     */
    private $cdSerialNumber;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_position", type="decimal", nullable=true)
     */
    private $nbPosition;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \IomType
     *
     * @ORM\ManyToOne(targetEntity="IomType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_iom_type", referencedColumnName="id_iom_type")
     * })
     */
    private $idIomType;

    /**
     * @var \Equipment
     *
     * @ORM\ManyToOne(targetEntity="Equipment")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_equipment", referencedColumnName="id_equipment")
     * })
     */
    private $idEquipment;

    /**
     * @var \Shelf
     *
     * @ORM\ManyToOne(targetEntity="Shelf")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_shelf", referencedColumnName="id_shelf")
     * })
     */
    private $idShelf;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create", referencedColumnName="id")
     * })
     */
    private $idUserCreate;



    /**
     * Get idIom
     *
     * @return integer 
     */
    public function getIdIom()
    {
        return $this->idIom;
    }

    /**
     * Set cdIom
     *
     * @param string $cdIom
     * @return Iom
     */
    public function setCdIom($cdIom)
    {
        $this->cdIom = $cdIom;
    
        return $this;
    }

    /**
     * Get cdIom
     *
     * @return string 
     */
    public function getCdIom()
    {
        return $this->cdIom;
    }

    /**
     * Set lbIom
     *
     * @param string $lbIom
     * @return Iom
     */
    public function setLbIom($lbIom)
    {
        $this->lbIom = $lbIom;
    
        return $this;
    }

    /**
     * Get lbIom
     *
     * @return string 
     */
    public function getLbIom()
    {
        return $this->lbIom;
    }

    /**
     * Set cmIom
     *
     * @param string $cmIom
     * @return Iom
     */
    public function setCmIom($cmIom)
    {
        $this->cmIom = $cmIom;
    
        return $this;
    }

    /**
     * Get cmIom
     *
     * @return string 
     */
    public function getCmIom()
    {
        return $this->cmIom;
    }

    /**
     * Set cdSerialNumber
     *
     * @param string $cdSerialNumber
     * @return Iom
     */
    public function setCdSerialNumber($cdSerialNumber)
    {
        $this->cdSerialNumber = $cdSerialNumber;
    
        return $this;
    }

    /**
     * Get cdSerialNumber
     *
     * @return string 
     */
    public function getCdSerialNumber()
    {
        return $this->cdSerialNumber;
    }

    /**
     * Set nbPosition
     *
     * @param float $nbPosition
     * @return Iom
     */
    public function setNbPosition($nbPosition)
    {
        $this->nbPosition = $nbPosition;
    
        return $this;
    }

    /**
     * Get nbPosition
     *
     * @return float 
     */
    public function getNbPosition()
    {
        return $this->nbPosition;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return Iom
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return Iom
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Iom
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Iom
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set idIomType
     *
     * @param \Etrali\GinangBundle\Entity\IomType $idIomType
     * @return Iom
     */
    public function setIdIomType(\Etrali\GinangBundle\Entity\IomType $idIomType = null)
    {
        $this->idIomType = $idIomType;
    
        return $this;
    }

    /**
     * Get idIomType
     *
     * @return \Etrali\GinangBundle\Entity\IomType 
     */
    public function getIdIomType()
    {
        return $this->idIomType;
    }

    /**
     * Set idEquipment
     *
     * @param \Etrali\GinangBundle\Entity\Equipment $idEquipment
     * @return Iom
     */
    public function setIdEquipment(\Etrali\GinangBundle\Entity\Equipment $idEquipment = null)
    {
        $this->idEquipment = $idEquipment;
    
        return $this;
    }

    /**
     * Get idEquipment
     *
     * @return \Etrali\GinangBundle\Entity\Equipment 
     */
    public function getIdEquipment()
    {
        return $this->idEquipment;
    }

    /**
     * Set idShelf
     *
     * @param \Etrali\GinangBundle\Entity\Shelf $idShelf
     * @return Iom
     */
    public function setIdShelf(\Etrali\GinangBundle\Entity\Shelf $idShelf = null)
    {
        $this->idShelf = $idShelf;
    
        return $this;
    }

    /**
     * Get idShelf
     *
     * @return \Etrali\GinangBundle\Entity\Shelf 
     */
    public function getIdShelf()
    {
        return $this->idShelf;
    }

    /**
     * Set idUserCreate
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreate
     * @return Iom
     */
    public function setIdUserCreate(\Etrali\GinangBundle\Entity\Myuser $idUserCreate = null)
    {
        $this->idUserCreate = $idUserCreate;
    
        return $this;
    }

    /**
     * Get idUserCreate
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreate()
    {
        return $this->idUserCreate;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }