<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkFunction
 *
 * @ORM\Table(name="link_function")
 * @ORM\Entity
 */
class LinkFunction
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_function", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkFunction;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_function", type="string", length=100, nullable=false)
     */
    private $cdLinkFunction;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_function", type="string", length=255, nullable=false)
     */
    private $lbLinkFunction;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;
    
        /**
     * @var \LinkFunctionType
     *
     * @ORM\ManyToOne(targetEntity="LinkFunctionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_function_type", referencedColumnName="id_link_function_type")
     * })      
     */
    private $idLinkFunctionType;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

    public function __toString()
    {
        return $this->getLbLinkFunction()."";
    }

    /**
     * Get idLinkFunction
     *
     * @return integer 
     */
    public function getIdLinkFunction()
    {
        return $this->idLinkFunction;
    }

    /**
     * Set cdLinkFunction
     *
     * @param string $cdLinkFunction
     * @return LinkFunction
     */
    public function setCdLinkFunction($cdLinkFunction)
    {
        $this->cdLinkFunction = $cdLinkFunction;
    
        return $this;
    }

    /**
     * Get cdLinkFunction
     *
     * @return string 
     */
    public function getCdLinkFunction()
    {
        return $this->cdLinkFunction;
    }

    /**
     * Set lbLinkFunction
     *
     * @param string $lbLinkFunction
     * @return LinkFunction
     */
    public function setLbLinkFunction($lbLinkFunction)
    {
        $this->lbLinkFunction = $lbLinkFunction;
    
        return $this;
    }

    /**
     * Get lbLinkFunction
     *
     * @return string 
     */
    public function getLbLinkFunction()
    {
        return $this->lbLinkFunction;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkFunction
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idLinkFunctionType
     *
     * @param \Etrali\GinangBundle\Entity\LinkFunctionType $idLinkFunctionType
     * @return LinkFunction
     */
    public function setIdLinkFunctionType(\Etrali\GinangBundle\Entity\LinkFunctionType $idLinkFunctionType = null)
    {
        $this->idLinkFunctionType = $idLinkFunctionType;
    
        return $this;
    }

    /**
     * Get idLinkFunctionType
     *
     * @return \Etrali\GinangBundle\Entity\LinkFunctionType 
     */
    public function getIdLinkFunctionType()
    {
        return $this->idLinkFunctionType;
    }public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return LinkFunction
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}