<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkFunctionType
 *
 * @ORM\Table(name="link_function_type")
 * @ORM\Entity
 */
class LinkFunctionType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_function_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkFunctionType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_function_type", type="string", length=100, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50) 
     */
    private $lbLinkFunctionType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_function_type", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20) 
     */
    private $cdLinkFunctionType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;



    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbLinkFunctionType().'';
    }  
    /**
     * Get idLinkFunctionType
     *
     * @return integer 
     */
    public function getIdLinkFunctionType()
    {
        return $this->idLinkFunctionType;
    }

    /**
     * Set lbLinkFunctionType
     *
     * @param string $lbLinkFunctionType
     * @return LinkFunctionType
     */
    public function setLbLinkFunctionType($lbLinkFunctionType)
    {
        $this->lbLinkFunctionType = $lbLinkFunctionType;
    
        return $this;
    }

    /**
     * Get lbLinkFunctionType
     *
     * @return string 
     */
    public function getLbLinkFunctionType()
    {
        return $this->lbLinkFunctionType;
    }


    /**
     * Set cdLinkFunctionType
     *
     * @param string $cdLinkFunctionType
     * @return LinkFunctionType
     */
    public function setCdLinkFunctionType($cdLinkFunctionType)
    {
        $this->cdLinkFunctionType = $cdLinkFunctionType;
    
        return $this;
    }

    /**
     * Get cdLinkFunctionType
     *
     * @return string 
     */
    public function getCdLinkFunctionType()
    {
        return $this->cdLinkFunctionType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkFunctionType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LinkFunctionType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return LinkFunctionType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return LinkFunctionType
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return LinkFunctionType
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function getParentBranch() { return NULL; }  }