<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkPhysical
 *
 * @ORM\Table(name="link_physical")
 * @ORM\Entity
 */
class LinkPhysical
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_physical", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkPhysical;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_physical", type="string", length=15, nullable=true)
     */
    private $cdLinkPhysical;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_physical", type="string", length=100, nullable=true)
     */
    private $lbLinkPhysical;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var \Port
     *
     * @ORM\ManyToOne(targetEntity="Port")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_a", referencedColumnName="id_port")
     * })
     */
    private $idPortA;

    /**
     * @var \Port
     *
     * @ORM\ManyToOne(targetEntity="Port")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_b", referencedColumnName="id_port")
     * })
     */
    private $idPortB;



    /**
     * Get idLinkPhysical
     *
     * @return integer 
     */
    public function getIdLinkPhysical()
    {
        return $this->idLinkPhysical;
    }

    /**
     * Set cdLinkPhysical
     *
     * @param string $cdLinkPhysical
     * @return LinkPhysical
     */
    public function setCdLinkPhysical($cdLinkPhysical)
    {
        $this->cdLinkPhysical = $cdLinkPhysical;
    
        return $this;
    }

    /**
     * Get cdLinkPhysical
     *
     * @return string 
     */
    public function getCdLinkPhysical()
    {
        return $this->cdLinkPhysical;
    }

    /**
     * Set lbLinkPhysical
     *
     * @param string $lbLinkPhysical
     * @return LinkPhysical
     */
    public function setLbLinkPhysical($lbLinkPhysical)
    {
        $this->lbLinkPhysical = $lbLinkPhysical;
    
        return $this;
    }

    /**
     * Get lbLinkPhysical
     *
     * @return string 
     */
    public function getLbLinkPhysical()
    {
        return $this->lbLinkPhysical;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return LinkPhysical
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return LinkPhysical
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkPhysical
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LinkPhysical
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return LinkPhysical
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return LinkPhysical
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return LinkPhysical
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set idPortA
     *
     * @param \Etrali\GinangBundle\Entity\Port $idPortA
     * @return LinkPhysical
     */
    public function setIdPortA(\Etrali\GinangBundle\Entity\Port $idPortA = null)
    {
        $this->idPortA = $idPortA;
    
        return $this;
    }

    /**
     * Get idPortA
     *
     * @return \Etrali\GinangBundle\Entity\Port 
     */
    public function getIdPortA()
    {
        return $this->idPortA;
    }

    /**
     * Set idPortB
     *
     * @param \Etrali\GinangBundle\Entity\Port $idPortB
     * @return LinkPhysical
     */
    public function setIdPortB(\Etrali\GinangBundle\Entity\Port $idPortB = null)
    {
        $this->idPortB = $idPortB;
    
        return $this;
    }

    /**
     * Get idPortB
     *
     * @return \Etrali\GinangBundle\Entity\Port 
     */
    public function getIdPortB()
    {
        return $this->idPortB;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }