<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkTemplate
 *
 * @ORM\Table(name="link_template")
 * @ORM\Entity
 */
class LinkTemplate
{
    /**
     * @var string
     *
     * @ORM\Column(name="cd_link", type="string", length=15, nullable=true)
     */
    private $cdLink;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link", type="string", length=100, nullable=true)
     */
    private $lbLink;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_reference", type="string", length=45, nullable=true)
     */
    private $cdLinkReference;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_reference_b", type="string", length=15, nullable=true)
     */
    private $cdLinkReferenceB;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_bandwidth", type="decimal", nullable=true)
     */
    private $nbBandwidth;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var string
     *
     * @ORM\Column(name="bl_standby", type="string", length=255, nullable=true)
     */
    private $blStandby;

    /**
     * @var string
     *
     * @ORM\Column(name="bl_connected", type="string", length=255, nullable=true)
     */
    private $blConnected;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Cable
     *
     * @ORM\ManyToOne(targetEntity="Cable")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_cable", referencedColumnName="id_cable")
     * })
     */
    private $idCable;

    /**
     * @var \Access
     *
     * @ORM\ManyToOne(targetEntity="Access")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_access", referencedColumnName="id_access")
     * })
     */
    private $idAccess;

    /**
     * @var \Port
     *
     * @ORM\ManyToOne(targetEntity="Port")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_1", referencedColumnName="id_port")
     * })
     */
    private $idPort1;

    /**
     * @var \Port
     *
     * @ORM\ManyToOne(targetEntity="Port")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_2", referencedColumnName="id_port")
     * })
     */
    private $idPort2;

    /**
     * @var \Link
     *
     * @ORM\ManyToOne(targetEntity="Link")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_groomed", referencedColumnName="id_link")
     * })
     */
    private $idLinkGroomed;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var \Link
     *
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="NONE")
     * @ORM\OneToOne(targetEntity="Link")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link", referencedColumnName="id_link")
     * })
     */
    private $idLink;

    /**
     * @var \LinkType
     *
     * @ORM\ManyToOne(targetEntity="LinkType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_type", referencedColumnName="id_link_type")
     * })
     */
    private $idLinkType;

    /**
     * @var \LinkFunction
     *
     * @ORM\ManyToOne(targetEntity="LinkFunction")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_function", referencedColumnName="id_link_function")
     * })
     */
    private $idLinkFunction;

    /**
     * @var \LinkProtocol
     *
     * @ORM\ManyToOne(targetEntity="LinkProtocol")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_protocol", referencedColumnName="id_link_protocol")
     * })
     */
    private $idLinkProtocol;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;



    /**
     * Set cdLink
     *
     * @param string $cdLink
     * @return LinkTemplate
     */
    public function setCdLink($cdLink)
    {
        $this->cdLink = $cdLink;
    
        return $this;
    }

    /**
     * Get cdLink
     *
     * @return string 
     */
    public function getCdLink()
    {
        return $this->cdLink;
    }

    /**
     * Set lbLink
     *
     * @param string $lbLink
     * @return LinkTemplate
     */
    public function setLbLink($lbLink)
    {
        $this->lbLink = $lbLink;
    
        return $this;
    }

    /**
     * Get lbLink
     *
     * @return string 
     */
    public function getLbLink()
    {
        return $this->lbLink;
    }

    /**
     * Set cdLinkReference
     *
     * @param string $cdLinkReference
     * @return LinkTemplate
     */
    public function setCdLinkReference($cdLinkReference)
    {
        $this->cdLinkReference = $cdLinkReference;
    
        return $this;
    }

    /**
     * Get cdLinkReference
     *
     * @return string 
     */
    public function getCdLinkReference()
    {
        return $this->cdLinkReference;
    }

    /**
     * Set cdLinkReferenceB
     *
     * @param string $cdLinkReferenceB
     * @return LinkTemplate
     */
    public function setCdLinkReferenceB($cdLinkReferenceB)
    {
        $this->cdLinkReferenceB = $cdLinkReferenceB;
    
        return $this;
    }

    /**
     * Get cdLinkReferenceB
     *
     * @return string 
     */
    public function getCdLinkReferenceB()
    {
        return $this->cdLinkReferenceB;
    }

    /**
     * Set nbBandwidth
     *
     * @param float $nbBandwidth
     * @return LinkTemplate
     */
    public function setNbBandwidth($nbBandwidth)
    {
        $this->nbBandwidth = $nbBandwidth;
    
        return $this;
    }

    /**
     * Get nbBandwidth
     *
     * @return float 
     */
    public function getNbBandwidth()
    {
        return $this->nbBandwidth;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return LinkTemplate
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return LinkTemplate
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blStandby
     *
     * @param string $blStandby
     * @return LinkTemplate
     */
    public function setBlStandby($blStandby)
    {
        $this->blStandby = $blStandby;
    
        return $this;
    }

    /**
     * Get blStandby
     *
     * @return string 
     */
    public function getBlStandby()
    {
        return $this->blStandby;
    }

    /**
     * Set blConnected
     *
     * @param string $blConnected
     * @return LinkTemplate
     */
    public function setBlConnected($blConnected)
    {
        $this->blConnected = $blConnected;
    
        return $this;
    }

    /**
     * Get blConnected
     *
     * @return string 
     */
    public function getBlConnected()
    {
        return $this->blConnected;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkTemplate
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LinkTemplate
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return LinkTemplate
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return LinkTemplate
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return LinkTemplate
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idCable
     *
     * @param \Etrali\GinangBundle\Entity\Cable $idCable
     * @return LinkTemplate
     */
    public function setIdCable(\Etrali\GinangBundle\Entity\Cable $idCable = null)
    {
        $this->idCable = $idCable;
    
        return $this;
    }

    /**
     * Get idCable
     *
     * @return \Etrali\GinangBundle\Entity\Cable 
     */
    public function getIdCable()
    {
        return $this->idCable;
    }

    /**
     * Set idAccess
     *
     * @param \Etrali\GinangBundle\Entity\Access $idAccess
     * @return LinkTemplate
     */
    public function setIdAccess(\Etrali\GinangBundle\Entity\Access $idAccess = null)
    {
        $this->idAccess = $idAccess;
    
        return $this;
    }

    /**
     * Get idAccess
     *
     * @return \Etrali\GinangBundle\Entity\Access 
     */
    public function getIdAccess()
    {
        return $this->idAccess;
    }

    /**
     * Set idPort1
     *
     * @param \Etrali\GinangBundle\Entity\Port $idPort1
     * @return LinkTemplate
     */
    public function setIdPort1(\Etrali\GinangBundle\Entity\Port $idPort1 = null)
    {
        $this->idPort1 = $idPort1;
    
        return $this;
    }

    /**
     * Get idPort1
     *
     * @return \Etrali\GinangBundle\Entity\Port 
     */
    public function getIdPort1()
    {
        return $this->idPort1;
    }

    /**
     * Set idPort2
     *
     * @param \Etrali\GinangBundle\Entity\Port $idPort2
     * @return LinkTemplate
     */
    public function setIdPort2(\Etrali\GinangBundle\Entity\Port $idPort2 = null)
    {
        $this->idPort2 = $idPort2;
    
        return $this;
    }

    /**
     * Get idPort2
     *
     * @return \Etrali\GinangBundle\Entity\Port 
     */
    public function getIdPort2()
    {
        return $this->idPort2;
    }

    /**
     * Set idLinkGroomed
     *
     * @param \Etrali\GinangBundle\Entity\Link $idLinkGroomed
     * @return LinkTemplate
     */
    public function setIdLinkGroomed(\Etrali\GinangBundle\Entity\Link $idLinkGroomed = null)
    {
        $this->idLinkGroomed = $idLinkGroomed;
    
        return $this;
    }

    /**
     * Get idLinkGroomed
     *
     * @return \Etrali\GinangBundle\Entity\Link 
     */
    public function getIdLinkGroomed()
    {
        return $this->idLinkGroomed;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return LinkTemplate
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set idLink
     *
     * @param \Etrali\GinangBundle\Entity\Link $idLink
     * @return LinkTemplate
     */
    public function setIdLink(\Etrali\GinangBundle\Entity\Link $idLink)
    {
        $this->idLink = $idLink;
    
        return $this;
    }

    /**
     * Get idLink
     *
     * @return \Etrali\GinangBundle\Entity\Link 
     */
    public function getIdLink()
    {
        return $this->idLink;
    }

    /**
     * Set idLinkType
     *
     * @param \Etrali\GinangBundle\Entity\LinkType $idLinkType
     * @return LinkTemplate
     */
    public function setIdLinkType(\Etrali\GinangBundle\Entity\LinkType $idLinkType = null)
    {
        $this->idLinkType = $idLinkType;
    
        return $this;
    }

    /**
     * Get idLinkType
     *
     * @return \Etrali\GinangBundle\Entity\LinkType 
     */
    public function getIdLinkType()
    {
        return $this->idLinkType;
    }

    /**
     * Set idLinkFunction
     *
     * @param \Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction
     * @return LinkTemplate
     */
    public function setIdLinkFunction(\Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction = null)
    {
        $this->idLinkFunction = $idLinkFunction;
    
        return $this;
    }

    /**
     * Get idLinkFunction
     *
     * @return \Etrali\GinangBundle\Entity\LinkFunction 
     */
    public function getIdLinkFunction()
    {
        return $this->idLinkFunction;
    }

    /**
     * Set idLinkProtocol
     *
     * @param \Etrali\GinangBundle\Entity\LinkProtocol $idLinkProtocol
     * @return LinkTemplate
     */
    public function setIdLinkProtocol(\Etrali\GinangBundle\Entity\LinkProtocol $idLinkProtocol = null)
    {
        $this->idLinkProtocol = $idLinkProtocol;
    
        return $this;
    }

    /**
     * Get idLinkProtocol
     *
     * @return \Etrali\GinangBundle\Entity\LinkProtocol 
     */
    public function getIdLinkProtocol()
    {
        return $this->idLinkProtocol;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return LinkTemplate
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }