<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkType
 *
 * @ORM\Table(name="link_type")
 * @ORM\Entity
 */
class LinkType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_type", type="string", length=15, nullable=true)
     */
    private $cdLinkType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_type", type="string", length=100, nullable=true)
     */
    private $lbLinkType;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_max", type="integer", nullable=true)
     */
    private $nbMax;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_max_unit", type="string", length=100, nullable=true)
     */
    private $cdMaxUnit;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel_range_from_1", type="integer", nullable=true)
     */
    private $nbChannelRangeFrom1;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel_range_to_1", type="integer", nullable=true)
     */
    private $nbChannelRangeTo1;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel_range_from_2", type="integer", nullable=true)
     */
    private $nbChannelRangeFrom2;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel_range_to_2", type="integer", nullable=true)
     */
    private $nbChannelRangeTo2;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel", type="integer", nullable=true)
     */
    private $nbChannel;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;



    /**
     * Get idLinkType
     *
     * @return integer 
     */
    public function getIdLinkType()
    {
        return $this->idLinkType;
    }

    /**
     * Set cdLinkType
     *
     * @param string $cdLinkType
     * @return LinkType
     */
    public function setCdLinkType($cdLinkType)
    {
        $this->cdLinkType = $cdLinkType;
    
        return $this;
    }

    /**
     * Get cdLinkType
     *
     * @return string 
     */
    public function getCdLinkType()
    {
        return $this->cdLinkType;
    }

    /**
     * Set lbLinkType
     *
     * @param string $lbLinkType
     * @return LinkType
     */
    public function setLbLinkType($lbLinkType)
    {
        $this->lbLinkType = $lbLinkType;
    
        return $this;
    }

    /**
     * Get lbLinkType
     *
     * @return string 
     */
    public function getLbLinkType()
    {
        return $this->lbLinkType;
    }

    /**
     * Set nbMax
     *
     * @param integer $nbMax
     * @return LinkType
     */
    public function setNbMax($nbMax)
    {
        $this->nbMax = $nbMax;
    
        return $this;
    }

    /**
     * Get nbMax
     *
     * @return integer 
     */
    public function getNbMax()
    {
        return $this->nbMax;
    }

    /**
     * Set cdMaxUnit
     *
     * @param string $cdMaxUnit
     * @return LinkType
     */
    public function setCdMaxUnit($cdMaxUnit)
    {
        $this->cdMaxUnit = $cdMaxUnit;
    
        return $this;
    }

    /**
     * Get cdMaxUnit
     *
     * @return string 
     */
    public function getCdMaxUnit()
    {
        return $this->cdMaxUnit;
    }

    /**
     * Set nbChannelRangeFrom1
     *
     * @param integer $nbChannelRangeFrom1
     * @return LinkType
     */
    public function setNbChannelRangeFrom1($nbChannelRangeFrom1)
    {
        $this->nbChannelRangeFrom1 = $nbChannelRangeFrom1;
    
        return $this;
    }

    /**
     * Get nbChannelRangeFrom1
     *
     * @return integer 
     */
    public function getNbChannelRangeFrom1()
    {
        return $this->nbChannelRangeFrom1;
    }

    /**
     * Set nbChannelRangeTo1
     *
     * @param integer $nbChannelRangeTo1
     * @return LinkType
     */
    public function setNbChannelRangeTo1($nbChannelRangeTo1)
    {
        $this->nbChannelRangeTo1 = $nbChannelRangeTo1;
    
        return $this;
    }

    /**
     * Get nbChannelRangeTo1
     *
     * @return integer 
     */
    public function getNbChannelRangeTo1()
    {
        return $this->nbChannelRangeTo1;
    }

    /**
     * Set nbChannelRangeFrom2
     *
     * @param integer $nbChannelRangeFrom2
     * @return LinkType
     */
    public function setNbChannelRangeFrom2($nbChannelRangeFrom2)
    {
        $this->nbChannelRangeFrom2 = $nbChannelRangeFrom2;
    
        return $this;
    }

    /**
     * Get nbChannelRangeFrom2
     *
     * @return integer 
     */
    public function getNbChannelRangeFrom2()
    {
        return $this->nbChannelRangeFrom2;
    }

    /**
     * Set nbChannelRangeTo2
     *
     * @param integer $nbChannelRangeTo2
     * @return LinkType
     */
    public function setNbChannelRangeTo2($nbChannelRangeTo2)
    {
        $this->nbChannelRangeTo2 = $nbChannelRangeTo2;
    
        return $this;
    }

    /**
     * Get nbChannelRangeTo2
     *
     * @return integer 
     */
    public function getNbChannelRangeTo2()
    {
        return $this->nbChannelRangeTo2;
    }

    /**
     * Set nbChannel
     *
     * @param integer $nbChannel
     * @return LinkType
     */
    public function setNbChannel($nbChannel)
    {
        $this->nbChannel = $nbChannel;
    
        return $this;
    }

    /**
     * Get nbChannel
     *
     * @return integer 
     */
    public function getNbChannel()
    {
        return $this->nbChannel;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LinkType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return LinkType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return LinkType
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return LinkType
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }