<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkVirtual
 *
 * @ORM\Table(name="link_virtual")
 * @ORM\Entity
 */
class LinkVirtual
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_virtual", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkVirtual;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_virtual", type="string", length=15, nullable=true)
     */
    private $cdLinkVirtual;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_virtual", type="string", length=100, nullable=true)
     */
    private $lbLinkVirtual;

    /**
     * @var string
     *
     * @ORM\Column(name="ar_ts_1", type="string", length=255, nullable=true)
     */
    private $arTs1;

    /**
     * @var string
     *
     * @ORM\Column(name="ar_ts_2", type="string", length=255, nullable=true)
     */
    private $arTs2;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_port_1", type="boolean", nullable=true)
     */
    private $blPort1;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_port_2", type="boolean", nullable=true)
     */
    private $blPort2;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_bandwidth", type="decimal", nullable=true)
     */
    private $nbBandwidth;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Link
     *
     * @ORM\ManyToOne(targetEntity="Link")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link", referencedColumnName="id_link")
     * })
     */
    private $idLink;

    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     */
    private $idService;



    /**
     * Get idLinkVirtual
     *
     * @return integer 
     */
    public function getIdLinkVirtual()
    {
        return $this->idLinkVirtual;
    }

    /**
     * Set cdLinkVirtual
     *
     * @param string $cdLinkVirtual
     * @return LinkVirtual
     */
    public function setCdLinkVirtual($cdLinkVirtual)
    {
        $this->cdLinkVirtual = $cdLinkVirtual;
    
        return $this;
    }

    /**
     * Get cdLinkVirtual
     *
     * @return string 
     */
    public function getCdLinkVirtual()
    {
        return $this->cdLinkVirtual;
    }

    /**
     * Set lbLinkVirtual
     *
     * @param string $lbLinkVirtual
     * @return LinkVirtual
     */
    public function setLbLinkVirtual($lbLinkVirtual)
    {
        $this->lbLinkVirtual = $lbLinkVirtual;
    
        return $this;
    }

    /**
     * Get lbLinkVirtual
     *
     * @return string 
     */
    public function getLbLinkVirtual()
    {
        return $this->lbLinkVirtual;
    }

    /**
     * Set arTs1
     *
     * @param string $arTs1
     * @return LinkVirtual
     */
    public function setArTs1($arTs1)
    {
        $this->arTs1 = $arTs1;
    
        return $this;
    }

    /**
     * Get arTs1
     *
     * @return string 
     */
    public function getArTs1()
    {
        return $this->arTs1;
    }

    /**
     * Set arTs2
     *
     * @param string $arTs2
     * @return LinkVirtual
     */
    public function setArTs2($arTs2)
    {
        $this->arTs2 = $arTs2;
    
        return $this;
    }

    /**
     * Get arTs2
     *
     * @return string 
     */
    public function getArTs2()
    {
        return $this->arTs2;
    }

    /**
     * Set blPort1
     *
     * @param boolean $blPort1
     * @return LinkVirtual
     */
    public function setBlPort1($blPort1)
    {
        $this->blPort1 = $blPort1;
    
        return $this;
    }

    /**
     * Get blPort1
     *
     * @return boolean 
     */
    public function getBlPort1()
    {
        return $this->blPort1;
    }

    /**
     * Set blPort2
     *
     * @param boolean $blPort2
     * @return LinkVirtual
     */
    public function setBlPort2($blPort2)
    {
        $this->blPort2 = $blPort2;
    
        return $this;
    }

    /**
     * Get blPort2
     *
     * @return boolean 
     */
    public function getBlPort2()
    {
        return $this->blPort2;
    }

    /**
     * Set nbBandwidth
     *
     * @param float $nbBandwidth
     * @return LinkVirtual
     */
    public function setNbBandwidth($nbBandwidth)
    {
        $this->nbBandwidth = $nbBandwidth;
    
        return $this;
    }

    /**
     * Get nbBandwidth
     *
     * @return float 
     */
    public function getNbBandwidth()
    {
        return $this->nbBandwidth;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return LinkVirtual
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return LinkVirtual
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkVirtual
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idLink
     *
     * @param \Etrali\GinangBundle\Entity\Link $idLink
     * @return LinkVirtual
     */
    public function setIdLink(\Etrali\GinangBundle\Entity\Link $idLink = null)
    {
        $this->idLink = $idLink;
    
        return $this;
    }

    /**
     * Get idLink
     *
     * @return \Etrali\GinangBundle\Entity\Link 
     */
    public function getIdLink()
    {
        return $this->idLink;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return LinkVirtual
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }