<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoop
 *
 * @ORM\Table(name="local_loop")
 * @ORM\Entity
 */
class LocalLoop
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLocalLoop;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_local_loop", type="string", length=15, nullable=true)
     */
    private $cdLocalLoop;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_administrative_ref", type="string", length=20, nullable=true)
     */
    private $cdAdministrativeRef;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_technical_ref", type="string", length=30, nullable=true)
     */
    private $cdTechnicalRef;


    /**
     * @var string
     *
     * @ORM\Column(name="cm_local_loop", type="string", length=255, nullable=true)
     */
    private $cmLocalLoop;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_order", type="datetime", nullable=true)
     */
    private $dtOrder;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery_requested", type="datetime", nullable=true)
     */
    private $dtDeliveryRequested;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_delivery", type="datetime", nullable=true)
     */
    private $dtDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_requested_cancel", type="datetime", nullable=true)
     */
    private $dtRequestedCancel;


    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_scheduled_updown_delivery", type="datetime", nullable=true)
     */
    private $dtScheduledUpdownDelivery;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_technical_ref2", type="string", length=30, nullable=true)
     */
    private $cdTechnicalRef2;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_terminate", type="datetime", nullable=true)
     */
    private $dtInitTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_updown", type="datetime", nullable=true)
     */
    private $dtInitUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_requested_updown", type="datetime", nullable=true)
     */
    private $dtRequestedUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_scheduled_delivery", type="datetime", nullable=true)
     */
    private $dtScheduledDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_terminate", type="datetime", nullable=true)
     */
    private $dtRealTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_updown", type="datetime", nullable=true)
     */
    private $dtRealUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_terminate", type="datetime", nullable=true)
     */
    private $dtRequestTerminate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_french", type="boolean", nullable=true)
     */
    private $blFrench;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_express", type="boolean", nullable=true)
     */
    private $blExpress;


    /**
     * @var \BandwidthAssignee
     *
     * @ORM\ManyToOne(targetEntity="BandwidthAssignee")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_old_bandwidth", referencedColumnName="id_bandwidth_assignee")
     * })
     */
    private $idOldBandwidth; 
    
    /**
     * @var \LocalLoopType
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_type", referencedColumnName="id_local_loop_type")
     * })
     */
    private $idLocalLoopType=1;    


    /**
     * @var \Capacity
     *
     * @ORM\ManyToOne(targetEntity="Capacity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_capacity", referencedColumnName="id_capacity")
     * })
     */
    private $idCapacity;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Interfaces
     *
     * @ORM\ManyToOne(targetEntity="Interfaces")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_interface", referencedColumnName="id_interface")
     * })
     */
    private $idInterface;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider_of_carrier", referencedColumnName="id_provider")
     * })
     */
    private $idProviderOfCarrier;

    /**
     * @var \LocalLoopOwner
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopOwner")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_owner", referencedColumnName="id_local_loop_owner")
     * })
     */
    private $idLocalLoopOwner;

    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_sister", referencedColumnName="id_local_loop")
     * })
     */
    private $idLocalLoopSister;

    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_parent", referencedColumnName="id_local_loop")
     * })
     */
    private $idLocalLoopParent;

    /**
     * @var \BandwidthAssignee
     *
     * @ORM\ManyToOne(targetEntity="BandwidthAssignee")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_bandwidth", referencedColumnName="id_bandwidth_assignee")
     * })
     */
    private $idBandwidth;

    /**
     * @var \Protocol
     *
     * @ORM\ManyToOne(targetEntity="Protocol")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_protocol", referencedColumnName="id_protocol")
     * })
     */
    private $idProtocol;
    
    /**
     * @var \LinkFunction
     *
     * @ORM\ManyToOne(targetEntity="LinkFunction")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_link_function", referencedColumnName="id_link_function")
     * })    
     */
    private $idLinkFunction;    
    
    /**
     * @var \LocalLoopExtremity
     *
     * @ORM\OneToMany(targetEntity="LocalLoopExtremity", mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"blOld"="asc","blTransferred"="asc","idLocalLoopExtremity" = "asc"})
     */
    private $idLocalLoopExtremity;
    
    /**
     * @var \LocalLoopExtremityTech
     *
     * @ORM\OneToMany(targetEntity="LocalLoopExtremityTech", mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"blOld"="asc","blTransferred"="asc","idLocalLoopExtremityTech" = "asc"})
     */
    private $idLocalLoopExtremityTech;    

    /**
     * @var \LocalLoopOption
     *
     * @ORM\OneToMany(targetEntity="LocalLoopOption", mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idLocalLoopOption" = "asc"})         
     */
    private $idLocalLoopOption;  
    
    /**
     * @var \LocalLoopTransactions
     *
     * @ORM\OneToMany(targetEntity="LocalLoopTransactions",mappedBy="idLocalLoop", cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idLocalLoopTransactions" = "desc"})
     */
    private $idLocalLoopTransactions;    
    
    /**
     * @var \CostingLocalLoopLine
     *
     * @ORM\OneToMany(targetEntity="CostingLocalLoopLine",mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )  
     */
    private $idCostingLocalLoopLine;       
  
    
        /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;   
    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_operation", type="integer", nullable=true)
     */
    private $nbOperation=1;  
    
    /**
     * @var \LocalLoopExtremity
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transfer_extremity", referencedColumnName="id_local_loop_extremity")
     * })
     */
    private $idTransferExtremity;  
    
    /**
     * @var \Note
     *
     * @ORM\OneToMany(targetEntity="Note", mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idNote" = "asc"})         
     */
    private $idNote;      
    
    /**
     * @var \ServiceExtremityTech
     *
     * @ORM\OneToMany(targetEntity="ServiceExtremityTech", mappedBy="idLocalLoop",cascade={"persist","remove"}, orphanRemoval=true )           
     */
    private $idServiceExtremityTech;      
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

    public function __toString()
    {
        return $this->getCdLocalLoop()." : ".$this->getCdTechnicalRef();
    }
    
    public static function getModifierRoles()
    {
        return array("ROLE_SUPER_ADMINISTRATOR","ROLE_NETWORK_ADMINISTRATOR","ROLE_NETWORK_ENGINEER_ADMIN","ROLE_NETWORK_ENGINEER");
    }
    
    public static function getReaderRoles()
    {
        return array("ROLE_SUPER_ADMINISTRATOR","ROLE_ENTMC_INDIA", "ROLE_CSC_FRANCE", "ROLE_NETWORK_ACCOUNTING","ROLE_NETWORK_ADMINISTRATOR","ROLE_NETWORK_ENGINEER_ADMIN","ROLE_NETWORK_ENGINEER","ROLE_MARKETING_PRE_SALES","ROLE_SALES_ADMINISTRATOR","ROLE_BACKBONE_LINK_ADMINISTRATOR");
    }     
    
public function getCollections()
    {
        $role=$GLOBALS['kernel']->getContainer()->get('etrali.security.context');
        $onglets=array();
        if ($role->isGranted("ROLE_SUPER_ADMINISTRATOR", $this) )
            $onglets=array_merge($onglets,array("Extremities"=>"LocalLoopExtremity","Costings"=>"CostingLocalLoopLine","Technical"=>"LocalLoopExtremityTech", "Options"=>"LocalLoopOption","Connected services"=>"Service","Notes"=>"Note"));                 
        else if ($role->isGranted("ROLE_ENTMC_INDIA", $this)||$role->isGranted("ROLE_CSC_FRANCE", $this)||$role->isGranted("ROLE_NETWORK_ACCOUNTING", $this)||
            $role->isGranted("ROLE_NETWORK_ADMINISTRATOR", $this)||$role->isGranted("ROLE_NETWORK_ENGINEER_ADMIN", $this)||$role->isGranted("ROLE_NETWORK_ENGINEER", $this)||$role->isGranted("ROLE_MARKETING_PRE_SALES", $this)||
            $role->isGranted("ROLE_SALES_ADMINISTRATOR", $this)||$role->isGranted("ROLE_BACKBONE_LINK_ADMINISTRATOR", $this))
       {
            if ($role->isGranted('ROLE_ENTMC_INDIA',$this))
                $onglets=array_merge($onglets,array("Extremities"=>"LocalLoopExtremity","Technical"=>"LocalLoopExtremityTech", "Options"=>"LocalLoopOption","Connected services"=>"Service"));        
            else{
                if($role->isGranted('ROLE_CSC_FRANCE',$this))
                    $onglets=array_merge($onglets,array("Extremities"=>"LocalLoopExtremity","Technical"=>"LocalLoopExtremityTech", "Options"=>"LocalLoopOption","Connected services"=>"Service","Notes"=>"Note")); 
                else{
                    if ($role->isGranted("ROLE_NETWORK_ACCOUNTING", $this)||$role->isGranted("ROLE_NETWORK_ADMINISTRATOR", $this)||
                        $role->isGranted("ROLE_NETWORK_ENGINEER_ADMIN", $this)||$role->isGranted("ROLE_NETWORK_ENGINEER", $this)||$role->isGranted("ROLE_MARKETING_PRE_SALES", $this)||$role->isGranted("ROLE_SALES_ADMINISTRATOR", $this))
                    {
                        $onglets=array_merge($onglets,array("Extremities"=>"LocalLoopExtremity","Costings"=>"CostingLocalLoopLine","Technical"=>"LocalLoopExtremityTech", "Options"=>"LocalLoopOption","Connected services"=>"Service","Notes"=>"Note")); 
                    }      
                    else
                        $onglets=array_merge($onglets,array("Extremities"=>"LocalLoopExtremity","Costings"=>"CostingLocalLoopLine","Technical"=>"LocalLoopExtremityTech", "Options"=>"LocalLoopOption","Connected services"=>"Service","Progression"=>"LocalLoopTransactions","Notes"=>"Note")); 
                }
            }
        }
        return $onglets;
    }  
          
    public function getEditType($type)
    {
        $idtrans=$this->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans);  
        $type->setObject($this);    
        return $type;
    }
    
    public function getServices()
    {
        $services=array();
        foreach ($this->getIdServiceExtremityTech() as $extr)
        {
            if (!isset($services[$extr->getIdService()->getIdService()]))
                $services[$extr->getIdService()->getIdService()]=$extr->getIdService();
        }
        return $services;
    }
  
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idLocalLoopExtremity = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idLocalLoopExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idLocalLoopOption = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idLocalLoopTransactions = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idCostingLocalLoopLine = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idLocalLoop
     *
     * @return integer 
     */
    public function getIdLocalLoop()
    {
        return $this->idLocalLoop;
    }

    /**
     * Set cdLocalLoop
     *
     * @param string $cdLocalLoop
     * @return LocalLoop
     */
    public function setCdLocalLoop($cdLocalLoop)
    {
        $this->cdLocalLoop = $cdLocalLoop;
    
        return $this;
    }

    /**
     * Get cdLocalLoop
     *
     * @return string 
     */
    public function getCdLocalLoop()
    {
        return $this->cdLocalLoop;
    }

    /**
     * Set cdAdministrativeRef
     *
     * @param string $cdAdministrativeRef
     * @return LocalLoop
     */
    public function setCdAdministrativeRef($cdAdministrativeRef)
    {
        $this->cdAdministrativeRef = $cdAdministrativeRef;
    
        return $this;
    }

    /**
     * Get cdAdministrativeRef
     *
     * @return string 
     */
    public function getCdAdministrativeRef()
    {
        return $this->cdAdministrativeRef;
    }

    /**
     * Set cdTechnicalRef
     *
     * @param string $cdTechnicalRef
     * @return LocalLoop
     */
    public function setCdTechnicalRef($cdTechnicalRef)
    {
        $this->cdTechnicalRef = $cdTechnicalRef;
    
        return $this;
    }

    /**
     * Get cdTechnicalRef
     *
     * @return string 
     */
    public function getCdTechnicalRef()
    {
        return $this->cdTechnicalRef;
    }

    /**
     * Set cmLocalLoop
     *
     * @param string $cmLocalLoop
     * @return LocalLoop
     */
    public function setCmLocalLoop($cmLocalLoop)
    {
        $this->cmLocalLoop = $cmLocalLoop;
    
        return $this;
    }

    /**
     * Get cmLocalLoop
     *
     * @return string 
     */
    public function getCmLocalLoop()
    {
        return $this->cmLocalLoop;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LocalLoop
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtOrder
     *
     * @param \DateTime $dtOrder
     * @return LocalLoop
     */
    public function setDtOrder($dtOrder)
    {
        $this->dtOrder = $dtOrder;
    
        return $this;
    }

    /**
     * Get dtOrder
     *
     * @return \DateTime 
     */
    public function getDtOrder()
    {
        return $this->dtOrder;
    }

    /**
     * Set dtDeliveryRequested
     *
     * @param \DateTime $dtDeliveryRequested
     * @return LocalLoop
     */
    public function setDtDeliveryRequested($dtDeliveryRequested)
    {
        $this->dtDeliveryRequested = $dtDeliveryRequested;
    
        return $this;
    }

    /**
     * Get dtDeliveryRequested
     *
     * @return \DateTime 
     */
    public function getDtDeliveryRequested()
    {
        return $this->dtDeliveryRequested;
    }

    /**
     * Set dtDelivery
     *
     * @param \DateTime $dtDelivery
     * @return LocalLoop
     */
    public function setDtDelivery($dtDelivery)
    {
        $this->dtDelivery = $dtDelivery;
    
        return $this;
    }

    /**
     * Get dtDelivery
     *
     * @return \DateTime 
     */
    public function getDtDelivery()
    {
        return $this->dtDelivery;
    }

    /**
     * Set dtRequestedCancel
     *
     * @param \DateTime $dtRequestedCancel
     * @return LocalLoop
     */
    public function setDtRequestedCancel($dtRequestedCancel)
    {
        $this->dtRequestedCancel = $dtRequestedCancel;
    
        return $this;
    }

    /**
     * Get dtRequestedCancel
     *
     * @return \DateTime 
     */
    public function getDtRequestedCancel()
    {
        return $this->dtRequestedCancel;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LocalLoop
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtScheduledUpdownDelivery
     *
     * @param \DateTime $dtScheduledUpdownDelivery
     * @return LocalLoop
     */
    public function setDtScheduledUpdownDelivery($dtScheduledUpdownDelivery)
    {
        $this->dtScheduledUpdownDelivery = $dtScheduledUpdownDelivery;
    
        return $this;
    }

    /**
     * Get dtScheduledUpdownDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduledUpdownDelivery()
    {
        return $this->dtScheduledUpdownDelivery;
    }

    /**
     * Set cdTechnicalRef2
     *
     * @param string $cdTechnicalRef2
     * @return LocalLoop
     */
    public function setCdTechnicalRef2($cdTechnicalRef2)
    {
        $this->cdTechnicalRef2 = $cdTechnicalRef2;
    
        return $this;
    }

    /**
     * Get cdTechnicalRef2
     *
     * @return string 
     */
    public function getCdTechnicalRef2()
    {
        return $this->cdTechnicalRef2;
    }

    /**
     * Set dtInitTerminate
     *
     * @param \DateTime $dtInitTerminate
     * @return LocalLoop
     */
    public function setDtInitTerminate($dtInitTerminate)
    {
        $this->dtInitTerminate = $dtInitTerminate;
    
        return $this;
    }

    /**
     * Get dtInitTerminate
     *
     * @return \DateTime 
     */
    public function getDtInitTerminate()
    {
        return $this->dtInitTerminate;
    }

    /**
     * Set dtInitUpdown
     *
     * @param \DateTime $dtInitUpdown
     * @return LocalLoop
     */
    public function setDtInitUpdown($dtInitUpdown)
    {
        $this->dtInitUpdown = $dtInitUpdown;
    
        return $this;
    }

    /**
     * Get dtInitUpdown
     *
     * @return \DateTime 
     */
    public function getDtInitUpdown()
    {
        return $this->dtInitUpdown;
    }

    /**
     * Set dtRequestedUpdown
     *
     * @param \DateTime $dtRequestedUpdown
     * @return LocalLoop
     */
    public function setDtRequestedUpdown($dtRequestedUpdown)
    {
        $this->dtRequestedUpdown = $dtRequestedUpdown;
    
        return $this;
    }

    /**
     * Get dtRequestedUpdown
     *
     * @return \DateTime 
     */
    public function getDtRequestedUpdown()
    {
        return $this->dtRequestedUpdown;
    }

    /**
     * Set dtScheduledDelivery
     *
     * @param \DateTime $dtScheduledDelivery
     * @return LocalLoop
     */
    public function setDtScheduledDelivery($dtScheduledDelivery)
    {
        $this->dtScheduledDelivery = $dtScheduledDelivery;
    
        return $this;
    }

    /**
     * Get dtScheduledDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduledDelivery()
    {
        return $this->dtScheduledDelivery;
    }

    /**
     * Set dtRealTerminate
     *
     * @param \DateTime $dtRealTerminate
     * @return LocalLoop
     */
    public function setDtRealTerminate($dtRealTerminate)
    {
        $this->dtRealTerminate = $dtRealTerminate;
    
        return $this;
    }

    /**
     * Get dtRealTerminate
     *
     * @return \DateTime 
     */
    public function getDtRealTerminate()
    {
        return $this->dtRealTerminate;
    }

    /**
     * Set dtRealUpdown
     *
     * @param \DateTime $dtRealUpdown
     * @return LocalLoop
     */
    public function setDtRealUpdown($dtRealUpdown)
    {
        $this->dtRealUpdown = $dtRealUpdown;
    
        return $this;
    }

    /**
     * Get dtRealUpdown
     *
     * @return \DateTime 
     */
    public function getDtRealUpdown()
    {
        return $this->dtRealUpdown;
    }

    /**
     * Set dtRequestTerminate
     *
     * @param \DateTime $dtRequestTerminate
     * @return LocalLoop
     */
    public function setDtRequestTerminate($dtRequestTerminate)
    {
        $this->dtRequestTerminate = $dtRequestTerminate;
    
        return $this;
    }

    /**
     * Get dtRequestTerminate
     *
     * @return \DateTime 
     */
    public function getDtRequestTerminate()
    {
        return $this->dtRequestTerminate;
    }

    /**
     * Set blFrench
     *
     * @param boolean $blFrench
     * @return LocalLoop
     */
    public function setBlFrench($blFrench)
    {
        $this->blFrench = $blFrench;
    
        return $this;
    }

    /**
     * Get blFrench
     *
     * @return boolean 
     */
    public function getBlFrench()
    {
        return $this->blFrench;
    }

    /**
     * Set blExpress
     *
     * @param boolean $blExpress
     * @return LocalLoop
     */
    public function setBlExpress($blExpress)
    {
        $this->blExpress = $blExpress;
    
        return $this;
    }

    /**
     * Get blExpress
     *
     * @return boolean 
     */
    public function getBlExpress()
    {
        return $this->blExpress;
    }

    /**
     * Set nbOperation
     *
     * @param integer $nbOperation
     * @return LocalLoop
     */
    public function setNbOperation($nbOperation)
    {
        $this->nbOperation = $nbOperation;
    
        return $this;
    }

    /**
     * Get nbOperation
     *
     * @return integer 
     */
    public function getNbOperation()
    {
        return $this->nbOperation;
    }

    /**
     * Set idOldBandwidth
     *
     * @param \Etrali\GinangBundle\Entity\BandwidthAssignee $idOldBandwidth
     * @return LocalLoop
     */
    public function setIdOldBandwidth(\Etrali\GinangBundle\Entity\BandwidthAssignee $idOldBandwidth = null)
    {
        $this->idOldBandwidth = $idOldBandwidth;
    
        return $this;
    }

    /**
     * Get idOldBandwidth
     *
     * @return \Etrali\GinangBundle\Entity\BandwidthAssignee 
     */
    public function getIdOldBandwidth()
    {
        return $this->idOldBandwidth;
    }

    /**
     * Set idLocalLoopType
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopType $idLocalLoopType
     * @return LocalLoop
     */
    public function setIdLocalLoopType(\Etrali\GinangBundle\Entity\LocalLoopType $idLocalLoopType = null)
    {
        $this->idLocalLoopType = $idLocalLoopType;
    
        return $this;
    }

    /**
     * Get idLocalLoopType
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopType 
     */
    public function getIdLocalLoopType()
    {
        return $this->idLocalLoopType;
    }

    /**
     * Set idCapacity
     *
     * @param \Etrali\GinangBundle\Entity\Capacity $idCapacity
     * @return LocalLoop
     */
    public function setIdCapacity(\Etrali\GinangBundle\Entity\Capacity $idCapacity = null)
    {
        $this->idCapacity = $idCapacity;
    
        return $this;
    }

    /**
     * Get idCapacity
     *
     * @return \Etrali\GinangBundle\Entity\Capacity 
     */
    public function getIdCapacity()
    {
        return $this->idCapacity;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return LocalLoop
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idInterface
     *
     * @param \Etrali\GinangBundle\Entity\Interfaces $idInterface
     * @return LocalLoop
     */
    public function setIdInterface(\Etrali\GinangBundle\Entity\Interfaces $idInterface = null)
    {
        $this->idInterface = $idInterface;
    
        return $this;
    }

    /**
     * Get idInterface
     *
     * @return \Etrali\GinangBundle\Entity\Interfaces 
     */
    public function getIdInterface()
    {
        return $this->idInterface;
    }

    /**
     * Set idProviderOfCarrier
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProviderOfCarrier
     * @return LocalLoop
     */
    public function setIdProviderOfCarrier(\Etrali\GinangBundle\Entity\Provider $idProviderOfCarrier = null)
    {
        $this->idProviderOfCarrier = $idProviderOfCarrier;
    
        return $this;
    }

    /**
     * Get idProviderOfCarrier
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProviderOfCarrier()
    {
        return $this->idProviderOfCarrier;
    }

    /**
     * Set idLocalLoopOwner
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopOwner $idLocalLoopOwner
     * @return LocalLoop
     */
    public function setIdLocalLoopOwner(\Etrali\GinangBundle\Entity\LocalLoopOwner $idLocalLoopOwner = null)
    {
        $this->idLocalLoopOwner = $idLocalLoopOwner;
    
        return $this;
    }

    /**
     * Get idLocalLoopOwner
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopOwner 
     */
    public function getIdLocalLoopOwner()
    {
        return $this->idLocalLoopOwner;
    }

    /**
     * Set idLocalLoopSister
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoopSister
     * @return LocalLoop
     */
    public function setIdLocalLoopSister(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoopSister = null)
    {
        $this->idLocalLoopSister = $idLocalLoopSister;
    
        return $this;
    }

    /**
     * Get idLocalLoopSister
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoopSister()
    {
        return $this->idLocalLoopSister;
    }

    /**
     * Set idLocalLoopParent
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoopParent
     * @return LocalLoop
     */
    public function setIdLocalLoopParent(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoopParent = null)
    {
        $this->idLocalLoopParent = $idLocalLoopParent;
    
        return $this;
    }

    /**
     * Get idLocalLoopParent
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoopParent()
    {
        return $this->idLocalLoopParent;
    }

    /**
     * Set idBandwidth
     *
     * @param \Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidth
     * @return LocalLoop
     */
    public function setIdBandwidth(\Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidth = null)
    {
        $this->idBandwidth = $idBandwidth;
    
        return $this;
    }

    /**
     * Get idBandwidth
     *
     * @return \Etrali\GinangBundle\Entity\BandwidthAssignee 
     */
    public function getIdBandwidth()
    {
        return $this->idBandwidth;
    }

    /**
     * Set idProtocol
     *
     * @param \Etrali\GinangBundle\Entity\Protocol $idProtocol
     * @return LocalLoop
     */
    public function setIdProtocol(\Etrali\GinangBundle\Entity\Protocol $idProtocol = null)
    {
        $this->idProtocol = $idProtocol;
    
        return $this;
    }

    /**
     * Get idProtocol
     *
     * @return \Etrali\GinangBundle\Entity\Protocol 
     */
    public function getIdProtocol()
    {
        return $this->idProtocol;
    }

    /**
     * Set idLinkFunction
     *
     * @param \Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction
     * @return LocalLoop
     */
    public function setIdLinkFunction(\Etrali\GinangBundle\Entity\LinkFunction $idLinkFunction = null)
    {
        $this->idLinkFunction = $idLinkFunction;
    
        return $this;
    }

    /**
     * Get idLinkFunction
     *
     * @return \Etrali\GinangBundle\Entity\LinkFunction 
     */
    public function getIdLinkFunction()
    {
        return $this->idLinkFunction;
    }

    /**
     * Add idLocalLoopExtremity
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity
     * @return LocalLoop
     */
    public function addIdLocalLoopExtremity(\Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity)
    {
        $this->idLocalLoopExtremity[] = $idLocalLoopExtremity;
    
        return $this;
    }

    /**
     * Remove idLocalLoopExtremity
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity
     */
    public function removeIdLocalLoopExtremity(\Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity)
    {
        $this->idLocalLoopExtremity->removeElement($idLocalLoopExtremity);
    }

    /**
     * Get idLocalLoopExtremity
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopExtremity()
    {
        return $this->idLocalLoopExtremity;
    }

    /**
     * Add idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return LocalLoop
     */
    public function addIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech[] = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Remove idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     */
    public function removeIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech->removeElement($idLocalLoopExtremityTech);
    }

    /**
     * Get idLocalLoopExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }

    /**
     * Add idLocalLoopOption
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopOption $idLocalLoopOption
     * @return LocalLoop
     */
    public function addIdLocalLoopOption(\Etrali\GinangBundle\Entity\LocalLoopOption $idLocalLoopOption)
    {
        $this->idLocalLoopOption[] = $idLocalLoopOption;
    
        return $this;
    }

    /**
     * Remove idLocalLoopOption
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopOption $idLocalLoopOption
     */
    public function removeIdLocalLoopOption(\Etrali\GinangBundle\Entity\LocalLoopOption $idLocalLoopOption)
    {
        $this->idLocalLoopOption->removeElement($idLocalLoopOption);
    }

    /**
     * Get idLocalLoopOption
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopOption()
    {
        return $this->idLocalLoopOption;
    }

    /**
     * Add idLocalLoopTransactions
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopTransactions $idLocalLoopTransactions
     * @return LocalLoop
     */
    public function addIdLocalLoopTransaction(\Etrali\GinangBundle\Entity\LocalLoopTransactions $idLocalLoopTransactions)
    {
        $this->idLocalLoopTransactions[] = $idLocalLoopTransactions;
    
        return $this;
    }

    /**
     * Remove idLocalLoopTransactions
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopTransactions $idLocalLoopTransactions
     */
    public function removeIdLocalLoopTransaction(\Etrali\GinangBundle\Entity\LocalLoopTransactions $idLocalLoopTransactions)
    {
        $this->idLocalLoopTransactions->removeElement($idLocalLoopTransactions);
    }

    /**
     * Get idLocalLoopTransactions
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopTransactions()
    {
        return $this->idLocalLoopTransactions;
    }

    /**
     * Add idCostingLocalLoopLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingLocalLoopLine $idCostingLocalLoopLine
     * @return LocalLoop
     */
    public function addIdCostingLocalLoopLine(\Etrali\GinangBundle\Entity\CostingLocalLoopLine $idCostingLocalLoopLine)
    {
        $this->idCostingLocalLoopLine[] = $idCostingLocalLoopLine;
    
        return $this;
    }

    /**
     * Remove idCostingLocalLoopLine
     *
     * @param \Etrali\GinangBundle\Entity\CostingLocalLoopLine $idCostingLocalLoopLine
     */
    public function removeIdCostingLocalLoopLine(\Etrali\GinangBundle\Entity\CostingLocalLoopLine $idCostingLocalLoopLine)
    {
        $this->idCostingLocalLoopLine->removeElement($idCostingLocalLoopLine);
    }

    /**
     * Get idCostingLocalLoopLine
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCostingLocalLoopLine()
    {
        return $this->idCostingLocalLoopLine;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return LocalLoop
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return LocalLoop
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idTransferExtremity
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $idTransferExtremity
     * @return LocalLoop
     */
    public function setIdTransferExtremity(\Etrali\GinangBundle\Entity\LocalLoopExtremity $idTransferExtremity = null)
    {
        $this->idTransferExtremity = $idTransferExtremity;
    
        return $this;
    }

    /**
     * Get idTransferExtremity
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremity 
     */
    public function getIdTransferExtremity()
    {
        return $this->idTransferExtremity;
    }

    /**
     * Add idNote
     *
     * @param \Etrali\GinangBundle\Entity\Note $idNote
     * @return LocalLoop
     */
    public function addIdNote(\Etrali\GinangBundle\Entity\Note $idNote)
    {
        $this->idNote[] = $idNote;
    
        return $this;
    }

    /**
     * Remove idNote
     *
     * @param \Etrali\GinangBundle\Entity\Note $idNote
     */
    public function removeIdNote(\Etrali\GinangBundle\Entity\Note $idNote)
    {
        $this->idNote->removeElement($idNote);
    }

    /**
     * Get idNote
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdNote()
    {
        return $this->idNote;
    }

    /**
     * Add idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return LocalLoop
     */
    public function addIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech[] = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Remove idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     */
    public function removeIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech->removeElement($idServiceExtremityTech);
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return LocalLoop
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}