<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoopExtremity
 *
 * @ORM\Table(name="local_loop_extremity")
 * @ORM\Entity
 */
class LocalLoopExtremity
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop_extremity", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLocalLoopExtremity;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="text", nullable=true)
     */
    private $cmComment;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_old_terminate", type="datetime", nullable=true)
     */
    private $dtOldTerminate;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_transfer", type="datetime", nullable=true)
     */
    private $dtInitTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_transfer", type="datetime", nullable=true)
     */
    private $dtRequestTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_schedule_delivery", type="datetime", nullable=true)
     */
    private $dtScheduleDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_transfer_real_delivery", type="datetime", nullable=true)
     */
    private $dtTransferRealDelivery;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_transfer_complete", type="datetime", nullable=true)
     */
    private $dtTransferComplete;


    /**
     * @var string
     *
     * @ORM\Column(name="cd_local_loop_extremity_ref", type="string", length=45, nullable=true)
     */
    private $cdLocalLoopExtremityRef;


    /**
     * @var string
     *
     * @ORM\Column(name="lb_trader", type="string", length=30, nullable=true)
     */
    private $lbTrader;

    /**
     * @var string
     *
     * @ORM\Column(name="ll_extremity", type="string", length=2, nullable=true)
     */
    private $llExtremity;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_ptt", type="datetime", nullable=true)
     */
    private $dtPtt;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_ordre_racc", type="datetime", nullable=true)
     */
    private $dtOrdreRacc;    



    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_fin_tech", type="datetime", nullable=true)
     */
    private $dtFinTech;

    /**
     * @var string
     *
     * @ORM\Column(name="nb_chrono", type="string", length=45, nullable=true)
     */
    private $nbChrono;


    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \AddressPop
     *
     * @ORM\ManyToOne(targetEntity="AddressPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address_pop", referencedColumnName="id_address_pop")
     * })
     */    
    private $idAddressPop;    
    
    /**
     * @var \ContactPop
     *
     * @ORM\ManyToOne(targetEntity="ContactPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact_pop", referencedColumnName="id_contact_pop")
     * })
     */    
    private $idContactPop;
    
    /**
     * @var \LocalLoopExtremityOwner
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityOwner")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_owner", referencedColumnName="id_local_loop_extremity_owner")
     * })
     * @Assert\NotNull()       
     */
    private $idLocalLoopExtremityOwner;    

    /**
     * @var \Access
     *
     * @ORM\ManyToOne(targetEntity="Access")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_access", referencedColumnName="id_access")
     * })
     */
    private $idAccess;



    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer", referencedColumnName="id_customer")
     * })
     */
    private $idCustomer;
    
    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="Contact")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_admin_contact", referencedColumnName="id_contact")
     * })
     */    
    private $idAdminContact;
    
    /**
     * @var \Address
     *
     * @ORM\ManyToOne(targetEntity="Address")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_delivery_address", referencedColumnName="id_address")
     * })
     */    
    private $idDeliveryAddress;        

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old", type="boolean", nullable=true)
     */
    private $blOld=false;    
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_transferred", type="boolean", nullable=true)
     */
    private $blTransferred=false;      
    

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;
    
        /**
     * @var \AddressProvider
     *
     * @ORM\ManyToOne(targetEntity="AddressProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address_provider", referencedColumnName="id_address_provider")
     * })
     */    
    private $idAddressProvider;    
    
    /**
     * @var \ContactProvider
     *
     * @ORM\ManyToOne(targetEntity="ContactProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact_provider", referencedColumnName="id_contact_provider")
     * })
     */    
    private $idContactProvider;


    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="Contact")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_technical_contact", referencedColumnName="id_contact")
     * })
     */
    private $idTechnicalContact;

    /**
     * @var \LocalLoopExtremity
     *
     * @ORM\OneToOne(targetEntity="LocalLoopExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_old_extremity", referencedColumnName="id_local_loop_extremity")
     * })
     */    
    private $idOldExtremity;  
    
    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop", inversedBy="idLocalLoopExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop", referencedColumnName="id_local_loop")
     * })
     */    
    private $idLocalLoop;
    
    /**
     * @var \LocalLoopExtremityTech
     *
     * @ORM\OneToOne(targetEntity="LocalLoopExtremityTech", mappedBy="idLocalLoopExtremity")
     */    
    private $idLocalLoopExtremityTech;        
    
 
    /**
     * @var string
     *
     * @ORM\Column(name="lb_siret", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $lbSiret;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_ls_account", type="string", length=20, nullable=true)
     * @Assert\MaxLength(20) 
     */
    private $lbLsAccount;
    
    /**
     * @var \LocalLoopExtremitySide
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremitySide")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_side", referencedColumnName="id_local_loop_extremity_side")
     * })
     */
    private $idLocalLoopExtremitySide;    
    
    /**
     * @var \LocalLoopExtremitySituation
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremitySituation")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_situation", referencedColumnName="id_local_loop_extremity_situation")
     * })
     */
    private $idLocalLoopExtremitySituation;       

    public function __toString()
    {
        return $this->getCdLocalLoopExtremityRef()."";
    }

    public function getHeadInfo()
    {
            $lbparent="";
            $lbaddr="";                
            $lbcontact="";         
        if ($this->getIdLocalLoopExtremityOwner()!=NULL)
        {            
            switch ($this->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner())
            {
                case 1:
                    $lbparent=$this->getIdCustomer()!=NULL?$this->getIdCustomer():"";
                    $lbaddr=$this->getIdCustomer()!=NULL?$this->getIdDeliveryAddress():"";                
                    $lbcontact=$this->getIdCustomer()!=NULL?$this->getIdAdminContact():"";                                
                break;
                case 2:
                    $lbparent=$this->getIdPop()!=NULL?$this->getIdPop():"";
                    $lbaddr=$this->getIdPop()!=NULL?$this->getIdAddressPop():"";                                
                    $lbcontact=$this->getIdPop()!=NULL?$this->getIdContactPop():"";    
                break;
                case 3:
                    $lbparent=$this->getIdProvider()!=NULL?$this->getIdProvider():"";
                    $lbaddr=$this->getIdProvider()!=NULL?$this->getIdAddressProvider():"";                                
                    $lbcontact=$this->getIdProvider()!=NULL?$this->getIdContactProvider():"";                                                
                break;        
            }
        }
            $retour= "<td >".$this->getCdLocalLoopExtremityRef()."</td><td>".$lbparent."</td><td>".$lbaddr."</td><td>".$lbcontact."</td>";
            if (!$this->getBlOld() && ($this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==27 || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==33  || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==39 || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==42  || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==43))
                $retour.="<td><button type='button' id='bb_transfer_button' class='transfer_button btn btn-link' data-id='".$this->getIdLocalLoopExtremity()."'><i class='icones_actions_synchro'></i></button></td>";
            else
                $retour.="<td></td>";
            return $retour;
    }  
    
    public function getHeadColumns()
    {
            $retour= "<th>Extremity ref</th><th>Customer/Provider/Pop</th><th>Delivery address</th><th>Administrative Contact</th>";
            if ($this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==27 || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==33 || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==39  || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==42  || $this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus()==43)
                $retour.="<th>Transfer</th>";
            return $retour;
    } 

   
    public function getEditType($type)
    {
        $idtrans=$this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdLocalLoop()->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans);  
        $type->setOld($this->getIdLocalLoop()->getIdTransferExtremity()!=NULL &&  $this->getIdLocalLoop()->getIdTransferExtremity()->getIdOldExtremity()->getIdLocalLoopExtremity()==$this->getIdLocalLoopExtremity());
        $type->setTransfer($this->getIdLocalLoop()->getIdTransferExtremity()!=NULL &&  $this->getIdLocalLoop()->getIdTransferExtremity()->getIdLocalLoopExtremity()==$this->getIdLocalLoopExtremity());        
        $type->setObject($this);     
        return $type;
    }

        /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     */
    public function postSave(\Symfony\Component\Form\Form $form, $em)
    {
        $tech=  $this->getIdLocalLoopExtremityTech();
        $tech->setIdPop($this->getIdPop());        
        $tech->setIdProvider($this->getIdProvider());   
        $tech->setIdCustomer($this->getIdCustomer());           
        $tech->setIdLocalLoopExtremityOwner($this->getIdLocalLoopExtremityOwner());  
        
        if ($this->getIdPop()!=NULL)
        {
            $found=false;
            $techContact=null;
            $cpt=0;
            foreach ($this->getIdPop()->getTechnicalContacts() as $contact)
            {
                $techContact=$contact;            
                if ($contact->getBlDefault())
                {                
                    $found=true;
                    break;
                }                
                $cpt++;
            } 
            if ($found || $cpt==1)
               $tech->setIdTechnicalContactPop( $techContact);   
        }
        if ($this->getIdProvider()!=NULL)
        {
            $found=false;
            $techContact=null;
            $cpt=0;
            foreach ($this->getIdProvider()->getTechnicalContacts() as $contact)
            {
                $techContact=$contact;            
                if ($contact->getBlDefault())
                {                
                    $found=true;
                    break;
                }                
                $cpt++;
            } 
            if ($found || $cpt==1)
               $tech->setIdTechnicalContactProvider( $techContact);   
        }
        if ($this->getIdCustomer()!=NULL)
        {
            $found=false;
            $techContact=null;
            $cpt=0;
            foreach ($this->getIdCustomer()->getTechnicalContacts() as $contact)
            {
                $techContact=$contact;            
                if ($contact->getBlDefault())
                {                
                    $found=true;
                    break;
                }                
                $cpt++;
            } 
            if ($found || $cpt==1)
                   $tech->setIdTechnicalContact( $techContact);   
        }        
       
        $em->persist($tech);
        $em->flush();
    }       

    /**
     * Get idLocalLoopExtremity
     *
     * @return integer 
     */
    public function getIdLocalLoopExtremity()
    {
        return $this->idLocalLoopExtremity;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return LocalLoopExtremity
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set dtOldTerminate
     *
     * @param \DateTime $dtOldTerminate
     * @return LocalLoopExtremity
     */
    public function setDtOldTerminate($dtOldTerminate)
    {
        $this->dtOldTerminate = $dtOldTerminate;
    
        return $this;
    }

    /**
     * Get dtOldTerminate
     *
     * @return \DateTime 
     */
    public function getDtOldTerminate()
    {
        return $this->dtOldTerminate;
    }

    /**
     * Set dtInitTransfer
     *
     * @param \DateTime $dtInitTransfer
     * @return LocalLoopExtremity
     */
    public function setDtInitTransfer($dtInitTransfer)
    {
        $this->dtInitTransfer = $dtInitTransfer;
    
        return $this;
    }

    /**
     * Get dtInitTransfer
     *
     * @return \DateTime 
     */
    public function getDtInitTransfer()
    {
        return $this->dtInitTransfer;
    }

    /**
     * Set dtRequestTransfer
     *
     * @param \DateTime $dtRequestTransfer
     * @return LocalLoopExtremity
     */
    public function setDtRequestTransfer($dtRequestTransfer)
    {
        $this->dtRequestTransfer = $dtRequestTransfer;
    
        return $this;
    }

    /**
     * Get dtRequestTransfer
     *
     * @return \DateTime 
     */
    public function getDtRequestTransfer()
    {
        return $this->dtRequestTransfer;
    }

    /**
     * Set dtScheduleDelivery
     *
     * @param \DateTime $dtScheduleDelivery
     * @return LocalLoopExtremity
     */
    public function setDtScheduleDelivery($dtScheduleDelivery)
    {
        $this->dtScheduleDelivery = $dtScheduleDelivery;
    
        return $this;
    }

    /**
     * Get dtScheduleDelivery
     *
     * @return \DateTime 
     */
    public function getDtScheduleDelivery()
    {
        return $this->dtScheduleDelivery;
    }

    /**
     * Set dtTransferRealDelivery
     *
     * @param \DateTime $dtTransferRealDelivery
     * @return LocalLoopExtremity
     */
    public function setDtTransferRealDelivery($dtTransferRealDelivery)
    {
        $this->dtTransferRealDelivery = $dtTransferRealDelivery;
    
        return $this;
    }

    /**
     * Get dtTransferRealDelivery
     *
     * @return \DateTime 
     */
    public function getDtTransferRealDelivery()
    {
        return $this->dtTransferRealDelivery;
    }

    /**
     * Set dtTransferComplete
     *
     * @param \DateTime $dtTransferComplete
     * @return LocalLoopExtremity
     */
    public function setDtTransferComplete($dtTransferComplete)
    {
        $this->dtTransferComplete = $dtTransferComplete;
    
        return $this;
    }

    /**
     * Get dtTransferComplete
     *
     * @return \DateTime 
     */
    public function getDtTransferComplete()
    {
        return $this->dtTransferComplete;
    }

    /**
     * Set cdLocalLoopExtremityRef
     *
     * @param string $cdLocalLoopExtremityRef
     * @return LocalLoopExtremity
     */
    public function setCdLocalLoopExtremityRef($cdLocalLoopExtremityRef)
    {
        $this->cdLocalLoopExtremityRef = $cdLocalLoopExtremityRef;
    
        return $this;
    }

    /**
     * Get cdLocalLoopExtremityRef
     *
     * @return string 
     */
    public function getCdLocalLoopExtremityRef()
    {
        return $this->cdLocalLoopExtremityRef;
    }

    /**
     * Set lbTrader
     *
     * @param string $lbTrader
     * @return LocalLoopExtremity
     */
    public function setLbTrader($lbTrader)
    {
        $this->lbTrader = $lbTrader;
    
        return $this;
    }

    /**
     * Get lbTrader
     *
     * @return string 
     */
    public function getLbTrader()
    {
        return $this->lbTrader;
    }

    /**
     * Set llExtremity
     *
     * @param string $llExtremity
     * @return LocalLoopExtremity
     */
    public function setLlExtremity($llExtremity)
    {
        $this->llExtremity = $llExtremity;
    
        return $this;
    }

    /**
     * Get llExtremity
     *
     * @return string 
     */
    public function getLlExtremity()
    {
        return $this->llExtremity;
    }

    /**
     * Set dtPtt
     *
     * @param \DateTime $dtPtt
     * @return LocalLoopExtremity
     */
    public function setDtPtt($dtPtt)
    {
        $this->dtPtt = $dtPtt;
    
        return $this;
    }

    /**
     * Get dtPtt
     *
     * @return \DateTime 
     */
    public function getDtPtt()
    {
        return $this->dtPtt;
    }

    /**
     * Set dtOrdreRacc
     *
     * @param \DateTime $dtOrdreRacc
     * @return LocalLoopExtremity
     */
    public function setDtOrdreRacc($dtOrdreRacc)
    {
        $this->dtOrdreRacc = $dtOrdreRacc;
    
        return $this;
    }

    /**
     * Get dtOrdreRacc
     *
     * @return \DateTime 
     */
    public function getDtOrdreRacc()
    {
        return $this->dtOrdreRacc;
    }

    /**
     * Set dtFinTech
     *
     * @param \DateTime $dtFinTech
     * @return LocalLoopExtremity
     */
    public function setDtFinTech($dtFinTech)
    {
        $this->dtFinTech = $dtFinTech;
    
        return $this;
    }

    /**
     * Get dtFinTech
     *
     * @return \DateTime 
     */
    public function getDtFinTech()
    {
        return $this->dtFinTech;
    }

    /**
     * Set nbChrono
     *
     * @param string $nbChrono
     * @return LocalLoopExtremity
     */
    public function setNbChrono($nbChrono)
    {
        $this->nbChrono = $nbChrono;
    
        return $this;
    }

    /**
     * Get nbChrono
     *
     * @return string 
     */
    public function getNbChrono()
    {
        return $this->nbChrono;
    }

    /**
     * Set blOld
     *
     * @param boolean $blOld
     * @return LocalLoopExtremity
     */
    public function setBlOld($blOld)
    {
        $this->blOld = $blOld;
    
        return $this;
    }

    /**
     * Get blOld
     *
     * @return boolean 
     */
    public function getBlOld()
    {
        return $this->blOld;
    }

    /**
     * Set lbSiret
     *
     * @param string $lbSiret
     * @return LocalLoopExtremity
     */
    public function setLbSiret($lbSiret)
    {
        $this->lbSiret = $lbSiret;
    
        return $this;
    }

    /**
     * Get lbSiret
     *
     * @return string 
     */
    public function getLbSiret()
    {
        return $this->lbSiret;
    }

    /**
     * Set lbLsAccount
     *
     * @param string $lbLsAccount
     * @return LocalLoopExtremity
     */
    public function setLbLsAccount($lbLsAccount)
    {
        $this->lbLsAccount = $lbLsAccount;
    
        return $this;
    }

    /**
     * Get lbLsAccount
     *
     * @return string 
     */
    public function getLbLsAccount()
    {
        return $this->lbLsAccount;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return LocalLoopExtremity
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idAddressPop
     *
     * @param \Etrali\GinangBundle\Entity\AddressPop $idAddressPop
     * @return LocalLoopExtremity
     */
    public function setIdAddressPop(\Etrali\GinangBundle\Entity\AddressPop $idAddressPop = null)
    {
        $this->idAddressPop = $idAddressPop;
    
        return $this;
    }

    /**
     * Get idAddressPop
     *
     * @return \Etrali\GinangBundle\Entity\AddressPop 
     */
    public function getIdAddressPop()
    {
        return $this->idAddressPop;
    }

    /**
     * Set idContactPop
     *
     * @param \Etrali\GinangBundle\Entity\ContactPop $idContactPop
     * @return LocalLoopExtremity
     */
    public function setIdContactPop(\Etrali\GinangBundle\Entity\ContactPop $idContactPop = null)
    {
        $this->idContactPop = $idContactPop;
    
        return $this;
    }

    /**
     * Get idContactPop
     *
     * @return \Etrali\GinangBundle\Entity\ContactPop 
     */
    public function getIdContactPop()
    {
        return $this->idContactPop;
    }

    /**
     * Set idLocalLoopExtremityOwner
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idLocalLoopExtremityOwner
     * @return LocalLoopExtremity
     */
    public function setIdLocalLoopExtremityOwner(\Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idLocalLoopExtremityOwner = null)
    {
        $this->idLocalLoopExtremityOwner = $idLocalLoopExtremityOwner;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityOwner
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner 
     */
    public function getIdLocalLoopExtremityOwner()
    {
        return $this->idLocalLoopExtremityOwner;
    }

    /**
     * Set idAccess
     *
     * @param \Etrali\GinangBundle\Entity\Access $idAccess
     * @return LocalLoopExtremity
     */
    public function setIdAccess(\Etrali\GinangBundle\Entity\Access $idAccess = null)
    {
        $this->idAccess = $idAccess;
    
        return $this;
    }

    /**
     * Get idAccess
     *
     * @return \Etrali\GinangBundle\Entity\Access 
     */
    public function getIdAccess()
    {
        return $this->idAccess;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return LocalLoopExtremity
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idAdminContact
     *
     * @param \Etrali\GinangBundle\Entity\Contact $idAdminContact
     * @return LocalLoopExtremity
     */
    public function setIdAdminContact(\Etrali\GinangBundle\Entity\Contact $idAdminContact = null)
    {
        $this->idAdminContact = $idAdminContact;
    
        return $this;
    }

    /**
     * Get idAdminContact
     *
     * @return \Etrali\GinangBundle\Entity\Contact 
     */
    public function getIdAdminContact()
    {
        return $this->idAdminContact;
    }

    /**
     * Set idDeliveryAddress
     *
     * @param \Etrali\GinangBundle\Entity\Address $idDeliveryAddress
     * @return LocalLoopExtremity
     */
    public function setIdDeliveryAddress(\Etrali\GinangBundle\Entity\Address $idDeliveryAddress = null)
    {
        $this->idDeliveryAddress = $idDeliveryAddress;
    
        return $this;
    }

    /**
     * Get idDeliveryAddress
     *
     * @return \Etrali\GinangBundle\Entity\Address 
     */
    public function getIdDeliveryAddress()
    {
        return $this->idDeliveryAddress;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return LocalLoopExtremity
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idAddressProvider
     *
     * @param \Etrali\GinangBundle\Entity\AddressProvider $idAddressProvider
     * @return LocalLoopExtremity
     */
    public function setIdAddressProvider(\Etrali\GinangBundle\Entity\AddressProvider $idAddressProvider = null)
    {
        $this->idAddressProvider = $idAddressProvider;
    
        return $this;
    }

    /**
     * Get idAddressProvider
     *
     * @return \Etrali\GinangBundle\Entity\AddressProvider 
     */
    public function getIdAddressProvider()
    {
        return $this->idAddressProvider;
    }

    /**
     * Set idContactProvider
     *
     * @param \Etrali\GinangBundle\Entity\ContactProvider $idContactProvider
     * @return LocalLoopExtremity
     */
    public function setIdContactProvider(\Etrali\GinangBundle\Entity\ContactProvider $idContactProvider = null)
    {
        $this->idContactProvider = $idContactProvider;
    
        return $this;
    }

    /**
     * Get idContactProvider
     *
     * @return \Etrali\GinangBundle\Entity\ContactProvider 
     */
    public function getIdContactProvider()
    {
        return $this->idContactProvider;
    }

    /**
     * Set idTechnicalContact
     *
     * @param \Etrali\GinangBundle\Entity\Contact $idTechnicalContact
     * @return LocalLoopExtremity
     */
    public function setIdTechnicalContact(\Etrali\GinangBundle\Entity\Contact $idTechnicalContact = null)
    {
        $this->idTechnicalContact = $idTechnicalContact;
    
        return $this;
    }

    /**
     * Get idTechnicalContact
     *
     * @return \Etrali\GinangBundle\Entity\Contact 
     */
    public function getIdTechnicalContact()
    {
        return $this->idTechnicalContact;
    }

    /**
     * Set idOldExtremity
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $idOldExtremity
     * @return LocalLoopExtremity
     */
    public function setIdOldExtremity(\Etrali\GinangBundle\Entity\LocalLoopExtremity $idOldExtremity = null)
    {
        $this->idOldExtremity = $idOldExtremity;
    
        return $this;
    }

    /**
     * Get idOldExtremity
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremity 
     */
    public function getIdOldExtremity()
    {
        return $this->idOldExtremity;
    }

    /**
     * Set idLocalLoop
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop
     * @return LocalLoopExtremity
     */
    public function setIdLocalLoop(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop = null)
    {
        $this->idLocalLoop = $idLocalLoop;
    
        return $this;
    }

    /**
     * Get idLocalLoop
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoop()
    {
        return $this->idLocalLoop;
    }

    /**
     * Set idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return LocalLoopExtremity
     */
    public function setIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech = null)
    {
        $this->idLocalLoopExtremityTech = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityTech 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }

    /**
     * Set idLocalLoopExtremitySide
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremitySide $idLocalLoopExtremitySide
     * @return LocalLoopExtremity
     */
    public function setIdLocalLoopExtremitySide(\Etrali\GinangBundle\Entity\LocalLoopExtremitySide $idLocalLoopExtremitySide = null)
    {
        $this->idLocalLoopExtremitySide = $idLocalLoopExtremitySide;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremitySide
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremitySide 
     */
    public function getIdLocalLoopExtremitySide()
    {
        return $this->idLocalLoopExtremitySide;
    }

    /**
     * Set idLocalLoopExtremitySituation
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremitySituation $idLocalLoopExtremitySituation
     * @return LocalLoopExtremity
     */
    public function setIdLocalLoopExtremitySituation(\Etrali\GinangBundle\Entity\LocalLoopExtremitySituation $idLocalLoopExtremitySituation = null)
    {
        $this->idLocalLoopExtremitySituation = $idLocalLoopExtremitySituation;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremitySituation
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremitySituation 
     */
    public function getIdLocalLoopExtremitySituation()
    {
        return $this->idLocalLoopExtremitySituation;
    }

    /**
     * Set blTransfered
     *
     * @param boolean $blTransfered
     * @return LocalLoopExtremity
     */
    public function setBlTransfered($blTransfered)
    {
        $this->blTransfered = $blTransfered;
    
        return $this;
    }

    /**
     * Get blTransfered
     *
     * @return boolean 
     */
    public function getBlTransfered()
    {
        return $this->blTransfered;
    }

    /**
     * Set blTransferred
     *
     * @param boolean $blTransferred
     * @return LocalLoopExtremity
     */
    public function setBlTransferred($blTransferred)
    {
        $this->blTransferred = $blTransferred;
    
        return $this;
    }

    /**
     * Get blTransferred
     *
     * @return boolean 
     */
    public function getBlTransferred()
    {
        return $this->blTransferred;
    }
        
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdLocalLoop()!=null)
            return $this->getIdLocalLoop()->getIdBranch();
        return NULL;
    }
}