<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoop
 *
 * @ORM\Table(name="local_loop_extremity_additional")
 * @ORM\Entity
 */
class LocalLoopExtremityAdditional
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop_extremity_additional", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLocalLoopExtremityAdditional;

    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop", referencedColumnName="id_local_loop")
     * })
     */
    private $idLocalLoop;     
    
    
    
    /**
     * @var \Ts
     *
     * @ORM\OneToMany(targetEntity="Ts",mappedBy="idLocalLoopExtremityAdditional",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idTs;
    
        /**
     * @var \Vlan
     *
     * @ORM\OneToOne(targetEntity="Vlan", inversedBy="idLocalLoopExtremityAdditional")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_vlan", referencedColumnName="id_vlan")
     * })
     */
    private $idVlan;    
    
    /**
     * @var \PortInstance
     *
     * @ORM\ManyToOne(targetEntity="PortInstance", inversedBy="idLocalLoopExtremityAdditional")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_instance", referencedColumnName="id_port_instance")
     * })
     */
    private $idPortInstance;   
    
    
    /**
     * @var string
     *
     * @ORM\Column(name="id_connection_path", type="string", length=1000, nullable=true)
     */
    private $idConnectionPath;   
    
    /**
     * @var \ServiceExtremityTech
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremityTech", inversedBy="idLocalLoopExtremityAdditional", cascade={"persist"})
     * @ORM\JoinColumns({
     *      @ORM\JoinColumn(name="id_service_extremity_tech", referencedColumnName="id_service_extremity_tech")
     * })
     */
    private $idServiceExtremityTech;
    
    /**
     * 
     * @return type
     */
    public function __toString()
    {
        return $this->getIdLocalLoopExtremityAdditional()."";
    }
    
    
    /**
     * 
     */
    public function getCollections()
    {     
    }  
    
    /**
     * 
     * @param type $type
     */
    public function getEditType($type)
    {     
    }
    
    /**
     * 
     * @return null
     */  
    public function getParentBranch() 
    { 
        return NULL;       
    }        
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idTs = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idLocalLoopExtremityAdditional
     *
     * @return integer 
     */
    public function getIdLocalLoopExtremityAdditional()
    {
        return $this->idLocalLoopExtremityAdditional;
    }

    /**
     * Set idConnectionPath
     *
     * @param string $idConnectionPath
     * @return LocalLoopExtremityAdditional
     */
    public function setIdConnectionPath($idConnectionPath)
    {
        $this->idConnectionPath = $idConnectionPath;
    
        return $this;
    }

    /**
     * Get idConnectionPath
     *
     * @return string 
     */
    public function getIdConnectionPath()
    {
        return $this->idConnectionPath;
    }

    /**
     * Set idLocalLoop
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop
     * @return LocalLoopExtremityAdditional
     */
    public function setIdLocalLoop(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop = null)
    {
        $this->idLocalLoop = $idLocalLoop;
    
        return $this;
    }

    /**
     * Get idLocalLoop
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoop()
    {
        return $this->idLocalLoop;
    }



    /**
     * Add idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     * @return LocalLoopExtremityAdditional
     */
    public function addIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs[] = $idTs;
    
        return $this;
    }

    /**
     * Remove idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     */
    public function removeIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs->removeElement($idTs);
    }

    /**
     * Get idTs
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdTs()
    {
        return $this->idTs;
    }

    /**
     * Set idVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idVlan
     * @return LocalLoopExtremityAdditional
     */
    public function setIdVlan(\Etrali\GinangBundle\Entity\Vlan $idVlan = null)
    {
        $this->idVlan = $idVlan;
    
        return $this;
    }

    /**
     * Get idVlan
     *
     * @return \Etrali\GinangBundle\Entity\Vlan 
     */
    public function getIdVlan()
    {
        return $this->idVlan;
    }

    /**
     * Set idPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idPortInstance
     * @return LocalLoopExtremityAdditional
     */
    public function setIdPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idPortInstance = null)
    {
        $this->idPortInstance = $idPortInstance;
    
        return $this;
    }

    /**
     * Get idPortInstance
     *
     * @return \Etrali\GinangBundle\Entity\PortInstance 
     */
    public function getIdPortInstance()
    {
        return $this->idPortInstance;
    }

    /**
     * Set idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return LocalLoopExtremityAdditional
     */
    public function setIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech = null)
    {
        $this->idServiceExtremityTech = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremityTech 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }
}