<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoopExtremityTech
 *
 * @ORM\Table(name="local_loop_extremity_tech")
 * @ORM\Entity
 */
class LocalLoopExtremityTech
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop_extremity_tech", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLocalLoopExtremityTech;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="text", nullable=true)
     */
    private $cmComment;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_ll_tested", type="datetime", nullable=true)
     */
    private $dtLlTested;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_old_ll_tested", type="datetime", nullable=true)
     */
    private $dtOldLlTested;    


    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="Contact")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_technical_contact", referencedColumnName="id_contact")
     * })
     */
    private $idTechnicalContact;
    
    /**
     * @var \ContactProvider
     *
     * @ORM\ManyToOne(targetEntity="ContactProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_technical_contact_provider", referencedColumnName="id_contact_provider")
     * })
     */
    private $idTechnicalContactProvider; 
    
    /**
     * @var \ContactPop
     *
     * @ORM\ManyToOne(targetEntity="ContactPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_technical_contact_pop", referencedColumnName="id_contact_pop")
     * })
     */
    private $idTechnicalContactPop;     
    
    /**
     * @var \Ts
     *
     * @ORM\OneToMany(targetEntity="Ts",mappedBy="idInLocalLoopExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idTs;
    
        /**
     * @var \Vlan
     *
     * @ORM\OneToOne(targetEntity="Vlan", mappedBy="idInLocalLoopExtremityTech")
     */
    private $idVlan;    
    
    /**
     * @var \PortInstance
     *
     * @ORM\ManyToOne(targetEntity="PortInstance", inversedBy="idInLocalLoopExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_instance", referencedColumnName="id_port_instance")
     * })
     */
    private $idPortInstance;   
    
        /**
     * @var string
     *
     * @ORM\Column(name="lb_connection_path", type="string", length=1000, nullable=true)
     */
    private $lbConnectionPath;
    
    /**
     * @ORM\OneToMany(targetEntity="Ts", mappedBy="idLocalLoopExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutTs;
    
    /**
     * @var \PortInstance
     *
     * @ORM\OneToMany(targetEntity="PortInstance", mappedBy="idLocalLoopExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutPortInstance;      

    /**
     * @ORM\OneToMany(targetEntity="Vlan", mappedBy="idLocalLoopExtremityTech",cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutVlan;
    
    /**
     * @var \ConnectionPath
     *
     * @ORM\OneToMany(targetEntity="ConnectionPath", mappedBy="idLocalLoopExtremityTech" ,cascade={"persist","remove"}, orphanRemoval=true)
     */
    private $idOutConnectionPath;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_racc", type="datetime", nullable=true)
     */
    private $dtRacc;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_fin_tech", type="datetime", nullable=true)
     */
    private $dtFinTech;


    /**
     * @var string
     *
     * @ORM\Column(name="constit1", type="string", length=10, nullable=true)
     */
    private $constit1;

    /**
     * @var string
     *
     * @ORM\Column(name="constit_reception", type="string", length=10, nullable=true)
     */
    private $constitReception;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_constit", type="datetime", nullable=true)
     */
    private $dtConstit;

    /**
     * @var string
     *
     * @ORM\Column(name="equipement", type="string", length=100, nullable=true)
     */
    private $equipement;

    /**
     * @var string
     *
     * @ORM\Column(name="carte_nature", type="string", length=100, nullable=true)
     */
    private $carteNature;

    /**
     * @var string
     *
     * @ORM\Column(name="nombre_it", type="string", length=100, nullable=true)
     */
    private $nombreIt;

    /**
     * @var boolean
     *
     * @ORM\Column(name="raccordement", type="boolean", nullable=true)
     */
    private $raccordement;

    /**
     * @var string
     *
     * @ORM\Column(name="penetration", type="string", length=45, nullable=true)
     */
    private $penetration;

    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop", inversedBy="idLocalLoopExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop", referencedColumnName="id_local_loop")
     * })
     */    
    private $idLocalLoop;
    
    /**
     * @var \LocalLoopExtremity
     *
     * @ORM\OneToOne(targetEntity="LocalLoopExtremity", inversedBy="idLocalLoopExtremityTech")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity", referencedColumnName="id_local_loop_extremity")
     * })
     */    
    private $idLocalLoopExtremity; 
    
    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer", referencedColumnName="id_customer")
     * })
     */
    private $idCustomer;
    
    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;
    
    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;
    
    /**
     * @var \LocalLoopExtremityOwner
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityOwner")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_owner", referencedColumnName="id_local_loop_extremity_owner")
     * })
     */
    private $idLocalLoopExtremityOwner;   
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old", type="boolean", nullable=true)
     */
    private $blOld=false;  
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_transferred", type="boolean", nullable=true)
     */
    private $blTransferred=false;   
      
    

    public function __toString() {
        return $this->getIdLocalLoopExtremity()!=NULL?$this->getIdLocalLoopExtremity()->getCdLocalLoopExtremityRef()."":$this->getIdLocalLoopExtremityTech()."";
    }
    
    public function getHeadInfo()
    {
        $lbparent="";
      
        if ($this->getIdLocalLoopExtremityOwner()!=NULL)
        {          
            switch ($this->getIdLocalLoopExtremity()->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner())
            {
                case 1:
                    $lbparent=$this->getIdLocalLoopExtremity()->getIdCustomer()!=NULL?$this->getIdLocalLoopExtremity()->getIdCustomer():"";                              
                break;
                case 2:
                    $lbparent=$this->getIdLocalLoopExtremity()->getIdPop()!=NULL?$this->getIdLocalLoopExtremity()->getIdPop():""; 
                break;
                case 3:
                    $lbparent=$this->getIdLocalLoopExtremity()->getIdProvider()!=NULL?$this->getIdLocalLoopExtremity()->getIdProvider():"";                                              
                break;        
            }    
        }
            $path=$this->getIdPortInstance()!=NULL?\Etrali\GinangBundle\EtraliGinangBundle::getUnlinkedConnectionPath($this->getLbConnectionPath(), $this->getIdPortInstance()):"";
            return "<td>".$this->getIdLocalLoopExtremity()->getCdLocalLoopExtremityRef()."</td><td>".$lbparent."</td><td>".($this->getDtLlTested()?$this->getDtLlTested()->format("d/m/Y"):"&nbsp;")."</td><td>".$path."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Extremity Ref</th><th>Customer/Provider/Pop</th><th>LL tested date</th><th>Incoming connection path</th>";
    }  
    
    public function getEditType($type)
    {
        $idtrans=$this->getIdLocalLoop()->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdLocalLoop()->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans);  
        $type->setOld($this->getIdLocalLoop()->getIdTransferExtremity()!=NULL &&  $this->getIdLocalLoop()->getIdTransferExtremity()->getIdOldExtremity()->getIdLocalLoopExtremity()==$this->getIdLocalLoopExtremity()->getIdLocalLoopExtremity());        
        $type->setTransfer($this->getIdLocalLoop()->getIdTransferExtremity()!=NULL &&  $this->getIdLocalLoop()->getIdTransferExtremity()->getIdLocalLoopExtremity()==$this->getIdLocalLoopExtremity()->getIdLocalLoopExtremity());                
        $type->setObject($this);           
        return $type;
    }
   
    public function hasTsByNumber($number)
    {
        foreach ($this->getIdTs() as $bbts) {
            if ($bbts->getNbTs() == $number)
                return true;
        }
        return false;
    }
    
    public function hasOutTsByNumber($number)
    {
        foreach ($this->getIdOutTs() as $bbts) {
            if ($bbts->getNbTs() == $number)
                return true;
        }
        return false;
    } 
    
    public function hasOutVlan($vlanref)
    {
        foreach ($this->getIdOutVlan() as $vlan)
        {
            if ($vlan->getLbVlan()==$vlanref)
                return true;
        }
        return false;
    }
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdLocalLoop()!=null)
            return $this->getIdLocalLoop()->getIdBranch();
        return NULL;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idOutTs = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idOutPortInstance = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idOutVlan = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idServiceExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idLocalLoopExtremityTech
     *
     * @return integer 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return LocalLoopExtremityTech
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set dtLlTested
     *
     * @param \DateTime $dtLlTested
     * @return LocalLoopExtremityTech
     */
    public function setDtLlTested($dtLlTested)
    {
        $this->dtLlTested = $dtLlTested;
    
        return $this;
    }

    /**
     * Get dtLlTested
     *
     * @return \DateTime 
     */
    public function getDtLlTested()
    {
        return $this->dtLlTested;
    }

    /**
     * Set dtOldLlTested
     *
     * @param \DateTime $dtOldLlTested
     * @return LocalLoopExtremityTech
     */
    public function setDtOldLlTested($dtOldLlTested)
    {
        $this->dtOldLlTested = $dtOldLlTested;
    
        return $this;
    }

    /**
     * Get dtOldLlTested
     *
     * @return \DateTime 
     */
    public function getDtOldLlTested()
    {
        return $this->dtOldLlTested;
    }

    /**
     * Set lbConnectionPath
     *
     * @param string $lbConnectionPath
     * @return LocalLoopExtremityTech
     */
    public function setLbConnectionPath($lbConnectionPath)
    {
        $this->lbConnectionPath = $lbConnectionPath;
    
        return $this;
    }

    /**
     * Get lbConnectionPath
     *
     * @return string 
     */
    public function getLbConnectionPath()
    {
        return $this->lbConnectionPath;
    }

    /**
     * Set lbOutConnectionPath
     *
     * @param string $lbOutConnectionPath
     * @return LocalLoopExtremityTech
     */
    public function setLbOutConnectionPath($lbOutConnectionPath)
    {
        $this->lbOutConnectionPath = $lbOutConnectionPath;
    
        return $this;
    }

    /**
     * Get lbOutConnectionPath
     *
     * @return string 
     */
    public function getLbOutConnectionPath()
    {
        return $this->lbOutConnectionPath;
    }

    /**
     * Set dtRacc
     *
     * @param \DateTime $dtRacc
     * @return LocalLoopExtremityTech
     */
    public function setDtRacc($dtRacc)
    {
        $this->dtRacc = $dtRacc;
    
        return $this;
    }

    /**
     * Get dtRacc
     *
     * @return \DateTime 
     */
    public function getDtRacc()
    {
        return $this->dtRacc;
    }

    /**
     * Set dtFinTech
     *
     * @param \DateTime $dtFinTech
     * @return LocalLoopExtremityTech
     */
    public function setDtFinTech($dtFinTech)
    {
        $this->dtFinTech = $dtFinTech;
    
        return $this;
    }

    /**
     * Get dtFinTech
     *
     * @return \DateTime 
     */
    public function getDtFinTech()
    {
        return $this->dtFinTech;
    }

    /**
     * Set constit1
     *
     * @param string $constit1
     * @return LocalLoopExtremityTech
     */
    public function setConstit1($constit1)
    {
        $this->constit1 = $constit1;
    
        return $this;
    }

    /**
     * Get constit1
     *
     * @return string 
     */
    public function getConstit1()
    {
        return $this->constit1;
    }

    /**
     * Set constitReception
     *
     * @param string $constitReception
     * @return LocalLoopExtremityTech
     */
    public function setConstitReception($constitReception)
    {
        $this->constitReception = $constitReception;
    
        return $this;
    }

    /**
     * Get constitReception
     *
     * @return string 
     */
    public function getConstitReception()
    {
        return $this->constitReception;
    }

    /**
     * Set dtConstit
     *
     * @param \DateTime $dtConstit
     * @return LocalLoopExtremityTech
     */
    public function setDtConstit($dtConstit)
    {
        $this->dtConstit = $dtConstit;
    
        return $this;
    }

    /**
     * Get dtConstit
     *
     * @return \DateTime 
     */
    public function getDtConstit()
    {
        return $this->dtConstit;
    }

    /**
     * Set equipement
     *
     * @param string $equipement
     * @return LocalLoopExtremityTech
     */
    public function setEquipement($equipement)
    {
        $this->equipement = $equipement;
    
        return $this;
    }

    /**
     * Get equipement
     *
     * @return string 
     */
    public function getEquipement()
    {
        return $this->equipement;
    }

    /**
     * Set carteNature
     *
     * @param string $carteNature
     * @return LocalLoopExtremityTech
     */
    public function setCarteNature($carteNature)
    {
        $this->carteNature = $carteNature;
    
        return $this;
    }

    /**
     * Get carteNature
     *
     * @return string 
     */
    public function getCarteNature()
    {
        return $this->carteNature;
    }

    /**
     * Set nombreIt
     *
     * @param string $nombreIt
     * @return LocalLoopExtremityTech
     */
    public function setNombreIt($nombreIt)
    {
        $this->nombreIt = $nombreIt;
    
        return $this;
    }

    /**
     * Get nombreIt
     *
     * @return string 
     */
    public function getNombreIt()
    {
        return $this->nombreIt;
    }

    /**
     * Set raccordement
     *
     * @param boolean $raccordement
     * @return LocalLoopExtremityTech
     */
    public function setRaccordement($raccordement)
    {
        $this->raccordement = $raccordement;
    
        return $this;
    }

    /**
     * Get raccordement
     *
     * @return boolean 
     */
    public function getRaccordement()
    {
        return $this->raccordement;
    }

    /**
     * Set penetration
     *
     * @param string $penetration
     * @return LocalLoopExtremityTech
     */
    public function setPenetration($penetration)
    {
        $this->penetration = $penetration;
    
        return $this;
    }

    /**
     * Get penetration
     *
     * @return string 
     */
    public function getPenetration()
    {
        return $this->penetration;
    }

    /**
     * Set blOld
     *
     * @param boolean $blOld
     * @return LocalLoopExtremityTech
     */
    public function setBlOld($blOld)
    {
        $this->blOld = $blOld;
    
        return $this;
    }

    /**
     * Get blOld
     *
     * @return boolean 
     */
    public function getBlOld()
    {
        return $this->blOld;
    }

    /**
     * Set blTransferred
     *
     * @param boolean $blTransferred
     * @return LocalLoopExtremityTech
     */
    public function setBlTransferred($blTransferred)
    {
        $this->blTransferred = $blTransferred;
    
        return $this;
    }

    /**
     * Get blTransferred
     *
     * @return boolean 
     */
    public function getBlTransferred()
    {
        return $this->blTransferred;
    }

    /**
     * Set idTechnicalContact
     *
     * @param \Etrali\GinangBundle\Entity\Contact $idTechnicalContact
     * @return LocalLoopExtremityTech
     */
    public function setIdTechnicalContact(\Etrali\GinangBundle\Entity\Contact $idTechnicalContact = null)
    {
        $this->idTechnicalContact = $idTechnicalContact;
    
        return $this;
    }

    /**
     * Get idTechnicalContact
     *
     * @return \Etrali\GinangBundle\Entity\Contact 
     */
    public function getIdTechnicalContact()
    {
        return $this->idTechnicalContact;
    }

    /**
     * Set idTechnicalContactProvider
     *
     * @param \Etrali\GinangBundle\Entity\ContactProvider $idTechnicalContactProvider
     * @return LocalLoopExtremityTech
     */
    public function setIdTechnicalContactProvider(\Etrali\GinangBundle\Entity\ContactProvider $idTechnicalContactProvider = null)
    {
        $this->idTechnicalContactProvider = $idTechnicalContactProvider;
    
        return $this;
    }

    /**
     * Get idTechnicalContactProvider
     *
     * @return \Etrali\GinangBundle\Entity\ContactProvider 
     */
    public function getIdTechnicalContactProvider()
    {
        return $this->idTechnicalContactProvider;
    }

    /**
     * Set idTechnicalContactPop
     *
     * @param \Etrali\GinangBundle\Entity\ContactPop $idTechnicalContactPop
     * @return LocalLoopExtremityTech
     */
    public function setIdTechnicalContactPop(\Etrali\GinangBundle\Entity\ContactPop $idTechnicalContactPop = null)
    {
        $this->idTechnicalContactPop = $idTechnicalContactPop;
    
        return $this;
    }

    /**
     * Get idTechnicalContactPop
     *
     * @return \Etrali\GinangBundle\Entity\ContactPop 
     */
    public function getIdTechnicalContactPop()
    {
        return $this->idTechnicalContactPop;
    }

    /**
     * Set idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     * @return LocalLoopExtremityTech
     */
    public function setIdTs(\Etrali\GinangBundle\Entity\Ts $idTs = null)
    {
        $this->idTs = $idTs;
    
        return $this;
    }

    /**
     * Get idTs
     *
     * @return \Etrali\GinangBundle\Entity\Ts 
     */
    public function getIdTs()
    {
        return $this->idTs;
    }

    /**
     * Set idVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idVlan
     * @return LocalLoopExtremityTech
     */
    public function setIdVlan(\Etrali\GinangBundle\Entity\Vlan $idVlan = null)
    {
        $this->idVlan = $idVlan;
    
        return $this;
    }

    /**
     * Get idVlan
     *
     * @return \Etrali\GinangBundle\Entity\Vlan 
     */
    public function getIdVlan()
    {
        return $this->idVlan;
    }

    /**
     * Set idPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idPortInstance
     * @return LocalLoopExtremityTech
     */
    public function setIdPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idPortInstance = null)
    {
        $this->idPortInstance = $idPortInstance;
    
        return $this;
    }

    /**
     * Get idPortInstance
     *
     * @return \Etrali\GinangBundle\Entity\PortInstance 
     */
    public function getIdPortInstance()
    {
        return $this->idPortInstance;
    }

    /**
     * Add idOutTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idOutTs
     * @return LocalLoopExtremityTech
     */
    public function addIdOutT(\Etrali\GinangBundle\Entity\Ts $idOutTs)
    {
        $this->idOutTs[] = $idOutTs;
    
        return $this;
    }

    /**
     * Remove idOutTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idOutTs
     */
    public function removeIdOutT(\Etrali\GinangBundle\Entity\Ts $idOutTs)
    {
        $this->idOutTs->removeElement($idOutTs);
    }

    /**
     * Get idOutTs
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutTs()
    {
        return $this->idOutTs;
    }

    /**
     * Add idOutPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance
     * @return LocalLoopExtremityTech
     */
    public function addIdOutPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance)
    {
        $this->idOutPortInstance[] = $idOutPortInstance;
    
        return $this;
    }

    /**
     * Remove idOutPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance
     */
    public function removeIdOutPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idOutPortInstance)
    {
        $this->idOutPortInstance->removeElement($idOutPortInstance);
    }

    /**
     * Get idOutPortInstance
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutPortInstance()
    {
        return $this->idOutPortInstance;
    }

    /**
     * Add idOutVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idOutVlan
     * @return LocalLoopExtremityTech
     */
    public function addIdOutVlan(\Etrali\GinangBundle\Entity\Vlan $idOutVlan)
    {
        $this->idOutVlan[] = $idOutVlan;
    
        return $this;
    }

    /**
     * Remove idOutVlan
     *
     * @param \Etrali\GinangBundle\Entity\Vlan $idOutVlan
     */
    public function removeIdOutVlan(\Etrali\GinangBundle\Entity\Vlan $idOutVlan)
    {
        $this->idOutVlan->removeElement($idOutVlan);
    }

    /**
     * Get idOutVlan
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutVlan()
    {
        return $this->idOutVlan;
    }

    /**
     * Set idLocalLoop
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop
     * @return LocalLoopExtremityTech
     */
    public function setIdLocalLoop(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop = null)
    {
        $this->idLocalLoop = $idLocalLoop;
    
        return $this;
    }

    /**
     * Get idLocalLoop
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoop()
    {
        return $this->idLocalLoop;
    }

    /**
     * Set idLocalLoopExtremity
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity
     * @return LocalLoopExtremityTech
     */
    public function setIdLocalLoopExtremity(\Etrali\GinangBundle\Entity\LocalLoopExtremity $idLocalLoopExtremity = null)
    {
        $this->idLocalLoopExtremity = $idLocalLoopExtremity;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremity
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremity 
     */
    public function getIdLocalLoopExtremity()
    {
        return $this->idLocalLoopExtremity;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return LocalLoopExtremityTech
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return LocalLoopExtremityTech
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return LocalLoopExtremityTech
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idLocalLoopExtremityOwner
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idLocalLoopExtremityOwner
     * @return LocalLoopExtremityTech
     */
    public function setIdLocalLoopExtremityOwner(\Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idLocalLoopExtremityOwner = null)
    {
        $this->idLocalLoopExtremityOwner = $idLocalLoopExtremityOwner;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityOwner
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner 
     */
    public function getIdLocalLoopExtremityOwner()
    {
        return $this->idLocalLoopExtremityOwner;
    }

    /**
     * Add idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return LocalLoopExtremityTech
     */
    public function addIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech[] = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Remove idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     */
    public function removeIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech->removeElement($idServiceExtremityTech);
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->getIdLocalLoop()->getIdServiceExtremityTech();
    }

    /**
     * Add idOutConnectionPath
     *
     * @param \Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath
     * @return LocalLoopExtremityTech
     */
    public function addIdOutConnectionPath(\Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath)
    {
        $this->idOutConnectionPath[] = $idOutConnectionPath;
    
        return $this;
    }

    /**
     * Remove idOutConnectionPath
     *
     * @param \Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath
     */
    public function removeIdOutConnectionPath(\Etrali\GinangBundle\Entity\ConnectionPath $idOutConnectionPath)
    {
        $this->idOutConnectionPath->removeElement($idOutConnectionPath);
    }

    /**
     * Get idOutConnectionPath
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdOutConnectionPath()
    {
        return $this->idOutConnectionPath;
    }

    /**
     * Add idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     * @return LocalLoopExtremityTech
     */
    public function addIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs[] = $idTs;
    
        return $this;
    }

    /**
     * Remove idTs
     *
     * @param \Etrali\GinangBundle\Entity\Ts $idTs
     */
    public function removeIdT(\Etrali\GinangBundle\Entity\Ts $idTs)
    {
        $this->idTs->removeElement($idTs);
    }
}