<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; 
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoopTransactions
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Etrali\GinangBundle\Entity\LocalLoopTransactionsRepository")
 */
class LocalLoopTransactions
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop_transactions", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $idLocalLoopTransactions;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_extremity_ref", type="string", length=45, nullable=true)
     */
    private $cdExtremityRef;
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;
    
    /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;   
    
    /**
     * @var \LocalLoop
     *
     * @ORM\ManyToOne(targetEntity="LocalLoop", inversedBy="idLocalLoopTransactions")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop", referencedColumnName="id_local_loop")
     * })
     */    
    private $idLocalLoop; 
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_operation", type="string", length=45, nullable=true)
     */
    private $lbOperation;     
    
    
    public function getHeadInfo()
    {
            return "<td>".$this->getDtCreate()->format("d/m/Y H:i")."</td><td >".$this->getCdExtremityRef()."</td><td>".$this->getLbOperation()."</td><td>".$this->getIdTransactionType()."</td><td>".$this->getIdTransactionStatus()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Date</th><th>Extremity ref</th><th>Operation</th><th>Transaction type</th><th>Transaction status</th>";
    }   
    
    public function __toString()
    {
        return $this->getDtCreate()->format("d/m/Y H:i")."-".$this->getCdExtremityRef()."-".$this->getIdTransactionType()." : ".$this->getIdTransactionStatus();
    }

    /**
     * Get idLocalLoopTransactions
     *
     * @return integer 
     */
    public function getIdLocalLoopTransactions()
    {
        return $this->idLocalLoopTransactions;
    }


    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return LocalLoopTransactions
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set cdLocalLoop
     *
     * @param string $cdLocalLoop
     * @return LocalLoopTransactions
     */
    public function setCdLocalLoop($cdLocalLoop)
    {
        $this->cdLocalLoop = $cdLocalLoop;
    
        return $this;
    }

    /**
     * Get cdLocalLoop
     *
     * @return string 
     */
    public function getCdLocalLoop()
    {
        return $this->cdLocalLoop;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return LocalLoopTransactions
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return LocalLoopTransactions
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set cdExtremityRef
     *
     * @param string $cdExtremityRef
     * @return LocalLoopTransactions
     */
    public function setCdExtremityRef($cdExtremityRef)
    {
        $this->cdExtremityRef = $cdExtremityRef;
    
        return $this;
    }

    /**
     * Get cdExtremityRef
     *
     * @return string 
     */
    public function getCdExtremityRef()
    {
        return $this->cdExtremityRef;
    }

    /**
     * Set idLocalLoop
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop
     * @return LocalLoopTransactions
     */
    public function setIdLocalLoop(\Etrali\GinangBundle\Entity\LocalLoop $idLocalLoop = null)
    {
        $this->idLocalLoop = $idLocalLoop;
    
        return $this;
    }

    /**
     * Get idLocalLoop
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoop 
     */
    public function getIdLocalLoop()
    {
        return $this->idLocalLoop;
    }

    /**
     * Set lbOperation
     *
     * @param string $lbOperation
     * @return LocalLoopTransactions
     */
    public function setLbOperation($lbOperation)
    {
        $this->lbOperation = $lbOperation;
    
        return $this;
    }

    /**
     * Get lbOperation
     *
     * @return string 
     */
    public function getLbOperation()
    {
        return $this->lbOperation;
    }public function getParentBranch() { return NULL; }  }