<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * MailUser
 *
 * @ORM\Table(name="mail_user")
 * @ORM\Entity
 */
class MailUser
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_mail_user", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idMailUser;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Myuser
     *
     * @ORM\ManyToOne(targetEntity="Myuser", inversedBy="idMailUser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_myuser", referencedColumnName="id")
     * })
     */
    private $idMyuser;
    
    /**
     * @ORM\ManyToMany(targetEntity="Mail")
     * @ORM\JoinTable(name="mail_user_mail",
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_mail", referencedColumnName="id_mail")},
     *      joinColumns={@ORM\JoinColumn(name="id_mail_user", referencedColumnName="id_mail_user")}
     *      )      
     */
    private $idMail;    

    /**
     * @ORM\ManyToMany(targetEntity="Branch")
     * @ORM\JoinTable(name="mail_user_branch",
     *      inverseJoinColumns={@ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")},
     *      joinColumns={@ORM\JoinColumn(name="id_mail_user", referencedColumnName="id_mail_user")}
     *      )     
     */
    private $idBranch;    

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
      
    
    public function getHeadInfo()
    {    
        $chaine= "<td>[";
        foreach ($this->getIdBranch() as $br)
        {
            $chaine.= $br->getLbBranch()." | ";
        }
        $chaine.= "] assigned to [";
        foreach ($this->getIdMail() as $mail)
        {
            $chaine.= $mail->getLbMail()." | ";
        }        
        $chaine .="]</td>";
        return $chaine;
            
    }  
    
    public function getHeadColumns()
    {
        return "<th>Mail</th>";   
    }

    public function __toString()
    {
        return "";
    }
 

    /**
     * Get idMailUser
     *
     * @return integer 
     */
    public function getIdMailUser()
    {
        return $this->idMailUser;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return MailUser
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return MailUser
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idMyuser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idMyuser
     * @return MailUser
     */
    public function setIdMyuser(\Etrali\GinangBundle\Entity\Myuser $idMyuser = null)
    {
        $this->idMyuser = $idMyuser;
    
        return $this;
    }

    /**
     * Get idMyuser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdMyuser()
    {
        return $this->idMyuser;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idMail = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBranch = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idMail
     *
     * @param \Etrali\GinangBundle\Entity\Mail $idMail
     * @return MailUser
     */
    public function addIdMail(\Etrali\GinangBundle\Entity\Mail $idMail)
    {
        $this->idMail[] = $idMail;
    
        return $this;
    }

    /**
     * Remove idMail
     *
     * @param \Etrali\GinangBundle\Entity\Mail $idMail
     */
    public function removeIdMail(\Etrali\GinangBundle\Entity\Mail $idMail)
    {
        $this->idMail->removeElement($idMail);
    }

    /**
     * Get idMail
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdMail()
    {
        return $this->idMail;
    }

    /**
     * Add idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return MailUser
     */
    public function addIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch)
    {
        $this->idBranch[] = $idBranch;
    
        return $this;
    }

    /**
     * Remove idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     */
    public function removeIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch)
    {
        $this->idBranch->removeElement($idBranch);
    }

    /**
     * Get idBranch
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }
}