<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;
use FOS\UserBundle\Entity\User as BaseUser;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
/**
 * User
 *
 * @ORM\Table(name="myuser")
 * @ORM\Entity
 * @UniqueEntity(fields={"email"})
 * @UniqueEntity(fields={"username"})
 */
class Myuser extends BaseUser
{
    /**
     * @var integer
     *  
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;


    /**
     * @var string
     *
     * @ORM\Column(name="lb_firstname", type="string", length=45, nullable=true)
     */
    private $lbFirstname;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_lastname", type="string", length=45, nullable=true)
     */
    private $lbLastname;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_phone", type="string", length=25, nullable=true)
     */
    private $lbPhone;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_mobile", type="string", length=25, nullable=true)
     */
    private $lbMobile;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_fax", type="string", length=25, nullable=true)
     */
    private $lbFax;



    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_creation", type="datetime", nullable=true)
     */
    private $dtCreation;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_modification", type="datetime", nullable=true)
     */
    private $dtModification;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_disconnection", type="datetime", nullable=true)
     */
    private $dtDisconnection;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_sale_manager", type="boolean", nullable=true)
     */
    private $blSaleManager;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_rsc", type="boolean", nullable=true)
     */
    private $blRsc;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_global_account_manager", type="boolean", nullable=true)
     */
    private $blGlobalAccountManager;

    /**
     * @var \Ldap
     *
     * @ORM\ManyToOne(targetEntity="Ldap")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_ldap", referencedColumnName="id_ldap")
     * })
     */
    private $idLdap;
    
        
    /**
     * @var \UserInBranch
     *
     * @ORM\OneToMany(targetEntity="UserInBranch", mappedBy="idMyuser",cascade={"persist","remove"}, orphanRemoval=true )     
     */
    private $idUserInBranch;
    
    /**
     * @var \MailUser
     *
     * @ORM\OneToMany(targetEntity="MailUser", mappedBy="idMyuser",cascade={"persist","remove"}, orphanRemoval=true )     
     */
    private $idMailUser;
    
    private $passwordOriginal;
    

    
    /**
     * Get role
     *
     * @return string
     */
    public function getRole()
    {
        return $this->roles[0];
    }
    
    public static function getAllRoles()
    {
        return array("ROLE_EQUIPMENT_ADMINISTRATOR","ROLE_SUPER_ADMINISTRATOR","ROLE_ENTMC_INDIA", "ROLE_CSC_FRANCE", "ROLE_NETWORK_ACCOUNTING","ROLE_NETWORK_ADMINISTRATOR","ROLE_NETWORK_ENGINEER_ADMIN","ROLE_NETWORK_ENGINEER","ROLE_MARKETING_PRE_SALES","ROLE_SALES_ADMINISTRATOR","ROLE_BACKBONE_LINK_ADMINISTRATOR");
    } 
    
    public function getCollections()
    {      
        return array("Branch"=>"UserInBranch", "Mail"=>"MailUser");        
    } 
    
    public function getIdMyuser()
    {
        return $this->getId();
    }
    
    public function __construct()
    {
        parent::__construct();
        $this->enabled=true;
    }

    /**
     * Set lbLogin
     *
     * @param string $lbLogin
     * @return Myuser
     */
    public function setLbLogin($lbLogin)
    {
        $this->lbLogin = $lbLogin;
    
        return $this;
    }

    /**
     * Get lbLogin
     *
     * @return string 
     */
    public function getLbLogin()
    {
        return $this->lbLogin;
    }

    /**
     * Set lbFirstname
     *
     * @param string $lbFirstname
     * @return Myuser
     */
    public function setLbFirstname($lbFirstname)
    {
        $this->lbFirstname = $lbFirstname;
    
        return $this;
    }

    /**
     * Get lbFirstname
     *
     * @return string 
     */
    public function getLbFirstname()
    {
        return $this->lbFirstname;
    }

    /**
     * Set lbLastname
     *
     * @param string $lbLastname
     * @return Myuser
     */
    public function setLbLastname($lbLastname)
    {
        $this->lbLastname = $lbLastname;
    
        return $this;
    }

    /**
     * Get lbLastname
     *
     * @return string 
     */
    public function getLbLastname()
    {
        return $this->lbLastname;
    }

    /**
     * Set lbPhone
     *
     * @param string $lbPhone
     * @return Myuser
     */
    public function setLbPhone($lbPhone)
    {
        $this->lbPhone = $lbPhone;
    
        return $this;
    }

    /**
     * Get lbPhone
     *
     * @return string 
     */
    public function getLbPhone()
    {
        return $this->lbPhone;
    }

    /**
     * Set lbMobile
     *
     * @param string $lbMobile
     * @return Myuser
     */
    public function setLbMobile($lbMobile)
    {
        $this->lbMobile = $lbMobile;
    
        return $this;
    }

    /**
     * Get lbMobile
     *
     * @return string 
     */
    public function getLbMobile()
    {
        return $this->lbMobile;
    }

    /**
     * Set lbFax
     *
     * @param string $lbFax
     * @return Myuser
     */
    public function setLbFax($lbFax)
    {
        $this->lbFax = $lbFax;
    
        return $this;
    }

    /**
     * Get lbFax
     *
     * @return string 
     */
    public function getLbFax()
    {
        return $this->lbFax;
    }

    /**
     * Set lbEmail
     *
     * @param string $lbEmail
     * @return Myuser
     */
    public function setLbEmail($lbEmail)
    {
        $this->lbEmail = $lbEmail;
    
        return $this;
    }

    /**
     * Get lbEmail
     *
     * @return string 
     */
    public function getLbEmail()
    {
        return $this->lbEmail;
    }

    /**
     * Set lbPassword
     *
     * @param string $lbPassword
     * @return Myuser
     */
    public function setLbPassword($lbPassword)
    {
        $this->lbPassword = $lbPassword;
    
        return $this;
    }

    /**
     * Get lbPassword
     *
     * @return string 
     */
    public function getLbPassword()
    {
        return $this->lbPassword;
    }

    /**
     * Set dtCreation
     *
     * @param \DateTime $dtCreation
     * @return Myuser
     */
    public function setDtCreation($dtCreation)
    {
        $this->dtCreation = $dtCreation;
    
        return $this;
    }

    /**
     * Get dtCreation
     *
     * @return \DateTime 
     */
    public function getDtCreation()
    {
        return $this->dtCreation;
    }

    /**
     * Set dtModification
     *
     * @param \DateTime $dtModification
     * @return Myuser
     */
    public function setDtModification($dtModification)
    {
        $this->dtModification = $dtModification;
    
        return $this;
    }

    /**
     * Get dtModification
     *
     * @return \DateTime 
     */
    public function getDtModification()
    {
        return $this->dtModification;
    }

    /**
     * Set dtConnection
     *
     * @param \DateTime $dtConnection
     * @return Myuser
     */
    public function setDtConnection($dtConnection)
    {
        $this->dtConnection = $dtConnection;
    
        return $this;
    }

    /**
     * Get dtConnection
     *
     * @return \DateTime 
     */
    public function getDtConnection()
    {
        return $this->dtConnection;
    }

    /**
     * Set dtDisconnection
     *
     * @param \DateTime $dtDisconnection
     * @return Myuser
     */
    public function setDtDisconnection($dtDisconnection)
    {
        $this->dtDisconnection = $dtDisconnection;
    
        return $this;
    }

    /**
     * Get dtDisconnection
     *
     * @return \DateTime 
     */
    public function getDtDisconnection()
    {
        return $this->dtDisconnection;
    }

    /**
     * Set blSaleManager
     *
     * @param boolean $blSaleManager
     * @return Myuser
     */
    public function setBlSaleManager($blSaleManager)
    {
        $this->blSaleManager = $blSaleManager;
    
        return $this;
    }

    /**
     * Get blSaleManager
     *
     * @return boolean 
     */
    public function getBlSaleManager()
    {
        return $this->blSaleManager;
    }

    /**
     * Set blRsc
     *
     * @param boolean $blRsc
     * @return Myuser
     */
    public function setBlRsc($blRsc)
    {
        $this->blRsc = $blRsc;
    
        return $this;
    }

    /**
     * Get blRsc
     *
     * @return boolean 
     */
    public function getBlRsc()
    {
        return $this->blRsc;
    }

    /**
     * Set blGlobalAccountManager
     *
     * @param boolean $blGlobalAccountManager
     * @return Myuser
     */
    public function setBlGlobalAccountManager($blGlobalAccountManager)
    {
        $this->blGlobalAccountManager = $blGlobalAccountManager;
    
        return $this;
    }

    /**
     * Get blGlobalAccountManager
     *
     * @return boolean 
     */
    public function getBlGlobalAccountManager()
    {
        return $this->blGlobalAccountManager;
    }

    /**
     * Set idLdap
     *
     * @param \Etrali\GinangBundle\Entity\Ldap $idLdap
     * @return Myuser
     */
    public function setIdLdap(\Etrali\GinangBundle\Entity\Ldap $idLdap = null)
    {
        $this->idLdap = $idLdap;
    
        return $this;
    }

    /**
     * Get idLdap
     *
     * @return \Etrali\GinangBundle\Entity\Ldap 
     */
    public function getIdLdap()
    {
        return $this->idLdap;
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }
    
    public function __toString()
    {
            return $this->getUsername()." ( ".$this->getLbFirstname()." ".$this->getLbLastname().")";
    }
    
    public function getExpiresAt()
    {
        return $this->expiresAt;
    }
    
    public function getCredentialsExpireAt()
    {
        return $this->credentialsExpireAt;
    } 
        /**
     * Add idUserInBranch
     *
     * @param \Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch
     * @return Myuser
     */
    public function addIdUserInBranch(\Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch)
    {
        $this->idUserInBranch[] = $idUserInBranch;
    
        return $this;
    }

    /**
     * Remove idUserInBranch
     *
     * @param \Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch
     */
    public function removeIdUserInBranch(\Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch)
    {
        $this->idUserInBranch->removeElement($idUserInBranch);
    }

    /**
     * Get idUserInBranch
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdUserInBranch()
    {
        return $this->idUserInBranch;
    }

    /**
     * Add idMailUser
     *
     * @param \Etrali\GinangBundle\Entity\MailUser $idMailUser
     * @return Myuser
     */
    public function addIdMailUser(\Etrali\GinangBundle\Entity\MailUser $idMailUser)
    {
        $this->idMailUser[] = $idMailUser;
    
        return $this;
    }

    /**
     * Remove idMailUser
     *
     * @param \Etrali\GinangBundle\Entity\MailUser $idMailUser
     */
    public function removeIdMailUser(\Etrali\GinangBundle\Entity\MailUser $idMailUser)
    {
        $this->idMailUser->removeElement($idMailUser);
    }

    /**
     * Get idMailUser
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdMailUser()
    {
        return $this->idMailUser;
    }
      
    /**
     * 
     * @return String
     */      
    private function getPasswordRandomly(){
        $Password="";
        $probabilite_type_caractere=array(0,1,2,3,3,3,3,3,3,3,3);
        $caractere_special=array('-','_','?','!','$','#','.','%');

        for($i=0;$i<7;$i++){
            switch($probabilite_type_caractere[rand(0,count($probabilite_type_caractere)-1)]){
                case 0:
                  $Password.=chr(rand(65,90));
                break;
                case 1:
                  $Password.=$caractere_special[rand(0,count($caractere_special)-1)];
                break;
                case 2:
                  $Password.=rand(0,9);
                break;
                default:
                  $Password.=chr(rand(97,122));           
            }         
         }
	 return $Password;
    }
    
    /**
     * 
     */
    public function createdSalt(){
        $this->setSalt(base_convert(sha1(uniqid(mt_rand(), true)), 16, 36));
    }
    
    /**
     * 
     * @param String $password
     */
    public function createdPassword(){    
        $this->setPlainPassword($this->getPasswordRandomly());
        $this->setPasswordOriginal($this->getPlainPassword());
        $userManager = $GLOBALS['kernel']->getContainer()->get('fos_user.user_manager');
        $userManager->updatePassword($this);        
    }
    
    /**
     * 
     * @param String $salt
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
     public function setSalt($salt)
    {
        $this->salt=$salt;
        return $this;
    }
    /**
     * 
     * @param String $passwordOriginal
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
    public function setPasswordOriginal($passwordOriginal){
        $this->passwordOriginal=$passwordOriginal;
        return $this;
    }
    /**
     * 
     * @return String
     */
    public function getPasswordOriginal(){
        return $this->passwordOriginal;
    }    
    /**
     * 
     * @param boolean $enabled
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
    public function setEnabled($enabled){
        $this->enabled=$enabled;
        return $this;
    }
    /**
     * 
     * @return boolean
     */
    public function getEnabled(){
        return $this->enabled;
    }
    /**
     * 
     * @param boolean $locked
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
    public function setLocked($locked){
        $this->locked=$locked;
        return $this;
    }
    /**
     * 
     * @return boolean
     */
    public function getLocked(){
        return $this->locked;
    }    
     /**
     * 
     * @param boolean $expired
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
    public function setExpired($expired){
        $this->expired=$expired;
        return $this;
    }
    /**
     * 
     * @return boolean
     */
    public function getExpired(){
        return $this->expired;
    }
    /**
     * 
     * @param boolean $credentialsExpired
     * @return \Etrali\GinangBundle\Entity\Myuser
     */
    public function setCredentialsExpired($credentialsExpired){
        $this->credentialsExpired=$credentialsExpired;
        return $this;
    }
    /**
     * 
     * @return boolean
     */
    public function getCredentialsExpired(){
        return $this->credentialsExpired;
    }public function getParentBranch() { return NULL; }  }