<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * NoticePeriod
 *
 * @ORM\Table(name="notice_period")
 * @ORM\Entity
 */
class NoticePeriod
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_notice_period", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idNoticePeriod;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_notice_period", type="string", length=15, nullable=true)
     */
    private $cdNoticePeriod;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_notice_period", type="string", length=150, nullable=true)
     */
    private $lbNoticePeriod;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;


public function __toString() { return ''.$this->getLbNoticePeriod(); } public function getParentBranch() { return NULL; }  
    /**
     * Get idNoticePeriod
     *
     * @return integer 
     */
    public function getIdNoticePeriod()
    {
        return $this->idNoticePeriod;
    }

    /**
     * Set cdNoticePeriod
     *
     * @param string $cdNoticePeriod
     * @return NoticePeriod
     */
    public function setCdNoticePeriod($cdNoticePeriod)
    {
        $this->cdNoticePeriod = $cdNoticePeriod;
    
        return $this;
    }

    /**
     * Get cdNoticePeriod
     *
     * @return string 
     */
    public function getCdNoticePeriod()
    {
        return $this->cdNoticePeriod;
    }

    /**
     * Set lbNoticePeriod
     *
     * @param string $lbNoticePeriod
     * @return NoticePeriod
     */
    public function setLbNoticePeriod($lbNoticePeriod)
    {
        $this->lbNoticePeriod = $lbNoticePeriod;
    
        return $this;
    }

    /**
     * Get lbNoticePeriod
     *
     * @return string 
     */
    public function getLbNoticePeriod()
    {
        return $this->lbNoticePeriod;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return NoticePeriod
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return NoticePeriod
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return NoticePeriod
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return NoticePeriod
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
}