<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Payed
 *
 * @ORM\Table(name="payed")
 * @ORM\Entity
 */
class Payed
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_payed", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPayed;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_provider_account", type="string", length=45, nullable=true)
     */
    private $cdProviderAccount;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_branch_order", type="string", length=45, nullable=true)
     */
    private $cdBranchOrder;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_payed", type="string", length=255, nullable=true)
     */
    private $cmPayed;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;

    /**
     * @var \Address
     *
     * @ORM\ManyToOne(targetEntity="Address")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address", referencedColumnName="id_address")
     * })
     */
    private $idAddress;

    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="Contact")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact", referencedColumnName="id_contact")
     * })
     */
    private $idContact;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;



    /**
     * Get idPayed
     *
     * @return integer 
     */
    public function getIdPayed()
    {
        return $this->idPayed;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return Payed
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set cdProviderAccount
     *
     * @param string $cdProviderAccount
     * @return Payed
     */
    public function setCdProviderAccount($cdProviderAccount)
    {
        $this->cdProviderAccount = $cdProviderAccount;
    
        return $this;
    }

    /**
     * Get cdProviderAccount
     *
     * @return string 
     */
    public function getCdProviderAccount()
    {
        return $this->cdProviderAccount;
    }

    /**
     * Set cdBranchOrder
     *
     * @param string $cdBranchOrder
     * @return Payed
     */
    public function setCdBranchOrder($cdBranchOrder)
    {
        $this->cdBranchOrder = $cdBranchOrder;
    
        return $this;
    }

    /**
     * Get cdBranchOrder
     *
     * @return string 
     */
    public function getCdBranchOrder()
    {
        return $this->cdBranchOrder;
    }

    /**
     * Set cmPayed
     *
     * @param string $cmPayed
     * @return Payed
     */
    public function setCmPayed($cmPayed)
    {
        $this->cmPayed = $cmPayed;
    
        return $this;
    }

    /**
     * Get cmPayed
     *
     * @return string 
     */
    public function getCmPayed()
    {
        return $this->cmPayed;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Payed
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return Payed
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idAddress
     *
     * @param \Etrali\GinangBundle\Entity\Address $idAddress
     * @return Payed
     */
    public function setIdAddress(\Etrali\GinangBundle\Entity\Address $idAddress = null)
    {
        $this->idAddress = $idAddress;
    
        return $this;
    }

    /**
     * Get idAddress
     *
     * @return \Etrali\GinangBundle\Entity\Address 
     */
    public function getIdAddress()
    {
        return $this->idAddress;
    }

    /**
     * Set idContact
     *
     * @param \Etrali\GinangBundle\Entity\Contact $idContact
     * @return Payed
     */
    public function setIdContact(\Etrali\GinangBundle\Entity\Contact $idContact = null)
    {
        $this->idContact = $idContact;
    
        return $this;
    }

    /**
     * Get idContact
     *
     * @return \Etrali\GinangBundle\Entity\Contact 
     */
    public function getIdContact()
    {
        return $this->idContact;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return Payed
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return Payed
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }