<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PopAdditionalService
 *
 * @ORM\Table(name="pop_additional_service")
 * @ORM\Entity
 */
class PopAdditionalService
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_pop_additional_service", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPopAdditionalService;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_pop_additional_service", type="string", length=15, nullable=true)
     */
    private $cdPopAdditionalService;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_pop_additional_service", type="string", length=255, nullable=true)
     */
    private $lbPopAdditionalService;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_contract_ref", type="string", length=15, nullable=true)
     */
    private $cdContractRef;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_quantity", type="decimal", nullable=true)
     */
    private $nbQuantity;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \CostCenter
     *
     * @ORM\ManyToOne(targetEntity="CostCenter")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_cost_center", referencedColumnName="id_cost_center")
     * })
     */
    private $idCostCenter;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idPopAdditionalService
     *
     * @return integer 
     */
    public function getIdPopAdditionalService()
    {
        return $this->idPopAdditionalService;
    }

    /**
     * Set cdPopAdditionalService
     *
     * @param string $cdPopAdditionalService
     * @return PopAdditionalService
     */
    public function setCdPopAdditionalService($cdPopAdditionalService)
    {
        $this->cdPopAdditionalService = $cdPopAdditionalService;
    
        return $this;
    }

    /**
     * Get cdPopAdditionalService
     *
     * @return string 
     */
    public function getCdPopAdditionalService()
    {
        return $this->cdPopAdditionalService;
    }

    /**
     * Set lbPopAdditionalService
     *
     * @param string $lbPopAdditionalService
     * @return PopAdditionalService
     */
    public function setLbPopAdditionalService($lbPopAdditionalService)
    {
        $this->lbPopAdditionalService = $lbPopAdditionalService;
    
        return $this;
    }

    /**
     * Get lbPopAdditionalService
     *
     * @return string 
     */
    public function getLbPopAdditionalService()
    {
        return $this->lbPopAdditionalService;
    }

    /**
     * Set cdContractRef
     *
     * @param string $cdContractRef
     * @return PopAdditionalService
     */
    public function setCdContractRef($cdContractRef)
    {
        $this->cdContractRef = $cdContractRef;
    
        return $this;
    }

    /**
     * Get cdContractRef
     *
     * @return string 
     */
    public function getCdContractRef()
    {
        return $this->cdContractRef;
    }

    /**
     * Set nbQuantity
     *
     * @param float $nbQuantity
     * @return PopAdditionalService
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return float 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return PopAdditionalService
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idCostCenter
     *
     * @param \Etrali\GinangBundle\Entity\CostCenter $idCostCenter
     * @return PopAdditionalService
     */
    public function setIdCostCenter(\Etrali\GinangBundle\Entity\CostCenter $idCostCenter = null)
    {
        $this->idCostCenter = $idCostCenter;
    
        return $this;
    }

    /**
     * Get idCostCenter
     *
     * @return \Etrali\GinangBundle\Entity\CostCenter 
     */
    public function getIdCostCenter()
    {
        return $this->idCostCenter;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return PopAdditionalService
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return PopAdditionalService
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return PopAdditionalService
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}