<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PopContractualDetail
 *
 * @ORM\Table(name="pop_contractual_detail")
 * @ORM\Entity
 */
class PopContractualDetail
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_pop_contractual_detail", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPopContractualDetail;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_payer", type="integer", nullable=true)
     */
    private $idPayer;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_payer_account", type="string", length=100, nullable=true)
     */
    private $cdPayerAccount;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_payer_order", type="string", length=100, nullable=true)
     */
    private $cdPayerOrder;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_nrc", type="decimal", nullable=true)
     */
    private $nbNrc;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_mrc", type="decimal", nullable=true)
     */
    private $nbMrc;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_percentage", type="decimal", nullable=true)
     */
    private $nbPercentage;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_paying_frequency", type="decimal", nullable=true)
     */
    private $nbPayingFrequency;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_minimum_period", type="decimal", nullable=true)
     */
    private $nbMinimumPeriod;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_period_notice", type="decimal", nullable=true)
     */
    private $nbPeriodNotice;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_contractual", type="string", length=255, nullable=true)
     */
    private $cmContractual;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \PopAdditionalService
     *
     * @ORM\ManyToOne(targetEntity="PopAdditionalService")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop_additional_service", referencedColumnName="id_pop_additional_service")
     * })
     */
    private $idPopAdditionalService;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     */
    private $idCurrency;



    /**
     * Get idPopContractualDetail
     *
     * @return integer 
     */
    public function getIdPopContractualDetail()
    {
        return $this->idPopContractualDetail;
    }

    /**
     * Set idPayer
     *
     * @param integer $idPayer
     * @return PopContractualDetail
     */
    public function setIdPayer($idPayer)
    {
        $this->idPayer = $idPayer;
    
        return $this;
    }

    /**
     * Get idPayer
     *
     * @return integer 
     */
    public function getIdPayer()
    {
        return $this->idPayer;
    }

    /**
     * Set cdPayerAccount
     *
     * @param string $cdPayerAccount
     * @return PopContractualDetail
     */
    public function setCdPayerAccount($cdPayerAccount)
    {
        $this->cdPayerAccount = $cdPayerAccount;
    
        return $this;
    }

    /**
     * Get cdPayerAccount
     *
     * @return string 
     */
    public function getCdPayerAccount()
    {
        return $this->cdPayerAccount;
    }

    /**
     * Set cdPayerOrder
     *
     * @param string $cdPayerOrder
     * @return PopContractualDetail
     */
    public function setCdPayerOrder($cdPayerOrder)
    {
        $this->cdPayerOrder = $cdPayerOrder;
    
        return $this;
    }

    /**
     * Get cdPayerOrder
     *
     * @return string 
     */
    public function getCdPayerOrder()
    {
        return $this->cdPayerOrder;
    }

    /**
     * Set nbNrc
     *
     * @param float $nbNrc
     * @return PopContractualDetail
     */
    public function setNbNrc($nbNrc)
    {
        $this->nbNrc = $nbNrc;
    
        return $this;
    }

    /**
     * Get nbNrc
     *
     * @return float 
     */
    public function getNbNrc()
    {
        return $this->nbNrc;
    }

    /**
     * Set nbMrc
     *
     * @param float $nbMrc
     * @return PopContractualDetail
     */
    public function setNbMrc($nbMrc)
    {
        $this->nbMrc = $nbMrc;
    
        return $this;
    }

    /**
     * Get nbMrc
     *
     * @return float 
     */
    public function getNbMrc()
    {
        return $this->nbMrc;
    }

    /**
     * Set nbPercentage
     *
     * @param float $nbPercentage
     * @return PopContractualDetail
     */
    public function setNbPercentage($nbPercentage)
    {
        $this->nbPercentage = $nbPercentage;
    
        return $this;
    }

    /**
     * Get nbPercentage
     *
     * @return float 
     */
    public function getNbPercentage()
    {
        return $this->nbPercentage;
    }

    /**
     * Set nbPayingFrequency
     *
     * @param float $nbPayingFrequency
     * @return PopContractualDetail
     */
    public function setNbPayingFrequency($nbPayingFrequency)
    {
        $this->nbPayingFrequency = $nbPayingFrequency;
    
        return $this;
    }

    /**
     * Get nbPayingFrequency
     *
     * @return float 
     */
    public function getNbPayingFrequency()
    {
        return $this->nbPayingFrequency;
    }

    /**
     * Set nbMinimumPeriod
     *
     * @param float $nbMinimumPeriod
     * @return PopContractualDetail
     */
    public function setNbMinimumPeriod($nbMinimumPeriod)
    {
        $this->nbMinimumPeriod = $nbMinimumPeriod;
    
        return $this;
    }

    /**
     * Get nbMinimumPeriod
     *
     * @return float 
     */
    public function getNbMinimumPeriod()
    {
        return $this->nbMinimumPeriod;
    }

    /**
     * Set nbPeriodNotice
     *
     * @param float $nbPeriodNotice
     * @return PopContractualDetail
     */
    public function setNbPeriodNotice($nbPeriodNotice)
    {
        $this->nbPeriodNotice = $nbPeriodNotice;
    
        return $this;
    }

    /**
     * Get nbPeriodNotice
     *
     * @return float 
     */
    public function getNbPeriodNotice()
    {
        return $this->nbPeriodNotice;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return PopContractualDetail
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return PopContractualDetail
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set cmContractual
     *
     * @param string $cmContractual
     * @return PopContractualDetail
     */
    public function setCmContractual($cmContractual)
    {
        $this->cmContractual = $cmContractual;
    
        return $this;
    }

    /**
     * Get cmContractual
     *
     * @return string 
     */
    public function getCmContractual()
    {
        return $this->cmContractual;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return PopContractualDetail
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return PopContractualDetail
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return PopContractualDetail
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idPopAdditionalService
     *
     * @param \Etrali\GinangBundle\Entity\PopAdditionalService $idPopAdditionalService
     * @return PopContractualDetail
     */
    public function setIdPopAdditionalService(\Etrali\GinangBundle\Entity\PopAdditionalService $idPopAdditionalService = null)
    {
        $this->idPopAdditionalService = $idPopAdditionalService;
    
        return $this;
    }

    /**
     * Get idPopAdditionalService
     *
     * @return \Etrali\GinangBundle\Entity\PopAdditionalService 
     */
    public function getIdPopAdditionalService()
    {
        return $this->idPopAdditionalService;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return PopContractualDetail
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }