<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PopPayingDetail
 *
 * @ORM\Table(name="pop_paying_detail")
 * @ORM\Entity
 */
class PopPayingDetail
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_pop_paying_detail", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPopPayingDetail;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_branch_payer", type="integer", nullable=true)
     */
    private $idBranchPayer;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_branch_account", type="string", length=15, nullable=true)
     */
    private $cdBranchAccount;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_branch_order", type="string", length=15, nullable=true)
     */
    private $cdBranchOrder;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_nrc", type="decimal", nullable=true)
     */
    private $nbNrc;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_mrc", type="decimal", nullable=true)
     */
    private $nbMrc;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_billing_frequency", type="integer", nullable=true)
     */
    private $nbBillingFrequency;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_contract_period", type="integer", nullable=true)
     */
    private $nbContractPeriod;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_notice_period", type="integer", nullable=true)
     */
    private $nbNoticePeriod;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=255, nullable=true)
     */
    private $cmComment;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_sale", type="integer", nullable=true)
     */
    private $idUserSale;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_contract_ref", type="string", length=255, nullable=true)
     */
    private $lbContractRef;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_contract_start", type="datetime", nullable=true)
     */
    private $dtContractStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_contract_end", type="datetime", nullable=true)
     */
    private $dtContractEnd;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     */
    private $idCurrency;



    /**
     * Get idPopPayingDetail
     *
     * @return integer 
     */
    public function getIdPopPayingDetail()
    {
        return $this->idPopPayingDetail;
    }

    /**
     * Set idBranchPayer
     *
     * @param integer $idBranchPayer
     * @return PopPayingDetail
     */
    public function setIdBranchPayer($idBranchPayer)
    {
        $this->idBranchPayer = $idBranchPayer;
    
        return $this;
    }

    /**
     * Get idBranchPayer
     *
     * @return integer 
     */
    public function getIdBranchPayer()
    {
        return $this->idBranchPayer;
    }

    /**
     * Set cdBranchAccount
     *
     * @param string $cdBranchAccount
     * @return PopPayingDetail
     */
    public function setCdBranchAccount($cdBranchAccount)
    {
        $this->cdBranchAccount = $cdBranchAccount;
    
        return $this;
    }

    /**
     * Get cdBranchAccount
     *
     * @return string 
     */
    public function getCdBranchAccount()
    {
        return $this->cdBranchAccount;
    }

    /**
     * Set cdBranchOrder
     *
     * @param string $cdBranchOrder
     * @return PopPayingDetail
     */
    public function setCdBranchOrder($cdBranchOrder)
    {
        $this->cdBranchOrder = $cdBranchOrder;
    
        return $this;
    }

    /**
     * Get cdBranchOrder
     *
     * @return string 
     */
    public function getCdBranchOrder()
    {
        return $this->cdBranchOrder;
    }

    /**
     * Set nbNrc
     *
     * @param float $nbNrc
     * @return PopPayingDetail
     */
    public function setNbNrc($nbNrc)
    {
        $this->nbNrc = $nbNrc;
    
        return $this;
    }

    /**
     * Get nbNrc
     *
     * @return float 
     */
    public function getNbNrc()
    {
        return $this->nbNrc;
    }

    /**
     * Set nbMrc
     *
     * @param float $nbMrc
     * @return PopPayingDetail
     */
    public function setNbMrc($nbMrc)
    {
        $this->nbMrc = $nbMrc;
    
        return $this;
    }

    /**
     * Get nbMrc
     *
     * @return float 
     */
    public function getNbMrc()
    {
        return $this->nbMrc;
    }

    /**
     * Set nbBillingFrequency
     *
     * @param integer $nbBillingFrequency
     * @return PopPayingDetail
     */
    public function setNbBillingFrequency($nbBillingFrequency)
    {
        $this->nbBillingFrequency = $nbBillingFrequency;
    
        return $this;
    }

    /**
     * Get nbBillingFrequency
     *
     * @return integer 
     */
    public function getNbBillingFrequency()
    {
        return $this->nbBillingFrequency;
    }

    /**
     * Set nbContractPeriod
     *
     * @param integer $nbContractPeriod
     * @return PopPayingDetail
     */
    public function setNbContractPeriod($nbContractPeriod)
    {
        $this->nbContractPeriod = $nbContractPeriod;
    
        return $this;
    }

    /**
     * Get nbContractPeriod
     *
     * @return integer 
     */
    public function getNbContractPeriod()
    {
        return $this->nbContractPeriod;
    }

    /**
     * Set nbNoticePeriod
     *
     * @param integer $nbNoticePeriod
     * @return PopPayingDetail
     */
    public function setNbNoticePeriod($nbNoticePeriod)
    {
        $this->nbNoticePeriod = $nbNoticePeriod;
    
        return $this;
    }

    /**
     * Get nbNoticePeriod
     *
     * @return integer 
     */
    public function getNbNoticePeriod()
    {
        return $this->nbNoticePeriod;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return PopPayingDetail
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return PopPayingDetail
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return PopPayingDetail
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return PopPayingDetail
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idUserSale
     *
     * @param integer $idUserSale
     * @return PopPayingDetail
     */
    public function setIdUserSale($idUserSale)
    {
        $this->idUserSale = $idUserSale;
    
        return $this;
    }

    /**
     * Get idUserSale
     *
     * @return integer 
     */
    public function getIdUserSale()
    {
        return $this->idUserSale;
    }

    /**
     * Set lbContractRef
     *
     * @param string $lbContractRef
     * @return PopPayingDetail
     */
    public function setLbContractRef($lbContractRef)
    {
        $this->lbContractRef = $lbContractRef;
    
        return $this;
    }

    /**
     * Get lbContractRef
     *
     * @return string 
     */
    public function getLbContractRef()
    {
        return $this->lbContractRef;
    }

    /**
     * Set dtContractStart
     *
     * @param \DateTime $dtContractStart
     * @return PopPayingDetail
     */
    public function setDtContractStart($dtContractStart)
    {
        $this->dtContractStart = $dtContractStart;
    
        return $this;
    }

    /**
     * Get dtContractStart
     *
     * @return \DateTime 
     */
    public function getDtContractStart()
    {
        return $this->dtContractStart;
    }

    /**
     * Set dtContractEnd
     *
     * @param \DateTime $dtContractEnd
     * @return PopPayingDetail
     */
    public function setDtContractEnd($dtContractEnd)
    {
        $this->dtContractEnd = $dtContractEnd;
    
        return $this;
    }

    /**
     * Get dtContractEnd
     *
     * @return \DateTime 
     */
    public function getDtContractEnd()
    {
        return $this->dtContractEnd;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return PopPayingDetail
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return PopPayingDetail
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }