<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PortConnector
 *
 * @ORM\Table(name="port_connector")
 * @ORM\Entity
 */
class PortConnector
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_port_connector", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPortConnector;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_port_connector", type="string", length=15, nullable=true)
     */
    private $cdPortConnector;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_port_connector", type="string", length=100, nullable=true)
     */
    private $lbPortConnector;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;



    /**
     * Get idPortConnector
     *
     * @return integer 
     */
    public function getIdPortConnector()
    {
        return $this->idPortConnector;
    }

    /**
     * Set cdPortConnector
     *
     * @param string $cdPortConnector
     * @return PortConnector
     */
    public function setCdPortConnector($cdPortConnector)
    {
        $this->cdPortConnector = $cdPortConnector;
    
        return $this;
    }

    /**
     * Get cdPortConnector
     *
     * @return string 
     */
    public function getCdPortConnector()
    {
        return $this->cdPortConnector;
    }

    /**
     * Set lbPortConnector
     *
     * @param string $lbPortConnector
     * @return PortConnector
     */
    public function setLbPortConnector($lbPortConnector)
    {
        $this->lbPortConnector = $lbPortConnector;
    
        return $this;
    }

    /**
     * Get lbPortConnector
     *
     * @return string 
     */
    public function getLbPortConnector()
    {
        return $this->lbPortConnector;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return PortConnector
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return PortConnector
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return PortConnector
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return PortConnector
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return PortConnector
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }