<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PortSegmentationType
 *
 * @ORM\Table(name="port_segmentation_type")
 * @ORM\Entity
 */
class PortSegmentationType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_port_segmentation_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPortSegmentationType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_port_segmentation_type", type="string", length=15, nullable=true)
     */
    private $cdPortSegmentationType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_port_segmentation_type", type="string", length=100, nullable=true)
     */
    private $lbPortSegmentationType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

        /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
        /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbPortSegmentationType().'';
    }


    /**
     * Get idPortSegmentationType
     *
     * @return integer 
     */
    public function getIdPortSegmentationType()
    {
        return $this->idPortSegmentationType;
    }



    /**
     * Set cdPortSegmentationType
     *
     * @param string $cdPortSegmentationType
     * @return PortSegmentationType
     */
    public function setCdPortSegmentationType($cdPortSegmentationType)
    {
        $this->cdPortSegmentationType = $cdPortSegmentationType;
    
        return $this;
    }

    /**
     * Get cdPortSegmentationType
     *
     * @return string 
     */
    public function getCdPortSegmentationType()
    {
        return $this->cdPortSegmentationType;
    }

    /**
     * Set lbPortSegmentationType
     *
     * @param string $lbPortSegmentationType
     * @return PortSegmentationType
     */
    public function setLbPortSegmentationType($lbPortSegmentationType)
    {
        $this->lbPortSegmentationType = $lbPortSegmentationType;
    
        return $this;
    }

    /**
     * Get lbPortSegmentationType
     *
     * @return string 
     */
    public function getLbPortSegmentationType()
    {
        return $this->lbPortSegmentationType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return PortSegmentationType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return PortSegmentationType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return PortSegmentationType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return PortSegmentationType
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return PortSegmentationType
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return PortSegmentationType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}