<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Product
 *
 * @ORM\Table(name="product")
 * @ORM\Entity
 */
class Product
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_product", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProduct;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_product", type="string", length=15, nullable=false)
     */
    private $cdProduct;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_product", type="string", length=100, nullable=false)
     */
    private $lbProduct;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \BandwidthAssignee
     *
     * @ORM\ManyToOne(targetEntity="BandwidthAssignee", inversedBy="idProduct",cascade={"persist","remove"})
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_bandwidth_assignee", referencedColumnName="id_bandwidth_assignee")
     * })
     */
    private $idBandwidthAssignee;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;

    /**
     * @var \ProductType
     *
     * @ORM\ManyToOne(targetEntity="ProductType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product_type", referencedColumnName="id_product_type")
     * })
     */
    private $idProductType;

    public function __toString()
    {
        return "[".$this->getCdProduct()."] ".$this->getLbProduct();
    }

    /**
     * Get idProduct
     *
     * @return integer 
     */
    public function getIdProduct()
    {
        return $this->idProduct;
    }

    /**
     * Set cdProduct
     *
     * @param string $cdProduct
     * @return Product
     */
    public function setCdProduct($cdProduct)
    {
        $this->cdProduct = $cdProduct;
    
        return $this;
    }

    /**
     * Get cdProduct
     *
     * @return string 
     */
    public function getCdProduct()
    {
        return $this->cdProduct;
    }

    /**
     * Set lbProduct
     *
     * @param string $lbProduct
     * @return Product
     */
    public function setLbProduct($lbProduct)
    {
        $this->lbProduct = $lbProduct;
    
        return $this;
    }

    /**
     * Get lbProduct
     *
     * @return string 
     */
    public function getLbProduct()
    {
        return $this->lbProduct;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Product
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Product
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return Product
     */
    public function setIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType = null)
    {
        $this->idProductType = $idProductType;
    
        return $this;
    }

    /**
     * Get idProductType
     *
     * @return \Etrali\GinangBundle\Entity\ProductType 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }

    /**
     * Set idBandwidthAssignee
     *
     * @param \Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidthAssignee
     * @return Product
     */
    public function setIdBandwidthAssignee(\Etrali\GinangBundle\Entity\BandwidthAssignee $idBandwidthAssignee = null)
    {
        $this->idBandwidthAssignee = $idBandwidthAssignee;
    
        return $this;
    }

    /**
     * Get idBandwidthAssignee
     *
     * @return \Etrali\GinangBundle\Entity\BandwidthAssignee 
     */
    public function getIdBandwidthAssignee()
    {
        return $this->idBandwidthAssignee;
    }public function getParentBranch() { return NULL; }  }