<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ProductCaracs
 *
 * @ORM\Table(name="product_caracs")
 * @ORM\Entity
 */
class ProductCaracs
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_product_caracs", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProductCaracs;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_carac", type="string", length=255, nullable=false)
     */
    private $lbCarac;

    /**
     * @var string
     *
     * @ORM\Column(name="value1", type="string", length=255, nullable=true)
     */
    private $value1;

    /**
     * @var string
     *
     * @ORM\Column(name="value2", type="string", length=255, nullable=true)
     */
    private $value2;

    /**
     * @var integer
     *
     * @ORM\Column(name="bl_mandatory", type="boolean", nullable=false)
     */
    private $blMandatory;

    /**
     * @var integer
     *
     * @ORM\Column(name="position", type="integer", nullable=false)
     */
    private $position;
    
   
    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_location", type="integer", nullable=false)
     * 
     *  0: On commercial info, 1: on Extremity, 2: on Technical
     */
    private $nbLocation=0;       

    /**
     * @ORM\ManyToMany(targetEntity="ProductType", mappedBy="idProductCaracs")
     */
    private $idProductType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_widget_type", type="string", length=255, nullable=false)
     */
    private $lbWidgetType;
    
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_field", type="string", length=255, nullable=false)
     */
    private $lbField;
    
    public function __toString()
    {
       return $this->lbCarac."";
    }

    /**
     * Get idProductCaracs
     *
     * @return integer 
     */
    public function getIdProductCaracs()
    {
        return $this->idProductCaracs;
    }

    /**
     * Set lbCarac
     *
     * @param string $lbCarac
     * @return ProductCaracs
     */
    public function setLbCarac($lbCarac)
    {
        $this->lbCarac = $lbCarac;
    
        return $this;
    }

    /**
     * Get lbCarac
     *
     * @return string 
     */
    public function getLbCarac()
    {
        return $this->lbCarac;
    }

    /**
     * Set value1
     *
     * @param string $value1
     * @return ProductCaracs
     */
    public function setValue1($value1)
    {
        $this->value1 = $value1;
    
        return $this;
    }

    /**
     * Get value1
     *
     * @return string 
     */
    public function getValue1()
    {
        return $this->value1;
    }

    /**
     * Set value2
     *
     * @param string $value2
     * @return ProductCaracs
     */
    public function setValue2($value2)
    {
        $this->value2 = $value2;
    
        return $this;
    }

    /**
     * Get value2
     *
     * @return string 
     */
    public function getValue2()
    {
        return $this->value2;
    }

    /**
     * Set blMandatory
     *
     * @param integer $blMandatory
     * @return ProductCaracs
     */
    public function setBlMandatory($blMandatory)
    {
        $this->blMandatory = $blMandatory;
    
        return $this;
    }

    /**
     * Get blMandatory
     *
     * @return integer 
     */
    public function getBlMandatory()
    {
        return $this->blMandatory;
    }

    /**
     * Set position
     *
     * @param integer $position
     * @return ProductCaracs
     */
    public function setPosition($position)
    {
        $this->position = $position;
    
        return $this;
    }

    /**
     * Get position
     *
     * @return integer 
     */
    public function getPosition()
    {
        return $this->position;
    }

    /**
     * Set idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ProductCaracs
     */
    public function setIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType = null)
    {
        $this->idProductType = $idProductType;
    
        return $this;
    }

    /**
     * Get idProductType
     *
     * @return \Etrali\GinangBundle\Entity\ProductType 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }

    /**
     * Set idWidgetType
     *
     * @param \Etrali\GinangBundle\Entity\WidgetType $idWidgetType
     * @return ProductCaracs
     */
    public function setIdWidgetType(\Etrali\GinangBundle\Entity\WidgetType $idWidgetType = null)
    {
        $this->idWidgetType = $idWidgetType;
    
        return $this;
    }

    /**
     * Get idWidgetType
     *
     * @return \Etrali\GinangBundle\Entity\WidgetType 
     */
    public function getIdWidgetType()
    {
        return $this->idWidgetType;
    }

    /**
     * Set lbWidgetType
     *
     * @param string $lbWidgetType
     * @return ProductCaracs
     */
    public function setLbWidgetType($lbWidgetType)
    {
        $this->lbWidgetType = $lbWidgetType;
    
        return $this;
    }

    /**
     * Get lbWidgetType
     *
     * @return string 
     */
    public function getLbWidgetType()
    {
        return $this->lbWidgetType;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idProductType = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ProductCaracs
     */
    public function addIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType)
    {
        $this->idProductType[] = $idProductType;
    
        return $this;
    }

    /**
     * Remove idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     */
    public function removeIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType)
    {
        $this->idProductType->removeElement($idProductType);
    }

    /**
     * Set nbLocation
     *
     * @param integer $nbLocation
     * @return ProductCaracs
     */
    public function setNbLocation($nbLocation)
    {
        $this->nbLocation = $nbLocation;
    
        return $this;
    }

    /**
     * Get nbLocation
     *
     * @return integer 
     */
    public function getNbLocation()
    {
        return $this->nbLocation;
    }

    /**
     * Set lbField
     *
     * @param string $lbField
     * @return ProductCaracs
     */
    public function setLbField($lbField)
    {
        $this->lbField = $lbField;
    
        return $this;
    }

    /**
     * Get lbField
     *
     * @return string 
     */
    public function getLbField()
    {
        return $this->lbField;
    }public function getParentBranch() { return NULL; }  }