<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ProductCategory
 *
 * @ORM\Table(name="product_category")
 * @ORM\Entity
 */
class ProductCategory
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_product_category", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProductCategory;
    
    /**
     * @var \ProductType
     *
     * @ORM\OneToMany(targetEntity="ProductType", mappedBy="idProductCategory",cascade={"persist","remove"}, orphanRemoval=true )   
     * @ORM\OrderBy({"lbProductType" = "asc"})        
     */
    private $idProductType;      

    /**
     * @var string
     *
     * @ORM\Column(name="nom", type="string", length=255, nullable=false)
     */
    private $nom;

    public function __toString()
    {
        return $this->nom;
    }

    /**
     * Get idProductCategory
     *
     * @return integer 
     */
    public function getIdProductCategory()
    {
        return $this->idProductCategory;
    }

    /**
     * Set nom
     *
     * @param string $nom
     * @return ProductCategory
     */
    public function setNom($nom)
    {
        $this->nom = $nom;
    
        return $this;
    }

    /**
     * Get nom
     *
     * @return string 
     */
    public function getNom()
    {
        return $this->nom;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idProductType = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ProductCategory
     */
    public function addIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType)
    {
        $this->idProductType[] = $idProductType;
    
        return $this;
    }

    /**
     * Remove idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     */
    public function removeIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType)
    {
        $this->idProductType->removeElement($idProductType);
    }

    /**
     * Get idProductType
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }public function getParentBranch() { return NULL; }  }