<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Progression
 *
 * @ORM\Table(name="progression")
 * @ORM\Entity
 */
class Progression
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_progression", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProgression;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_status_mail", type="boolean", nullable=true)
     */
    private $blStatusMail;

    /**
     * @var \Event
     *
     * @ORM\ManyToOne(targetEntity="Event")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_event", referencedColumnName="id_event")
     * })
     */
    private $idEvent;

    /**
     * @var \StatusType
     *
     * @ORM\ManyToOne(targetEntity="StatusType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_status_type", referencedColumnName="id_status_type")
     * })
     */
    private $idStatusType;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;



    /**
     * Get idProgression
     *
     * @return integer 
     */
    public function getIdProgression()
    {
        return $this->idProgression;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return Progression
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return Progression
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set blStatusMail
     *
     * @param boolean $blStatusMail
     * @return Progression
     */
    public function setBlStatusMail($blStatusMail)
    {
        $this->blStatusMail = $blStatusMail;
    
        return $this;
    }

    /**
     * Get blStatusMail
     *
     * @return boolean 
     */
    public function getBlStatusMail()
    {
        return $this->blStatusMail;
    }

    /**
     * Set idEvent
     *
     * @param \Etrali\GinangBundle\Entity\Event $idEvent
     * @return Progression
     */
    public function setIdEvent(\Etrali\GinangBundle\Entity\Event $idEvent = null)
    {
        $this->idEvent = $idEvent;
    
        return $this;
    }

    /**
     * Get idEvent
     *
     * @return \Etrali\GinangBundle\Entity\Event 
     */
    public function getIdEvent()
    {
        return $this->idEvent;
    }

    /**
     * Set idStatusType
     *
     * @param \Etrali\GinangBundle\Entity\StatusType $idStatusType
     * @return Progression
     */
    public function setIdStatusType(\Etrali\GinangBundle\Entity\StatusType $idStatusType = null)
    {
        $this->idStatusType = $idStatusType;
    
        return $this;
    }

    /**
     * Get idStatusType
     *
     * @return \Etrali\GinangBundle\Entity\StatusType 
     */
    public function getIdStatusType()
    {
        return $this->idStatusType;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return Progression
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }