<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Project
 *
 * @ORM\Table(name="project")
 * @ORM\Entity
 */
class Project
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_project", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProject;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_project", type="string", length=15, nullable=true)
     */
    private $cdProject;

    /**
     * @var string
     *
     * @ORM\Column(name="descr", type="text", nullable=true)
     */
    private $descr;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer", inversedBy="idProject")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer", referencedColumnName="id_customer")
     * })
     */
    private $idCustomer;

    
    public function getHeadInfo()
    {
            return "<td>".$this->getCdProject()."</td><td >".$this->getDescr()."</td><td>".$this->getDtStart()->format('d/m/Y')."</td><td>".$this->getDtEnd()->format('d/m/Y')."</td>";
    }  
    
    public function getHeadColumns()
    { 
            return "<th>Project code</th><th>Description</th><th>Project Start Date</th><th>Project End Date</th>";
    }
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getCdProject().'';
    }      
   
    
    /**
     * Get idProject
     *
     * @return integer 
     */
    public function getIdProject()
    {
        return $this->idProject;
    }

    /**
     * Set cdProject
     *
     * @param string $cdProject
     * @return Project
     */
    public function setCdProject($cdProject)
    {
        $this->cdProject = $cdProject;
    
        return $this;
    }

    /**
     * Get cdProject
     *
     * @return string 
     */
    public function getCdProject()
    {
        return $this->cdProject;
    }

    /**
     * Set descr
     *
     * @param string $descr
     * @return Project
     */
    public function setDescr($descr)
    {
        $this->descr = $descr;
    
        return $this;
    }

    /**
     * Get descr
     *
     * @return string 
     */
    public function getDescr()
    {
        return $this->descr;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return Project
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return Project
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return Project
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }
                
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if ($this->getIdCustomer()!=null)
            return $this->getIdCustomer()->getIdBranch();
        return NULL;
    }
}