<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Protocol
 *
 * @ORM\Table(name="protocol")
 * @ORM\Entity
 */
class Protocol
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_protocol", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProtocol;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_protocol", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)
     */
    private $cdProtocol;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_protocol", type="string", length=45, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50)
     */
    private $lbProtocol;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     * @Assert\DateTime()
     */
    private $dtUpdate;    
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    
    
    /**
     * Get idProtocol
     *
     * @return integer 
     */
    public function getIdProtocol()
    {
        return $this->idProtocol;
    }

    /**
     * Set cdProtocol
     *
     * @param string $cdProtocol
     * @return Protocol
     */
    public function setCdProtocol($cdProtocol)
    {
        $this->cdProtocol = $cdProtocol;
    
        return $this;
    }

    /**
     * Get cdProtocol
     *
     * @return string 
     */
    public function getCdProtocol()
    {
        return $this->cdProtocol;
    }    
    
    /**
     * Set lbProtocol
     *
     * @param string $lbProtocol
     * @return Protocol
     */
    public function setLbProtocol($lbProtocol)
    {
        $this->lbProtocol = $lbProtocol;
    
        return $this;
    }

    /**
     * Get lbProtocol
     *
     * @return string 
     */
    public function getLbProtocol()
    {
        return $this->lbProtocol;
    }
    
   /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Protocol
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Protocol
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return Protocol
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }
    public function __toString()
    {
        return $this->getLbProtocol().'';
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Protocol
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }public function getParentBranch() { return NULL; }  }