<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ProviderPop
 *
 * @ORM\Table(name="provider_pop")
 * @ORM\Entity
 */
class ProviderPop
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_provider_pop", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProviderPop;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idProviderPop
     *
     * @return integer 
     */
    public function getIdProviderPop()
    {
        return $this->idProviderPop;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return ProviderPop
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ProviderPop
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return ProviderPop
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return ProviderPop
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ProviderPop
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}