<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ProviderWorldwideGroup
 *
 * @ORM\Table(name="provider_worldwide_group")
 * @ORM\Entity
 */
class ProviderWorldwideGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_provider_worldwide_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProviderWorldwideGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_provider_worldwide_group", type="string", length=15, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(30)   
     */
    private $cdProviderWorldwideGroup;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_provider_worldwide_group", type="string", length=100, nullable=false)
     * @Assert\MaxLength(30)       
     */
    private $lbProviderWorldwideGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var string
     *
     * @ORM\Column(name="comment", type="text", nullable=true)
     */
    private $comment;


    /**
     * @var \Cluster
     *
     * @ORM\OneToMany(targetEntity="Cluster", mappedBy="idProviderWorldwideGroup",cascade={"persist","remove"}, orphanRemoval=true)
     * @ORM\OrderBy({"blDeactivated" = "desc","lbCluster" = "asc"})        
     */
    
    private $idCluster;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     
    
    public function getCollections()
    {
        return array("Clusters"=>"Cluster");       
    }       
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbProviderWorldwideGroup().'';
    }    

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idCluster = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idProviderWorldwideGroup
     *
     * @return integer 
     */
    public function getIdProviderWorldwideGroup()
    {
        return $this->idProviderWorldwideGroup;
    }

    /**
     * Set cdProviderWorldwideGroup
     *
     * @param string $cdProviderWorldwideGroup
     * @return ProviderWorldwideGroup
     */
    public function setCdProviderWorldwideGroup($cdProviderWorldwideGroup)
    {
        $this->cdProviderWorldwideGroup = $cdProviderWorldwideGroup;
    
        return $this;
    }

    /**
     * Get cdProviderWorldwideGroup
     *
     * @return string 
     */
    public function getCdProviderWorldwideGroup()
    {
        return $this->cdProviderWorldwideGroup;
    }

    /**
     * Set lbProviderWorldwideGroup
     *
     * @param string $lbProviderWorldwideGroup
     * @return ProviderWorldwideGroup
     */
    public function setLbProviderWorldwideGroup($lbProviderWorldwideGroup)
    {
        $this->lbProviderWorldwideGroup = $lbProviderWorldwideGroup;
    
        return $this;
    }

    /**
     * Get lbProviderWorldwideGroup
     *
     * @return string 
     */
    public function getLbProviderWorldwideGroup()
    {
        return $this->lbProviderWorldwideGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ProviderWorldwideGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ProviderWorldwideGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return ProviderWorldwideGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set comment
     *
     * @param string $comment
     * @return ProviderWorldwideGroup
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    
        return $this;
    }

    /**
     * Get comment
     *
     * @return string 
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * Add idCluster
     *
     * @param \Etrali\GinangBundle\Entity\Cluster $idCluster
     * @return ProviderWorldwideGroup
     */
    public function addIdCluster(\Etrali\GinangBundle\Entity\Cluster $idCluster)
    {
        $this->idCluster[] = $idCluster;
    
        return $this;
    }

    /**
     * Remove idCluster
     *
     * @param \Etrali\GinangBundle\Entity\Cluster $idCluster
     */
    public function removeIdCluster(\Etrali\GinangBundle\Entity\Cluster $idCluster)
    {
        $this->idCluster->removeElement($idCluster);
    }

    /**
     * Get idCluster
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdCluster()
    {
        return $this->idCluster;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ProviderWorldwideGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}