<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * RebateCredit
 *
 * @ORM\Table(name="rebate_credit")
 * @ORM\Entity
 */
class RebateCredit
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_rebate_credit", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRebateCredit;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_rebate_credit", type="string", length=45, nullable=true)
     */
    private $cdRebateCredit;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_rebate_credit", type="string", length=255, nullable=true)
     */
    private $lbRebateCredit;

    /**
     * @var integer
     *
     * @ORM\Column(name="mt_value", type="integer", nullable=true)
     */
    private $mtValue;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_creation", type="datetime", nullable=true)
     */
    private $dtCreation;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_filter", type="string", length=255, nullable=true)
     */
    private $lbFilter;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_execute", type="boolean", nullable=true)
     */
    private $blExecute;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_previous_invoice", type="boolean", nullable=true)
     */
    private $blPreviousInvoice;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=255, nullable=true)
     */
    private $cmComment;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;

    /**
     * @var \RatePercentValueType
     *
     * @ORM\ManyToOne(targetEntity="RatePercentValueType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_rate_percent_value_type", referencedColumnName="id_rate_percent_value_type")
     * })
     */
    private $idRatePercentValueType;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     */
    private $idCurrency;

    /**
     * @var \BillingPeriod
     *
     * @ORM\ManyToOne(targetEntity="BillingPeriod")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_period", referencedColumnName="id_billing_period")
     * })
     */
    private $idBillingPeriod;



    /**
     * Get idRebateCredit
     *
     * @return integer 
     */
    public function getIdRebateCredit()
    {
        return $this->idRebateCredit;
    }

    /**
     * Set cdRebateCredit
     *
     * @param string $cdRebateCredit
     * @return RebateCredit
     */
    public function setCdRebateCredit($cdRebateCredit)
    {
        $this->cdRebateCredit = $cdRebateCredit;
    
        return $this;
    }

    /**
     * Get cdRebateCredit
     *
     * @return string 
     */
    public function getCdRebateCredit()
    {
        return $this->cdRebateCredit;
    }

    /**
     * Set lbRebateCredit
     *
     * @param string $lbRebateCredit
     * @return RebateCredit
     */
    public function setLbRebateCredit($lbRebateCredit)
    {
        $this->lbRebateCredit = $lbRebateCredit;
    
        return $this;
    }

    /**
     * Get lbRebateCredit
     *
     * @return string 
     */
    public function getLbRebateCredit()
    {
        return $this->lbRebateCredit;
    }

    /**
     * Set mtValue
     *
     * @param integer $mtValue
     * @return RebateCredit
     */
    public function setMtValue($mtValue)
    {
        $this->mtValue = $mtValue;
    
        return $this;
    }

    /**
     * Get mtValue
     *
     * @return integer 
     */
    public function getMtValue()
    {
        return $this->mtValue;
    }

    /**
     * Set dtCreation
     *
     * @param \DateTime $dtCreation
     * @return RebateCredit
     */
    public function setDtCreation($dtCreation)
    {
        $this->dtCreation = $dtCreation;
    
        return $this;
    }

    /**
     * Get dtCreation
     *
     * @return \DateTime 
     */
    public function getDtCreation()
    {
        return $this->dtCreation;
    }

    /**
     * Set lbFilter
     *
     * @param string $lbFilter
     * @return RebateCredit
     */
    public function setLbFilter($lbFilter)
    {
        $this->lbFilter = $lbFilter;
    
        return $this;
    }

    /**
     * Get lbFilter
     *
     * @return string 
     */
    public function getLbFilter()
    {
        return $this->lbFilter;
    }

    /**
     * Set blExecute
     *
     * @param boolean $blExecute
     * @return RebateCredit
     */
    public function setBlExecute($blExecute)
    {
        $this->blExecute = $blExecute;
    
        return $this;
    }

    /**
     * Get blExecute
     *
     * @return boolean 
     */
    public function getBlExecute()
    {
        return $this->blExecute;
    }

    /**
     * Set blPreviousInvoice
     *
     * @param boolean $blPreviousInvoice
     * @return RebateCredit
     */
    public function setBlPreviousInvoice($blPreviousInvoice)
    {
        $this->blPreviousInvoice = $blPreviousInvoice;
    
        return $this;
    }

    /**
     * Get blPreviousInvoice
     *
     * @return boolean 
     */
    public function getBlPreviousInvoice()
    {
        return $this->blPreviousInvoice;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return RebateCredit
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return RebateCredit
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return RebateCredit
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }

    /**
     * Set idRatePercentValueType
     *
     * @param \Etrali\GinangBundle\Entity\RatePercentValueType $idRatePercentValueType
     * @return RebateCredit
     */
    public function setIdRatePercentValueType(\Etrali\GinangBundle\Entity\RatePercentValueType $idRatePercentValueType = null)
    {
        $this->idRatePercentValueType = $idRatePercentValueType;
    
        return $this;
    }

    /**
     * Get idRatePercentValueType
     *
     * @return \Etrali\GinangBundle\Entity\RatePercentValueType 
     */
    public function getIdRatePercentValueType()
    {
        return $this->idRatePercentValueType;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return RebateCredit
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }

    /**
     * Set idBillingPeriod
     *
     * @param \Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod
     * @return RebateCredit
     */
    public function setIdBillingPeriod(\Etrali\GinangBundle\Entity\BillingPeriod $idBillingPeriod = null)
    {
        $this->idBillingPeriod = $idBillingPeriod;
    
        return $this;
    }

    /**
     * Get idBillingPeriod
     *
     * @return \Etrali\GinangBundle\Entity\BillingPeriod 
     */
    public function getIdBillingPeriod()
    {
        return $this->idBillingPeriod;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }