<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Room
 *
 * @ORM\Table(name="room")
 * @ORM\Entity
 */
class Room
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_room", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRoom;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_room", type="string", length=15, nullable=false)
     */
    private $cdRoom;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_room", type="string", length=100, nullable=true)
     */
    private $lbRoom;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Floor
     *
     * @ORM\ManyToOne(targetEntity="Floor")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_floor", referencedColumnName="id_floor")
     * })
     */
    private $idFloor;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idRoom
     *
     * @return integer 
     */
    public function getIdRoom()
    {
        return $this->idRoom;
    }

    /**
     * Set cdRoom
     *
     * @param string $cdRoom
     * @return Room
     */
    public function setCdRoom($cdRoom)
    {
        $this->cdRoom = $cdRoom;
    
        return $this;
    }

    /**
     * Get cdRoom
     *
     * @return string 
     */
    public function getCdRoom()
    {
        return $this->cdRoom;
    }

    /**
     * Set lbRoom
     *
     * @param string $lbRoom
     * @return Room
     */
    public function setLbRoom($lbRoom)
    {
        $this->lbRoom = $lbRoom;
    
        return $this;
    }

    /**
     * Get lbRoom
     *
     * @return string 
     */
    public function getLbRoom()
    {
        return $this->lbRoom;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Room
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idFloor
     *
     * @param \Etrali\GinangBundle\Entity\Floor $idFloor
     * @return Room
     */
    public function setIdFloor(\Etrali\GinangBundle\Entity\Floor $idFloor = null)
    {
        $this->idFloor = $idFloor;
    
        return $this;
    }

    /**
     * Get idFloor
     *
     * @return \Etrali\GinangBundle\Entity\Floor 
     */
    public function getIdFloor()
    {
        return $this->idFloor;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Room
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}