<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceExtremity
 *
 * @ORM\Table(name="service_extremity")
 * @ORM\Entity
 */
class ServiceExtremity
{   
    const OWNER_CUSTOMER = 1;
    const OWNER_POP = 2;
    const OWNER_PROVIDER = 3;
    const PRODUCT_CARACS_TRADER = 18;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_extremity", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceExtremity;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_service_extremity", type="string", length=45, nullable=true)
     */
    private $cdServiceExtremity;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=255, nullable=true)
     */
    private $cmComment;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_terminate", type="datetime", nullable=true)
     */
    private $dtInitTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_updown", type="datetime", nullable=true)
     */
    private $dtInitUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_updown", type="datetime", nullable=true)
     */
    private $dtRequestUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_updown", type="datetime", nullable=true)
     */
    private $dtRealUpdown;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_terminate", type="datetime", nullable=true)
     */
    private $dtRequestTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_real_terminate", type="datetime", nullable=true)
     */
    private $dtRealTerminate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_inservice", type="datetime", nullable=true)
     */
    private $dtInservice;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_transfer", type="datetime", nullable=true)
     */
    private $dtInitTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_init_add_extremity", type="datetime", nullable=true)
     */
    private $dtInitAddExtremity;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_transfer", type="datetime", nullable=true)
     */
    private $dtRequestTransfer;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_request_add_extremity", type="datetime", nullable=true)
     */
    private $dtRequestAddExtremity;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_complete_transfer", type="datetime", nullable=true)
     */
    private $dtCompleteTransfer;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_add_extremity_inservice", type="datetime", nullable=true)
     */
    private $dtAddExtremityInservice;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_old_extremity_terminate", type="datetime", nullable=true)
     */
    private $dtOldExtremityTerminate;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_local_loop_cost", type="decimal", nullable=true)
     */
    private $mtLocalLoopCost;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cm_local_loop_cost", type="string", length=4000, nullable=true)
     */
    private $cmLocalLoopCost;    

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;


    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer", referencedColumnName="id_customer")
     * })
     */
    private $idCustomer;

  
    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service", inversedBy="idServiceExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     */
    private $idService;

    /**
     * @var \Pop
     *
     * @ORM\ManyToOne(targetEntity="Pop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pop", referencedColumnName="id_pop")
     * })
     */
    private $idPop;

    /**
     * @var \AddressPop
     *
     * @ORM\ManyToOne(targetEntity="AddressPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address_pop", referencedColumnName="id_address_pop")
     * })
     */    
    private $idAddressPop;    
    
    /**
     * @var \ContactPop
     *
     * @ORM\ManyToOne(targetEntity="ContactPop")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact_pop", referencedColumnName="id_contact_pop")
     * })
     */    
    private $idContactPop;
    
    /**
     * @var \Contact
     *
     * @ORM\ManyToOne(targetEntity="Contact")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_admin_contact", referencedColumnName="id_contact")
     * })
     */    
    private $idAdminContact;
    
    /**
     * @var \Address
     *
     * @ORM\ManyToOne(targetEntity="Address")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_delivery_address", referencedColumnName="id_address")
     * })
     */    
    private $idDeliveryAddress;  
    
        /**
     * @var \AddressProvider
     *
     * @ORM\ManyToOne(targetEntity="AddressProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address_provider", referencedColumnName="id_address_provider")
     * })
     */    
    private $idAddressProvider;    
    
    /**
     * @var \ContactProvider
     *
     * @ORM\ManyToOne(targetEntity="ContactProvider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_contact_provider", referencedColumnName="id_contact_provider")
     * })
     */    
    private $idContactProvider;    


    /**
     * @var \Project
     *
     * @ORM\ManyToOne(targetEntity="Project")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_project", referencedColumnName="id_project")
     * })
     */
    private $idProject;

    /**
     * @var \LocalLoopExtremityOwner
     *
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityOwner")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity_owner", referencedColumnName="id_local_loop_extremity_owner")
     * })     
     */
    private $idServiceExtremityOwner;        
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_onnet", type="string", length=255, nullable=true)            
     */
    private $lbOnnet; 

      /**
     * @var \ServiceExtremityTech
     *
     * @ORM\OneToOne(targetEntity="ServiceExtremityTech", mappedBy="idServiceExtremity")
     */    
    private $idServiceExtremityTech;  
    
    /**
     * @var \TransferPrice
     *
     * @ORM\OneToOne(targetEntity="TransferPrice", mappedBy="idServiceExtremity")
     */    
    private $idTransferPrice;      
    
    /**
     * @var \ServiceExtremity
     *
     * @ORM\OneToOne(targetEntity="ServiceExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_old_extremity", referencedColumnName="id_service_extremity")
     * })
     */    
    private $idOldExtremity;  
    
    /**
     * @var \ServiceCaracs
     *
     * @ORM\OneToMany(targetEntity="ServiceCaracs", mappedBy="idServiceExtremity",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idServiceCaracs" = "asc"})         
     */
    private $idServiceCaracs;     
    
        /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old", type="boolean", nullable=true)
     */
    private $blOld=false;  
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_transferred", type="boolean", nullable=true)
     */
    private $blTransferred=false;      
    
    /**
     * 
     * @ORM\ManyToMany(targetEntity="BillingServiceLine", mappedBy="idServiceExtremity") 
     */
    private $idBillingServiceLine;
    
    /**
     * 
     * @ORM\ManyToMany(targetEntity="BillingOneShot", mappedBy="idServiceExtremity",cascade={"persist","remove"}, orphanRemoval=true ) 
     * @ORM\OrderBy({"idBillingOneShot" = "asc"})      
     */
    private $idBillingOneShot;    
   
    /**
     * 
     * @return string
     */ 
    public function __toString()
    {
        try
        {
            return $this->getCdServiceExtremity()."";
        }
        catch (\ErrorException $e)
        {
            var_dump($e);
            return "";
        }        

    }

    public function getHeadInfo()
    {
            $lbparent="";
            $lbaddr="";                
            $lbcontact="";         
        if ($this->getIdServiceExtremityOwner()!=NULL)
        {            
            switch ($this->getIdServiceExtremityOwner()->getIdLocalLoopExtremityOwner())
            {
                case 1:
                    $lbparent=$this->getIdCustomer()!=NULL?$this->getIdCustomer():"";
                    $lbaddr=$this->getIdCustomer()!=NULL?$this->getIdDeliveryAddress():"";                
                    $lbcontact=$this->getIdCustomer()!=NULL?$this->getIdAdminContact():"";                                
                break;
                case 2:
                    $lbparent=$this->getIdPop()!=NULL?$this->getIdPop():"";
                    $lbaddr=$this->getIdPop()!=NULL?$this->getIdAddressPop():"";                                
                    $lbcontact=$this->getIdPop()!=NULL?$this->getIdContactPop():"";    
                break;
                case 3:
                    $lbparent=$this->getIdProvider()!=NULL?$this->getIdProvider():"";
                    $lbaddr=$this->getIdProvider()!=NULL?$this->getIdAddressProvider():"";                                
                    $lbcontact=$this->getIdProvider()!=NULL?$this->getIdContactProvider():"";                                                
                break;        
            }
        }
            $retour= "<td >".$this->getCdServiceExtremity()."</td><td>".$lbparent."</td><td>".$lbaddr."</td><td>".$lbcontact."</td><td>";
            if (!$this->getBlOld() && $this->getIdService()->canTransfer()  && $this->getDtRealTerminate()==NULL)
                $retour.="<button type='button' id='bb_transfer_button' class='transfer_button btn btn-link' data-id='".$this->getIdServiceExtremity()."'><i class='icones_actions_synchro'></i></button>";
            if (!$this->getBlOld() && $this->getIdService()->canUpgradeExtremity()  && $this->getDtRealTerminate()==NULL)
                $retour.="<button type='button' id='bb_upgrade_button' class='upgrade_button btn btn-link' data-id='".$this->getIdServiceExtremity()."'><i class='icones_actions_update'></i></button>";
            if (!$this->getBlOld() && $this->getIdService()->canTerminateExtremity() && $this->getDtRealTerminate()==NULL)
                $retour.="<button type='button' id='bb_terminate_button' class='terminate_button btn btn-link' data-id='".$this->getIdServiceExtremity()."'><i class='icones_actions_cloture'></i></button>";

            $retour.="</td>";            
            return $retour;
    } 
    
    public function getHeadColumns()
    {
           $retour= "<th>Extremity ref</th><th>Customer/Provider/Pop</th><th>Delivery address</th><th>Administrative Contact</th>";            
           $retour.="<th></th>";
            return $retour;
    } 
    
    public function isNetrecovaConnected()
    {
        foreach ($this->getIdServiceCaracs() as $carac)
        {
            if ($carac->getIdProductCaracs()->getIdProductCaracs()==44 && $carac->getValeur()!=NULL)
                return true;
        }
        return false;
    }   
    
    public function retreiveCommercialRoute()
    {
        foreach ($this->getIdServiceCaracs() as $carac)
        {
            if ($carac->getIdProductCaracs()->getIdProductCaracs()==22 && $carac->getValeur()!=NULL)
                return $carac->getValeur();
        }
        return NULL;
    }      
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     */
    public function preSave(\Symfony\Component\Form\Form $form,$em)
    {    
        $foundConnected=false;
        foreach ($this->getIdServiceCaracs() as $service_carac)
        {
            if ($service_carac->getIdProductCaracs()->getNbLocation()==1 && isset($form[$service_carac->getIdProductCaracs()->getLbField()]))
            {
                if (is_object($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()) && substr(get_class($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()),0,27)=="Etrali\\GinangBundle\\Entity\\")
                {
                    $getter="get".ucfirst($service_carac->getIdProductCaracs()->getLbField());
                    if (property_exists($form[$service_carac->getIdProductCaracs()->getLbField()]->getData(), $service_carac->getIdProductCaracs()->getLbField()))
                        $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->$getter());
                    else
                        $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->getId()); 
                    
                    /** handle connected services * /
                     * 
                     */
                    if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==44 && !$this->getIdService()->hasParentService($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()))
                    {
                        $foundConnected=true;
                        $form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->addIdConnectedService($this->getIdService());
                        $em->persist($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
                        $this->getIdService()->addIdParentService($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
                    }                    
                }                    
                else if ($form[$service_carac->getIdProductCaracs()->getLbField()]->getData() instanceof \Datetime)
                    $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData()->format("Y-m-d H:i:s"));
                else
                    $service_carac->setValeur($form[$service_carac->getIdProductCaracs()->getLbField()]->getData());
            }
        }
        if (!$foundConnected)
        {
            $ids=array();
            foreach ($this->getIdService()->getIdServiceExtremity() as $extr)
            {
                foreach ($extr->getIdServiceCaracs() as $service_carac)
                {
                    if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==44 && $service_carac->getValeur()!=NULL)
                        $ids[$service_carac->getValeur()]=1;
                }
            }
            foreach ($this->getIdService()->getIdParentServices() as $parent)
            {
                if ($parent->getIdProduct()->getIdProductType()->getIdProductType()==5 && !array_key_exists($parent->getIdService(), $ids))
                {
                    $this->getIdService()->removeIdParentService($parent);
                    $parent->removeIdConnectedService($this->getIdService());
                    $em->persist($parent);
                }
            }            
        }
        $em->persist($this->getIdService());
        
        $em->flush();
    }

    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     */
    public function postSave(\Symfony\Component\Form\Form $form,$em)
    {
        $tech=  $this->getIdServiceExtremityTech();
        $tech->setIdPop($this->getIdPop());        
        $tech->setIdProvider($this->getIdProvider());   
        $tech->setIdCustomer($this->getIdCustomer());           
        $tech->setIdServiceExtremityOwner($this->getIdServiceExtremityOwner()); 

        foreach ($this->getIdServiceCaracs() as $service_carac)
        {
            if ($service_carac->getIdProductCaracs()->getLbField()=="dtAcceptSent")
            {                
                if ($this->getIdService()->getIdSelectedExtremity()==null && $service_carac->getValeur()!=null)
                {
                    $this->getIdService()->setIdSelectedExtremity ($this);
                    $em->persist($this->getIdService());
                }
            }
            $em->persist($service_carac);
        }        
        $em->persist($tech);
                
        $em->flush();
    }
        
    
    public function getEditType($type)
    {
        $idtrans=$this->getIdService()->getIdTransactionStatus()->getIdTransactionStatus();
        $idtype=$this->getIdService()->getIdTransactionType()->getIdTransactionType();        
        $type->setTransaction($idtype,$idtrans);  
        $type->setOld($this->getIdService()->getIdTransferExtremity()!=NULL &&  $this->getIdService()->getIdTransferExtremity()->getIdOldExtremity()!=NULL && $this->getIdService()->getIdTransferExtremity()->getIdOldExtremity()->getIdServiceExtremity()==$this->getIdServiceExtremity());
        $type->setTransfer($this->getIdService()->getIdTransferExtremity()!=NULL &&  $this->getIdService()->getIdTransferExtremity()->getIdServiceExtremity()==$this->getIdServiceExtremity());        
        $type->setObject($this);          
        return $type;
    }
    
    /**
     * Get cdServiceExtremity
     *
     * @return string 
     */
    public function getCdServiceExtremity()
    {
        try
        {            
        if ($this->getIdService()==NULL || $this->getIdService()->isP2P())
            return $this->cdServiceExtremity;
        else
        {
            $havecds=array(4,20,18,27);
            if (in_array($this->getIdService()->getIdProduct()->getIdProductType()->getIdProductType(),$havecds))
            {
                $prodcd=$this->getIdService()->getIdProduct()->getIdProductType()->getCdProductType ();
                $Aend="";
                $suppl="";
                if ($this->getBlOld())
                    $suppl="Old";
                if ($this->getIdServiceExtremityOwner()!=NULL)
                {
                    switch ($this->getIdServiceExtremityOwner()->getIdLocalLoopExtremityOwner())
                    {
                        case 1:
                            if ($this->getIdCustomer()!=NULL && $this->getIdDeliveryAddress()!=NULL && $this->getIdDeliveryAddress()->getIdCity()!=NULL)
                                $Aend=$this->getIdDeliveryAddress()->getIdCity()->getCdCity();
                            break;
                        case 2:
                            if ($this->getIdPop()!=NULL && $this->getIdAddressPop()!=NULL && $this->getIdAddressPop()->getIdCity()!=NULL)
                                $Aend=$this->getIdAddressPop()->getIdCity()->getCdCity();
                            break;
                        case 3:
                            if ($this->getIdProvider()!=NULL && $this->getIdAddressProvider()!=NULL && $this->getIdAddressProvider()->getIdCity()!=NULL)
                                $Aend=$this->getIdAddressProvider()->getIdCity()->getCdCity();
                            break;                                    
                    }
                }                
                return $prodcd.$Aend.$this->getIdService()->getIdService().substr($this->cdServiceExtremity,0,1).$suppl;
            }
        }
        }
        catch (Exception $e)
        {
            var_dump($e);
            return "";
        }        
    }
    
    /**
     * 
     * @return Branch
     */
    public function getParentBranch() {
        if($this->getIdService()!=null)
            return $this->getIdService()->getIdBranch();
        return NULL;
    }
    
    /**
     * 
     * @return entity
     */
    public function getExtremity(){
        if($this->idServiceExtremityOwner){
            $owner = $this->idServiceExtremityOwner->getIdLocalLoopExtremityOwner();
            if($owner == ServiceExtremity::OWNER_CUSTOMER)
                return $this->idCustomer;
            if($owner == ServiceExtremity::OWNER_POP)
                return $this->idPop;
            if($owner == ServiceExtremity::OWNER_PROVIDER)
                return $this->idProvider;

            return null;        
        }
        return null;
    }
    
    /**
     * 
     * @return entity
     */
    public function getExtremityAddress(){
        if($this->idServiceExtremityOwner){
            $owner = $this->idServiceExtremityOwner->getIdLocalLoopExtremityOwner();
            if($owner == ServiceExtremity::OWNER_CUSTOMER)
                return $this->idDeliveryAddress;
            if($owner == ServiceExtremity::OWNER_POP)
                return $this->idAddressPop;
            if($owner == ServiceExtremity::OWNER_PROVIDER)
                return $this->idAddressProvider;

            return null;        
        }
        return null;
    }
    
    /**
     * 
     * @return string
     */
    public function getStatus(){
        //Dans ServiceExtremity Si dtRealTerminate est défini status=Terminé, si dtInservice est défini status=Active, sinon Status=Création
        if($this->dtRealTerminate)
            return "Terminé";
        if($this->dtInservice)
            return "Active";
       
        return "Création";
    }
    
    /**
     * 
     * @return String
     */
   public function getTrader(){
       foreach ($this->getIdServiceCaracs() as $serviceCaracs){
           if($serviceCaracs->getIdProductCaracs()->getIdProductCaracs() == ServiceExtremity::PRODUCT_CARACS_TRADER)
               return $serviceCaracs->getValeur();
       }
       return null;
   }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idServiceCaracs = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBillingServiceLine = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idBillingOneShot = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idServiceExtremity
     *
     * @return integer 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Set cdServiceExtremity
     *
     * @param string $cdServiceExtremity
     * @return ServiceExtremity
     */
    public function setCdServiceExtremity($cdServiceExtremity)
    {
        $this->cdServiceExtremity = $cdServiceExtremity;
    
        return $this;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return ServiceExtremity
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set dtInitTerminate
     *
     * @param \DateTime $dtInitTerminate
     * @return ServiceExtremity
     */
    public function setDtInitTerminate($dtInitTerminate)
    {
        $this->dtInitTerminate = $dtInitTerminate;
    
        return $this;
    }

    /**
     * Get dtInitTerminate
     *
     * @return \DateTime 
     */
    public function getDtInitTerminate()
    {
        return $this->dtInitTerminate;
    }

    /**
     * Set dtInitUpdown
     *
     * @param \DateTime $dtInitUpdown
     * @return ServiceExtremity
     */
    public function setDtInitUpdown($dtInitUpdown)
    {
        $this->dtInitUpdown = $dtInitUpdown;
    
        return $this;
    }

    /**
     * Get dtInitUpdown
     *
     * @return \DateTime 
     */
    public function getDtInitUpdown()
    {
        return $this->dtInitUpdown;
    }

    /**
     * Set dtRequestUpdown
     *
     * @param \DateTime $dtRequestUpdown
     * @return ServiceExtremity
     */
    public function setDtRequestUpdown($dtRequestUpdown)
    {
        $this->dtRequestUpdown = $dtRequestUpdown;
    
        return $this;
    }

    /**
     * Get dtRequestUpdown
     *
     * @return \DateTime 
     */
    public function getDtRequestUpdown()
    {
        return $this->dtRequestUpdown;
    }

    /**
     * Set dtRealUpdown
     *
     * @param \DateTime $dtRealUpdown
     * @return ServiceExtremity
     */
    public function setDtRealUpdown($dtRealUpdown)
    {
        $this->dtRealUpdown = $dtRealUpdown;
    
        return $this;
    }

    /**
     * Get dtRealUpdown
     *
     * @return \DateTime 
     */
    public function getDtRealUpdown()
    {
        return $this->dtRealUpdown;
    }

    /**
     * Set dtRequestTerminate
     *
     * @param \DateTime $dtRequestTerminate
     * @return ServiceExtremity
     */
    public function setDtRequestTerminate($dtRequestTerminate)
    {
        $this->dtRequestTerminate = $dtRequestTerminate;
    
        return $this;
    }

    /**
     * Get dtRequestTerminate
     *
     * @return \DateTime 
     */
    public function getDtRequestTerminate()
    {
        return $this->dtRequestTerminate;
    }

    /**
     * Set dtRealTerminate
     *
     * @param \DateTime $dtRealTerminate
     * @return ServiceExtremity
     */
    public function setDtRealTerminate($dtRealTerminate)
    {
        $this->dtRealTerminate = $dtRealTerminate;
    
        return $this;
    }

    /**
     * Get dtRealTerminate
     *
     * @return \DateTime 
     */
    public function getDtRealTerminate()
    {
        return $this->dtRealTerminate;
    }

    /**
     * Set dtInservice
     *
     * @param \DateTime $dtInservice
     * @return ServiceExtremity
     */
    public function setDtInservice($dtInservice)
    {
        $this->dtInservice = $dtInservice;
    
        return $this;
    }

    /**
     * Get dtInservice
     *
     * @return \DateTime 
     */
    public function getDtInservice()
    {
        return $this->dtInservice;
    }

    /**
     * Set dtInitTransfer
     *
     * @param \DateTime $dtInitTransfer
     * @return ServiceExtremity
     */
    public function setDtInitTransfer($dtInitTransfer)
    {
        $this->dtInitTransfer = $dtInitTransfer;
    
        return $this;
    }

    /**
     * Get dtInitTransfer
     *
     * @return \DateTime 
     */
    public function getDtInitTransfer()
    {
        return $this->dtInitTransfer;
    }

    /**
     * Set dtInitAddExtremity
     *
     * @param \DateTime $dtInitAddExtremity
     * @return ServiceExtremity
     */
    public function setDtInitAddExtremity($dtInitAddExtremity)
    {
        $this->dtInitAddExtremity = $dtInitAddExtremity;
    
        return $this;
    }

    /**
     * Get dtInitAddExtremity
     *
     * @return \DateTime 
     */
    public function getDtInitAddExtremity()
    {
        return $this->dtInitAddExtremity;
    }

    /**
     * Set dtRequestTransfer
     *
     * @param \DateTime $dtRequestTransfer
     * @return ServiceExtremity
     */
    public function setDtRequestTransfer($dtRequestTransfer)
    {
        $this->dtRequestTransfer = $dtRequestTransfer;
    
        return $this;
    }

    /**
     * Get dtRequestTransfer
     *
     * @return \DateTime 
     */
    public function getDtRequestTransfer()
    {
        return $this->dtRequestTransfer;
    }

    /**
     * Set dtRequestAddExtremity
     *
     * @param \DateTime $dtRequestAddExtremity
     * @return ServiceExtremity
     */
    public function setDtRequestAddExtremity($dtRequestAddExtremity)
    {
        $this->dtRequestAddExtremity = $dtRequestAddExtremity;
    
        return $this;
    }

    /**
     * Get dtRequestAddExtremity
     *
     * @return \DateTime 
     */
    public function getDtRequestAddExtremity()
    {
        return $this->dtRequestAddExtremity;
    }

    /**
     * Set dtCompleteTransfer
     *
     * @param \DateTime $dtCompleteTransfer
     * @return ServiceExtremity
     */
    public function setDtCompleteTransfer($dtCompleteTransfer)
    {
        $this->dtCompleteTransfer = $dtCompleteTransfer;
    
        return $this;
    }

    /**
     * Get dtCompleteTransfer
     *
     * @return \DateTime 
     */
    public function getDtCompleteTransfer()
    {
        return $this->dtCompleteTransfer;
    }

    /**
     * Set dtAddExtremityInservice
     *
     * @param \DateTime $dtAddExtremityInservice
     * @return ServiceExtremity
     */
    public function setDtAddExtremityInservice($dtAddExtremityInservice)
    {
        $this->dtAddExtremityInservice = $dtAddExtremityInservice;
    
        return $this;
    }

    /**
     * Get dtAddExtremityInservice
     *
     * @return \DateTime 
     */
    public function getDtAddExtremityInservice()
    {
        return $this->dtAddExtremityInservice;
    }

    /**
     * Set dtOldExtremityTerminate
     *
     * @param \DateTime $dtOldExtremityTerminate
     * @return ServiceExtremity
     */
    public function setDtOldExtremityTerminate($dtOldExtremityTerminate)
    {
        $this->dtOldExtremityTerminate = $dtOldExtremityTerminate;
    
        return $this;
    }

    /**
     * Get dtOldExtremityTerminate
     *
     * @return \DateTime 
     */
    public function getDtOldExtremityTerminate()
    {
        return $this->dtOldExtremityTerminate;
    }

    /**
     * Set lbOnnet
     *
     * @param string $lbOnnet
     * @return ServiceExtremity
     */
    public function setLbOnnet($lbOnnet)
    {
        $this->lbOnnet = $lbOnnet;
    
        return $this;
    }

    /**
     * Get lbOnnet
     *
     * @return string 
     */
    public function getLbOnnet()
    {
        return $this->lbOnnet;
    }

    /**
     * Set blOld
     *
     * @param boolean $blOld
     * @return ServiceExtremity
     */
    public function setBlOld($blOld)
    {
        $this->blOld = $blOld;
    
        return $this;
    }

    /**
     * Get blOld
     *
     * @return boolean 
     */
    public function getBlOld()
    {
        return $this->blOld;
    }

    /**
     * Set blTransferred
     *
     * @param boolean $blTransferred
     * @return ServiceExtremity
     */
    public function setBlTransferred($blTransferred)
    {
        $this->blTransferred = $blTransferred;
    
        return $this;
    }

    /**
     * Get blTransferred
     *
     * @return boolean 
     */
    public function getBlTransferred()
    {
        return $this->blTransferred;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return ServiceExtremity
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return ServiceExtremity
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return ServiceExtremity
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Set idPop
     *
     * @param \Etrali\GinangBundle\Entity\Pop $idPop
     * @return ServiceExtremity
     */
    public function setIdPop(\Etrali\GinangBundle\Entity\Pop $idPop = null)
    {
        $this->idPop = $idPop;
    
        return $this;
    }

    /**
     * Get idPop
     *
     * @return \Etrali\GinangBundle\Entity\Pop 
     */
    public function getIdPop()
    {
        return $this->idPop;
    }

    /**
     * Set idAddressPop
     *
     * @param \Etrali\GinangBundle\Entity\AddressPop $idAddressPop
     * @return ServiceExtremity
     */
    public function setIdAddressPop(\Etrali\GinangBundle\Entity\AddressPop $idAddressPop = null)
    {
        $this->idAddressPop = $idAddressPop;
    
        return $this;
    }

    /**
     * Get idAddressPop
     *
     * @return \Etrali\GinangBundle\Entity\AddressPop 
     */
    public function getIdAddressPop()
    {
        return $this->idAddressPop;
    }

    /**
     * Set idContactPop
     *
     * @param \Etrali\GinangBundle\Entity\ContactPop $idContactPop
     * @return ServiceExtremity
     */
    public function setIdContactPop(\Etrali\GinangBundle\Entity\ContactPop $idContactPop = null)
    {
        $this->idContactPop = $idContactPop;
    
        return $this;
    }

    /**
     * Get idContactPop
     *
     * @return \Etrali\GinangBundle\Entity\ContactPop 
     */
    public function getIdContactPop()
    {
        return $this->idContactPop;
    }

    /**
     * Set idAdminContact
     *
     * @param \Etrali\GinangBundle\Entity\Contact $idAdminContact
     * @return ServiceExtremity
     */
    public function setIdAdminContact(\Etrali\GinangBundle\Entity\Contact $idAdminContact = null)
    {
        $this->idAdminContact = $idAdminContact;
    
        return $this;
    }

    /**
     * Get idAdminContact
     *
     * @return \Etrali\GinangBundle\Entity\Contact 
     */
    public function getIdAdminContact()
    {
        return $this->idAdminContact;
    }

    /**
     * Set idDeliveryAddress
     *
     * @param \Etrali\GinangBundle\Entity\Address $idDeliveryAddress
     * @return ServiceExtremity
     */
    public function setIdDeliveryAddress(\Etrali\GinangBundle\Entity\Address $idDeliveryAddress = null)
    {
        $this->idDeliveryAddress = $idDeliveryAddress;
    
        return $this;
    }

    /**
     * Get idDeliveryAddress
     *
     * @return \Etrali\GinangBundle\Entity\Address 
     */
    public function getIdDeliveryAddress()
    {
        return $this->idDeliveryAddress;
    }

    /**
     * Set idAddressProvider
     *
     * @param \Etrali\GinangBundle\Entity\AddressProvider $idAddressProvider
     * @return ServiceExtremity
     */
    public function setIdAddressProvider(\Etrali\GinangBundle\Entity\AddressProvider $idAddressProvider = null)
    {
        $this->idAddressProvider = $idAddressProvider;
    
        return $this;
    }

    /**
     * Get idAddressProvider
     *
     * @return \Etrali\GinangBundle\Entity\AddressProvider 
     */
    public function getIdAddressProvider()
    {
        return $this->idAddressProvider;
    }

    /**
     * Set idContactProvider
     *
     * @param \Etrali\GinangBundle\Entity\ContactProvider $idContactProvider
     * @return ServiceExtremity
     */
    public function setIdContactProvider(\Etrali\GinangBundle\Entity\ContactProvider $idContactProvider = null)
    {
        $this->idContactProvider = $idContactProvider;
    
        return $this;
    }

    /**
     * Get idContactProvider
     *
     * @return \Etrali\GinangBundle\Entity\ContactProvider 
     */
    public function getIdContactProvider()
    {
        return $this->idContactProvider;
    }

    /**
     * Set idProject
     *
     * @param \Etrali\GinangBundle\Entity\Project $idProject
     * @return ServiceExtremity
     */
    public function setIdProject(\Etrali\GinangBundle\Entity\Project $idProject = null)
    {
        $this->idProject = $idProject;
    
        return $this;
    }

    /**
     * Get idProject
     *
     * @return \Etrali\GinangBundle\Entity\Project 
     */
    public function getIdProject()
    {
        return $this->idProject;
    }

    /**
     * Set idServiceExtremityOwner
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idServiceExtremityOwner
     * @return ServiceExtremity
     */
    public function setIdServiceExtremityOwner(\Etrali\GinangBundle\Entity\LocalLoopExtremityOwner $idServiceExtremityOwner = null)
    {
        $this->idServiceExtremityOwner = $idServiceExtremityOwner;
    
        return $this;
    }

    /**
     * Get idServiceExtremityOwner
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityOwner 
     */
    public function getIdServiceExtremityOwner()
    {
        return $this->idServiceExtremityOwner;
    }

    /**
     * Set idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return ServiceExtremity
     */
    public function setIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech = null)
    {
        $this->idServiceExtremityTech = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremityTech 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }

    /**
     * Set idOldExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idOldExtremity
     * @return ServiceExtremity
     */
    public function setIdOldExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idOldExtremity = null)
    {
        $this->idOldExtremity = $idOldExtremity;
    
        return $this;
    }

    /**
     * Get idOldExtremity
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremity 
     */
    public function getIdOldExtremity()
    {
        return $this->idOldExtremity;
    }

    /**
     * Add idServiceCaracs
     *
     * @param \Etrali\GinangBundle\Entity\ServiceCaracs $idServiceCaracs
     * @return ServiceExtremity
     */
    public function addIdServiceCarac(\Etrali\GinangBundle\Entity\ServiceCaracs $idServiceCaracs)
    {
        $this->idServiceCaracs[] = $idServiceCaracs;
    
        return $this;
    }

    /**
     * Remove idServiceCaracs
     *
     * @param \Etrali\GinangBundle\Entity\ServiceCaracs $idServiceCaracs
     */
    public function removeIdServiceCarac(\Etrali\GinangBundle\Entity\ServiceCaracs $idServiceCaracs)
    {
        $this->idServiceCaracs->removeElement($idServiceCaracs);
    }

    /**
     * Get idServiceCaracs
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceCaracs()
    {
        return $this->idServiceCaracs;
    }

    /**
     * Add idBillingServiceLine
     *
     * @param \Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine
     * @return ServiceExtremity
     */
    public function addIdBillingServiceLine(\Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine)
    {
        $this->idBillingServiceLine[] = $idBillingServiceLine;
    
        return $this;
    }

    /**
     * Remove idBillingServiceLine
     *
     * @param \Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine
     */
    public function removeIdBillingServiceLine(\Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine)
    {
        $this->idBillingServiceLine->removeElement($idBillingServiceLine);
    }

    /**
     * Get idBillingServiceLine
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingServiceLine()
    {
        return $this->idBillingServiceLine;
    }

    /**
     * Add idBillingOneShot
     *
     * @param \Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot
     * @return ServiceExtremity
     */
    public function addIdBillingOneShot(\Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot)
    {
        $this->idBillingOneShot[] = $idBillingOneShot;
    
        return $this;
    }

    /**
     * Remove idBillingOneShot
     *
     * @param \Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot
     */
    public function removeIdBillingOneShot(\Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot)
    {
        $this->idBillingOneShot->removeElement($idBillingOneShot);
    }

    /**
     * Get idBillingOneShot
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingOneShot()
    {
        return $this->idBillingOneShot;
    }

    /**
     * Set idTransferPrice
     *
     * @param \Etrali\GinangBundle\Entity\TransferPrice $idTransferPrice
     * @return ServiceExtremity
     */
    public function setIdTransferPrice(\Etrali\GinangBundle\Entity\TransferPrice $idTransferPrice = null)
    {
        $this->idTransferPrice = $idTransferPrice;
    
        return $this;
    }

    /**
     * Get idTransferPrice
     *
     * @return \Etrali\GinangBundle\Entity\TransferPrice 
     */
    public function getIdTransferPrice()
    {
        return $this->idTransferPrice;
    }

    /**
     * Set mtLocalLoopCost
     *
     * @param float $mtLocalLoopCost
     * @return ServiceExtremity
     */
    public function setMtLocalLoopCost($mtLocalLoopCost)
    {
        $this->mtLocalLoopCost = $mtLocalLoopCost;
    
        return $this;
    }

    /**
     * Get mtLocalLoopCost
     *
     * @return float 
     */
    public function getMtLocalLoopCost()
    {
        return $this->mtLocalLoopCost;
    }

    /**
     * Set idLocalLoopCostType
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopCostType $idLocalLoopCostType
     * @return ServiceExtremity
     */
    public function setIdLocalLoopCostType(\Etrali\GinangBundle\Entity\LocalLoopCostType $idLocalLoopCostType = null)
    {
        $this->idLocalLoopCostType = $idLocalLoopCostType;
    
        return $this;
    }

    /**
     * Get idLocalLoopCostType
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopCostType 
     */
    public function getIdLocalLoopCostType()
    {
        return $this->idLocalLoopCostType;
    }
    
    /**
     * 
     * @return billingService
     */
    public function getBillingServiceActive(){
        $billingServiceLines = $this->getIdBillingServiceLine();
        $billingServiceLine = null;
        $billingService = null;

        if($billingServiceLines){
            $dtStartMrc = null;
            
            foreach($billingServiceLines as $value){
                if($value->getDtStartMrc() && (!$dtStartMrc || ($value->getDtStartMrc() > $dtStartMrc))){
                    $billingServiceLine = $value;
                    $dtStartMrc = $value->getDtStartMrc();
                }
            }
        }

        if(!empty($billingServiceLine))
            $billingService = $billingServiceLine->getIdBillingService();
        
        return $billingService;
    }

    /**
     * Set cmLocalLoopCost
     *
     * @param string $cmLocalLoopCost
     * @return ServiceExtremity
     */
    public function setCmLocalLoopCost($cmLocalLoopCost)
    {
        $this->cmLocalLoopCost = $cmLocalLoopCost;
    
        return $this;
    }

    /**
     * Get cmLocalLoopCost
     *
     * @return string 
     */
    public function getCmLocalLoopCost()
    {
        return $this->cmLocalLoopCost;
    }
}