<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceExtremityOption
 *
 * @ORM\Table(name="service_extremity_option")
 * @ORM\Entity
 */
class ServiceExtremityOption
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_extremity_option", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceExtremityOption;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_quantity", type="integer", nullable=true)
     */
    private $nbQuantity;

        /**
     * @var string
     *
     * @ORM\Column(name="lb_option", type="string", nullable=true)
     */
    private $lbOption;
    
    /**
     * @var \DateTime
     * @Gedmo\Timestampable(on="create") 
     * @ORM\Column(name="dt_create", type="datetime", nullable=false)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=false)
     */
    private $blDeactivated=true;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_billable", type="boolean", nullable=false)
     */
    private $blBillable=true;        

    /**
     * @var \OptionType
     *
     * @ORM\ManyToOne(targetEntity="OptionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_option_type", referencedColumnName="id_option_type")
     * })
     */
    private $idOptionType;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_option", type="string", nullable=true)
     * @Assert\NotBlank()
     */
    private $cdOption;    

    /**
     * @var \ServiceExtremity
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremity")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity", referencedColumnName="id_service_extremity")
     * })
     */
    private $idServiceExtremity;
    
 /**
     * @var \BillingOneShot
     *
     * @ORM\OneToMany(targetEntity="BillingOneShot", mappedBy="idServiceExtremityOption",cascade={"persist","remove"}, orphanRemoval=true )  
     * @ORM\OrderBy({"idBillingOneShot" = "asc"})         
     */
    private $idBillingOneShot;   
    
    /**
     * @var \BillingServiceLine
     * 
     * @ORM\OneToMany(targetEntity="BillingServiceLine", mappedBy="idServiceExtremityOption",cascade={"persist","remove"}, orphanRemoval=true ) 
     */
    private $idBillingServiceLine;  
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

   public function __toString()
    {
        return $this->getCdOption().":".$this->getLbOption();
    }
    
    

    public function getHeadInfo()
    {
            return "<td>".$this->getCdOption()."</td><td >".$this->getLbOption()."</td><td >".$this->getNbQuantity()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Ref</th><th>Description</th><th>Quantity</th>";
    }   

    /**
     * Get idServiceExtremityOption
     *
     * @return integer 
     */
    public function getIdServiceExtremityOption()
    {
        return $this->idServiceExtremityOption;
    }

    /**
     * Set nbQuantity
     *
     * @param integer $nbQuantity
     * @return ServiceExtremityOption
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return integer 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ServiceExtremityOption
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return ServiceExtremityOption
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ServiceExtremityOption
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idOptionType
     *
     * @param \Etrali\GinangBundle\Entity\OptionType $idOptionType
     * @return ServiceExtremityOption
     */
    public function setIdOptionType(\Etrali\GinangBundle\Entity\OptionType $idOptionType = null)
    {
        $this->idOptionType = $idOptionType;
    
        return $this;
    }

    /**
     * Get idOptionType
     *
     * @return \Etrali\GinangBundle\Entity\OptionType 
     */
    public function getIdOptionType()
    {
        return $this->idOptionType;
    }

    /**
     * Set idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return ServiceExtremityOption
     */
    public function setIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity = null)
    {
        $this->idServiceExtremity = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Get idServiceExtremity
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremity 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Set blBillable
     *
     * @param boolean $blBillable
     * @return ServiceExtremityOption
     */
    public function setBlBillable($blBillable)
    {
        $this->blBillable = $blBillable;
    
        return $this;
    }

    /**
     * Get blBillable
     *
     * @return boolean 
     */
    public function getBlBillable()
    {
        return $this->blBillable;
    }

    /**
     * Set lbOption
     *
     * @param string $lbOption
     * @return ServiceExtremityOption
     */
    public function setLbOption($lbOption)
    {
        $this->lbOption = $lbOption;
    
        return $this;
    }

    /**
     * Get lbOption
     *
     * @return string 
     */
    public function getLbOption()
    {
        return $this->lbOption;
    }

    /**
     * Set cdOption
     *
     * @param string $cdOption
     * @return ServiceExtremityOption
     */
    public function setCdOption($cdOption)
    {
        $this->cdOption = $cdOption;
    
        return $this;
    }

    /**
     * Get cdOption
     *
     * @return string 
     */
    public function getCdOption()
    {
        return $this->cdOption;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBillingOneShot = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idBillingOneShot
     *
     * @param \Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot
     * @return ServiceExtremityOption
     */
    public function addIdBillingOneShot(\Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot)
    {
        $this->idBillingOneShot[] = $idBillingOneShot;
    
        return $this;
    }

    /**
     * Remove idBillingOneShot
     *
     * @param \Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot
     */
    public function removeIdBillingOneShot(\Etrali\GinangBundle\Entity\BillingOneShot $idBillingOneShot)
    {
        $this->idBillingOneShot->removeElement($idBillingOneShot);
    }

    /**
     * Get idBillingOneShot
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingOneShot()
    {
        return $this->idBillingOneShot;
    }public function getParentBranch() { return NULL; }  
    /**
     * Add idBillingServiceLine
     *
     * @param \Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine
     * @return ServiceExtremityOption
     */
    public function addIdBillingServiceLine(\Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine)
    {
        $this->idBillingServiceLine[] = $idBillingServiceLine;
    
        return $this;
    }

    /**
     * Remove idBillingServiceLine
     *
     * @param \Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine
     */
    public function removeIdBillingServiceLine(\Etrali\GinangBundle\Entity\BillingServiceLine $idBillingServiceLine)
    {
        $this->idBillingServiceLine->removeElement($idBillingServiceLine);
    }

    /**
     * Get idBillingServiceLine
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBillingServiceLine()
    {
        return $this->idBillingServiceLine;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ServiceExtremityOption
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}