<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceInterfaceSettings
 *
 * @ORM\Table(name="service_interface_settings")
 * @ORM\Entity
 */
class ServiceInterfaceSettings
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_interface_settings", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceInterfaceSettings;


    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_hide", type="boolean", nullable=false)
     */
    private $blHide=true;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_editable", type="boolean", nullable=false)
     */
    private $blEditable=true;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_old_extremity", type="boolean", nullable=false)
     */
    private $blOldExtremity=false;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_mandatory", type="boolean", nullable=false)
     */
    private $blMandatory=true;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_one", type="boolean", nullable=false)
     */
    private $blOne=false;    
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;

    /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;

    /**
     * @var string
     *
     * @ORM\Column(name="lbEntity", type="string", length=45, nullable=true)
     */
    private $lbEntity;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lbField", type="string", length=45, nullable=true)
     */
    private $lbField;
    
    /**
     * @var \ProductType
     *
     * @ORM\ManyToOne(targetEntity="ProductType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product_type", referencedColumnName="id_product_type")
     * })
     */
    private $idProductType;
    

    public function __toString()
    {
        return $this->getLbField();
    }
    /**
     * Get idServiceInterfaceSettings
     *
     * @return integer 
     */
    public function getIdServiceInterfaceSettings()
    {
        return $this->idServiceInterfaceSettings;
    }

    /**
     * Set blHide
     *
     * @param boolean $blHide
     * @return ServiceInterfaceSettings
     */
    public function setBlHide($blHide)
    {
        $this->blHide = $blHide;
    
        return $this;
    }

    /**
     * Get blHide
     *
     * @return boolean 
     */
    public function getBlHide()
    {
        return $this->blHide;
    }

    /**
     * Set blEditable
     *
     * @param boolean $blEditable
     * @return ServiceInterfaceSettings
     */
    public function setBlEditable($blEditable)
    {
        $this->blEditable = $blEditable;
    
        return $this;
    }

    /**
     * Get blEditable
     *
     * @return boolean 
     */
    public function getBlEditable()
    {
        return $this->blEditable;
    }

    /**
     * Set lbField
     *
     * @param string $lbField
     * @return ServiceInterfaceSettings
     */
    public function setLbField($lbField)
    {
        $this->lbField = $lbField;
    
        return $this;
    }

    /**
     * Get lbField
     *
     * @return string 
     */
    public function getLbField()
    {
        return $this->lbField;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return ServiceInterfaceSettings
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return ServiceInterfaceSettings
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set blMandatory
     *
     * @param boolean $blMandatory
     * @return ServiceInterfaceSettings
     */
    public function setBlMandatory($blMandatory)
    {
        $this->blMandatory = $blMandatory;
    
        return $this;
    }

    /**
     * Get blMandatory
     *
     * @return boolean 
     */
    public function getBlMandatory()
    {
        return $this->blMandatory;
    }

    /**
     * Set lbEntity
     *
     * @param string $lbEntity
     * @return ServiceInterfaceSettings
     */
    public function setLbEntity($lbEntity)
    {
        $this->lbEntity = $lbEntity;
    
        return $this;
    }

    /**
     * Get lbEntity
     *
     * @return string 
     */
    public function getLbEntity()
    {
        return $this->lbEntity;
    }

    /**
     * Set blOldExtremity
     *
     * @param boolean $blOldExtremity
     * @return ServiceInterfaceSettings
     */
    public function setBlOldExtremity($blOldExtremity)
    {
        $this->blOldExtremity = $blOldExtremity;
    
        return $this;
    }

    /**
     * Get blOldExtremity
     *
     * @return boolean 
     */
    public function getBlOldExtremity()
    {
        return $this->blOldExtremity;
    }

    /**
     * Set idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ServiceInterfaceSettings
     */
    public function setIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType = null)
    {
        $this->idProductType = $idProductType;
    
        return $this;
    }

    /**
     * Get idProductType
     *
     * @return \Etrali\GinangBundle\Entity\ProductType 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }

    /**
     * Set blOne
     *
     * @param boolean $blOne
     * @return ServiceInterfaceSettings
     */
    public function setBlOne($blOne)
    {
        $this->blOne = $blOne;
    
        return $this;
    }

    /**
     * Get blOne
     *
     * @return boolean 
     */
    public function getBlOne()
    {
        return $this->blOne;
    }public function getParentBranch() { return NULL; }  }