<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; 
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceTransactions
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Etrali\GinangBundle\Entity\ServiceTransactionsRepository")
 */
class ServiceTransactions
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_transactions", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $idServiceTransactions;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_extremity_ref", type="string", length=45, nullable=true)
     */
    private $cdExtremityRef;
    
    /**
     * @var \TransactionType
     *
     * @ORM\ManyToOne(targetEntity="TransactionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_type", referencedColumnName="id_transaction_type")
     * })
     */
    private $idTransactionType;
    
    /**
     * @var \TransactionStatus
     *
     * @ORM\ManyToOne(targetEntity="TransactionStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_transaction_status", referencedColumnName="id_transaction_status")
     * })
     */
    private $idTransactionStatus;   
    
    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service", inversedBy="idServiceTransactions")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     */    
    private $idService; 
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_operation", type="string", length=45, nullable=true)
     */
    private $lbOperation;     
    
    
    public function getHeadInfo()
    {
            return "<td>".$this->getDtCreate()->format("d/m/Y")."</td><td >".$this->getCdExtremityRef()."</td><td>".$this->getIdTransactionType()."</td><td>".$this->getIdTransactionStatus()."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Date</th><th>Extremity ref</th><th>Transaction type</th><th>Transaction status</th>";
    }   
    
    public function __toString()
    {
        return $this->getDtCreate()->format("d/m/Y")."-".$this->getCdExtremityRef()."-".$this->getIdTransactionType()." : ".$this->getIdTransactionStatus();
    }

    /**
     * Get idServiceTransactions
     *
     * @return integer 
     */
    public function getIdServiceTransactions()
    {
        return $this->idServiceTransactions;
    }


    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ServiceTransactions
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set cdService
     *
     * @param string $cdService
     * @return ServiceTransactions
     */
    public function setCdService($cdService)
    {
        $this->cdService = $cdService;
    
        return $this;
    }

    /**
     * Get cdService
     *
     * @return string 
     */
    public function getCdService()
    {
        return $this->cdService;
    }

    /**
     * Set idTransactionType
     *
     * @param \Etrali\GinangBundle\Entity\TransactionType $idTransactionType
     * @return ServiceTransactions
     */
    public function setIdTransactionType(\Etrali\GinangBundle\Entity\TransactionType $idTransactionType = null)
    {
        $this->idTransactionType = $idTransactionType;
    
        return $this;
    }

    /**
     * Get idTransactionType
     *
     * @return \Etrali\GinangBundle\Entity\TransactionType 
     */
    public function getIdTransactionType()
    {
        return $this->idTransactionType;
    }

    /**
     * Set idTransactionStatus
     *
     * @param \Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus
     * @return ServiceTransactions
     */
    public function setIdTransactionStatus(\Etrali\GinangBundle\Entity\TransactionStatus $idTransactionStatus = null)
    {
        $this->idTransactionStatus = $idTransactionStatus;
    
        return $this;
    }

    /**
     * Get idTransactionStatus
     *
     * @return \Etrali\GinangBundle\Entity\TransactionStatus 
     */
    public function getIdTransactionStatus()
    {
        return $this->idTransactionStatus;
    }

    /**
     * Set cdExtremityRef
     *
     * @param string $cdExtremityRef
     * @return ServiceTransactions
     */
    public function setCdExtremityRef($cdExtremityRef)
    {
        $this->cdExtremityRef = $cdExtremityRef;
    
        return $this;
    }

    /**
     * Get cdExtremityRef
     *
     * @return string 
     */
    public function getCdExtremityRef()
    {
        return $this->cdExtremityRef;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return ServiceTransactions
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Set lbOperation
     *
     * @param string $lbOperation
     * @return ServiceTransactions
     */
    public function setLbOperation($lbOperation)
    {
        $this->lbOperation = $lbOperation;
    
        return $this;
    }

    /**
     * Get lbOperation
     *
     * @return string 
     */
    public function getLbOperation()
    {
        return $this->lbOperation;
    }public function getParentBranch() { return NULL; }  }