<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Access
 *
 * @ORM\Table(name="settings")
 * @ORM\Entity 
 */
class Settings
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_settings", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idSettings;
    
    /**
     * @var \DateTime
     *    
     * @ORM\Column(name="dt_local_loop_cost", type="datetime", nullable=true)
     */
    private $dtLocalLoopCost;    

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;
    
    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    public function __toString()
    {
        return $this->getIdSettings()."";
    }
    
    public static function getModifierRoles()
    {
        return array("ROLE_SUPER_ADMINISTRATOR");
    }
    
    public static function getReaderRoles()
    {
        return array("ROLE_EQUIPMENT_ADMINISTRATOR");
    }

    public function getParentBranch() {
        return NULL;
    }


    /**
     * Get idSettings
     *
     * @return integer 
     */
    public function getIdSettings()
    {
        return $this->idSettings;
    }

    /**
     * Set dtLocalLoopCost
     *
     * @param \DateTime $dtLocalLoopCost
     * @return Settings
     */
    public function setDtLocalLoopCost($dtLocalLoopCost)
    {
        $this->dtLocalLoopCost = $dtLocalLoopCost;
    
        return $this;
    }

    /**
     * Get dtLocalLoopCost
     *
     * @return \DateTime 
     */
    public function getDtLocalLoopCost()
    {
        return $this->dtLocalLoopCost;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return Settings
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return Settings
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }
}