<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * SfpModuleType
 *
 * @ORM\Table(name="sfp_module_type")
 * @ORM\Entity
 */
class SfpModuleType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_sfp_module_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idSfpModuleType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_sfp_module_type", type="string", length=15, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20) 
     */
    private $cdSfpModuleType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_sfp_module_type", type="string", length=100, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50) 
     */
    private $lbSfpModuleType;


    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;    


    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbSfpModuleType().'';
    }
    
    /**
     * Get idSfpModuleType
     *
     * @return integer 
     */
    public function getIdSfpModuleType()
    {
        return $this->idSfpModuleType;
    }

  

    /**
     * Set cdSfpModuleType
     *
     * @param string $cdSfpModuleType
     * @return SfpModuleType
     */
    public function setCdSfpModuleType($cdSfpModuleType)
    {
        $this->cdSfpModuleType = $cdSfpModuleType;
    
        return $this;
    }

    /**
     * Get cdSfpModuleType
     *
     * @return string 
     */
    public function getCdSfpModuleType()
    {
        return $this->cdSfpModuleType;
    }

    /**
     * Set lbSfpModuleType
     *
     * @param string $lbSfpModuleType
     * @return SfpModuleType
     */
    public function setLbSfpModuleType($lbSfpModuleType)
    {
        $this->lbSfpModuleType = $lbSfpModuleType;
    
        return $this;
    }

    /**
     * Get lbSfpModuleType
     *
     * @return string 
     */
    public function getLbSfpModuleType()
    {
        return $this->lbSfpModuleType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return SfpModuleType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return SfpModuleType
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return SfpModuleType
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return SfpModuleType
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return SfpModuleType
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return SfpModuleType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }public function getParentBranch() { return NULL; }  }