<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ShelfTemplate
 *
 * @ORM\Table(name="shelf_template")
 * @ORM\Entity
 */
class ShelfTemplate
{
    /**
     * @var string
     *
     * @ORM\Column(name="cd_shelf", type="string", length=15, nullable=true)
     */
    private $cdShelf;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_shelf", type="string", length=255, nullable=true)
     */
    private $lbShelf;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_shelf", type="string", length=255, nullable=true)
     */
    private $cmShelf;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_serial_number", type="string", length=45, nullable=true)
     */
    private $cdSerialNumber;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_position", type="decimal", nullable=true)
     */
    private $nbPosition;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \Shelf
     *
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="NONE")
     * @ORM\OneToOne(targetEntity="Shelf")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_shelf", referencedColumnName="id_shelf")
     * })
     */
    private $idShelf;

    /**
     * @var \ShelfType
     *
     * @ORM\ManyToOne(targetEntity="ShelfType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_shelf_type", referencedColumnName="id_shelf_type")
     * })
     */
    private $idShelfType;

    /**
     * @var \Equipment
     *
     * @ORM\ManyToOne(targetEntity="Equipment")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_equipment", referencedColumnName="id_equipment")
     * })
     */
    private $idEquipment;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create", referencedColumnName="id")
     * })
     */
    private $idUserCreate;



    /**
     * Set cdShelf
     *
     * @param string $cdShelf
     * @return ShelfTemplate
     */
    public function setCdShelf($cdShelf)
    {
        $this->cdShelf = $cdShelf;
    
        return $this;
    }

    /**
     * Get cdShelf
     *
     * @return string 
     */
    public function getCdShelf()
    {
        return $this->cdShelf;
    }

    /**
     * Set lbShelf
     *
     * @param string $lbShelf
     * @return ShelfTemplate
     */
    public function setLbShelf($lbShelf)
    {
        $this->lbShelf = $lbShelf;
    
        return $this;
    }

    /**
     * Get lbShelf
     *
     * @return string 
     */
    public function getLbShelf()
    {
        return $this->lbShelf;
    }

    /**
     * Set cmShelf
     *
     * @param string $cmShelf
     * @return ShelfTemplate
     */
    public function setCmShelf($cmShelf)
    {
        $this->cmShelf = $cmShelf;
    
        return $this;
    }

    /**
     * Get cmShelf
     *
     * @return string 
     */
    public function getCmShelf()
    {
        return $this->cmShelf;
    }

    /**
     * Set cdSerialNumber
     *
     * @param string $cdSerialNumber
     * @return ShelfTemplate
     */
    public function setCdSerialNumber($cdSerialNumber)
    {
        $this->cdSerialNumber = $cdSerialNumber;
    
        return $this;
    }

    /**
     * Get cdSerialNumber
     *
     * @return string 
     */
    public function getCdSerialNumber()
    {
        return $this->cdSerialNumber;
    }

    /**
     * Set nbPosition
     *
     * @param float $nbPosition
     * @return ShelfTemplate
     */
    public function setNbPosition($nbPosition)
    {
        $this->nbPosition = $nbPosition;
    
        return $this;
    }

    /**
     * Get nbPosition
     *
     * @return float 
     */
    public function getNbPosition()
    {
        return $this->nbPosition;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return ShelfTemplate
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return ShelfTemplate
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ShelfTemplate
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return ShelfTemplate
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set idShelf
     *
     * @param \Etrali\GinangBundle\Entity\Shelf $idShelf
     * @return ShelfTemplate
     */
    public function setIdShelf(\Etrali\GinangBundle\Entity\Shelf $idShelf)
    {
        $this->idShelf = $idShelf;
    
        return $this;
    }

    /**
     * Get idShelf
     *
     * @return \Etrali\GinangBundle\Entity\Shelf 
     */
    public function getIdShelf()
    {
        return $this->idShelf;
    }

    /**
     * Set idShelfType
     *
     * @param \Etrali\GinangBundle\Entity\ShelfType $idShelfType
     * @return ShelfTemplate
     */
    public function setIdShelfType(\Etrali\GinangBundle\Entity\ShelfType $idShelfType = null)
    {
        $this->idShelfType = $idShelfType;
    
        return $this;
    }

    /**
     * Get idShelfType
     *
     * @return \Etrali\GinangBundle\Entity\ShelfType 
     */
    public function getIdShelfType()
    {
        return $this->idShelfType;
    }

    /**
     * Set idEquipment
     *
     * @param \Etrali\GinangBundle\Entity\Equipment $idEquipment
     * @return ShelfTemplate
     */
    public function setIdEquipment(\Etrali\GinangBundle\Entity\Equipment $idEquipment = null)
    {
        $this->idEquipment = $idEquipment;
    
        return $this;
    }

    /**
     * Get idEquipment
     *
     * @return \Etrali\GinangBundle\Entity\Equipment 
     */
    public function getIdEquipment()
    {
        return $this->idEquipment;
    }

    /**
     * Set idUserCreate
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreate
     * @return ShelfTemplate
     */
    public function setIdUserCreate(\Etrali\GinangBundle\Entity\Myuser $idUserCreate = null)
    {
        $this->idUserCreate = $idUserCreate;
    
        return $this;
    }

    /**
     * Get idUserCreate
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreate()
    {
        return $this->idUserCreate;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }