<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TRight
 *
 * @ORM\Table(name="t_right")
 * @ORM\Entity
 */
class TRight
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_right", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRight;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_read", type="boolean", nullable=true)
     */
    private $blRead;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_modify", type="boolean", nullable=true)
     */
    private $blModify;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_create", type="boolean", nullable=true)
     */
    private $blCreate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_delete", type="boolean", nullable=true)
     */
    private $blDelete;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivate", type="boolean", nullable=true)
     */
    private $blDeactivate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_reactivate", type="boolean", nullable=true)
     */
    private $blReactivate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_export", type="boolean", nullable=true)
     */
    private $blExport;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_print", type="boolean", nullable=true)
     */
    private $blPrint;

    /**
     * @var \Profile
     *
     * @ORM\ManyToOne(targetEntity="Profile")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_profile", referencedColumnName="id_profile")
     * })
     */
    private $idProfile;

    /**
     * @var \Domain
     *
     * @ORM\ManyToOne(targetEntity="Domain")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_domain", referencedColumnName="id_domain")
     * })
     */
    private $idDomain;

    /**
     * @var \Functionality
     *
     * @ORM\ManyToOne(targetEntity="Functionality")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_functionality", referencedColumnName="id_functionality")
     * })
     */
    private $idFunctionality;



    /**
     * Get idRight
     *
     * @return integer 
     */
    public function getIdRight()
    {
        return $this->idRight;
    }

    /**
     * Set blRead
     *
     * @param boolean $blRead
     * @return TRight
     */
    public function setBlRead($blRead)
    {
        $this->blRead = $blRead;
    
        return $this;
    }

    /**
     * Get blRead
     *
     * @return boolean 
     */
    public function getBlRead()
    {
        return $this->blRead;
    }

    /**
     * Set blModify
     *
     * @param boolean $blModify
     * @return TRight
     */
    public function setBlModify($blModify)
    {
        $this->blModify = $blModify;
    
        return $this;
    }

    /**
     * Get blModify
     *
     * @return boolean 
     */
    public function getBlModify()
    {
        return $this->blModify;
    }

    /**
     * Set blCreate
     *
     * @param boolean $blCreate
     * @return TRight
     */
    public function setBlCreate($blCreate)
    {
        $this->blCreate = $blCreate;
    
        return $this;
    }

    /**
     * Get blCreate
     *
     * @return boolean 
     */
    public function getBlCreate()
    {
        return $this->blCreate;
    }

    /**
     * Set blDelete
     *
     * @param boolean $blDelete
     * @return TRight
     */
    public function setBlDelete($blDelete)
    {
        $this->blDelete = $blDelete;
    
        return $this;
    }

    /**
     * Get blDelete
     *
     * @return boolean 
     */
    public function getBlDelete()
    {
        return $this->blDelete;
    }

    /**
     * Set blDeactivate
     *
     * @param boolean $blDeactivate
     * @return TRight
     */
    public function setBlDeactivate($blDeactivate)
    {
        $this->blDeactivate = $blDeactivate;
    
        return $this;
    }

    /**
     * Get blDeactivate
     *
     * @return boolean 
     */
    public function getBlDeactivate()
    {
        return $this->blDeactivate;
    }

    /**
     * Set blReactivate
     *
     * @param boolean $blReactivate
     * @return TRight
     */
    public function setBlReactivate($blReactivate)
    {
        $this->blReactivate = $blReactivate;
    
        return $this;
    }

    /**
     * Get blReactivate
     *
     * @return boolean 
     */
    public function getBlReactivate()
    {
        return $this->blReactivate;
    }

    /**
     * Set blExport
     *
     * @param boolean $blExport
     * @return TRight
     */
    public function setBlExport($blExport)
    {
        $this->blExport = $blExport;
    
        return $this;
    }

    /**
     * Get blExport
     *
     * @return boolean 
     */
    public function getBlExport()
    {
        return $this->blExport;
    }

    /**
     * Set blPrint
     *
     * @param boolean $blPrint
     * @return TRight
     */
    public function setBlPrint($blPrint)
    {
        $this->blPrint = $blPrint;
    
        return $this;
    }

    /**
     * Get blPrint
     *
     * @return boolean 
     */
    public function getBlPrint()
    {
        return $this->blPrint;
    }

    /**
     * Set idProfile
     *
     * @param \Etrali\GinangBundle\Entity\Profile $idProfile
     * @return TRight
     */
    public function setIdProfile(\Etrali\GinangBundle\Entity\Profile $idProfile = null)
    {
        $this->idProfile = $idProfile;
    
        return $this;
    }

    /**
     * Get idProfile
     *
     * @return \Etrali\GinangBundle\Entity\Profile 
     */
    public function getIdProfile()
    {
        return $this->idProfile;
    }

    /**
     * Set idDomain
     *
     * @param \Etrali\GinangBundle\Entity\Domain $idDomain
     * @return TRight
     */
    public function setIdDomain(\Etrali\GinangBundle\Entity\Domain $idDomain = null)
    {
        $this->idDomain = $idDomain;
    
        return $this;
    }

    /**
     * Get idDomain
     *
     * @return \Etrali\GinangBundle\Entity\Domain 
     */
    public function getIdDomain()
    {
        return $this->idDomain;
    }

    /**
     * Set idFunctionality
     *
     * @param \Etrali\GinangBundle\Entity\Functionality $idFunctionality
     * @return TRight
     */
    public function setIdFunctionality(\Etrali\GinangBundle\Entity\Functionality $idFunctionality = null)
    {
        $this->idFunctionality = $idFunctionality;
    
        return $this;
    }

    /**
     * Get idFunctionality
     *
     * @return \Etrali\GinangBundle\Entity\Functionality 
     */
    public function getIdFunctionality()
    {
        return $this->idFunctionality;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }