<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Tarriff
 *
 * @ORM\Table(name="tarriff")
 * @ORM\Entity
 */
class Tarriff
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_tarriff", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTarriff;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_tarriff", type="string", length=45, nullable=true)
     */
    private $cdTarriff;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_tarriff", type="string", length=255, nullable=true)
     */
    private $lbTarriff;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_value", type="decimal", nullable=true)
     */
    private $mtValue;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_application", type="datetime", nullable=true)
     */
    private $dtApplication;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_filter", type="string", length=255, nullable=true)
     */
    private $lbFilter;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_execute", type="boolean", nullable=true)
     */
    private $blExecute;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=225, nullable=true)
     */
    private $cmComment;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \RatePercentValueType
     *
     * @ORM\ManyToOne(targetEntity="RatePercentValueType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_rate_percent_value_type", referencedColumnName="id_rate_percent_value_type")
     * })
     */
    private $idRatePercentValueType;

    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     */
    private $idCurrency;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idTarriff
     *
     * @return integer 
     */
    public function getIdTarriff()
    {
        return $this->idTarriff;
    }

    /**
     * Set cdTarriff
     *
     * @param string $cdTarriff
     * @return Tarriff
     */
    public function setCdTarriff($cdTarriff)
    {
        $this->cdTarriff = $cdTarriff;
    
        return $this;
    }

    /**
     * Get cdTarriff
     *
     * @return string 
     */
    public function getCdTarriff()
    {
        return $this->cdTarriff;
    }

    /**
     * Set lbTarriff
     *
     * @param string $lbTarriff
     * @return Tarriff
     */
    public function setLbTarriff($lbTarriff)
    {
        $this->lbTarriff = $lbTarriff;
    
        return $this;
    }

    /**
     * Get lbTarriff
     *
     * @return string 
     */
    public function getLbTarriff()
    {
        return $this->lbTarriff;
    }

    /**
     * Set mtValue
     *
     * @param float $mtValue
     * @return Tarriff
     */
    public function setMtValue($mtValue)
    {
        $this->mtValue = $mtValue;
    
        return $this;
    }

    /**
     * Get mtValue
     *
     * @return float 
     */
    public function getMtValue()
    {
        return $this->mtValue;
    }

    /**
     * Set dtApplication
     *
     * @param \DateTime $dtApplication
     * @return Tarriff
     */
    public function setDtApplication($dtApplication)
    {
        $this->dtApplication = $dtApplication;
    
        return $this;
    }

    /**
     * Get dtApplication
     *
     * @return \DateTime 
     */
    public function getDtApplication()
    {
        return $this->dtApplication;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Tarriff
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set lbFilter
     *
     * @param string $lbFilter
     * @return Tarriff
     */
    public function setLbFilter($lbFilter)
    {
        $this->lbFilter = $lbFilter;
    
        return $this;
    }

    /**
     * Get lbFilter
     *
     * @return string 
     */
    public function getLbFilter()
    {
        return $this->lbFilter;
    }

    /**
     * Set blExecute
     *
     * @param boolean $blExecute
     * @return Tarriff
     */
    public function setBlExecute($blExecute)
    {
        $this->blExecute = $blExecute;
    
        return $this;
    }

    /**
     * Get blExecute
     *
     * @return boolean 
     */
    public function getBlExecute()
    {
        return $this->blExecute;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return Tarriff
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Tarriff
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idRatePercentValueType
     *
     * @param \Etrali\GinangBundle\Entity\RatePercentValueType $idRatePercentValueType
     * @return Tarriff
     */
    public function setIdRatePercentValueType(\Etrali\GinangBundle\Entity\RatePercentValueType $idRatePercentValueType = null)
    {
        $this->idRatePercentValueType = $idRatePercentValueType;
    
        return $this;
    }

    /**
     * Get idRatePercentValueType
     *
     * @return \Etrali\GinangBundle\Entity\RatePercentValueType 
     */
    public function getIdRatePercentValueType()
    {
        return $this->idRatePercentValueType;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return Tarriff
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return Tarriff
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Tarriff
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}