<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TradExtraDatalinkGroup
 *
 * @ORM\Table(name="trad_extra_datalink_group")
 * @ORM\Entity
 */
class TradExtraDatalinkGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_trad_extra_datalink_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTradExtraDatalinkGroup;

   /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;
    
    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;
    
    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_trad_extra_datalink_group", type="string", length=255, nullable=true)
     */
    private $lbTradExtraDatalinkGroup;
    
    /**
     * @var string
     *
     * @ORM\Column(name="cd_trad_extra_datalink_group", type="string", length=255, nullable=true)
     */
    private $cdTradExtraDatalinkGroup;  
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;
    
        /**
     * @var \Service
     *
     * @ORM\OneToMany(targetEntity="Service", mappedBy="idTradExtraDatalinkGroup")
     * @ORM\OrderBy({"cdService" = "asc"})         
     */
    private $idService;

    public function __toString() {
        return '';
    }

    public function getParentBranch() {
        return NULL;
    }

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idService = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idTradExtraDatalinkGroup
     *
     * @return integer 
     */
    public function getIdTradExtraDatalinkGroup()
    {
        return $this->idTradExtraDatalinkGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return TradExtraDatalinkGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return TradExtraDatalinkGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return TradExtraDatalinkGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set lbTradExtraDatalinkGroup
     *
     * @param string $lbTradExtraDatalinkGroup
     * @return TradExtraDatalinkGroup
     */
    public function setLbTradExtraDatalinkGroup($lbTradExtraDatalinkGroup)
    {
        $this->lbTradExtraDatalinkGroup = $lbTradExtraDatalinkGroup;
    
        return $this;
    }

    /**
     * Get lbTradExtraDatalinkGroup
     *
     * @return string 
     */
    public function getLbTradExtraDatalinkGroup()
    {
        return $this->lbTradExtraDatalinkGroup;
    }

    /**
     * Set cdTradExtraDatalinkGroup
     *
     * @param string $cdTradExtraDatalinkGroup
     * @return TradExtraDatalinkGroup
     */
    public function setCdTradExtraDatalinkGroup($cdTradExtraDatalinkGroup)
    {
        $this->cdTradExtraDatalinkGroup = $cdTradExtraDatalinkGroup;
    
        return $this;
    }

    /**
     * Get cdTradExtraDatalinkGroup
     *
     * @return string 
     */
    public function getCdTradExtraDatalinkGroup()
    {
        return $this->cdTradExtraDatalinkGroup;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return TradExtraDatalinkGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Add idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return TradExtraDatalinkGroup
     */
    public function addIdService(\Etrali\GinangBundle\Entity\Service $idService)
    {
        $this->idService[] = $idService;
    
        return $this;
    }

    /**
     * Remove idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     */
    public function removeIdService(\Etrali\GinangBundle\Entity\Service $idService)
    {
        $this->idService->removeElement($idService);
    }

    /**
     * Get idService
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdService()
    {
        return $this->idService;
    }
}