<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TransferPrice
 *
 * @ORM\Table(name="transfer_price")
 * @ORM\Entity
 */
class TransferPrice {

    /**
     * @var integer
     *
     * @ORM\Column(name="id_transfer_price", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTransferPrice;

    /**
     * @var float
     *
     * @ORM\Column(name="mt_transfer_price", type="decimal", nullable=true)
     */
    private $mtTransferPrice;
    
    /**
     * @var \ServiceExtremity
     *
     * @ORM\OneToOne(targetEntity="ServiceExtremity", inversedBy="idTransferPrice")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity", referencedColumnName="id_service_extremity")
     * })
     */
    private $idServiceExtremity;   
    
    /**
     * @var \ServiceDevice
     *
     * @ORM\OneToOne(targetEntity="ServiceDevice", inversedBy="idTransferPrice")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_device", referencedColumnName="id_service_device")
     * })
     */
    private $idServiceDevice;       
    
    /**
     * @var \Currency
     *
     * @ORM\ManyToOne(targetEntity="Currency")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_currency", referencedColumnName="id_currency")
     * })
     */
    private $idCurrency;     
    
        /**
     * @var \BillingService
     *
     * @ORM\ManyToOne(targetEntity="BillingService")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_billing_service", referencedColumnName="id_billing_service")
     * })
     */
    private $idBillingService;
    
    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service",inversedBy="idTransferPrice")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     */
    private $idService;    

    public function __toString() {
        return '';
    }

    public function getParentBranch() {
        return NULL;
    }


    public function getHeadInfo()
    {
            return "<td >".($this->getIdService()->getIdProduct()->getIdProductType()->getIdProductType()==21?$this->getIdServiceDevice():$this->getIdServiceExtremity())."</td><td>".($this->getIdBillingService()!=NULL?$this->getIdBillingService():"")."</td><td>".$this->getMtTransferPrice()."</td><td>".$this->getIdCurrency()."</td>";
    } 
    
    public function getHeadColumns()
    {
           $retour= "<th>".($this->getIdService()->getIdProduct()->getIdProductType()->getIdProductType()==21?"Device ref":"Extremity ref")."</th><th>Customer</th><th>Transfer price</th><th>Base currency</th>";            
           return $retour;
    } 
        

    /**
     * Get idTransferPrice
     *
     * @return integer 
     */
    public function getIdTransferPrice()
    {
        return $this->idTransferPrice;
    }

    /**
     * Set mtTransferPrice
     *
     * @param float $mtTransferPrice
     * @return TransferPrice
     */
    public function setMtTransferPrice($mtTransferPrice)
    {
        $this->mtTransferPrice = $mtTransferPrice;
    
        return $this;
    }

    /**
     * Get mtTransferPrice
     *
     * @return float 
     */
    public function getMtTransferPrice()
    {
        return $this->mtTransferPrice;
    }

    /**
     * Set idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return TransferPrice
     */
    public function setIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity = null)
    {
        $this->idServiceExtremity = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Get idServiceExtremity
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremity 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Set idCurrency
     *
     * @param \Etrali\GinangBundle\Entity\Currency $idCurrency
     * @return TransferPrice
     */
    public function setIdCurrency(\Etrali\GinangBundle\Entity\Currency $idCurrency = null)
    {
        $this->idCurrency = $idCurrency;
    
        return $this;
    }

    /**
     * Get idCurrency
     *
     * @return \Etrali\GinangBundle\Entity\Currency 
     */
    public function getIdCurrency()
    {
        return $this->idCurrency;
    }

    /**
     * Set idBillingService
     *
     * @param \Etrali\GinangBundle\Entity\BillingService $idBillingService
     * @return TransferPrice
     */
    public function setIdBillingService(\Etrali\GinangBundle\Entity\BillingService $idBillingService = null)
    {
        $this->idBillingService = $idBillingService;
    
        return $this;
    }

    /**
     * Get idBillingService
     *
     * @return \Etrali\GinangBundle\Entity\BillingService 
     */
    public function getIdBillingService()
    {
        return $this->idBillingService;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return TransferPrice
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Set idServiceDevice
     *
     * @param \Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice
     * @return TransferPrice
     */
    public function setIdServiceDevice(\Etrali\GinangBundle\Entity\ServiceDevice $idServiceDevice = null)
    {
        $this->idServiceDevice = $idServiceDevice;
    
        return $this;
    }

    /**
     * Get idServiceDevice
     *
     * @return \Etrali\GinangBundle\Entity\ServiceDevice 
     */
    public function getIdServiceDevice()
    {
        return $this->idServiceDevice;
    }
}