<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Trave
 *
 * @ORM\Table(name="trave")
 * @ORM\Entity
 */
class Trave
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_trave", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTrave;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_trave", type="string", length=15, nullable=false)
     */
    private $cdTrave;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_trave", type="string", length=100, nullable=true)
     */
    private $lbTrave;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;

    /**
     * @var \Room
     *
     * @ORM\ManyToOne(targetEntity="Room")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_room", referencedColumnName="id_room")
     * })
     */
    private $idRoom;



    /**
     * Get idTrave
     *
     * @return integer 
     */
    public function getIdTrave()
    {
        return $this->idTrave;
    }

    /**
     * Set cdTrave
     *
     * @param string $cdTrave
     * @return Trave
     */
    public function setCdTrave($cdTrave)
    {
        $this->cdTrave = $cdTrave;
    
        return $this;
    }

    /**
     * Get cdTrave
     *
     * @return string 
     */
    public function getCdTrave()
    {
        return $this->cdTrave;
    }

    /**
     * Set lbTrave
     *
     * @param string $lbTrave
     * @return Trave
     */
    public function setLbTrave($lbTrave)
    {
        $this->lbTrave = $lbTrave;
    
        return $this;
    }

    /**
     * Get lbTrave
     *
     * @return string 
     */
    public function getLbTrave()
    {
        return $this->lbTrave;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Trave
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return Trave
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return Trave
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return Trave
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return Trave
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Set idRoom
     *
     * @param \Etrali\GinangBundle\Entity\Room $idRoom
     * @return Trave
     */
    public function setIdRoom(\Etrali\GinangBundle\Entity\Room $idRoom = null)
    {
        $this->idRoom = $idRoom;
    
        return $this;
    }

    /**
     * Get idRoom
     *
     * @return \Etrali\GinangBundle\Entity\Room 
     */
    public function getIdRoom()
    {
        return $this->idRoom;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }