<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Ts
 *
 * @ORM\Table(name="ts")
 * @ORM\Entity
 */
class Ts
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_ts", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTs;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_ts", type="string", length=255, nullable=true)
     */
    private $lbTs;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_ts", type="integer",  nullable=true)
     */
    private $nbTs;    
    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_channel", type="integer",  nullable=true)
     */
    private $nbChannel;        

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \PortInstance
     *
     * @ORM\ManyToOne(targetEntity="PortInstance", inversedBy="idTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_instance", referencedColumnName="id_port_instance")
     * })
     */
    private $idPortInstance;
    
    /**
     * @var \TsStatus
     *
     * @ORM\ManyToOne(targetEntity="TsStatus")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_ts_status", referencedColumnName="id_ts_status")
     * })
     */
    private $idTsStatus;    

    /**
     * @ORM\ManyToOne(targetEntity="BackboneLinkExtremityTech", inversedBy="idOutTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link_extremity_tech", referencedColumnName="id_backbone_link_extremity_tech")
     * })      
     */

    private $idBackboneLinkExtremityTech;
    
    /**
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityTech", inversedBy="idOutTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_tech", referencedColumnName="id_local_loop_extremity_tech")
     * })            
     */

    private $idLocalLoopExtremityTech;  
    
    /**
     * @var \LocalLoopExtremityAdditional     
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityAdditional", inversedBy="idTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_additional", referencedColumnName="id_local_loop_extremity_additional")
     * })     
     */

    private $idLocalLoopExtremityAdditional;     
    
    /**
     * @ORM\ManyToOne(targetEntity="ServiceExtremityTech", inversedBy="idTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_in_service_extremity_tech", referencedColumnName="id_service_extremity_tech")
     * })      
     */

    private $idServiceExtremityTech;  
    
    /**
     * @ORM\ManyToOne(targetEntity="BackboneLinkExtremityTech", inversedBy="idTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_in_backbone_link_extremity_tech", referencedColumnName="id_backbone_link_extremity_tech")
     * })           
     */

    private $idInBackboneLinkExtremityTech;
    
    /**
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityTech", inversedBy="idTs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_in_local_loop_extremity_tech", referencedColumnName="id_local_loop_extremity_tech")
     * }) 
     */

    private $idInLocalLoopExtremityTech;  
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     

    public function getHeadInfo()
    {
            return "<td >".$this->getNbTs()."</td><td>".$this->getNbChannel()."</td><td>".$this->getIdTsStatus()."</td><td>".($this->getIdServiceExtremityTech()!=NULL?$this->getIdServiceExtremityTech()->getIdService():"")."</td><td>".($this->getIdServiceExtremityTech()!=NULL?$this->getIdServiceExtremityTech():"")."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Timeslot</th><th>Channel</th><th>Status</th><th>Service</th><th>Service extremity</th>";
    }

    public function __toString() { return ''; } 
    
    public function getParentBranch() { return NULL; }  
    
        /**
     * Constructor
     */
    public function __construct()
    {

    }
    
   
    /**
     * Get idTs
     *
     * @return integer 
     */
    public function getIdTs()
    {
        return $this->idTs;
    }

    /**
     * Set lbTs
     *
     * @param string $lbTs
     * @return Ts
     */
    public function setLbTs($lbTs)
    {
        $this->lbTs = $lbTs;
    
        return $this;
    }

    /**
     * Get lbTs
     *
     * @return string 
     */
    public function getLbTs()
    {
        return $this->lbTs;
    }

    /**
     * Set nbTs
     *
     * @param integer $nbTs
     * @return Ts
     */
    public function setNbTs($nbTs)
    {
        $this->nbTs = $nbTs;
    
        return $this;
    }

    /**
     * Get nbTs
     *
     * @return integer 
     */
    public function getNbTs()
    {
        return $this->nbTs;
    }

    /**
     * Set nbChannel
     *
     * @param integer $nbChannel
     * @return Ts
     */
    public function setNbChannel($nbChannel)
    {
        $this->nbChannel = $nbChannel;
    
        return $this;
    }

    /**
     * Get nbChannel
     *
     * @return integer 
     */
    public function getNbChannel()
    {
        return $this->nbChannel;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Ts
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idPortInstance
     * @return Ts
     */
    public function setIdPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idPortInstance = null)
    {
        $this->idPortInstance = $idPortInstance;
    
        return $this;
    }

    /**
     * Get idPortInstance
     *
     * @return \Etrali\GinangBundle\Entity\PortInstance 
     */
    public function getIdPortInstance()
    {
        return $this->idPortInstance;
    }

    /**
     * Set idTsStatus
     *
     * @param \Etrali\GinangBundle\Entity\TsStatus $idTsStatus
     * @return Ts
     */
    public function setIdTsStatus(\Etrali\GinangBundle\Entity\TsStatus $idTsStatus = null)
    {
        $this->idTsStatus = $idTsStatus;
    
        return $this;
    }

    /**
     * Get idTsStatus
     *
     * @return \Etrali\GinangBundle\Entity\TsStatus 
     */
    public function getIdTsStatus()
    {
        return $this->idTsStatus;
    }

    /**
     * Add idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return Ts
     */
    public function addIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech[] = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     */
    public function removeIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech->removeElement($idBackboneLinkExtremityTech);
    }

    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkExtremityTech()
    {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Add idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return Ts
     */
    public function addIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech[] = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Remove idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     */
    public function removeIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech->removeElement($idLocalLoopExtremityTech);
    }

    /**
     * Get idLocalLoopExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }

    /**
     * Add idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return Ts
     */
    public function addIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech[] = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Remove idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     */
    public function removeIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech->removeElement($idServiceExtremityTech);
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }

    /**
     * Add idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     * @return Ts
     */
    public function addIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech)
    {
        $this->idInBackboneLinkExtremityTech[] = $idInBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Remove idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     */
    public function removeIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech)
    {
        $this->idInBackboneLinkExtremityTech->removeElement($idInBackboneLinkExtremityTech);
    }

    /**
     * Get idInBackboneLinkExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdInBackboneLinkExtremityTech()
    {
        return $this->idInBackboneLinkExtremityTech;
    }

    /**
     * Add idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     * @return Ts
     */
    public function addIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech)
    {
        $this->idInLocalLoopExtremityTech[] = $idInLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Remove idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     */
    public function removeIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech)
    {
        $this->idInLocalLoopExtremityTech->removeElement($idInLocalLoopExtremityTech);
    }

    /**
     * Get idInLocalLoopExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdInLocalLoopExtremityTech()
    {
        return $this->idInLocalLoopExtremityTech;
    }

    /**
     * Set idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return Ts
     */
    public function setIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech = null)
    {
        $this->idBackboneLinkExtremityTech = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Set idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return Ts
     */
    public function setIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech = null)
    {
        $this->idLocalLoopExtremityTech = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Set idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return Ts
     */
    public function setIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech = null)
    {
        $this->idServiceExtremityTech = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Set idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     * @return Ts
     */
    public function setIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech = null)
    {
        $this->idInBackboneLinkExtremityTech = $idInBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Set idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     * @return Ts
     */
    public function setIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech = null)
    {
        $this->idInLocalLoopExtremityTech = $idInLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Set idLocalLoopExtremityAdditional
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional $idLocalLoopExtremityAdditional
     * @return Ts
     */
    public function setIdLocalLoopExtremityAdditional(\Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional $idLocalLoopExtremityAdditional = null)
    {
        $this->idLocalLoopExtremityAdditional = $idLocalLoopExtremityAdditional;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityAdditional
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional 
     */
    public function getIdLocalLoopExtremityAdditional()
    {
        return $this->idLocalLoopExtremityAdditional;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Ts
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}