<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Vlan
 *
 * @ORM\Table(name="vlan")
 * @ORM\Entity
 */
class Vlan
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_vlan", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idVlan;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_vlan", type="string", length=255, nullable=true)
     */
    private $lbVlan;
    

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \PortInstance
     *
     * @ORM\ManyToOne(targetEntity="PortInstance", inversedBy="idVlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port_instance", referencedColumnName="id_port_instance")
     * })
     */
    private $idPortInstance;

    /**
     * @ORM\ManyToOne(targetEntity="BackboneLinkExtremityTech", inversedBy="idOutVlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_backbone_link_extremity_tech", referencedColumnName="id_backbone_link_extremity_tech")
     * })       
     */

    private $idBackboneLinkExtremityTech;
    
    /**
     * @ORM\ManyToOne(targetEntity="LocalLoopExtremityTech", inversedBy="idOutVlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_local_loop_extremity_tech", referencedColumnName="id_local_loop_extremity_tech")
     * })        
     */

    private $idLocalLoopExtremityTech;  
    
    /**
     * @var \LocalLoopExtremityAdditional     
     * @ORM\OneToOne(targetEntity="LocalLoopExtremityAdditional", mappedBy="idVlan")    
     */

    private $idLocalLoopExtremityAdditional;     
    
    /**
     * @ORM\OneToOne(targetEntity="ServiceExtremityTech", mappedBy="idVlan")
     */

    private $idServiceExtremityTech;     

    /**
     * @ORM\OneToOne(targetEntity="BackboneLinkExtremityTech", inversedBy="idVlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_in_backbone_link_extremity_tech", referencedColumnName="id_backbone_link_extremity_tech")
     * })        
     */

    private $idInBackboneLinkExtremityTech;
    
    /**
     * @ORM\OneToOne(targetEntity="LocalLoopExtremityTech", inversedBy="idVlan")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_in_local_loop_extremity_tech", referencedColumnName="id_local_loop_extremity_tech")
     * })      
     */

    private $idInLocalLoopExtremityTech;  
    
     /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
    
    public function getHeadInfo()
    {
            return "<td >".$this->getLbVlan()."</td><td>".($this->getIdServiceExtremityTech()!=NULL?$this->getIdServiceExtremityTech()->getIdService():"")."</td><td>".($this->getIdServiceExtremityTech()!=NULL?$this->getIdServiceExtremityTech():"")."</td>";
    }  
    
    public function getHeadColumns()
    {
            return "<th>Vlan ref</th><th>Service</th><th>Service extremity</th>";
    }    


    public function __toString() { return ''; } 
    
    public function getParentBranch() { return NULL; }  


    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBackboneLinkExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idLocalLoopExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idServiceExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idInBackboneLinkExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
        $this->idInLocalLoopExtremityTech = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Get idVlan
     *
     * @return integer 
     */
    public function getIdVlan()
    {
        return $this->idVlan;
    }

    /**
     * Set lbVlan
     *
     * @param string $lbVlan
     * @return Vlan
     */
    public function setLbVlan($lbVlan)
    {
        $this->lbVlan = $lbVlan;
    
        return $this;
    }

    /**
     * Get lbVlan
     *
     * @return string 
     */
    public function getLbVlan()
    {
        return $this->lbVlan;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Vlan
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idPortInstance
     *
     * @param \Etrali\GinangBundle\Entity\PortInstance $idPortInstance
     * @return Vlan
     */
    public function setIdPortInstance(\Etrali\GinangBundle\Entity\PortInstance $idPortInstance = null)
    {
        $this->idPortInstance = $idPortInstance;
    
        return $this;
    }

    /**
     * Get idPortInstance
     *
     * @return \Etrali\GinangBundle\Entity\PortInstance 
     */
    public function getIdPortInstance()
    {
        return $this->idPortInstance;
    }

    /**
     * Add idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return Vlan
     */
    public function addIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech[] = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Remove idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     */
    public function removeIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech)
    {
        $this->idBackboneLinkExtremityTech->removeElement($idBackboneLinkExtremityTech);
    }

    /**
     * Get idBackboneLinkExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBackboneLinkExtremityTech()
    {
        return $this->idBackboneLinkExtremityTech;
    }

    /**
     * Add idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return Vlan
     */
    public function addIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech[] = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Remove idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     */
    public function removeIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech)
    {
        $this->idLocalLoopExtremityTech->removeElement($idLocalLoopExtremityTech);
    }

    /**
     * Get idLocalLoopExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdLocalLoopExtremityTech()
    {
        return $this->idLocalLoopExtremityTech;
    }

    /**
     * Add idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return Vlan
     */
    public function addIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech[] = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Remove idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     */
    public function removeIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech)
    {
        $this->idServiceExtremityTech->removeElement($idServiceExtremityTech);
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }

    /**
     * Add idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     * @return Vlan
     */
    public function addIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech)
    {
        $this->idInBackboneLinkExtremityTech[] = $idInBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Remove idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     */
    public function removeIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech)
    {
        $this->idInBackboneLinkExtremityTech->removeElement($idInBackboneLinkExtremityTech);
    }

    /**
     * Get idInBackboneLinkExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdInBackboneLinkExtremityTech()
    {
        return $this->idInBackboneLinkExtremityTech;
    }

    /**
     * Add idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     * @return Vlan
     */
    public function addIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech)
    {
        $this->idInLocalLoopExtremityTech[] = $idInLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Remove idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     */
    public function removeIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech)
    {
        $this->idInLocalLoopExtremityTech->removeElement($idInLocalLoopExtremityTech);
    }

    /**
     * Get idInLocalLoopExtremityTech
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdInLocalLoopExtremityTech()
    {
        return $this->idInLocalLoopExtremityTech;
    }

    /**
     * Set idBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech
     * @return Vlan
     */
    public function setIdBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idBackboneLinkExtremityTech = null)
    {
        $this->idBackboneLinkExtremityTech = $idBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Set idLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech
     * @return Vlan
     */
    public function setIdLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idLocalLoopExtremityTech = null)
    {
        $this->idLocalLoopExtremityTech = $idLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Set idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return Vlan
     */
    public function setIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech = null)
    {
        $this->idServiceExtremityTech = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Set idInBackboneLinkExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech
     * @return Vlan
     */
    public function setIdInBackboneLinkExtremityTech(\Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $idInBackboneLinkExtremityTech = null)
    {
        $this->idInBackboneLinkExtremityTech = $idInBackboneLinkExtremityTech;
    
        return $this;
    }

    /**
     * Set idInLocalLoopExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech
     * @return Vlan
     */
    public function setIdInLocalLoopExtremityTech(\Etrali\GinangBundle\Entity\LocalLoopExtremityTech $idInLocalLoopExtremityTech = null)
    {
        $this->idInLocalLoopExtremityTech = $idInLocalLoopExtremityTech;
    
        return $this;
    }

    /**
     * Set idLocalLoopExtremityAdditional
     *
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional $idLocalLoopExtremityAdditional
     * @return Vlan
     */
    public function setIdLocalLoopExtremityAdditional(\Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional $idLocalLoopExtremityAdditional = null)
    {
        $this->idLocalLoopExtremityAdditional = $idLocalLoopExtremityAdditional;
    
        return $this;
    }

    /**
     * Get idLocalLoopExtremityAdditional
     *
     * @return \Etrali\GinangBundle\Entity\LocalLoopExtremityAdditional 
     */
    public function getIdLocalLoopExtremityAdditional()
    {
        return $this->idLocalLoopExtremityAdditional;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Vlan
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}