<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * WorldGroup
 *
 * @ORM\Table(name="world_group")
 * @ORM\Entity
 */
class WorldGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_world_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idWorldGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_world_group", type="string", length=15, nullable=false)
     */
    private $cdWorldGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_world_group", type="string", length=100, nullable=true)
     */
    private $lbWorldGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_create_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="create")	
     */
    private $idUserCreateBy;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_update_by", referencedColumnName="id")
     * })
     * @Gedmo\Blameable(on="update")
     */
    private $idUserUpdateBy;
    
    /**
     * @var \World
     *
     * @ORM\OneToMany(targetEntity="ContinentGroup", mappedBy="idWorldGroup",cascade={"persist","remove"}, orphanRemoval=true )   
     */
    private $idContinentGroup;    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;
      
    
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbWorldGroup().'';
    }

  
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idWorld = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
 

    /**
     * Get idWorldGroup
     *
     * @return integer 
     */
    public function getIdWorldGroup()
    {
        return $this->idWorldGroup;
    }

    /**
     * Set cdWorldGroup
     *
     * @param string $cdWorldGroup
     * @return WorldGroup
     */
    public function setCdWorldGroup($cdWorldGroup)
    {
        $this->cdWorldGroup = $cdWorldGroup;
    
        return $this;
    }

    /**
     * Get cdWorldGroup
     *
     * @return string 
     */
    public function getCdWorldGroup()
    {
        return $this->cdWorldGroup;
    }

    /**
     * Set lbWorldGroup
     *
     * @param string $lbWorldGroup
     * @return WorldGroup
     */
    public function setLbWorldGroup($lbWorldGroup)
    {
        $this->lbWorldGroup = $lbWorldGroup;
    
        return $this;
    }

    /**
     * Get lbWorldGroup
     *
     * @return string 
     */
    public function getLbWorldGroup()
    {
        return $this->lbWorldGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return WorldGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return WorldGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return WorldGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return WorldGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }

    /**
     * Set idUserCreateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserCreateBy
     * @return WorldGroup
     */
    public function setIdUserCreateBy(\Etrali\GinangBundle\Entity\Myuser $idUserCreateBy = null)
    {
        $this->idUserCreateBy = $idUserCreateBy;
    
        return $this;
    }

    /**
     * Get idUserCreateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserCreateBy()
    {
        return $this->idUserCreateBy;
    }

    /**
     * Set idUserUpdateBy
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy
     * @return WorldGroup
     */
    public function setIdUserUpdateBy(\Etrali\GinangBundle\Entity\Myuser $idUserUpdateBy = null)
    {
        $this->idUserUpdateBy = $idUserUpdateBy;
    
        return $this;
    }

    /**
     * Get idUserUpdateBy
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserUpdateBy()
    {
        return $this->idUserUpdateBy;
    }

    /**
     * Add idContinentGroup
     *
     * @param \Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup
     * @return WorldGroup
     */
    public function addIdContinentGroup(\Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup)
    {
        $this->idContinentGroup[] = $idContinentGroup;
    
        return $this;
    }

    /**
     * Remove idContinentGroup
     *
     * @param \Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup
     */
    public function removeIdContinentGroup(\Etrali\GinangBundle\Entity\ContinentGroup $idContinentGroup)
    {
        $this->idContinentGroup->removeElement($idContinentGroup);
    }

    /**
     * Get idContinentGroup
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdContinentGroup()
    {
        return $this->idContinentGroup;
    }
}