<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * WorldwideGroup
 *
 * @ORM\Table(name="worldwide_group")
 * @ORM\Entity
 */
class WorldwideGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_worldwide_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idWorldwideGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_worldwide_group", type="string", length=15, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(30)   
     */
    private $cdWorldwideGroup;
    
    /**
     * @var string
     *
     * @ORM\Column(name="lb_worldwide_group", type="string", length=100, nullable=false)
     * @Assert\MaxLength(30)       
     */
    private $lbWorldwideGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="create")
     * @ORM\Column(name="dt_create", type="datetime", nullable=true)
     */
    private $dtCreate;

    /**
     * @var \DateTime
     *
     * @Gedmo\Timestampable(on="update")     
     * @ORM\Column(name="dt_update", type="datetime", nullable=true)
     */
    private $dtUpdate;

    /**
     * @var string
     *
     * @ORM\Column(name="comment", type="text", nullable=true)
     */
    private $comment;

    /**
     * @var \Myuser
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_global_account_manager", referencedColumnName="id")
     * })
     */
    private $idUserGlobalAccountManager;

    /**
     * @var \BranchCluster
     *
     * @ORM\OneToMany(targetEntity="BranchCluster", mappedBy="idWorldwideGroup")
     */
    
    private $idBranchCluster;
    
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated;     
 
    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbWorldwideGroup().'';
    }    

    /**
     * Get idWorldwideGroup
     *
     * @return integer 
     */
    public function getIdWorldwideGroup()
    {
        return $this->idWorldwideGroup;
    }

    /**
     * Set lbWorldwideGroup
     *
     * @param string $lbWorldwideGroup
     * @return WorldwideGroup
     */
    public function setLbWorldwideGroup($lbWorldwideGroup)
    {
        $this->lbWorldwideGroup = $lbWorldwideGroup;
    
        return $this;
    }

    /**
     * Get lbWorldwideGroup
     *
     * @return string 
     */
    public function getLbWorldwideGroup()
    {
        return $this->lbWorldwideGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return WorldwideGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set dtCreate
     *
     * @param \DateTime $dtCreate
     * @return WorldwideGroup
     */
    public function setDtCreate($dtCreate)
    {
        $this->dtCreate = $dtCreate;
    
        return $this;
    }

    /**
     * Get dtCreate
     *
     * @return \DateTime 
     */
    public function getDtCreate()
    {
        return $this->dtCreate;
    }

    /**
     * Set dtUpdate
     *
     * @param \DateTime $dtUpdate
     * @return WorldwideGroup
     */
    public function setDtUpdate($dtUpdate)
    {
        $this->dtUpdate = $dtUpdate;
    
        return $this;
    }

    /**
     * Get dtUpdate
     *
     * @return \DateTime 
     */
    public function getDtUpdate()
    {
        return $this->dtUpdate;
    }

    /**
     * Set cdWorldwideGroup
     *
     * @param string $cdWorldwideGroup
     * @return WorldwideGroup
     */
    public function setCdWorldwideGroup($cdWorldwideGroup)
    {
        $this->cdWorldwideGroup = $cdWorldwideGroup;
    
        return $this;
    }

    /**
     * Get cdWorldwideGroup
     *
     * @return string 
     */
    public function getCdWorldwideGroup()
    {
        return $this->cdWorldwideGroup;
    }

    /**
     * Set comment
     *
     * @param string $comment
     * @return WorldwideGroup
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    
        return $this;
    }

    /**
     * Get comment
     *
     * @return string 
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * Set idUserGlobalAccountManager
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUserGlobalAccountManager
     * @return WorldwideGroup
     */
    public function setIdUserGlobalAccountManager(\Etrali\GinangBundle\Entity\Myuser $idUserGlobalAccountManager = null)
    {
        $this->idUserGlobalAccountManager = $idUserGlobalAccountManager;
    
        return $this;
    }

    /**
     * Get idUserGlobalAccountManager
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUserGlobalAccountManager()
    {
        return $this->idUserGlobalAccountManager;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->idBranchCluster = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add idBranchCluster
     *
     * @param \Etrali\GinangBundle\Entity\BranchCluster $idBranchCluster
     * @return WorldwideGroup
     */
    public function addIdBranchCluster(\Etrali\GinangBundle\Entity\BranchCluster $idBranchCluster)
    {
        $this->idBranchCluster[] = $idBranchCluster;
    
        return $this;
    }

    /**
     * Remove idBranchCluster
     *
     * @param \Etrali\GinangBundle\Entity\BranchCluster $idBranchCluster
     */
    public function removeIdBranchCluster(\Etrali\GinangBundle\Entity\BranchCluster $idBranchCluster)
    {
        $this->idBranchCluster->removeElement($idBranchCluster);
    }

    /**
     * Get idBranchCluster
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getIdBranchCluster()
    {
        return $this->idBranchCluster;
    }
public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return WorldwideGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}