<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * XconnectTemplate
 *
 * @ORM\Table(name="xconnect_template")
 * @ORM\Entity
 */
class XconnectTemplate
{
    /**
     * @var string
     *
     * @ORM\Column(name="cd_xconnect", type="string", length=100, nullable=true)
     */
    private $cdXconnect;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_xconnect", type="string", length=255, nullable=true)
     */
    private $lbXconnect;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_meet_prot", type="string", length=255, nullable=true)
     */
    private $lbMeetProt;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Xconnect
     *
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="NONE")
     * @ORM\OneToOne(targetEntity="Xconnect")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_xconnect", referencedColumnName="id_xconnect")
     * })
     */
    private $idXconnect;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Provider
     *
     * @ORM\ManyToOne(targetEntity="Provider")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_provider", referencedColumnName="id_provider")
     * })
     */
    private $idProvider;

    /**
     * @var \Port
     *
     * @ORM\ManyToOne(targetEntity="Port")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_port", referencedColumnName="id_port")
     * })
     */
    private $idPort;



    /**
     * Set cdXconnect
     *
     * @param string $cdXconnect
     * @return XconnectTemplate
     */
    public function setCdXconnect($cdXconnect)
    {
        $this->cdXconnect = $cdXconnect;
    
        return $this;
    }

    /**
     * Get cdXconnect
     *
     * @return string 
     */
    public function getCdXconnect()
    {
        return $this->cdXconnect;
    }

    /**
     * Set lbXconnect
     *
     * @param string $lbXconnect
     * @return XconnectTemplate
     */
    public function setLbXconnect($lbXconnect)
    {
        $this->lbXconnect = $lbXconnect;
    
        return $this;
    }

    /**
     * Get lbXconnect
     *
     * @return string 
     */
    public function getLbXconnect()
    {
        return $this->lbXconnect;
    }

    /**
     * Set lbMeetProt
     *
     * @param string $lbMeetProt
     * @return XconnectTemplate
     */
    public function setLbMeetProt($lbMeetProt)
    {
        $this->lbMeetProt = $lbMeetProt;
    
        return $this;
    }

    /**
     * Get lbMeetProt
     *
     * @return string 
     */
    public function getLbMeetProt()
    {
        return $this->lbMeetProt;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return XconnectTemplate
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idXconnect
     *
     * @param \Etrali\GinangBundle\Entity\Xconnect $idXconnect
     * @return XconnectTemplate
     */
    public function setIdXconnect(\Etrali\GinangBundle\Entity\Xconnect $idXconnect)
    {
        $this->idXconnect = $idXconnect;
    
        return $this;
    }

    /**
     * Get idXconnect
     *
     * @return \Etrali\GinangBundle\Entity\Xconnect 
     */
    public function getIdXconnect()
    {
        return $this->idXconnect;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return XconnectTemplate
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idProvider
     *
     * @param \Etrali\GinangBundle\Entity\Provider $idProvider
     * @return XconnectTemplate
     */
    public function setIdProvider(\Etrali\GinangBundle\Entity\Provider $idProvider = null)
    {
        $this->idProvider = $idProvider;
    
        return $this;
    }

    /**
     * Get idProvider
     *
     * @return \Etrali\GinangBundle\Entity\Provider 
     */
    public function getIdProvider()
    {
        return $this->idProvider;
    }

    /**
     * Set idPort
     *
     * @param \Etrali\GinangBundle\Entity\Port $idPort
     * @return XconnectTemplate
     */
    public function setIdPort(\Etrali\GinangBundle\Entity\Port $idPort = null)
    {
        $this->idPort = $idPort;
    
        return $this;
    }

    /**
     * Get idPort
     *
     * @return \Etrali\GinangBundle\Entity\Port 
     */
    public function getIdPort()
    {
        return $this->idPort;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }