<?php
namespace Etrali\GinangBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;


class ProductChangeType extends AbstractType 
{
   /**
     * {@inheritdoc}
     */
  public function buildForm(FormBuilderInterface $builder, array $options) {

    $builder -> setAttribute('dataType', $options['dataType']);
  }

   /**
     * {@inheritdoc}
     */
  public function buildView(FormView $view, FormInterface $form, array $options) {
    $view -> set('dataType', $form -> getAttribute('dataType'));
    $view->vars = array_replace($view->vars, array(
                'class'          => $options['class'],      
                'motherfield'          => $options['motherfield'],      
            ));    
  }

public function setDefaultOptions(OptionsResolverInterface $resolver)
{
    $resolver->setDefaults(array('required'      =>  isset($options['required'])  ? $options['required'] :false,'dataType'=>'entity','motherfield'=>''));
}  


  /**
     * Returns the allowed option values for each option (if any).
     *
     * @param array $options
     *
     * @return array The allowed option values
     */
    public function getAllowedOptionValues(array $options)
    {
        return array('required' => array(false,true));
    }

   /**
     * {@inheritdoc}
     */
  public function getParent() {
    return 'entity';
  }

   /**
     * {@inheritdoc}
     */
  public function getName() {
    return 'product_change';
  }

}
