<?php

namespace Etrali\GinangBundle\Form\Type\Reporting;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class ReportingAllServicesPerCustomerType extends AbstractType 
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
  
    $builder->add('customerManagedBranch', 'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Customer Managed Branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',
                'attr' => array('onChange'=>'AjaxOfCustomerBranch()')
                ));
    
    $builder->add('extremityCustomerName', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Customer',  
                'multiple' => true,  
                'label' => 'Extremity Customer Name',                  
                'help' => NULL,  
                'translation_domain' => 'Admin',
                'attr' => array('onChange'=>'AjaxOfDeliveryAddressCustomer()')
                )); 
    
    $builder->add('extremityCustomerDeliveryAddress', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Address',  
                'multiple' => true,  
                'label' => 'Extremity Customer Delivery Address',                  
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('product', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Product',  
                'multiple' => true,  
                'label' => 'Product',                 
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('projectCode', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Project',  
                'multiple' => true,  
                'label' => 'Project Code',                 
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('serviceStatus', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'EtraliGinangBundle:TransactionStatus',  
                'multiple' => true,  
                'label' => 'Service Status',                  
                'help' => NULL,  
                'translation_domain' => 'Admin',));    

  }
  
  public function getName()
  {
    return 'etrali_ginangBundle_reporting_all_services_per_customer';
  }   

}

