<?php

namespace Etrali\GinangBundle\Form\Type\Reporting;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class ReportingPendingServicesType extends AbstractType 
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
  
   $builder->add('commercialBranch', 'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Commercial branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',));
    
    $builder->add('extremityBranch',  'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Extremity branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',));
    
    $builder->add('customer', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Customer',  
                'multiple' => true,  
                'label' => 'Customer',  
                'empty_value'=>'Any Customer',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('provider', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Provider',  
                'multiple' => true,  
                'label' => 'Provider',  
                'empty_value'=>'Any Provider',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
        
    $builder->add('pop', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Pop',  
                'multiple' => true,  
                'label' => 'Pop',  
                'empty_value'=>'Any Pop',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('billedCustomer', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Customer',  
                'multiple' => true,  
                'label' => 'Billed customer',  
                'empty_value'=>'Any Billed customer',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('projectCode', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Project',  
                'multiple' => true,  
                'label' => 'Project Code',  
                'empty_value'=>'Any Project Code',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('serviceStatus', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\TransactionStatus',  
                'multiple' => true,  
                'label' => 'Service Status',  
                'empty_value'=>'Any Service Status',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
  }
  
  public function getName()
  {
    return 'etrali_ginangBundle_reporting_pending_services';
  }   

}

