<?php

namespace Etrali\GinangBundle\Form\Type\Service;

use Admingenerator\GeneratorBundle\Form\Type\PortMapperType;
use Admingenerator\GeneratorBundle\Form\Type\SearchListType;
use DateInterval;
use Etrali\GinangBundle\Entity\Service;
use Etrali\GinangBundle\Entity\ServiceTransactions;
use Etrali\GinangBundle\SendMail;

use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints;

class CustomValidator {

    private static $missingServices=array();
    
    private static function addSpecialFields($form, $entity_name, $entityManager, $object) {
        if ($object != NULL) {
            foreach ($object->getIdServiceCaracs() as $carac) {
                if ($carac->getIdProductCaracs()->getLbWidgetType() == "checkbox") {
                    $tab = array();                   
                    $form->add($carac->getIdProductCaracs()->getLbField(), "checkbox", array('required' => false, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>($carac->getValeur()=="1")));
                } else if ($carac->getIdProductCaracs()->getLbWidgetType() == "choice") {
                    $tab = array();
                    if (is_numeric($carac->getIdProductCaracs()->getValue1()) && is_numeric($carac->getIdProductCaracs()->getValue2())) {
                        for ($i = intval($carac->getIdProductCaracs()->getValue1()); $i <= intval($carac->getIdProductCaracs()->getValue2()); $i++)
                            $tab[$i] = $i;
                    } else {
                        $tab[$carac->getIdProductCaracs()->getValue1()] = $carac->getIdProductCaracs()->getValue1();
                        $tab[$carac->getIdProductCaracs()->getValue2()] = $carac->getIdProductCaracs()->getValue2();
                    }
                    $form->add($carac->getIdProductCaracs()->getLbField(), "choice", array('required' => false, 'choices' => $tab, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$carac->getValeur()));
                } else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 12) == "search_list:") {
                    $tab=explode(":",$carac->getIdProductCaracs()->getLbWidgetType());
                    $entity =$tab[1];
                    $val=NULL;
                    if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                        $val=$entityManager->getRepository('EtraliGinangBundle:' . $entity)->find($carac->getValeur());
                    $options= array('required' => false, 'class' => 'EtraliGinangBundle:' . $entity, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                    for ($i=2;$i<count($tab);$i++)
                    {
                        $keyval=explode("~",$tab[$i]);
                        $options[$keyval[0]]=str_replace("->",":",$keyval[1]);
                    }                    
                    $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);
                }
                else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 22) == "search_list_connected:") {
                    $tab=explode(":",$carac->getIdProductCaracs()->getLbWidgetType());
                    $entity ="Service";
                    $val=NULL;
                    if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                        $val=$entityManager->getRepository('EtraliGinangBundle:Service')->find($carac->getValeur());
                    $options= array('required' => false, 'class' => 'EtraliGinangBundle:Service', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                    $idprodtype=explode(",",$tab[2]);
                    if (count($idprodtype)==3)                        
                        $options['action']='Etrali_GinangBundle_Service_all_bundles';
                    else if (count($idprodtype)==2)                        
                        $options['action']='Etrali_GinangBundle_Service_areainter_bundles';                    
                    else
                        $options['action']='Etrali_GinangBundle_Service_inter_bundles';
                    $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);
                }
                else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 23) == "search_list_membership:") {
                    $tab=explode(":",$carac->getIdProductCaracs()->getLbWidgetType());
                    $entity ="Service";
                    $val=NULL;
                    if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                        $val=$entityManager->getRepository('EtraliGinangBundle:Service')->find($carac->getValeur());
                    $options= array('required' => false, 'class' => 'EtraliGinangBundle:Service', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                    $options['action']='Etrali_GinangBundle_Service_memberships';
                    $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);
                }                
                else if ($carac->getIdProductCaracs()->getLbWidgetType() == "integer" && $carac->getIdProductCaracs()->getValue1() != null && $carac->getIdProductCaracs()->getValue2() != null) {
                    $form->add($carac->getIdProductCaracs()->getLbField(), 'integer', array('required' => false, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$carac->getValeur(), 'constraints' => array(
                            new Constraints\Range(array(
                                'min' => intval($carac->getIdProductCaracs()->getValue1()),
                                'max' => intval($carac->getIdProductCaracs()->getValue2()))))));
                } else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 11) == "port_mapper") {
                    $form->add($carac->getIdProductCaracs()->getLbField(), new PortMapperType(), array('class' => 'EtraliGinangBundle:Port', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$carac->getValeur(),));
                } else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 7) == "special")
                {
                    switch ($carac->getIdProductCaracs()->getLbField())
                    {
                        case "idAcceptContact":
                            if ($object->getIdServiceExtremityOwner()!=null)
                            {
                                $val=NULL;
                                switch ($object->getIdServiceExtremityOwner()->getIdLocalLoopExtremityOwner())
                                {
                                    case 1:
                                        if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                                            $val=$entityManager->getRepository('EtraliGinangBundle:Contact')->find($carac->getValeur());
                                        $options= array('required' => false, 'class' => 'EtraliGinangBundle:Contact', 'motherentity'=>'idCustomer', 'motherfield'=>'_idCustomer', 'action'=>'Etrali_GinangBundle_Contact_acceptance', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                                        $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);                                    
                                        break;                                  
                                    case 2:
                                        if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                                            $val=$entityManager->getRepository('EtraliGinangBundle:ContactPop')->find($carac->getValeur());
                                        $options= array('required' => false, 'class' => 'EtraliGinangBundle:ContactPop', 'motherentity'=>'idPop', 'motherfield'=>'_idPop', 'action'=>'Etrali_GinangBundle_ContactPop_acceptance', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                                        $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);                                    break;  
                                    case 3:
                                        if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                                            $val=$entityManager->getRepository('EtraliGinangBundle:ContactProvider')->find($carac->getValeur());
                                        $options= array('required' => false, 'class' => 'EtraliGinangBundle:ContactProvider', 'motherentity'=>'idProvider', 'motherfield'=>'_idProvider', 'action'=>'Etrali_GinangBundle_ContactProvider_acceptance', 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val);
                                        $form->add($carac->getIdProductCaracs()->getLbField(), new SearchListType(),$options);
                                        break;                                   
                                }                           
                            }
                            break;                         
                    }
                }
                else if (substr($carac->getIdProductCaracs()->getLbWidgetType(), 0, 10) == "datepicker")
                {
                    $val=NULL;
                    if ($carac->getValeur()!=NULL && $carac->getValeur()!="")
                       $val=new \Datetime($carac->getValeur());
                    $form->add($carac->getIdProductCaracs()->getLbField(), $carac->getIdProductCaracs()->getLbWidgetType(), array('required' => false, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$val));
                }
                else
                    $form->add($carac->getIdProductCaracs()->getLbField(), $carac->getIdProductCaracs()->getLbWidgetType(), array('required' => false, 'mapped' => false, 'label' => $carac->getIdProductCaracs()->getLbCarac(), 'cascade_validation' => true, 'data'=>$carac->getValeur()));
            }
        }
    }

    private static function getField($extr, $name) {
        $assocname = "get" . ucfirst($name);
        if (method_exists($extr,$assocname)) {
            return $extr->$assocname();
        } else {
            $val = self::findFieldValue($extr, $name);
            return $val;
        }
    }
    
    private static function validateFactorized($setting, FormBuilderInterface $builder, $entity_name, $entityManager, $id_transaction_type, $id_transaction_status, $is_old, $subform = "", $is_transfer, $object = null) {
        $treated=false;
        $objprop=$setting->getLbField();
        $transferTypes=array(10,12,13,16);        
        if ($setting->getBlOne()  && $object->getIdService()->isP2P() &&  (      ($entity_name == "ServiceExtremity" && $object->getIdService()->getIdSelectedExtremity() != NULL && $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() != $object->getIdServiceExtremity())
                                      ||   ($entity_name == "ServiceExtremityTech" && $object->getIdService()->getIdSelectedExtremity() != NULL && $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() != $object->getIdServiceExtremity()->getIdServiceExtremity())))
        {
            $builder->remove($objprop);   
            $treated=true;
        }
        else
        {
            if ($setting->getBlHide()) {
                $treated=true;
                if ($builder->has($objprop)) {               
                    $options = $builder->get($objprop)->getOptions();
                    $type = $builder->get($objprop)->getType()->getName();
                    if ($type == "datepicker") {
                        $type = "datetime";
                        $options =array("widget" => "single_text", "label" => "°", "required" => false, 'attr' => array('style' => 'display:none;'), 'mapped'=>(isset($options["mapped"])?$options["mapped"]:true));
                        $builder->add($objprop, $type, $options);
                        $builder->get($objprop)->setRequired(false);
                    } else {
                                $type = "hidden";       // get the name of the type
                                $options=$builder->getOptions();
                                $builder->add($objprop, $type, $options);
                                $builder->get($objprop)->setRequired(false);
                    }
                }
            }
            if ($builder->has($objprop)) {
                       $dohide=true;                       
                       if ($setting->getBlEditable())
                       {    
                           if ($entity_name == "BillingService")
                                $dohide=false;
                            else if ($setting->getBlOne() && $object != null) {
                                if ($entity_name == "ServiceExtremity" && ($object->getIdService()->isP2P()) && ($object->getIdService()->getIdSelectedExtremity() == NULL || $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() == $object->getIdServiceExtremity()))
                                { 
                                        if (!$setting->getBlOldExtremity() && !$is_old)
                                            $dohide=false;                           
                                }
                                else if ($entity_name == "ServiceExtremityTech" && ($object->getIdService()->isP2P())  && ($object->getIdService()->getIdSelectedExtremity() == NULL || $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() == $object->getIdServiceExtremity()->getIdServiceExtremity()))
                                {                               
                                        if (!$setting->getBlOldExtremity() && !$is_old)
                                            $dohide=false;                                      
                                }  
                                else if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                                    $dohide=false;   
                            }
                            else if (in_array($id_transaction_type,$transferTypes) && ($entity_name=="ServiceExtremity" || $entity_name=="ServiceExtremityTech"))
                           {    
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                    $dohide=false;                                                 
                          }
                          else if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                                    $dohide=false;    
                       }

                       if ($dohide)
                       {                          
                           $builder->get($setting->getLbField())->setDisabled(true);      
                            if (substr($setting->getLbField(),0,2)=='dt')
                            {
                                $options = $builder->get($objprop)->getOptions();
                                $getter='get'.ucfirst($setting->getLbField());
                                $type = $builder->get($setting->getLbField())->getType()->getName(); 
                                if ($type=="datepicker" && ($object==NULL || ((method_exists($object,$getter) && $object->$getter()==NULL) || (!method_exists($object,$getter) && self::findFieldValue($object,$setting->getLbField())==NULL))))
                                {
                                    $type="datetime";
                                    $options=array("widget"=>"single_text","label"=>"°","required"=>false,'attr'=>array('style'=>'display:none;'),'mapped'=>(isset($options["mapped"])?$options["mapped"]:true));             
                                    $builder->add($setting->getLbField(), $type, $options);
                                    $builder->get($setting->getLbField())->setRequired(false);                                        
                                }                                    
                            }                           
                       }
                       else 
                           { 
                           $treated=true;
                           }
            }
            if ($setting->getBlMandatory()) {
                if ($builder->has($objprop)) {
                    $putRequired=false;
                    if ($entity_name == "BillingService")
                        $putRequired=true;
                    else if ($setting->getBlOne() && $object != null) 
                    {
                                if ($entity_name == "ServiceExtremity" && $object->getIdService()->isP2P() && ($object->getIdService()->getIdSelectedExtremity() == NULL || $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() == $object->getIdServiceExtremity()))
                                { 
                                        if (!$setting->getBlOldExtremity() && !$is_old)
                                            $putRequired=true;                          
                                }
                                else if ($entity_name == "ServiceExtremityTech"  && $object->getIdService()->isP2P() && ($object->getIdService()->getIdSelectedExtremity() == NULL || $object->getIdService()->getIdSelectedExtremity()->getIdServiceExtremity() == $object->getIdServiceExtremity()->getIdServiceExtremity()))
                                {                               
                                        if (!$setting->getBlOldExtremity() && !$is_old)
                                            $putRequired=true;                                     
                                }  
                                else if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                                    $putRequired=true;
                    }
                    else if (in_array($id_transaction_type,$transferTypes) && ($entity_name=="ServiceExtremity" || $entity_name=="ServiceExtremityTech"))
                           {    
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                    $putRequired=true;                                                   
                          }
                    else if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                        $putRequired=true;
                    if ($putRequired)
                    {
                        $treated=true;                    
                        $builder->get($objprop)->setRequired(true);
                    }
                }
            } else {
                if ($builder->has($objprop)) {
                    if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                    {
                        $builder->get($objprop)->setRequired(false);
                    }
                }
            }            
        }         

         return $treated;
    }
        
    
    public static function isEndTransaction($id_transaction_type,$id_status)
    {
        return   ($id_transaction_type==9 && $id_status>54)
                 || ($id_transaction_type==10 && $id_status>65)
                 || ($id_transaction_type==11 && $id_status>75)
                 || ($id_transaction_type==12 && $id_status>85)
                 || ($id_transaction_type==13 && $id_status>96)
                 || ($id_transaction_type==14 && $id_status>102)
                 || ($id_transaction_type==15 && $id_status>105)
                 || ($id_transaction_type==16 && $id_status>98)
                 || ($id_transaction_type==17 && $id_status>107);
    }
    
    public static function validateFieldFromDb(FormBuilderInterface $builder,$entity_name,$entityManager,$id_transaction_type,$id_transaction_status,$is_old,$subform="",$is_transfer,$object=null)
    {
        if ($entity_name!="BillingService" && $entity_name!="ServiceDevice")
            self::addSpecialFields($builder,$entity_name,$entityManager,$object);
        
        $statuses=array(49,50,51,60,61,62,71,72,73,81,82,83,91,92,93);
        $endstatus=$id_transaction_status;        
        if (in_array($id_transaction_status,$statuses))
        {
            /* Notice : $endstatus is passed by reference */
            
            self::isValidBBFrameToFrame($object,$entityManager,NULL,$endstatus);
            if ($endstatus!="")
            {
                if (strpos($endstatus,":")!==FALSE)
                {
                    $tab=explode(":",$endstatus);
                    $id_status=$tab[count($tab)-1]+1;
                }
                else
                    $id_status=$endstatus+1;
            }
            else
                $id_status=$id_transaction_status+1; 
        }
        else
        {
            $shortProds=array(5,6,7,8,9,15,16,20,21);
            $jumpStatuses=array(45=>54,56=>65,67=>75,77=>85,87=>96);
            if ($object!=NULL)
            {
                if ($entity_name == "BillingService" || $entity_name == "ServiceExtremity" || $entity_name == "ServiceDevice" || $entity_name == "ServiceExtremityTech")
                   $idProdType=$object->getIdService()->getIdProduct()->getIdProductType()->getIdProductType();
                else
                    $idProdType=$object->getIdProduct()->getIdProductType()->getIdProductType();
                if (in_array($idProdType,$shortProds) && array_key_exists($id_transaction_status,$jumpStatuses))
                    $id_status=$jumpStatuses[$id_transaction_status];
                else
                    $id_status=$id_transaction_status+1;  
            }
            else
                $id_status=$id_transaction_status+1;  
        }        
        
           

         if (self::isEndTransaction($id_transaction_type,$id_status))
             $id_status=$id_transaction_status;
             
         $treated=array();
         $treatedProduct=array();
         switch ($entity_name)
         {
             case "Service":
                 $idProductType=$object!=null?$object->getIdProduct()->getIdProductType():$entityManager->getRepository('EtraliGinangBundle:ProductType')->find(1);
                 break;
             default:
                 $idProductType=$object!=null?$object->getIdService()->getIdProduct()->getIdProductType():$entityManager->getRepository('EtraliGinangBundle:ProductType')->find(1);
                 break;
         }
         
         $tabttype=array("=".$id_transaction_type," is null");
         $tabptype=array("=".$idProductType->getIdProductType()," is null");
         $tabstatus=array("=".$id_status," is null");
         
         foreach ($tabttype as $ttype)
         {
             foreach ($tabptype as $ptype)
             {
                 foreach ($tabstatus as $status)
                 {
                    $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\ServiceInterfaceSettings')
                               ->createQueryBuilder('q')->leftJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                               ->andWhere("q.lbEntity='".$entity_name."'")
                               ->andWhere("t.idTransactionType".$ttype)
                               ->andWhere("q.idProductType".$ptype)                 
                               ->andWhere("s.idTransactionStatus".$status)->getQuery()->getResult();

                    /* treat lines applied to specified transaction status  */
                    foreach($result as $setting)
                    {
                        if (!isset($treated[$setting->getLbField()]) || !$treated[$setting->getLbField()])
                        {         
                            $treated[$setting->getLbField()]=self::validateFactorized($setting,$builder,$entity_name,$entityManager,$id_transaction_type,$id_status,$is_old,$subform,$is_transfer,$object);
                        }
                    }                          
                 }
             }
         }
         
        if  ((   ($id_transaction_type==9 && $id_status==45) 
                  || ($id_transaction_type==10 && $id_status==56)                   
                  || ($id_transaction_type==13 && $id_status==87) )
                  &&  $entity_name=="ServiceExtremity")                     
            {                     
                 $fields=array('idAdminContact','idContactPop','idContactProvider','idDeliveryAddress','idAddressPop','idAddressProvider');
                 foreach ($fields as $f)
                     $type = $builder->get($f)->setRequired(true); 
            }          
               
    }
    
    public static function findFieldValue($entity,$fieldName)
    {              
         foreach ($entity->getIdServiceCaracs() as $carac)
         {
             if ($carac->getIdProductCaracs()->getLbField()==$fieldName)
             {
                 return $carac->getValeur();
             }
         }
         return "N/A";
    }
    
    private static function parseFormula($formula,$entity)
    {
        $formula=trim($formula);
        if (strlen($formula)>0)
        {
            if (substr($formula,0,1)=="(" && substr($formula,-1)==")")
                return self::parseFormula(substr($formula,1,-1),$entity);
            else {
                $etpos=strpos($formula,'&');
                $oupos=strpos($formula,'|');
                if ($etpos===FALSE && $oupos===FALSE)
                {
                    if (substr($formula,-2)==":1")
                    {
                        $found=false;
                        foreach ($entity->getIdConnectedServices() as $connserv)
                        {
                            if ($connserv->getIdProduct()->getIdProductType()->getCdProductType()==substr($formula,0,-2))
                                $found=true;
                        }
                        if (!$found)  
                        {
                            self::$missingServices[]=substr($formula,0,-2);
                            return true;
                        }
                    }
                    else
                        return false;
                }
                else
                {
                    
                    if ($etpos<$oupos)
                    {                        
                        $part1=trim(substr($formula,0,$etpos));
                        $part2=trim(substr($formula,$etpos+1));
                        return self::parseFormula($part1,$entity) && self::parseFormula($part2,$entity);                        
                    }
                    else
                    {
                        $part1=trim(substr($formula,0,$oupos));
                        $part2=trim(substr($formula,$oupos+1));
                        return self::parseFormula($part1,$entity) || self::parseFormula($part2,$entity);                          
                    }
                }
            }
        }
        else
            return false;
    }    
  
    public static function handleValidation($idProductType,$id_status,$entity,$missfields)
    {
        $products=array(1,2,3,4,17,18,19,10,11,12,13,14,22,23,27);
        $statuses=array(48,59,70,80,90);
        if (in_array($idProductType->getIdProductType(),$products) && in_array($id_status,$statuses) && !$entity->getBlValidated())
        {
            $missfields["Service"]["Manual validation"]=1;
        }
        return $missfields;        
    }
    
    
    private static function handleNetrecovaRemoval($extr,$em)
    {
        $foundConnected=false;
        foreach ($extr->getIdServiceCaracs() as $service_carac)
        {
                    /** handle connected services * /
                     * 
                     */
                    if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==44 && $service_carac->getValeur()!=NULL)
                    {
                        $service_carac->setValeur(NULL);
                        $em->persist($service_carac);
                        $foundConnected=true;
                        break;
                    }                    
        }
        if ($foundConnected)
        {
            $ids=array();
            foreach ($extr->getIdService()->getIdServiceExtremity() as $extrloop)
            {
                foreach ($extrloop->getIdServiceCaracs() as $service_carac)
                {
                    if ($service_carac->getIdProductCaracs()->getIdProductCaracs()==44 && $service_carac->getValeur()!=NULL)
                        $ids[$service_carac->getValeur()]=1;
                }
            }
            foreach ($extr->getIdService()->getIdParentServices() as $parent)
            {
                if ($parent->getIdProduct()->getIdProductType()->getIdProductType()==5 && !array_key_exists($parent->getIdService(), $ids))
                {
                    $extr->getIdService()->removeIdParentService($parent);
                    $parent->removeIdConnectedService($extr->getIdService());
                    $em->persist($parent);
                }
            }            
        }
        $em->persist($extr->getIdService());       
        
    }
    
    public static function handlePostSaveService(Service $Service,$controller,$id_status,$em,$container)
    {
            $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
            $Service->setIdTransactionStatus($TransStatus);
            $em->persist($Service);
            
            $history=new ServiceTransactions();
            $history->setIdService($Service);
            $history->setCdService($Service->getCdService());
            $history->setIdTransactionStatus($TransStatus);
            $history->setIdTransactionType($Service->getIdTransactionType());                      
            $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
            $em->persist($history); 
            
            switch ($id_status)
            {
                case 45:
                    SendMail::send($controller,$container,"jconan@protego.net",1,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                    
                    break;                
                case 46:
                    foreach ($Service->getIdServiceExtremity() as $extr)
                        SendMail::send($controller,$container,"jconan@protego.net",2,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break;
                case 47:
                    foreach ($Service->getIdServiceExtremity() as $extr)
                        SendMail::send($controller,$container,"jconan@protego.net",3,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                    
                    break;
                case 48:
                    SendMail::send($controller,$container,"jconan@protego.net",4,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService())); 
                    break;
                case 49: 
                    $Service->setIdSelectedExtremity(NULL);
                    $em->persist($Service);
                    SendMail::send($controller,$container,"jconan@protego.net",5,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                      
                    SendMail::send($controller,$container,"jconan@protego.net",7,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                            
                    break; 
                case 50:
                    $Service->setBlBbstatus(true);
                    $em->persist($Service);
                    SendMail::send($controller,$container,"jconan@protego.net",10,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService())); 
                    break;                    
                case 51:
                    $Service->setBlLlstatus(true);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",9,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService())); 
                    break;
                case 52:
                    SendMail::send($controller,$container,"jconan@protego.net",11,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                     
                    break;
                case 53:
                    SendMail::send($controller,$container,"jconan@protego.net",12,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                     
                    SendMail::send($controller,$container,"jconan@protego.net",14,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService())); 
                    
                    $id_status+=1;
                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);                                                      
                case 54:
                    if ($Service->getDtDelivery()==NULL)
                    {
                        $Service->setDtDelivery(new \Datetime());
                        $em->persist($Service);
                    }
                    foreach ($Service->getIdBillingService() as $bs)
                    {
                        if ($bs->getDtStart()==NULL)
                        {
                            $bs->setDtStart(new \Datetime());
                            $em->persist($bs);
                        }  
                    }
                    foreach ($Service->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtStartMrc()==NULL)
                            {
                                $bsl->setDtStartMrc(new \Datetime());
                                $em->persist($bsl);
                            }                            
                    }
                    
                    SendMail::send($controller,$container,"jconan@protego.net",16,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break;
                    
                case 56:
                    SendMail::send($controller,$container,"jconan@protego.net",17,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break;
                case 57:
                    SendMail::send($controller,$container,"jconan@protego.net",18,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break;   
                case 58:
                    SendMail::send($controller,$container,"jconan@protego.net",19,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break;   
                case 59:
                    SendMail::send($controller,$container,"jconan@protego.net",20,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    break; 
                case 60:
                    $Service->setIdSelectedExtremity(NULL);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",21,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));
                    SendMail::send($controller,$container,"jconan@protego.net",23,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                    
                    break;   
                case 61:
                    $Service->setBlBbstatus(true);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",26,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                   
                    break;    
                case 62:
                    $Service->setBlLlstatus(true);
                    $em->persist($Service);                        
                    SendMail::send($controller,$container,"jconan@protego.net",25,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                   
                    break; 
                case 63:
                    SendMail::send($controller,$container,"jconan@protego.net",27,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                   
                    break;   
                case 64:
                    SendMail::send($controller,$container,"jconan@protego.net",28,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));   
                    SendMail::send($controller,$container,"jconan@protego.net",29,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));  
                    $id_status+=1;
                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);                                                      
                    
                case 65:                           
                     $transferExtr=$Service->getIdTransferExtremity();
                     $transferExtr->setCdServiceExtremity(substr($transferExtr->getCdServiceExtremity(),0,strlen($transferExtr->getCdServiceExtremity())-3));
                     $transferExtr->getIdOldExtremity()->setCdServiceExtremity($transferExtr->getIdOldExtremity()->getCdServiceExtremity()."Old");
                     $transferExtr->getIdOldExtremity()->setBlTransferred(true);
                     $transferExtr->getIdOldExtremity()->getIdServiceExtremityTech()->setBlTransferred(true);
                    if ($transferExtr->getDtCompleteTransfer()==NULL)
                        $transferExtr->setDtCompleteTransfer(new \Datetime());
                                        
                     self::handleNetrecovaRemoval($transferExtr->getIdOldExtremity(),$em);
                    
                     $transferExtr->getIdOldExtremity()->setDtOldExtremityTerminate(clone $transferExtr->getDtCompleteTransfer()); 
                     $transferExtr->getIdOldExtremity()->getDtOldExtremityTerminate()->sub(new DateInterval('P1D'));                     
                     $em->persist($transferExtr); 
                     $em->persist($transferExtr->getIdOldExtremity());                     
                                                      
                    foreach ($Service->getIdTransferExtremity()->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtStartMrc()==NULL)
                            {
                                $bsl->setDtStartMrc(new \Datetime());
                                $em->persist($bsl);
                            }                            
                    }                    
                    SendMail::send($controller,$container,"jconan@protego.net",30,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    SendMail::send($controller,$container,"jconan@protego.net",600,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));   
                    SendMail::send($controller,$container,"jconan@protego.net",650,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break; 
                case 67:
                    SendMail::send($controller,$container,"jconan@protego.net",31,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;
                case 68:
                    SendMail::send($controller,$container,"jconan@protego.net",32,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;   
                case 69:
                    SendMail::send($controller,$container,"jconan@protego.net",33,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 70:
                    SendMail::send($controller,$container,"jconan@protego.net",34,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 71:
                    $Service->setIdSelectedExtremity(NULL);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",35,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",37,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                        
                    break; 
                case 72:
                    $Service->setBlBbstatus(true);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",40,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 73:
                    $Service->setBlLlstatus(true);
                    $em->persist($Service);                        
                    SendMail::send($controller,$container,"jconan@protego.net",39,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 74:
                    SendMail::send($controller,$container,"jconan@protego.net",41,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",43,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));  
                    $id_status+=1;
                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);                                                      
                    
                case 75:
                    if ($Service->getDtRealUpdown()==NULL)
                    {
                        $Service->setDtRealUpdown(new \Datetime());
                        $em->persist($Service);
                    }                    
                    foreach ($Service->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtStartMrc()==NULL)
                            {
                                $bsl->setDtStartMrc(new \Datetime());
                                $em->persist($bsl);
                            }                                
                    }                  
                    SendMail::send($controller,$container,"jconan@protego.net",45,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break;  
                case 77:
                    SendMail::send($controller,$container,"jconan@protego.net",31,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;
                case 78:
                    SendMail::send($controller,$container,"jconan@protego.net",32,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;   
                case 79:
                    SendMail::send($controller,$container,"jconan@protego.net",33,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 80:
                    SendMail::send($controller,$container,"jconan@protego.net",34,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 81:
                    $Service->setIdSelectedExtremity(NULL);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",35,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",37,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                        
                    break; 
                case 82:
                    $Service->setBlBbstatus(true);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",40,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 83:
                    $Service->setBlLlstatus(true);
                    $em->persist($Service);                        
                    SendMail::send($controller,$container,"jconan@protego.net",39,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 84:
                    SendMail::send($controller,$container,"jconan@protego.net",41,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",43,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService())); 
                    $id_status+=1;
                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);                                                      
                    
                case 85: 
                    $transferExtr=$Service->getIdTransferExtremity();
                    if ($transferExtr->getDtRealUpdown()==NULL)
                    {
                        $transferExtr->setDtRealUpdown(new \Datetime());
                        $em->persist($transferExtr);
                    }                                      
                  
                    foreach ($Service->getIdTransferExtremity()->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtStartMrc()==NULL)
                            {
                                $bsl->setDtStartMrc(new \Datetime());
                                $em->persist($bsl);
                            }                            
                    }                    
                    SendMail::send($controller,$container,"jconan@protego.net",45,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break;   
                case 87:
                    SendMail::send($controller,$container,"jconan@protego.net",46,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;
                case 88:
                    SendMail::send($controller,$container,"jconan@protego.net",47,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;   
                case 89:
                    SendMail::send($controller,$container,"jconan@protego.net",48,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 90:
                    SendMail::send($controller,$container,"jconan@protego.net",49,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 91:
                    $Service->setIdSelectedExtremity(NULL);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",50,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",52,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                        
                    break; 
                case 92:
                    $Service->setBlBbstatus(true);
                    $em->persist($Service);                    
                    SendMail::send($controller,$container,"jconan@protego.net",55,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 93:
                    $Service->setBlLlstatus(true);
                    $em->persist($Service);                        
                    SendMail::send($controller,$container,"jconan@protego.net",54,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                       
                    break;  
                case 95:
                    SendMail::send($controller,$container,"jconan@protego.net",56,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    SendMail::send($controller,$container,"jconan@protego.net",58,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));   
                    $id_status+=1;
                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);                                                      
                    
                case 96:    
                    $transferExtr=$Service->getIdTransferExtremity();
                    if ($transferExtr->getDtAddExtremityInservice()==NULL)
                    {
                        $transferExtr->setDtAddExtremityInservice(new \Datetime());
                        $em->persist($transferExtr);
                    }                                        
                    foreach ($Service->getIdTransferExtremity()->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtStartMrc()==NULL)
                            {
                                $bsl->setDtStartMrc(new \Datetime());
                                $em->persist($bsl);
                            }                            
                    }                   
                    SendMail::send($controller,$container,"jconan@protego.net",59,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break;                       
                case 98:    
                    $transferExtr=$Service->getIdTransferExtremity();
                    if ($transferExtr->getDtRealTerminate()==NULL)
                    {
                        $transferExtr->setDtRealTerminate(new \Datetime());
                        $em->persist($transferExtr);
                    }                                     
                    foreach ($Service->getIdTransferExtremity()->getIdBillingServiceLine() as $bsl)
                    {
                        if ($bsl->getDtEndMrc()==NULL)
                        {
                            $bsl->setDtEndMrc(clone $Service->getIdTransferExtremity()->getDtRealTerminate());
                            $em->persist($bsl);
                        }                        
                    }                   
                    SendMail::send($controller,$container,"jconan@protego.net",60,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break; 
                case 101:
                    SendMail::send($controller,$container,"jconan@protego.net",81,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));    
                    break;
                case 102:                    
                    $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find($id_status);
                    $Service->setIdTransactionStatus($TransStatus);
                    $em->persist($Service); 
                    
                    $history=new ServiceTransactions();
                    $history->setIdService($Service);
                    $history->setCdService($Service->getCdService());
                    $history->setIdTransactionStatus($TransStatus);
                    $history->setIdTransactionType($Service->getIdTransactionType());                      
                    $history->setLbOperation($Service->getIdTransactionType()." ".$Service->getNbOperation());
                    $em->persist($history);   
                    SendMail::send($controller,$container,"jconan@protego.net",82,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));                     
                    break;
                case 104:    
                    $device=$Service->getIdSelectedDevice();
                    if ($device->getDtRealTerminate()==NULL)
                    {
                        $device->setDtRealTerminate(new \Datetime());
                        $em->persist($device);
                    }                                                      
                    SendMail::send($controller,$container,"jconan@protego.net",83,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break;                 
                case 107:   
                    if ($Service->getDtRealTerminate()==NULL)
                    {
                        $Service->setDtRealTerminate(new \Datetime());
                        $em->persist($Service);
                    }  
                    foreach ($Service->getIdBillingService() as $bs)
                    {
                        $bs->setDtEnd(clone $Service->getDtRealTerminate());
                        $em->persist($bs);
                    }
                    foreach ($Service->getIdBillingServiceLine() as $bsl)
                    {
                            if ($bsl->getDtEndMrc()==NULL)
                            {
                                $bsl->setDtEndMrc(clone $Service->getDtRealTerminate());
                                $em->persist($bsl);
                            }                            
                    }                   
                    SendMail::send($controller,$container,"jconan@protego.net",62,array("DATE"=>date("d/m/Y H:i"),"REF"=>$Service->getCdService()));     
                    break;                      
            }
            $em->flush();            
        
    }
    
    public static function isValidBBFrameToFrame($entity,$em,$controller,&$endstatus)
    {
        if (!($entity instanceof Service))
            $entity=$entity->getIdservice();
        $id_type=$entity->getIdTransactionType()->getIdTransactionType();   
        $id_status=$endstatus;
        if (self::isEndTransaction($id_type,$id_status+1))
             return "NA";
        
        $chaineret="";
        $treated=array();         
        $missfields=array();
        
        $idProductType=$entity->getIdProduct()->getIdProductType();
        $transferTypes=array(10,12,13);
        $retstat=array();
        
        $statuses=array(49,60,71,81,91);
        $statuses2=array(50,61,72,82,92);
        $statuses3=array(51,62,73,83,93);        
        if (in_array($id_status,$statuses))
        {
           $allin=true;
           if (!$entity->hasOffNet())
           {
                foreach ($entity->getIdServiceExtremityTech() as $extr)
                {
                    if ($extr->getCdPipeId()==NULL || $extr->getCdPipeId()=="")
                    {
                        $missfields["ServiceExtremityTech"]["Pipe ID"]=1;
                        $allin=false;
                        break;
                    }
                    if ($extr->getDtBackboneProgram()==NULL )
                    {
                        $missfields["ServiceExtremityTech"]["Backbone program date"]=1;
                        $allin=false;
                        break;
                    }               
                }
                if ($allin && !$entity->getBlBbstatus())
                    $retstat[]=$id_status+1;
           }

           $allin2=true;
           foreach ($entity->getIdServiceExtremityTech() as $extr)
           {
                if ($extr->getIdLocalLoop()==NULL)
                {
                    $missfields["ServiceExtremity"]["Local loop ref"]=1;
                    $allin2=false;
                    break;
                }
                else  
                {
                    foreach ($extr->getIdLocalLoop()->getIdLocalLoopExtremityTech() as $extrtech)
                    {
                        if ($extrtech->getDtLlTested()==NULL)
                        {
                            $missfields["Local loop extremity"]["Local loop tested"]=1;
                            $allin2=false;
                            break;                            
                        }
                    }
                }                   
           }
           if ($allin2  && !$entity->getBlLlstatus())
               $retstat[]=$id_status+2;
           
           $allin2bis=$allin && $allin2 && $entity->hasCaracLbConnection();
           if ($allin2bis && $id_status!=71 && $id_status!=81)
               $retstat[]=$id_status+3;       
           
           $allin3=false;           
           if ($allin && $allin2)
           {
               if ((!$entity->hasCaracLbConnection() || $entity->getCaracLbConnection()!="frame-to-frame") && ((in_array($id_type,$transferTypes) && $entity->getIdTransferExtremity()->getIdServiceExtremityTech()->hasDtEndToEnd()) || (!in_array($id_type,$transferTypes) && $entity->hasDtEndToEnd())))
               {
                   $allin3=true;
                if ($id_status!=71 && $id_status!=81)
                     $retstat[]=$id_status+4;                  
                else
                     $retstat[]=$id_status+3;                 
               }
               else
               {
                   $allin3=false;
                   $missfields["ServiceExtremityTech"]["End to end date"]=1;
               }
           }
           
           $allin4=$allin3 || ($allin2bis && $entity->getCaracLbConnection()=="frame-to-frame");
           if ($allin4)
           {
               if ($id_status!=71 && $id_status!=81)
                    $retstat[]=$id_status+5;                    
               else
                    $retstat[]=$id_status+4;                    
           }
        }
        else if (in_array($id_status,$statuses2))
        {
           $allin=true;
            $allin2=true;
           foreach ($entity->getIdServiceExtremityTech() as $extr)
           {
                if ($extr->getIdLocalLoop()==NULL)
                {
                    $missfields["ServiceExtremity"]["Local loop ref"]=1;
                    $allin2=false;
                    break;
                }
                else  
                {
                    foreach ($extr->getIdLocalLoop()->getIdLocalLoopExtremityTech() as $extrtech)
                    {
                        if ($extrtech->getDtLlTested()==NULL)
                        {
                            $missfields["Local loop extremity"]["Local loop tested"]=1;
                            $allin2=false;
                            break;                            
                        }
                    }
                }                 
           }
           if ($allin2 && !$entity->getBlLlstatus())
               $retstat[]=$id_status+1;
           
           $allin2bis=$allin && $allin2 && $entity->hasCaracLbConnection();
           if ($allin2bis && $id_status!=72 && $id_status!=82)
               $retstat[]=$id_status+2;       
           
           $allin3=false;
           if ($allin && $allin2)
           {
               if ((!$entity->hasCaracLbConnection() || $entity->getCaracLbConnection()!="frame-to-frame") && ((in_array($id_type,$transferTypes) && $entity->getIdTransferExtremity()->getIdServiceExtremityTech()->hasDtEndToEnd()) || (!in_array($id_type,$transferTypes) && $entity->hasDtEndToEnd())))
               {
                   $allin3=true;
                if ($id_status!=72 && $id_status!=82)
                     $retstat[]=$id_status+3;                  
                else
                     $retstat[]=$id_status+2;                 
               }
               else
               {
                   $allin3=false;
                   $missfields["ServiceExtremityTech"]["End to end date"]=1;
               }
           }
           
           $allin4=$allin3 || ($allin2bis && $entity->getCaracLbConnection()=="frame-to-frame");
           if ($allin4)
           {
               if ($id_status!=72 && $id_status!=82)
                    $retstat[]=$id_status+4;                    
               else
                    $retstat[]=$id_status+3;                    
           }
        }
        else if (in_array($id_status,$statuses3))
        {
           $allin2=true;
           $allin=true;
           if (!$entity->hasOffNet())
           {
                foreach ($entity->getIdServiceExtremityTech() as $extr)
                {
                    if ($extr->getCdPipeId()==NULL || $extr->getCdPipeId()=="")
                    {
                        $missfields["ServiceExtremityTech"]["Pipe ID"]=1;
                        $allin=false;
                        break;
                    }
                    if ($extr->getDtBackboneProgram()==NULL )
                    {
                        $missfields["ServiceExtremityTech"]["Backbone program date"]=1;
                        $allin=false;
                        break;
                    }               
                }
                if ($allin && !$entity->getBlBbstatus())
                    $retstat[]=$id_status-1;
           }
           
           $allin2bis=$allin && $allin2 && $entity->hasCaracLbConnection();
           if ($allin2bis && $id_status!=73 && $id_status!=83)
               $retstat[]=$id_status+1;       
           
           $allin3=false;
           if ($allin && $allin2)
           {
               if ((!$entity->hasCaracLbConnection() || $entity->getCaracLbConnection()!="frame-to-frame") && ((in_array($id_type,$transferTypes) && $entity->getIdTransferExtremity()->getIdServiceExtremityTech()->hasDtEndToEnd()) || (!in_array($id_type,$transferTypes) && $entity->hasDtEndToEnd())))
               {
                   $allin3=true;
                if ($id_status!=73 && $id_status!=83)
                     $retstat[]=$id_status+2;                  
                else
                     $retstat[]=$id_status+1;                 
               }
               else
               {
                   $allin3=false;
                   $missfields["ServiceExtremityTech"]["End to end date"]=1;
               }
           }

           $allin4=$allin3 || ($allin2bis && $entity->getCaracLbConnection()=="frame-to-frame");
           if ($allin4)
           {
               if ($id_status!=73 && $id_status!=83)
                    $retstat[]=$id_status+3;                    
               else
                    $retstat[]=$id_status+2;                    
           }
        }                        
        $endstatus=implode(":",$retstat);

        foreach ($missfields as $key=>$value)
        {
            $chaineret.="In $key : ";
            $labels=array();
            if ($controller!=NULL)
            {
                $ymlfile=$controller->get("kernel")->getRootDir().'/../src/Etrali/GinangBundle/Resources/config/'.$key.'-generator.yml';                           
                if (file_exists($ymlfile))
                    $infos=$controller->getFromExternYaml($ymlfile,'params.fields');     
            }
            foreach ($value as $fieldname=>$entdesc)
            {
                if (isset($infos[$fieldname]))
                    $chaineret.=$infos[$fieldname]["label"].",";
                else
                    $chaineret.=$fieldname.",";
            }
            $chaineret.="<br>";
        }
        return $chaineret;        
         
    }
    
    public static function isValidForNextStep($entity,$entityManager,$controller,&$endstatus)
    {       
         $id_type=$entity->getIdTransactionType()->getIdTransactionType();
         $id_status=$entity->getIdTransactionStatus()->getIdTransactionStatus();

        $shortProds=array(5,6,7,8,9,15,16,20,21);
        $jumpStatuses=array(45=>54,56=>65,67=>75,77=>85,87=>96);
        if (in_array($entity->getIdProduct()->getIdProductType()->getIdProductType(),$shortProds) && array_key_exists($entity->getIdTransactionStatus()->getIdTransactionStatus(),$jumpStatuses))
        {
            $id_status=$jumpStatuses[$entity->getIdTransactionStatus()->getIdTransactionStatus()];
        }
        else
            $id_status=$entity->getIdTransactionStatus()->getIdTransactionStatus()+1;     
         $endstatus=$id_status;
         if (self::isEndTransaction($id_type,$id_status))
             return "NA";

         $chaineret="";
         $treated=array();         
         $missfields=array();
         
         if ($entity instanceof Service )
         {
                 $idProductType=$entity->getIdProduct()->getIdProductType();
                 $missfields=self::handleValidation($idProductType,$id_status,$entity,$missfields);
         }
         else
                 $idProductType=$entity->getIdService()->getIdProduct()->getIdProductType();            
         
         $tabptype=array("=".$idProductType->getIdProductType()," is null");
         $transferTypes=array(10,12,13,16);
         
         foreach ($tabptype as $ptype)
         {         
               $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\ServiceInterfaceSettings')
                       ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                       ->andWhere("t.idTransactionType=".$entity->getIdTransactionType()->getIdTransactionType())
                       ->andWhere("s.idTransactionStatus=".$id_status)
                       ->andWhere("q.idProductType".$ptype)->getQuery()->getResult();                 

               foreach($result as $setting)
               {
                   if (!isset($treated[$setting->getLbField()]))
                   {
                       $treated[$setting->getLbField()]=true;           
                       if ($setting->getBlMandatory())
                       {
                          $assocname="get".ucfirst($setting->getLbField());
                          if ($setting->getLbEntity()=="ServiceExtremity")
                          {    
                              $cptMissed=0;
                                foreach ($entity->getIdServiceExtremity() as $extr)
                                {
                                    if (method_exists($extr,$assocname))
                                    {
                                        if ($setting->getBlOldExtremity() && $extr->getBlOld() && $extr->$assocname()==NULL)
                                        {
                                            $cptMissed++;
                                        }
                                        if (!$setting->getBlOldExtremity() && !$extr->getBlOld()  && ($entity->getIdTransferExtremity()==NULL ||  !in_array($id_type,$transferTypes)  || $extr->getIdServiceExtremity()==$entity->getIdTransferExtremity()->getIdServiceExtremity())  && $extr->$assocname()==NULL)
                                        {
                                            $cptMissed++;
                                        }                                         
                                    }
                                    else
                                    {
                                        if ($setting->getBlOldExtremity() && $extr->getBlOld())
                                        {
                                            $val=self::findFieldValue($extr,$setting->getLbField());
                                              if ($val==NULL)
                                                  $cptMissed++;
                                        }
                                        if (!$setting->getBlOldExtremity() && !$extr->getBlOld()  && ($entity->getIdTransferExtremity()==NULL ||  !in_array($id_type,$transferTypes)  || $extr->getIdServiceExtremity()==$entity->getIdTransferExtremity()->getIdServiceExtremity()))
                                        {
                                              $val=self::findFieldValue($extr,$setting->getLbField());

                                              if ($val==NULL)
                                                  $cptMissed++;
                                        }                                         
                                    }

                                }
                                 if ($setting->getBlOne())
                                 {
                                     if ($entity->isP2P() && $cptMissed==count($entity->getIdServiceExtremity()))
                                        $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;   
                                     else if (!$entity->isP2P() && $cptMissed>0)
                                        $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;   
                                 }
                                 else if ($cptMissed>0)
                                       $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;   
                          }
                          else if ($setting->getLbEntity()=="ServiceDevice")
                          {    
                              $cptMissed=0;
                                foreach ($entity->getIdServiceDevice() as $dev)
                                {
                                    if (method_exists($dev,$assocname))
                                    {
                                        if ($dev->$assocname()==NULL)
                                            $cptMissed++;                                      
                                    }
                                  
                                }
                                if ($cptMissed>0)
                                       $missfields[$setting->getLbEntity()][$setting->getLbField()]=$dev;   
                          }
                          else if ($setting->getLbEntity()=="ServiceExtremityTech")
                          {
                              $cptMissed=0;
                              foreach ($entity->getIdServiceExtremityTech() as $extr)
                              {
                                    if (method_exists($extr,$assocname))
                                    {
                                        if ($setting->getBlOldExtremity() && $extr->getBlOld() && $extr->$assocname()==NULL)
                                        {
                                            $cptMissed++;
                                        }
                                        if (!$setting->getBlOldExtremity() && !$extr->getBlOld()  && ($entity->getIdTransferExtremity()==NULL ||  !in_array($id_type,$transferTypes)  || $extr->getIdServiceExtremity()->getIdServiceExtremity()==$entity->getIdTransferExtremity()->getIdServiceExtremity())  && $extr->$assocname()==NULL)
                                        {
                                            $cptMissed++;
                                        }                                         
                                    }
                                    else
                                    {
                                        if ($setting->getBlOldExtremity() && $extr->getBlOld())
                                        {
                                            $val=self::findFieldValue($extr,$setting->getLbField());

                                              if ($val==NULL)
                                                  $cptMissed++;
                                        }
                                        if (!$setting->getBlOldExtremity() && !$extr->getBlOld()  && ($entity->getIdTransferExtremity()==NULL ||  !in_array($id_type,$transferTypes)  || $extr->getIdServiceExtremity()->getIdServiceExtremity()==$entity->getIdTransferExtremity()->getIdServiceExtremity()))
                                        {
                                              $val=self::findFieldValue($extr,$setting->getLbField());

                                              if ($val==NULL)
                                                  $cptMissed++;
                                        }                                         
                                    }
                              }
                             if ($setting->getBlOne())
                             {
                                 if ($entity->isP2P() && $cptMissed==count($entity->getIdServiceExtremityTech()))
                                    $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;   
                                 else if (!$entity->isP2P() && $cptMissed>0)
                                    $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;   
                             }
                             else if ($cptMissed>0)
                                   $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;                                                           
                          }  
                          else if ($setting->getLbEntity()=="BillingService")
                          {
                              $cptMissed=0;
                              foreach ($entity->getIdBillingService() as $extr)
                              {
                                      if ($extr->$assocname()==NULL)
                                        $cptMissed++;
                              }
                              if ($cptMissed>0)
                                   $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;  
                          }                           
                          else 
                          {
                              $assocname="get".ucfirst($setting->getLbField());
                              if (method_exists($entity,$assocname))
                              {
                                    if ($entity->$assocname()==NULL)
                                          $missfields[$setting->getLbEntity()][$setting->getLbField()]=$entity;
                              }
                              else
                              {
                                  
                                   $val=self::findFieldValue($entity,$setting->getLbField());                                  
                                   if ($val==NULL)
                                      $missfields[$setting->getLbEntity()][$setting->getLbField()]=$entity;
                              }
                          }
                       }
                   }
                /* hack for customer/pop/provider */
                foreach ($entity->getIdServiceExtremity() as $extr)
                       {
                          if ($extr->getIdServiceExtremityOwner()!=NULL)
                          {
                            switch ($extr->getIdServiceExtremityOwner()->getIdLocalLoopExtremityOwner())
                            {
                                case 1:
                                    if ($extr->getIdCustomer()==NULL)
                                        $missfields["ServiceExtremity"]["idCustomer"]=$extr;
                                    if ($extr->getIdAdminContact()==NULL)
                                        $missfields["ServiceExtremity"]["idAdminContact"]=$extr;
                                    if ($extr->getIdDeliveryAddress()==NULL)
                                        $missfields["ServiceExtremity"]["idDeliveryAddress"]=$extr;
                                    break;                                  
                                case 2:
                                    if ($extr->getIdPop()==NULL)
                                        $missfields["ServiceExtremity"]["idPop"]=$extr;                                  
                                    if ($extr->getIdContactPop()==NULL)
                                        $missfields["ServiceExtremity"]["idContactPop"]=$extr;
                                    if ($extr->getIdAddressPop()==NULL)
                                        $missfields["ServiceExtremity"]["idAddressPop"]=$extr;                                  
                                    break;  
                                case 3:
                                    if ($extr->getIdProvider()==NULL)
                                        $missfields["ServiceExtremity"]["idProvider"]=$extr;                                  
                                    if ($extr->getIdContactProvider()==NULL)
                                        $missfields["ServiceExtremity"]["idContactPovider"]=$extr;
                                    if ($extr->getIdAddressProvider()==NULL)
                                        $missfields["ServiceExtremity"]["idAddressProvider"]=$extr;                                  
                                    break;                                   
                            }                           
                          }
                          else
                          {
                                if ($extr->getIdCustomer()==NULL)
                                        $missfields["ServiceExtremity"]["idCustomer"]=$extr;   
                                if ($extr->getIdPop()==NULL)
                                        $missfields["ServiceExtremity"]["idPop"]=$extr;                    
                                if ($extr->getIdProvider()==NULL)
                                        $missfields["ServiceExtremity"]["idProvider"]=$extr;      
                          }
                       }                                  
               }                     
         } 

        /*** detect local loop scheduled delivery ***/
        $statuses=array(49,60,71,81,91);
        if (in_array($id_status,$statuses))
        {
            foreach ($entity->getIdServiceExtremityTech() as $extrtech)
            {
                if ($extrtech->getIdLocalLoop()==NULL)
                {
                    $missfields["ServiceExtremityTech"]["Local Loop ref"]=1;
                    break;
                }
                if ($extrtech->getIdLocalLoop()->getDtScheduledDelivery()==NULL)
                {
                    $missfields["ServiceExtremityTech"]["LL scheduled delivery date"]=1;
                    break;
                }                    
            }        
        }
        
        /*** detect local loop scheduled delivery ***/
        $statuses=array(45,87);
        if (in_array($id_status,$statuses))
        {
            $wholeService=TRUE;
            foreach ($entity->getIdBIllingService() as $billingserv)
            {
                foreach ($billingserv->getIdBillingServiceLine() as $line)
                {                    
                    if ($line->getIdServiceExtremity()->count()>0)
                        $wholeService=FALSE;
                }
                    
            }
            if (!$wholeService)
            {
                foreach ($entity->getIdServiceExtremity() as $extrtech)
                {
                    if ($extrtech->getIdBillingServiceLine()->count() ==0)
                        $missfields["Billing"][$extrtech->getCdServiceExtremity()]=1;
                }        
            }
        }        

        
        foreach ($missfields as $key=>$value)
        {
            $chaineret.="In $key : ";
            $labels=array();
            $ymlfile=$controller->get("kernel")->getRootDir().'/../src/Etrali/GinangBundle/Resources/config/'.$key.'-generator.yml';                           
            if (file_exists($ymlfile))
                $infos=$controller->getFromExternYaml($ymlfile,'params.fields');     
            foreach ($value as $fieldname=>$entdesc)
            {
                if (isset($infos[$fieldname]))
                    $chaineret.=$infos[$fieldname]["label"].",";
                else
                    $chaineret.=$fieldname.",";
            }
            $chaineret.="<br>";
        }

        return $chaineret;
        
    }
}

?>
