<?php

namespace Admingenerator\GeneratorBundle\Form\Type;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class MultiSearchListType extends AbstractType 
{
   /**
     * {@inheritdoc}
     */
  public function buildForm(FormBuilderInterface $builder, array $options) {

    $builder -> setAttribute('dataType', $options['dataType']);
  }

   /**
     * {@inheritdoc}
     */
  public function buildView(FormView $view, FormInterface $form, array $options) {
    $view -> set('dataType', $form -> getAttribute('dataType'));
    $view->vars = array_merge($view->vars, array(
                'class'          => $options['class'],
                'motherentity'          => $options['motherentity'],        
                'motherfield'          => $options['motherfield'],  
                'daughterfield'          => $options['daughterfield'],  
                'restrictfield'          => $options['restrictfield'],         
                'restrictentity'          => $options['restrictentity'],  
                'action'          => $options['action']        
            ));    
  }

  
  /**
     * {@inheritdoc}
     */
  public function getDefaultOptions(array $options) {
    return array('required'      =>  isset($options['required'])  ? $options['required'] :false,'dataType'=>'collection','class'=>'','motherentity'=>'','motherfield'=>'','restrictentity'=>'','restrictfield'=>'','daughterfield'=>'','action'=>'');
  }


  /**
     * Returns the allowed option values for each option (if any).
     *
     * @param array $options
     *
     * @return array The allowed option values
     */
    public function getAllowedOptionValues(array $options)
    {
        return array('required' => array(false,true));
    }

   /**
     * {@inheritdoc}
     */
  public function getParent() {
    return 'double_list';
  }

   /**
     * {@inheritdoc}
     */
  public function getName() {
    return 'multi_search_list';
  }

}
