<?php

namespace Admingenerator\GeneratorBundle\Menu;

use Symfony\Component\HttpFoundation\Request;

class DefaultMenuBuilder extends AdmingeneratorMenuBuilder
{
    /**
     * @param Request $request
     * @param Router  $router
     */
    
    
    /****************************  touts les roles ************************
     * ********************************************************************
     * 
       (
          $role->isGrantedOr("ROLE_EQUIPMENT_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_ENTMC_INDIA")||
          $role->isGrantedOr("ROLE_CSC_FRANCE")||
          $role->isGrantedOr("ROLE_NETWORK_ACCOUNTING")||
          $role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN")||
          $role->isGrantedOr("ROLE_NETWORK_ENGINEER")||          
          $role->isGrantedOr("ROLE_MARKETING_PRE_SALES")||
          $role->isGrantedOr("ROLE_SALES_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR")
       )
     *
     * ********************************************************************* 
     */
    
    public function createAdminMenu(Request $request) 
    {      
        $menu = parent::createAdminMenu($request);
      
        
        $varenv=$this->container->get('kernel')->getEnvironment()=="dev"?"/app_dev.php":"/app.php";
        //$this->container->get('security.context')->isGrantedOr('ROLE_ADMIN');
        $role=$this->container->get('etrali.security.context');
        /**
         * Translation domain is passed down to child elements
         * in addNavLinkURI, addNavLinkRoute, addDropdownMenu methods.
         */
        $menu->setExtra('translation_domain', 'Admingenerator');
        $menu->setExtra('request_uri', $request->getUri());
        
       
        $this->addNavLinkURI($menu, 'Home', $varenv.'/');  
        
        $menuDone=false;
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ACCOUNTING", true)||
          $role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES", true)||
          $role->isGrantedOr("ROLE_SALES_ADMINISTRATOR", true))
        {
            $help = $this->addDropdownMenu($menu, 'Customers');
            $help->setExtra('request_uri', $request->getUri());            
            $this->addNavLinkURI($help, 'Customers', $varenv.'/admin/etrali_ginang_bundle/Customer');
            $menuDone=true;
        }
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR")||$role->isGrantedOr("ROLE_ENTMC_INDIA")||$role->isGrantedOr("ROLE_CSC_FRANCE")||$role->isGrantedOr("ROLE_NETWORK_ACCOUNTING")||
          $role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR")||$role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN")||$role->isGrantedOr("ROLE_NETWORK_ENGINEER")||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES")||
          $role->isGrantedOr("ROLE_SALES_ADMINISTRATOR"))
        {
            if (!$menuDone)
            {
                $help = $this->addDropdownMenu($menu, 'Customers');
                $help->setExtra('request_uri', $request->getUri());                         
            }
            $this->addNavLinkURI($help, 'Customer groups', $varenv.'/admin/etrali_ginang_bundle/CustomerGroup'); 
            $this->addNavLinkURI($help, 'Continent groups', $varenv.'/admin/etrali_ginang_bundle/ContinentGroup'); 
            $this->addNavLinkURI($help, 'World groups', $varenv.'/admin/etrali_ginang_bundle/WorldGroup');             
        }
        
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ACCOUNTING", true)||
          $role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES", true)||
          $role->isGrantedOr("ROLE_SALES_ADMINISTRATOR", true))
        {
            $this->addNavLinkURI($menu, 'Services', $varenv.'/admin/etrali_ginang_bundle/Service'); 
            $groups = $this->addDropdownMenu($menu, 'Groups');
            $groups->setExtra('request_uri', $request->getUri());             
            $this->addNavLinkURI($groups, 'Business conference groups', $varenv.'/admin/etrali_ginang_bundle/BusinessConferenceGroup');            
            $this->addNavLinkURI($groups, 'Trad Extra Datalink groups', $varenv.'/admin/etrali_ginang_bundle/TradExtraDatalinkGroup');                        
        }
            
            
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ACCOUNTING", true)||
           $role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR", true))
        {  
            $this->addNavLinkURI($menu, 'Backbone link', $varenv.'/admin/etrali_ginang_bundle/BackboneLink');
        }
        
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ACCOUNTING", true)||
           $role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES", true)||
           $role->isGrantedOr("ROLE_SALES_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR", true))
        {
            $this->addNavLinkURI($menu, 'Local loop', $varenv.'/admin/etrali_ginang_bundle/LocalLoop');   
        }
        
                
        if($role->isGrantedOr("ROLE_EQUIPMENT_ADMINISTRATOR")||$role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR")||$role->isGrantedOr("ROLE_ENTMC_INDIA")||$role->isGrantedOr("ROLE_CSC_FRANCE")||
          $role->isGrantedOr("ROLE_NETWORK_ACCOUNTING")||$role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR")||$role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN")||$role->isGrantedOr("ROLE_NETWORK_ENGINEER")||          
          $role->isGrantedOr("ROLE_MARKETING_PRE_SALES")||$role->isGrantedOr("ROLE_SALES_ADMINISTRATOR"))
       {
            $provider = $this->addDropdownMenu($menu, 'Providers');
            $provider->setExtra('request_uri', $request->getUri());        
            $this->addNavLinkURI($provider, 'Providers', $varenv.'/admin/etrali_ginang_bundle/Provider');     
            $this->addNavLinkURI($provider, 'Worldwide groups', $varenv.'/admin/etrali_ginang_bundle/ProviderWorldwideGroup'); 
            $this->addNavLinkURI($provider, 'Provider country groups', $varenv.'/admin/etrali_ginang_bundle/CountryProviderGroup');                       
        }
        
         
        $menuDone=false;
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR", true)||
          $role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES", true)||$role->isGrantedOr("ROLE_SALES_ADMINISTRATOR", true)||
          $role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR", true))
        {
                $menu1 = $this->addDropdownMenu($menu, 'Equipment');
                $menu1->setExtra('request_uri', $request->getUri());                                    
                $this->addNavLinkURI($menu1, 'Acess management', $varenv.'/admin/etrali_ginang_bundle/Access');
                $menuDone=true;
        }
        
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR")||$role->isGrantedOr("ROLE_ENTMC_INDIA")||$role->isGrantedOr("ROLE_CSC_FRANCE")||$role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN")||$role->isGrantedOr("ROLE_NETWORK_ENGINEER")||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES")||$role->isGrantedOr("ROLE_SALES_ADMINISTRATOR")||
          $role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR"))
        {
            if (!$menuDone)
            {
                $menu1 = $this->addDropdownMenu($menu, 'Equipment'); 
                $menu1->setExtra('request_uri', $request->getUri()); 
            }
            $this->addNavLinkURI($menu1, 'Models', $varenv.'/admin/etrali_ginang_bundle/ComplexModel');
            $menuDone=true;
         
        }
        
        $menuDone=false;
        if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR')||$role->isGrantedOr('ROLE_EQUIPMENT_ADMINISTRATOR'))
        {
            $back_office = $this->addDropdownMenu($menu, 'Back office');
            $back_office->setExtra('request_uri', $request->getUri());   
            $this->addNavLinkURI($back_office, 'Address types', $varenv.'/admin/etrali_ginang_bundle/AddressType');
            $this->addNavLinkURI($back_office, 'Bandwidth types', $varenv.'/admin/etrali_ginang_bundle/BandwidthAssigneeSelect');            
            
            if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR')){
                $this->addNavLinkURI($back_office, 'Branches', $varenv.'/admin/etrali_ginang_bundle/Branch');
            }          
          
            $this->addNavLinkURI($back_office, 'Cabinet types', $varenv.'/admin/etrali_ginang_bundle/CabinetType');   
            $this->addNavLinkURI($back_office, 'Cabinet sizes', $varenv.'/admin/etrali_ginang_bundle/CabinetSize');   
            $this->addNavLinkURI($back_office, 'Cable types', $varenv.'/admin/etrali_ginang_bundle/CableType');
            $this->addNavLinkURI($back_office, 'Capacity', $varenv.'/admin/etrali_ginang_bundle/Capacity');
            $this->addNavLinkURI($back_office, 'Civility', $varenv.'/admin/etrali_ginang_bundle/Civility');
            $this->addNavLinkURI($back_office, 'City', $varenv.'/admin/etrali_ginang_bundle/City');
            $this->addNavLinkURI($back_office, 'Commercial routes', $varenv.'/admin/etrali_ginang_bundle/CommercialRoute');   
            $this->addNavLinkURI($back_office, 'Country', $varenv.'/admin/etrali_ginang_bundle/Country');
            $this->addNavLinkURI($back_office, 'Currency', $varenv.'/admin/etrali_ginang_bundle/Currency');
            $this->addNavLinkURI($back_office, 'Currency conversion', $varenv.'/admin/etrali_ginang_bundle/CurrencyConversion'); 
            $this->addNavLinkURI($back_office, 'Customer nature', $varenv.'/admin/etrali_ginang_bundle/CustomerNature');             
            
            if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR'))
                $this->addNavLinkURI($back_office, 'Clusters', $varenv.'/admin/etrali_ginang_bundle/BranchCluster');
            
           
            $this->addNavLinkURI($back_office, 'Interfaces', $varenv.'/admin/etrali_ginang_bundle/Interfaces');
            
            if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR'))
                $this->addNavLinkURI($back_office, 'Mail templates', $varenv.'/admin/etrali_ginang_bundle/Mail');
            
            $this->addNavLinkURI($back_office, 'Notice periods', $varenv.'/admin/etrali_ginang_bundle/NoticePeriod');           
            $this->addNavLinkURI($back_office, 'Option types', $varenv.'/admin/etrali_ginang_bundle/OptionType');
            $this->addNavLinkURI($back_office, 'Port types', $varenv.'/admin/etrali_ginang_bundle/PortType');            
            $this->addNavLinkURI($back_office, 'Port subtypes', $varenv.'/admin/etrali_ginang_bundle/PortSubType');
            if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR'))
                $this->addNavLinkURI($back_office, 'Products', $varenv.'/admin/etrali_ginang_bundle/Product');
            $menuDone=true;
        }
        
        
        if($role->isGrantedOr("ROLE_SUPER_ADMINISTRATOR", true)||$role->isGrantedOr("ROLE_ENTMC_INDIA", true)||$role->isGrantedOr("ROLE_CSC_FRANCE", true)||$role->isGrantedOr("ROLE_NETWORK_ADMINISTRATOR", true)||
          $role->isGrantedOr("ROLE_NETWORK_ENGINEER_ADMIN", true)||$role->isGrantedOr("ROLE_NETWORK_ENGINEER", true)||$role->isGrantedOr("ROLE_MARKETING_PRE_SALES", true)||$role->isGrantedOr("ROLE_SALES_ADMINISTRATOR", true)||
          $role->isGrantedOr("ROLE_BACKBONE_LINK_ADMINISTRATOR", true))
       {
            if (!$menuDone) 
            {
                $back_office = $this->addDropdownMenu($menu, 'Back office');
                $back_office->setExtra('request_uri', $request->getUri());    
            }
            $this->addNavLinkURI($menu, 'Pops', $varenv.'/admin/etrali_ginang_bundle/Pop'); 
       }
            
        if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR')||$role->isGrantedOr('ROLE_EQUIPMENT_ADMINISTRATOR')){          
            $this->addNavLinkURI($back_office, 'Protocol', $varenv.'/admin/etrali_ginang_bundle/Protocol');
            $this->addNavLinkURI($back_office, 'Provider type', $varenv.'/admin/etrali_ginang_bundle/CompanyType');
                $this->addNavLinkURI($back_office, 'SFP modules types', $varenv.'/admin/etrali_ginang_bundle/SfpModuleType');            
        }
        
        if($role->isGrantedOr('ROLE_SUPER_ADMINISTRATOR'))
        {
            $this->addNavLinkURI($back_office, 'Technical route', $varenv.'/admin/etrali_ginang_bundle/Route');            
            $this->addNavLinkURI($back_office, 'Users settings', $varenv.'/admin/etrali_ginang_bundle/Myuser');
            $this->addNavLinkURI($back_office, 'Global settings', $varenv.'/admin/etrali_ginang_bundle/Settings/1/edit');            
        }
        
    if(true)
        {        
            $reporting = $this->addDropdownMenu($menu, 'Reporting');
            $reporting->setExtra('request_uri', $request->getUri());            
            $this->addNavLinkURI($reporting, "Services switched into 'In Service' status", $varenv.'/reportingServiceStatusInService');
            $this->addNavLinkURI($reporting, "Services switched into 'Terminated' status", $varenv.'/reportingServiceStatusTerminated');
            $this->addNavLinkURI($reporting, "Pending services", $varenv.'/reportingPendingServices');
            $this->addNavLinkURI($reporting, "Local Loop Report", $varenv.'/reportingLocalLoop');
            $this->addNavLinkURI($reporting, "Local Loop Report with Options and French LL", $varenv.'/reportingLocalLoopOptionsFrenchLL');
            $this->addNavLinkURI($reporting, "Local Loop Report with Connected Services", $varenv.'/reportingLocalLoopConnectedServices');
            $this->addNavLinkURI($reporting, "All services per Customer", $varenv.'/reportingAllServicesPerCustomer');
            $this->addNavLinkURI($reporting, "Local Loop Cost to Central", $varenv.'/reportingLocalLoopCostCentral');
            $this->addNavLinkURI($reporting, "LL to Customer Billing Branch", $varenv.'/reportingLocalLoopToCustomerBillingBranch');
            $this->addNavLinkURI($reporting, "Transfer price per Customer Billing Branch", $varenv.'/reportingTransferPriceCustomerBillingBranch');
        }
        
        return $menu;
    }
}
