# Symfony2 Admin Generator
---------------------------------------

[![KnpBundles Badge](http://knpbundles.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/badge-short)](http://knpbundles.com/symfony2admingenerator/AdmingeneratorGeneratorBundle)
![project status](http://stillmaintained.com/cedriclombardot/AdmingeneratorGeneratorBundle.png) 
[![build status](https://secure.travis-ci.org/symfony2admingenerator/AdmingeneratorGeneratorBundle.png)](http://travis-ci.org/symfony2admingenerator/AdmingeneratorGeneratorBundle)

### The Real Missing Admin Generator for Symfony2! 
This package is a Symfony2 Admin Generator based on YAML configuration and Twig templating. It's inspired by [fzaninotto/Doctrine2ActiveRecord](https://github.com/fzaninotto/Doctrine2ActiveRecord).

### Follow us on Twitter!

Don't miss any updates from **Symfony2 Admin Generator**! Join Twitter today and [follow us](https://twitter.com/sf2admgen)!

## Features:

* Generate Views and Controllers for Models with one command
* Configure all options in one (per model) YAML file
* Includes standard actions: create/edit, show, delete, list/nestedset tree list
* Flexible and extendable: you can *easily* add or overwrite almost everything!
* Supports most popular model managers: **Doctrine ORM**, **Doctrine ODM** and **Propel**
* Introduces nested forms: create/edit object and all it's associated objects in one form!
* Manage relations one to one, one to many, many to one and **many to many**
* Fully translatable: all field elements (labels, placeholders, helpers), all widgets, actions, error messages and titles
* **List features:** sortable, paginated, filters, batch actions, scopes
* **Nestedset tree list features:** drag&drop to manage your tree
* **New/Edit featues:** fieldsets, tabbable, cool widgets for *collection, file upload, date and entity* fields
* Translated into DE, **EN (default)**, ES, FA, FR, IT, JA, PL, PT, RU, SL, TR, UK (you can easily contribute to add your own)
* Credentials for actions, columns and form fields
* Complete admin design based on [twitter bootstrap](http://twitter.github.com/bootstrap/) *(see next section)*
* ... and more!

## This bundle in pictures

![Preview of list](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/raw/master/Resources/old-doc/doc_list.png)

![Preview of edit](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/raw/master/Resources/old-doc/doc_edit.png)

# Important note

Documentation is currently being rewritten. Old documentation can be found in:

* [Resources/old-doc](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/tree/master/Resources/old-doc) directory
* [symfony2admingenerator.org](http://symfony2admingenerator.org) website
* some new features configuration can be found in github issues/PR comments

Sorry for inconvenience, we will fix that as soon as possible!

## Installation

All the installation instructions are located in [documentation](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/blob/master/Resources/doc/documentation.md#installation).

## Documentation

The documentation for this bundle is located in `Resources/doc` directory. Start by reading [Table of contents](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/blob/master/Resources/doc/documentation.md#table-of-contents).

## Support

If you're haveing trouble or you found an error feel free to open a github ticket, but first please read [submitting issues](https://github.com/symfony2admingenerator/AdmingeneratorGeneratorBundle/blob/master/Resources/doc/support/submitting-issues.md).

## Sensio Connect

https://connect.sensiolabs.com/club/symfony2admingenerator

